# quadrature expressions: Q[ShellQuartet] = ( set(SymbolExpressions),
# ((FunctionQuartet), (Expression, Symbols)))
Q = 
{('d', 'd', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f1': '(B10*(3*Cx + 2*xij) + Cx*pow(sx,2))',
                         'f10': '(B10 + pow(sz,2))',
                         'f11': '3*pow(B10,2)',
                         'f15': '(sz*pow(Cz,2) + B10*(3*Cz + zij))',
                         'f2': '(B10*(3*Cy + yij) + sy*pow(Cy,2))',
                         'f5': '(Cz*pow(sz,2) + B10*(3*Cz + 2*zij))',
                         'f6': '(B10*(3*Cy + 2*yij) + Cy*pow(sy,2))',
                         'f7': '(B10*(3*Cx + xij) + sx*pow(Cx,2))',
                         'f9': '(pow(sy,2) + B10)',
                         'sx': '(Cx + xij)',
                         'sy': '(Cy + yij)',
                         'sz': '(Cz + zij)'},
                        ((((0, 1, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('(Py + Cy*yij)*(Cz*zij + Pz)',
                           ['zij', 'Py', 'yij', 'Cz', 'Pz', 'Cy'])),
                         (((0, 1, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*sx*(Cz*zij + Pz)',
                           ['zij', 'Cz', 'Pz', 'sx', 'Cy'])),
                         (((0, 1, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*sx*(Py + Cy*yij)',
                           ['yij', 'Cz', 'sx', 'Cy', 'Py'])),
                         (((1, 1, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*sz*(Py + Cy*yij)',
                           ['yij', 'sz', 'Cx', 'Cy', 'Py'])),
                         (((1, 1, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(Px + Cx*xij)*(Py + Cy*yij)',
                           ['Cx', 'Px', 'Py', 'xij', 'yij', 'Cy'])),
                         (((2, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(f11 + B10*(6*Cx*xij + pow(xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(sx,2))',
                           ['sx', 'B10', 'f11', 'xij', 'Cx'])),
                         (((0, 2, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(6*Cy*yij + pow(yij,2) + 6*pow(Cy,2)) + f11 + pow(Cy,2)*pow(sy,2))',
                           ['yij', 'B10', 'f11', 'Cy', 'sy'])),
                         (((0, 0, 2), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('(f11 + pow(Cz,2)*pow(sz,2) + B10*(6*Cz*zij + pow(zij,2) + 6*pow(Cz,2)))',
                           ['zij', 'B10', 'Cz', 'f11', 'sz'])),
                         (((1, 0, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*sy*(Cz*zij + Pz)',
                           ['zij', 'Cz', 'Pz', 'Cx', 'sy'])),
                         (((1, 0, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(Px + Cx*xij)*(Cz*zij + Pz)',
                           ['Cx', 'Px', 'zij', 'xij', 'Cz', 'Pz'])),
                         (((0, 0, 2), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*(xij*(xij + 2*Cx) + Px)',
                           ['Pz', 'Cx', 'xij', 'Px'])),
                         (((0, 2, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*(xij*(xij + 2*Cx) + Px)',
                           ['Px', 'Py', 'xij', 'Cx'])),
                         (((1, 0, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*sy*(Px + Cx*xij)',
                           ['Cz', 'xij', 'Px', 'sy', 'Cx'])),
                         (((0, 1, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*(xij*(xij + 2*Cx) + Px)',
                           ['Cz', 'Px', 'xij', 'Cy', 'Cx'])),
                         (((1, 1, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*sz*(Px + Cx*xij)',
                           ['sz', 'xij', 'Px', 'Cy', 'Cx'])),
                         (((1, 1, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*f10', ['f10', 'Cx', 'Cy'])),
                         (((1, 0, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*f9', ['f9', 'Cz', 'Cx'])),
                         (((0, 0, 2), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*sx*sy', ['Pz', 'sx', 'sy'])),
                         (((2, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Px*sy*sz', ['sz', 'sy', 'Px'])),
                         (((0, 2, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Py*sx*sz', ['sz', 'Py', 'sx'])),
                         (((0, 2, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Py*f10', ['Py', 'f10'])),
                         (((2, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Px*f10', ['f10', 'Px'])),
                         (((2, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*f9', ['f9', 'Px'])),
                         (((0, 0, 2), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f9', ['f9', 'Pz'])),
                         (((2, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f7*sy', ['f7', 'sy'])),
                         (((2, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f7*sz', ['f7', 'sz'])),
                         (((0, 2, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f2*sz', ['sz', 'f2'])),
                         (((0, 2, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f2*sx', ['sx', 'f2'])),
                         (((0, 0, 2), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f15*sx', ['f15', 'sx'])),
                         (((0, 0, 2), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f15*sy', ['f15', 'sy'])),
                         (((1, 0, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f5', ['Cx', 'f5'])),
                         (((1, 1, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f6', ['f6', 'Cx'])),
                         (((0, 1, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f6', ['f6', 'Cz'])),
                         (((1, 0, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f1', ['f1', 'Cz'])),
                         (((1, 1, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f1', ['f1', 'Cy'])),
                         (((0, 1, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f5', ['Cy', 'f5'])))),
 ('d', 'p', 'p', 's'): ({'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f1': '(B00*(yij + 2*Cy) + Dy*(B10 + Cy*sy))',
                         'f10': '(B10*(3*Cx + xij) + sx*pow(Cx,2))',
                         'f12': '(Dx*Px + 2*B00*Cx)',
                         'f13': '(Dx*sx + B00)',
                         'f20': '(sz*pow(Cz,2) + B10*(3*Cz + zij))',
                         'f3': '3*B00*B10',
                         'f4': '(Dy*Py + 2*B00*Cy)',
                         'f5': '(B10*(3*Cy + yij) + sy*pow(Cy,2))',
                         'f8': '(Dz*Pz + 2*B00*Cz)',
                         'sx': '(Cx + xij)',
                         'sy': '(Cy + yij)',
                         'sz': '(Cz + zij)'},
                        ((((1, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*(f8 + Qz*zij)', ['zij', 'f8', 'Cx', 'Qz'])),
                         (((0, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*(f8 + Qz*zij)', ['zij', 'f8', 'Qz', 'Cy'])),
                         (((0, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('(B00*Cz*(3*Cz + 2*zij) + B10*Dz*(3*Cz + zij) + f3 + Dz*sz*pow(Cz,2))',
                           ['B10', 'sz', 'Cz', 'zij', 'Dz', 'B00', 'f3'])),
                         (((0, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('(f3 + B00*Cy*(3*Cy + 2*yij) + B10*Dy*(3*Cy + yij) + Dy*sy*pow(Cy,2))',
                           ['B10', 'Dy', 'sy', 'yij', 'B00', 'f3', 'Cy'])),
                         (((2, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(Dx*sx*pow(Cx,2) + B00*Cx*(3*Cx + 2*xij) + B10*Dx*(3*Cx + xij) + f3)',
                           ['Dx', 'Cx', 'xij', 'B10', 'B00', 'sx', 'f3'])),
                         (((1, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*(f12 + Qx*xij)', ['Qx', 'f12', 'xij', 'Cy'])),
                         (((1, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*(f12 + Qx*xij)', ['Qx', 'Cz', 'f12', 'xij'])),
                         (((1, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*(Px + Cx*xij)',
                           ['Dy', 'Cz', 'Cx', 'Px', 'xij'])),
                         (((1, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Cz*(Dy*yij + Qy)',
                           ['Dy', 'Cz', 'Qy', 'Cx', 'yij'])),
                         (((1, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*(Cz*zij + Pz)',
                           ['zij', 'Dy', 'Cz', 'Pz', 'Cx'])),
                         (((0, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*(Cz*zij + Pz)',
                           ['zij', 'Dx', 'Cz', 'Pz', 'Cy'])),
                         (((0, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*(Py + Cy*yij)',
                           ['yij', 'Dx', 'Cz', 'Py', 'Cy'])),
                         (((1, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*(Py + Cy*yij)',
                           ['Dz', 'yij', 'Cx', 'Cy', 'Py'])),
                         (((1, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Cy*(Dz*zij + Qz)',
                           ['Dz', 'zij', 'Cx', 'Cy', 'Qz'])),
                         (((2, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Px*(Dz*zij + Qz)', ['Dz', 'zij', 'Qz', 'Px'])),
                         (((0, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Py*(Dz*zij + Qz)', ['Dz', 'zij', 'Py', 'Qz'])),
                         (((0, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Py*sz', ['Dx', 'sz', 'Py'])),
                         (((2, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Px*sz', ['Dy', 'sz', 'Px'])),
                         (((2, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Px*(Dy*yij + Qy)', ['Dy', 'Qy', 'Px', 'yij'])),
                         (((0, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Pz*(Dy*yij + Qy)', ['Dy', 'Pz', 'Qy', 'yij'])),
                         (((0, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Pz*sx', ['Dy', 'Pz', 'sx'])),
                         (((0, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Pz*sy', ['Dx', 'Pz', 'sy'])),
                         (((2, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Px*sy', ['Dz', 'sy', 'Px'])),
                         (((1, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*(Px + Cx*xij)',
                           ['Dz', 'xij', 'Px', 'Cy', 'Cx'])),
                         (((1, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*(Px + Cx*xij)', ['xij', 'Qz', 'Px', 'Cx'])),
                         (((1, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Qy*(Px + Cx*xij)', ['Qy', 'Cx', 'Px', 'xij'])),
                         (((1, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Qy*sz', ['sz', 'Qy', 'Cx'])),
                         (((0, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Qy*(Cz*zij + Pz)', ['zij', 'Pz', 'Cz', 'Qy'])),
                         (((1, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Qx*(Cz*zij + Pz)', ['zij', 'Qx', 'Pz', 'Cz'])),
                         (((1, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Qx*sy', ['Qx', 'Cz', 'sy'])),
                         (((1, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Qz*sy', ['Cx', 'sy', 'Qz'])),
                         (((0, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*(Py + Cy*yij)', ['yij', 'Qz', 'Cy', 'Py'])),
                         (((1, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Qx*(Py + Cy*yij)', ['yij', 'Qx', 'Py', 'Cy'])),
                         (((1, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Qx*sz', ['Qx', 'Cy', 'sz'])),
                         (((0, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f13', ['f13', 'Cz', 'Cy'])),
                         (((0, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Qy*sx', ['Cz', 'Qy', 'sx'])),
                         (((0, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Qz*sx', ['Qz', 'Cy', 'sx'])),
                         (((0, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Py*sx', ['Dz', 'Py', 'sx'])),
                         (((0, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Py*f13', ['f13', 'Py'])),
                         (((0, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Pz*f13', ['f13', 'Pz'])),
                         (((2, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('f12*sy', ['f12', 'sy'])),
                         (((2, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('f12*sz', ['sz', 'f12'])),
                         (((0, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('f4*sz', ['f4', 'sz'])),
                         (((0, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('f4*sx', ['f4', 'sx'])),
                         (((0, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('f8*sx', ['f8', 'sx'])),
                         (((0, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('f8*sy', ['f8', 'sy'])),
                         (((2, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f10', ['Dy', 'f10'])),
                         (((2, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f10', ['Dz', 'f10'])),
                         (((0, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f5', ['Dz', 'f5'])),
                         (((0, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f5', ['Dx', 'f5'])),
                         (((0, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f20', ['Dx', 'f20'])),
                         (((0, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f20', ['Dy', 'f20'])),
                         (((1, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*f1', ['f1', 'Cx'])),
                         (((0, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*f1', ['f1', 'Cz'])))),
 ('d', 'p', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f2': '(B10 + Cz*sz)',
                         'sx': '(Cx + xij)',
                         'sy': '(Cy + yij)',
                         'sz': '(Cz + zij)'},
                        ((((1, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*(Py + Cy*yij)', ['yij', 'Cx', 'Cy', 'Py'])),
                         (((0, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*(Py + Cy*yij)', ['yij', 'Cz', 'Py', 'Cy'])),
                         (((0, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(3*Cy + yij) + sy*pow(Cy,2))',
                           ['yij', 'B10', 'sy', 'Cy'])),
                         (((0, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(sz*pow(Cz,2) + B10*(3*Cz + zij))',
                           ['zij', 'B10', 'sz', 'Cz'])),
                         (((2, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(3*Cx + xij) + sx*pow(Cx,2))',
                           ['B10', 'Cx', 'xij', 'sx'])),
                         (((1, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*(Px + Cx*xij)', ['Cz', 'Cx', 'Px', 'xij'])),
                         (((1, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*(Px + Cx*xij)', ['xij', 'Px', 'Cy', 'Cx'])),
                         (((1, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*sz', ['sz', 'Cx', 'Cy'])),
                         (((0, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*sx', ['Cz', 'sx', 'Cy'])),
                         (((1, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*sy', ['Cz', 'Cx', 'sy'])),
                         (((2, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*sy', ['sy', 'Px'])),
                         (((2, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Px*sz', ['sz', 'Px'])),
                         (((0, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Py*sz', ['sz', 'Py'])),
                         (((0, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*sx', ['Py', 'sx'])),
                         (((0, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*sx', ['Pz', 'sx'])),
                         (((0, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*sy', ['Pz', 'sy'])),
                         (((1, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f2', ['Cx', 'f2'])),
                         (((0, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f2', ['f2', 'Cy'])))),
 ('d', 's', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))'},
                        ((((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py', ['Py'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz', ['Pz'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px', ['Px'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy', ['Cx', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz', ['Cz', 'Cx'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz', ['Cz', 'Cy'])))),
 ('d', 'sp', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'sx': '(Cx + xij)',
                          'sy': '(Cy + yij)',
                          'sz': '(Cz + zij)'},
                         ((((0, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(B10 + Cz*sz)', ['B10', 'Cz', 'Cy', 'sz'])),
                          (((0, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Py*sz', ['sz', 'Py'])),
                          (((1, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*(B10 + Cx*sx)', ['B10', 'Cz', 'Cx', 'sx'])),
                          (((1, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*(B10 + Cz*sz)', ['B10', 'Cz', 'Cx', 'sz'])),
                          (((0, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(sz*pow(Cz,2) + B10*(3*Cz + zij))',
                            ['zij', 'B10', 'sz', 'Cz'])),
                          (((0, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*(B10 + Cy*sy)', ['B10', 'Cz', 'sy', 'Cy'])),
                          (((0, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10*(3*Cy + yij) + sy*pow(Cy,2))',
                            ['yij', 'B10', 'sy', 'Cy'])),
                          (((1, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*(B10 + Cy*sy)', ['B10', 'Cx', 'Cy', 'sy'])),
                          (((1, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(B10 + Cx*sx)', ['B10', 'Cx', 'Cy', 'sx'])),
                          (((2, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10*(3*Cx + xij) + sx*pow(Cx,2))',
                            ['B10', 'Cx', 'xij', 'sx'])),
                          (((2, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px*sy', ['sy', 'Px'])),
                          (((1, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz*sy', ['Cz', 'Cx', 'sy'])),
                          (((0, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*sy', ['Pz', 'sy'])),
                          (((0, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*sx', ['Pz', 'sx'])),
                          (((0, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*sx', ['Cz', 'sx', 'Cy'])),
                          (((0, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py*sx', ['Py', 'sx'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py', ['Py'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz', ['Pz'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px', ['Px'])),
                          (((2, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Px*sz', ['sz', 'Px'])),
                          (((1, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*sz', ['sz', 'Cx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy', ['Cx', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz', ['Cz', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz', ['Cz', 'Cy'])))),
 ('f', 'd', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f10': '(3*pow(B10,2) + B10*(6*Cy*yij + pow(yij,2) + 6*pow(Cy,2)) + pow(Cy,2)*pow(sy,2))',
                         'f11': '(B10 + Cy*sy)',
                         'f12': '(B10*(3*Cy + 2*yij) + Cy*pow(sy,2))',
                         'f13': '(B10*(3*Cx + xij) + sx*pow(Cx,2))',
                         'f14': '(B10 + Cz*sz)',
                         'f15': '(3*pow(B10,2) + 3*B10*Cx*(xij + 2*Cx) + sx*pow(Cx,3))',
                         'f16': '(pow(sy,2) + B10)',
                         'f18': '(B10 + pow(sz,2))',
                         'f2': '(B10*(3*Cx + 2*xij) + Cx*pow(sx,2))',
                         'f20': '(3*pow(B10,2) + sz*pow(Cz,3) + 3*B10*Cz*(2*Cz + zij))',
                         'f22': '(3*B10 + pow(Cz,2))',
                         'f23': '(3*B10 + pow(Cy,2))',
                         'f24': '(sz*pow(Cz,2) + B10*(3*Cz + zij))',
                         'f3': '(3*pow(B10,2) + sy*pow(Cy,3) + 3*B10*Cy*(yij + 2*Cy))',
                         'f4': '(3*pow(B10,2) + pow(Cz,2)*pow(sz,2) + B10*(6*Cz*zij + pow(zij,2) + 6*pow(Cz,2)))',
                         'f5': '(B10*(3*Cy + yij) + sy*pow(Cy,2))',
                         'f6': '(3*pow(B10,2) + B10*(6*Cx*xij + pow(xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(sx,2))',
                         'f8': '(Cz*pow(sz,2) + B10*(3*Cz + 2*zij))',
                         'sx': '(Cx + xij)',
                         'sy': '(Cy + yij)',
                         'sz': '(Cz + zij)'},
                        ((((0, 0, 3), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f22*(xij*(xij + 2*Cx) + Px)',
                           ['Cz', 'f22', 'Cx', 'xij', 'Px'])),
                         (((1, 2, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Py*sz*(Px + Cx*xij)',
                           ['sz', 'xij', 'Py', 'Px', 'Cx'])),
                         (((0, 2, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Py*(xij*(xij + 2*Cx) + Px)',
                           ['Cz', 'Px', 'Py', 'xij', 'Cx'])),
                         (((1, 1, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f11*(Px + Cx*xij)',
                           ['Cz', 'xij', 'f11', 'Px', 'Cx'])),
                         (((1, 0, 2), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*sy*(Px + Cx*xij)',
                           ['xij', 'Pz', 'Px', 'sy', 'Cx'])),
                         (((0, 1, 2), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Pz*(xij*(xij + 2*Cx) + Px)',
                           ['Px', 'Pz', 'xij', 'Cy', 'Cx'])),
                         (((0, 3, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f23*(xij*(xij + 2*Cx) + Px)',
                           ['Px', 'f23', 'xij', 'Cy', 'Cx'])),
                         (((1, 1, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f14*(Px + Cx*xij)',
                           ['f14', 'xij', 'Px', 'Cy', 'Cx'])),
                         (((1, 2, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f5*(Px + Cx*xij)', ['xij', 'Cx', 'Px', 'f5'])),
                         (((1, 0, 2), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f24*(Px + Cx*xij)', ['f24', 'Cx', 'Px', 'xij'])),
                         (((0, 0, 3), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('(3*pow(B10,2)*(5*Cz + 2*zij) + pow(Cz,3)*pow(sz,2) + B10*Cz*(3*pow(zij,2) + 10*pow(Cz,2) + 12*Cz*zij))',
                           ['zij', 'B10', 'Cz', 'sz'])),
                         (((0, 2, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f5*sx', ['Cz', 'sx', 'f5'])),
                         (((0, 2, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Py*f14*sx', ['f14', 'Py', 'sx'])),
                         (((2, 0, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Px*f14*sy', ['f14', 'sy', 'Px'])),
                         (((3, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f0*sy*sz', ['sz', 'f0', 'Cx', 'sy'])),
                         (((1, 2, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f5*sz', ['sz', 'Cx', 'f5'])),
                         (((1, 0, 2), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Pz*f16', ['f16', 'Pz', 'Cx'])),
                         (((1, 0, 2), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f24*sy', ['f24', 'Cx', 'sy'])),
                         (((3, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(pow(Cx,3)*pow(sx,2) + B10*Cx*(12*Cx*xij + 10*pow(Cx,2) + 3*pow(xij,2)) + 3*pow(B10,2)*(5*Cx + 2*xij))',
                           ['B10', 'Cx', 'xij', 'sx'])),
                         (((0, 3, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*pow(B10,2)*(5*Cy + 2*yij) + B10*Cy*(12*Cy*yij + 3*pow(yij,2) + 10*pow(Cy,2)) + pow(Cy,3)*pow(sy,2))',
                           ['yij', 'B10', 'sy', 'Cy'])),
                         (((2, 1, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f13*sz', ['f13', 'Cy', 'sz'])),
                         (((0, 3, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f23*sx*sz', ['sz', 'f23', 'sx', 'Cy'])),
                         (((0, 3, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f18*f23', ['f23', 'f18', 'Cy'])),
                         (((2, 1, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Px*f18', ['Px', 'Cy', 'f18'])),
                         (((2, 1, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Px*f11*sz', ['sz', 'f11', 'Px'])),
                         (((0, 1, 2), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f11*sx', ['Pz', 'f11', 'sx'])),
                         (((0, 1, 2), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f24*sx', ['f24', 'sx', 'Cy'])),
                         (((1, 1, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f2', ['Cz', 'f2', 'Cy'])),
                         (((1, 1, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*f12', ['Cz', 'f12', 'Cx'])),
                         (((1, 1, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*f8', ['f8', 'Cx', 'Cy'])),
                         (((1, 1, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f11*f14', ['f14', 'Cx', 'f11'])),
                         (((1, 2, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Py*f18', ['Cx', 'f18', 'Py'])),
                         (((3, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f0*f18', ['f0', 'Cx', 'f18'])),
                         (((3, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f0*f16', ['f16', 'f0', 'Cx'])),
                         (((2, 0, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Px*f16', ['f16', 'Cz', 'Px'])),
                         (((0, 0, 3), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f16*f22', ['f16', 'Cz', 'f22'])),
                         (((0, 0, 3), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f22*sx*sy', ['Cz', 'f22', 'sx', 'sy'])),
                         (((2, 0, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f13*sy', ['f13', 'Cz', 'sy'])),
                         (((3, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f15*sy', ['f15', 'sy'])),
                         (((3, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f15*sz', ['f15', 'sz'])),
                         (((0, 3, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f3*sz', ['sz', 'f3'])),
                         (((0, 3, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f3*sx', ['f3', 'sx'])),
                         (((0, 0, 3), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f20*sx', ['f20', 'sx'])),
                         (((0, 0, 3), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f20*sy', ['f20', 'sy'])),
                         (((2, 1, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*f12', ['f12', 'Px'])),
                         (((2, 0, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Px*f8', ['f8', 'Px'])),
                         (((0, 2, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Py*f8', ['f8', 'Py'])),
                         (((1, 2, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*f2', ['Py', 'f2'])),
                         (((1, 0, 2), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f2', ['Pz', 'f2'])),
                         (((0, 1, 2), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f12', ['f12', 'Pz'])),
                         (((1, 0, 2), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f4', ['f4', 'Cx'])),
                         (((1, 2, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f10', ['Cx', 'f10'])),
                         (((0, 2, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f10', ['Cz', 'f10'])),
                         (((2, 0, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f6', ['f6', 'Cz'])),
                         (((2, 1, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((0, 1, 2), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f4', ['f4', 'Cy'])),
                         (((0, 2, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f14*f5', ['f14', 'f5'])),
                         (((2, 0, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f13*f14', ['f14', 'f13'])),
                         (((2, 1, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f11*f13', ['f13', 'f11'])),
                         (((0, 1, 2), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f11*f24', ['f24', 'f11'])))),
 ('f', 'p', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f11': '(3*B10 + pow(Cz,2))',
                         'f12': '(3*B10 + pow(Cy,2))',
                         'f13': '(sz*pow(Cz,2) + B10*(3*Cz + zij))',
                         'f2': '(B10*(3*Cy + yij) + sy*pow(Cy,2))',
                         'f5': '(B10 + Cy*sy)',
                         'f6': '(B10*(3*Cx + xij) + sx*pow(Cx,2))',
                         'f8': '3*pow(B10,2)',
                         'sx': '(Cx + xij)',
                         'sy': '(Cy + yij)',
                         'sz': '(Cz + zij)'},
                        ((((1, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*(Cz*zij + Pz)',
                           ['zij', 'Cz', 'Pz', 'Cx', 'Cy'])),
                         (((1, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*(Px + Cx*xij)',
                           ['Cz', 'xij', 'Px', 'Cy', 'Cx'])),
                         (((3, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cx*(xij + 2*Cx) + sx*pow(Cx,3) + f8)',
                           ['B10', 'f8', 'Cx', 'xij', 'sx'])),
                         (((0, 3, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(sy*pow(Cy,3) + f8 + 3*B10*Cy*(yij + 2*Cy))',
                           ['yij', 'B10', 'f8', 'Cy', 'sy'])),
                         (((0, 0, 3), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(sz*pow(Cz,3) + 3*B10*Cz*(2*Cz + zij) + f8)',
                           ['zij', 'B10', 'sz', 'f8', 'Cz'])),
                         (((2, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Px*(Cz*zij + Pz)', ['zij', 'Cz', 'Pz', 'Px'])),
                         (((0, 2, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Py*(Cz*zij + Pz)', ['zij', 'Cz', 'Pz', 'Py'])),
                         (((0, 2, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Py*sx', ['Cz', 'Py', 'sx'])),
                         (((0, 0, 3), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f11*sx', ['Cz', 'f11', 'sx'])),
                         (((0, 0, 3), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f11*sy', ['Cz', 'f11', 'sy'])),
                         (((2, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Px*sy', ['Cz', 'sy', 'Px'])),
                         (((2, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Px*sz', ['sz', 'Px', 'Cy'])),
                         (((0, 3, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f12*sz', ['sz', 'f12', 'Cy'])),
                         (((0, 3, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f12*sx', ['f12', 'sx', 'Cy'])),
                         (((0, 1, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Pz*sx', ['Pz', 'sx', 'Cy'])),
                         (((1, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Pz*sy', ['Pz', 'Cx', 'sy'])),
                         (((1, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*(Px + Cx*xij)', ['Pz', 'Cx', 'Px', 'xij'])),
                         (((1, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*(Px + Cx*xij)', ['xij', 'Py', 'Px', 'Cx'])),
                         (((1, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Py*sz', ['sz', 'Cx', 'Py'])),
                         (((3, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f0*sz', ['sz', 'f0', 'Cx'])),
                         (((3, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f0*sy', ['f0', 'Cx', 'sy'])),
                         (((1, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*f5', ['Cz', 'Cx', 'f5'])),
                         (((2, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*f5', ['Px', 'f5'])),
                         (((0, 1, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f5', ['Pz', 'f5'])),
                         (((1, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f13', ['f13', 'Cx'])),
                         (((1, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f2', ['Cx', 'f2'])),
                         (((0, 2, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f2', ['Cz', 'f2'])),
                         (((2, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f6', ['f6', 'Cz'])),
                         (((2, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((0, 1, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f13', ['f13', 'Cy'])))),
 ('f', 's', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))'},
                        ((((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Px', ['Px', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Px', ['Cz', 'Px'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Py', ['Cx', 'Py'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Py', ['Cz', 'Py'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cz + pow(Cz,3))', ['B10', 'Cz'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cy + pow(Cy,3))', ['B10', 'Cy'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cx + pow(Cx,3))', ['B10', 'Cx'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Pz', ['Pz', 'Cx'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Pz', ['Pz', 'Cy'])))),
 ('f', 'sp', 's', 's'): ({'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'f0': '(3*B10 + pow(Cx,2))',
                          'f11': '(3*B10 + pow(Cz,2))',
                          'f12': '(3*B10 + pow(Cy,2))',
                          'f13': '(sz*pow(Cz,2) + B10*(3*Cz + zij))',
                          'f2': '(B10*(3*Cy + yij) + sy*pow(Cy,2))',
                          'f5': '(B10 + Cy*sy)',
                          'f6': '(B10*(3*Cx + xij) + sx*pow(Cx,2))',
                          'f8': '3*pow(B10,2)',
                          'sx': '(Cx + xij)',
                          'sy': '(Cy + yij)',
                          'sz': '(Cz + zij)'},
                         ((((3, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(3*B10*Cx*(xij + 2*Cx) + sx*pow(Cx,3) + f8)',
                            ['B10', 'f8', 'Cx', 'xij', 'sx'])),
                          (((0, 3, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(sy*pow(Cy,3) + f8 + 3*B10*Cy*(yij + 2*Cy))',
                            ['yij', 'B10', 'f8', 'Cy', 'sy'])),
                          (((0, 0, 3), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(sz*pow(Cz,3) + 3*B10*Cz*(2*Cz + zij) + f8)',
                            ['zij', 'B10', 'sz', 'f8', 'Cz'])),
                          (((2, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Px*(Cz*zij + Pz)', ['zij', 'Cz', 'Pz', 'Px'])),
                          (((0, 2, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Cz*zij + Pz)', ['zij', 'Cz', 'Pz', 'Py'])),
                          (((1, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*(Cz*zij + Pz)',
                            ['zij', 'Cz', 'Pz', 'Cx', 'Cy'])),
                          (((1, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*(Px + Cx*xij)',
                            ['Cz', 'xij', 'Px', 'Cy', 'Cx'])),
                          (((1, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Px + Cx*xij)', ['xij', 'Py', 'Px', 'Cx'])),
                          (((1, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*(Px + Cx*xij)', ['Pz', 'Cx', 'Px', 'xij'])),
                          (((1, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Pz*sy', ['Pz', 'Cx', 'sy'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                          (((1, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz*f5', ['Cz', 'Cx', 'f5'])),
                          (((0, 2, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Py*sx', ['Cz', 'Py', 'sx'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Py', ['Cz', 'Py'])),
                          (((0, 2, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f2', ['Cz', 'f2'])),
                          (((1, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f2', ['Cx', 'f2'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Py', ['Cx', 'Py'])),
                          (((1, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Py*sz', ['sz', 'Cx', 'Py'])),
                          (((3, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f0*sz', ['sz', 'f0', 'Cx'])),
                          (((3, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f0*sy', ['f0', 'Cx', 'sy'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f0', ['f0', 'Cx'])),
                          (((1, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f13', ['f13', 'Cx'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Pz', ['Pz', 'Cx'])),
                          (((0, 1, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Pz*sx', ['Pz', 'sx', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Pz', ['Pz', 'Cy'])),
                          (((0, 1, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*f5', ['Pz', 'f5'])),
                          (((2, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px*f5', ['Px', 'f5'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Px', ['Cz', 'Px'])),
                          (((2, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Px*sy', ['Cz', 'sy', 'Px'])),
                          (((0, 0, 3), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f11*sy', ['Cz', 'f11', 'sy'])),
                          (((0, 0, 3), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f11*sx', ['Cz', 'f11', 'sx'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f11', ['Cz', 'f11'])),
                          (((2, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f6', ['f6', 'Cz'])),
                          (((2, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f6', ['f6', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Px', ['Px', 'Cy'])),
                          (((2, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Px*sz', ['sz', 'Px', 'Cy'])),
                          (((0, 3, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f12*sz', ['sz', 'f12', 'Cy'])),
                          (((0, 3, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f12*sx', ['f12', 'sx', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f12', ['f12', 'Cy'])),
                          (((0, 1, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f13', ['f13', 'Cy'])))),
 ('p', 'p', 'p', 's'): ({'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f1': '(Dz*sz + B00)',
                         'f11': '(B10 + Cz*sz)',
                         'f3': '(B10 + Cy*sy)',
                         'f7': '(B10 + Cx*sx)',
                         'sx': '(Cx + xij)',
                         'sy': '(Cy + yij)',
                         'sz': '(Cz + zij)'},
                        ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('(B00*(yij + 2*Cy) + Dy*(B10 + Cy*sy))',
                           ['B10', 'Dy', 'sy', 'yij', 'B00', 'Cy'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('(Dz*(B10 + Cz*sz) + B00*(2*Cz + zij))',
                           ['B10', 'sz', 'zij', 'Dz', 'Cz', 'B00'])),
                         (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(Dx*(B10 + Cx*sx) + B00*(xij + 2*Cx))',
                           ['Dx', 'Cx', 'xij', 'B10', 'B00', 'sx'])),
                         (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*(Dx*xij + Qx)', ['Qx', 'Dx', 'Cz', 'xij'])),
                         (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*(Dx*xij + Qx)', ['Dx', 'Qx', 'xij', 'Cy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*sx', ['Dz', 'sx', 'Cy'])),
                         (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*sz', ['Dx', 'sz', 'Cy'])),
                         (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*sz', ['Dy', 'sz', 'Cx'])),
                         (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*(Dy*yij + Qy)', ['Dy', 'Qy', 'Cx', 'yij'])),
                         (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*(Dy*yij + Qy)', ['Dy', 'Cz', 'Qy', 'yij'])),
                         (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*sx', ['Dy', 'Cz', 'sx'])),
                         (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*sy', ['Dx', 'Cz', 'sy'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*sy', ['Dz', 'Cx', 'sy'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*f1', ['f1', 'Cx'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*f1', ['f1', 'Cy'])),
                         (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Qx*sy', ['Qx', 'sy'])),
                         (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Qx*sz', ['Qx', 'sz'])),
                         (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Qy*sz', ['sz', 'Qy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Qy*sx', ['Qy', 'sx'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*sx', ['Qz', 'sx'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*sy', ['Qz', 'sy'])),
                         (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f7', ['Dy', 'f7'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f7', ['Dz', 'f7'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f3', ['Dz', 'f3'])),
                         (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f3', ['Dx', 'f3'])),
                         (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f11', ['Dx', 'f11'])),
                         (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f11', ['Dy', 'f11'])))),
 ('p', 'p', 's', 's'): ({'sx': '(Cx + xij)',
                         'sy': '(Cy + yij)',
                         'sz': '(Cz + zij)'},
                        ((((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10 + Cy*sy)', ['B10', 'sy', 'Cy'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(B10 + Cz*sz)', ['B10', 'Cz', 'sz'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10 + Cx*sx)', ['B10', 'Cx', 'sx'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*sy', ['Cx', 'sy'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*sz', ['sz', 'Cx'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*sz', ['sz', 'Cy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*sx', ['sx', 'Cy'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*sx', ['Cz', 'sx'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*sy', ['Cz', 'sy'])))),
 ('p', 's', 's', 's'): ({},
                        ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx', ['Cx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy', ['Cy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz', ['Cz'])))),
 ('s', 's', 's', 's'): ({},
                        ((((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('1', [])),)),
 ('sp', 'p', 'p', 's'): ({'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f1': '(Dz*sz + B00)',
                          'f11': '(B10 + Cz*sz)',
                          'f12': '(B10 + Cy*sy)',
                          'f6': '(B10 + Cx*sx)',
                          'sx': '(Cx + xij)',
                          'sy': '(Cy + yij)',
                          'sz': '(Cz + zij)'},
                         ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(B00*(yij + 2*Cy) + Dy*(B10 + Cy*sy))',
                            ['B10', 'Dy', 'sy', 'yij', 'B00', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(Dz*(B10 + Cz*sz) + B00*(2*Cz + zij))',
                            ['B10', 'sz', 'zij', 'Dz', 'Cz', 'B00'])),
                          (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*(B10 + Cx*sx) + B00*(xij + 2*Cx))',
                            ['Dx', 'Cx', 'xij', 'B10', 'B00', 'sx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*sz', ['Dy', 'sz', 'Cx'])),
                          (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*(Dx*xij + Qx)', ['Dx', 'Qx', 'xij', 'Cy'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*xij + Qx)', ['Dx', 'Qx', 'xij'])),
                          (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*(Dx*xij + Qx)', ['Qx', 'Dx', 'Cz', 'xij'])),
                          (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*sy', ['Dx', 'Cz', 'sy'])),
                          (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*(Dy*yij + Qy)', ['Dy', 'Cz', 'Qy', 'yij'])),
                          (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*(Dy*yij + Qy)', ['Dy', 'Qy', 'Cx', 'yij'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*yij + Qy)', ['Dy', 'Qy', 'yij'])),
                          (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy*sx', ['Qy', 'sx'])),
                          (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f12', ['Dx', 'f12'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f12', ['Dz', 'f12'])),
                          (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx*sy', ['Qx', 'sy'])),
                          (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Qx*sz', ['Qx', 'sz'])),
                          (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*sz', ['Dx', 'sz', 'Cy'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*sz', ['Dx', 'sz'])),
                          (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Qy*sz', ['sz', 'Qy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*sz', ['Dy', 'sz'])),
                          (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f6', ['Dy', 'f6'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f6', ['Dz', 'f6'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*sy', ['Dz', 'Cx', 'sy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*sy', ['Dz', 'sy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*sx', ['Dz', 'sx', 'Cy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*sx', ['Dz', 'sx'])),
                          (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*sx', ['Dy', 'Cz', 'sx'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*sx', ['Dy', 'sx'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*sx', ['Qz', 'sx'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*sy', ['Qz', 'sy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*sy', ['Dx', 'sy'])),
                          (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f11', ['Dx', 'f11'])),
                          (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f11', ['Dy', 'f11'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f1', ['f1', 'Cy'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f1', ['f1', 'Cx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('f1', ['f1'])))),
 ('sp', 'p', 's', 's'): ({'sx': '(Cx + xij)',
                          'sy': '(Cy + yij)',
                          'sz': '(Cz + zij)'},
                         ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + Cx*sx)', ['B10', 'Cx', 'sx'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + Cy*sy)', ['B10', 'sy', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + Cz*sz)', ['B10', 'Cz', 'sz'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*sx', ['Cz', 'sx'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*sy', ['Cz', 'sy'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*sy', ['Cx', 'sy'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*sz', ['sz', 'Cx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*sz', ['sz', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*sx', ['sx', 'Cy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('sx', ['sx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('sy', ['sy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('sz', ['sz'])))),
 ('sp', 's', 's', 's'): ({},
                         ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx', ['Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy', ['Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz', ['Cz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('1', [])))),
 ('sp', 'sp', 'p', 's'): ({'Px': '(B10 + pow(Cx,2))',
                           'Py': '(B10 + pow(Cy,2))',
                           'Pz': '(B10 + pow(Cz,2))',
                           'Qy': '(Cy*Dy + B00)',
                           'f1': 'Cz*Dz',
                           'f14': '(B10 + Cz*sz)',
                           'f15': '(B10 + Cy*sy)',
                           'f4': 'Cx*Dx',
                           'f8': 'Cy*Dy',
                           'f9': '(B10 + Cx*sx)',
                           'sx': '(Cx + xij)',
                           'sy': '(Cy + yij)',
                           'sz': '(Cz + zij)'},
                          ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(B00*(yij + 2*Cy) + f8*yij + Dy*Py)',
                             ['Dy', 'Py', 'yij', 'B00', 'f8', 'Cy'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(f4*xij + Dx*Px + B00*(xij + 2*Cx))',
                             ['f4', 'Dx', 'xij', 'Px', 'B00', 'Cx'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*(B00 + f4 + Dx*xij)',
                             ['f4', 'Dx', 'B00', 'xij', 'Cy'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*(B00 + f4 + Dx*xij)',
                             ['f4', 'Dx', 'Cz', 'xij', 'B00'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(B00 + f4 + Dx*xij)',
                             ['f4', 'Dx', 'B00', 'xij'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(Dz*Pz + B00*(2*Cz + zij) + f1*zij)',
                             ['f1', 'Cz', 'zij', 'Dz', 'B00', 'Pz'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cy*(B00 + Dz*zij + f1)',
                             ['Dz', 'zij', 'B00', 'Cy', 'f1'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*(B00 + Dz*zij + f1)',
                             ['Dz', 'zij', 'B00', 'Cx', 'f1'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(B00 + Dz*zij + f1)',
                             ['Dz', 'zij', 'B00', 'f1'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*(Dy*yij + Qy)', ['Dy', 'Qy', 'Cx', 'yij'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*(Dy*yij + Qy)', ['Dy', 'Cz', 'Qy', 'yij'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(Dy*yij + Qy)', ['Dy', 'Qy', 'yij'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*sx', ['Dy', 'Cz', 'sx'])),
                           (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy', ['Dy', 'Cz'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Qy*sx', ['Qy', 'sx'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Qy*sz', ['sz', 'Qy'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('sz*(B00 + f4)', ['f4', 'sz', 'B00'])),
                           (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(B00 + f4)', ['f4', 'B00'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('sy*(B00 + f4)', ['f4', 'B00', 'sy'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('sy*(B00 + f1)', ['f1', 'B00', 'sy'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('sx*(B00 + f1)', ['f1', 'B00', 'sx'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('(B00 + f1)', ['f1', 'B00'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*f9', ['Dz', 'f9'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*f9', ['Dy', 'f9'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*sz', ['Dy', 'sz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*sz', ['Dy', 'sz', 'Cx'])),
                           (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy', ['Dy', 'Cx'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz', ['Dz', 'Cx'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*sy', ['Dz', 'Cx', 'sy'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*sy', ['Dz', 'sy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*f15', ['Dz', 'f15'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*f15', ['f15', 'Dx'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*f14', ['Dx', 'f14'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*f14', ['Dy', 'f14'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*sx', ['Dy', 'sx'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*sx', ['Dz', 'sx'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*sx', ['Dz', 'sx', 'Cy'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz', ['Dz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx', ['Dx', 'Cy'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*sz', ['Dx', 'sz', 'Cy'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*sz', ['Dx', 'sz'])),
                           (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx', ['Dx', 'Cz'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*sy', ['Dx', 'Cz', 'sy'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*sy', ['Dx', 'sy'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx', ['Dx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy', ['Dy'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz', ['Dz'])),
                           (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Qy', ['Qy'])))),
 ('sp', 'sp', 's', 's'): ({'sx': '(Cx + xij)',
                           'sy': '(Cy + yij)',
                           'sz': '(Cz + zij)'},
                          ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('(B10 + Cx*sx)', ['B10', 'Cx', 'sx'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('(B10 + Cy*sy)', ['B10', 'sy', 'Cy'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('(B10 + Cz*sz)', ['B10', 'Cz', 'sz'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*sx', ['Cz', 'sx'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*sy', ['Cz', 'sy'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*sy', ['Cx', 'sy'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*sz', ['sz', 'Cx'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cy*sz', ['sz', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*sx', ['sx', 'Cy'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('sx', ['sx'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('sy', ['sy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('sz', ['sz'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx', ['Cx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy', ['Cy'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz', ['Cz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('1', [])))),
 ('sp', 'sp', 'sp', 's'): ({'Px': '(B10 + pow(Cx,2))',
                            'Py': '(B10 + pow(Cy,2))',
                            'Pz': '(B10 + pow(Cz,2))',
                            'Qy': '(Cy*Dy + B00)',
                            'f2': 'Cz*Dz',
                            'f5': 'Cx*Dx',
                            'f9': 'Cy*Dy',
                            'sx': '(Cx + xij)',
                            'sy': '(Cy + yij)',
                            'sz': '(Cz + zij)'},
                           ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('(B00*(yij + 2*Cy) + f9*yij + Dy*Py)',
                              ['Dy', 'Py', 'yij', 'B00', 'f9', 'Cy'])),
                            (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('(f5*xij + Dx*Px + B00*(xij + 2*Cx))',
                              ['Dx', 'Cx', 'Px', 'f5', 'xij', 'B00'])),
                            (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cy*(B00 + f5 + Dx*xij)',
                              ['Dx', 'B00', 'xij', 'Cy', 'f5'])),
                            (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cz*(B00 + f5 + Dx*xij)',
                              ['f5', 'Dx', 'Cz', 'xij', 'B00'])),
                            (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('(B00 + f5 + Dx*xij)',
                              ['Dx', 'B00', 'xij', 'f5'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('(Dz*Pz + B00*(2*Cz + zij) + f2*zij)',
                              ['Cz', 'zij', 'f2', 'Dz', 'B00', 'Pz'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('Cy*(B00 + Dz*zij + f2)',
                              ['Dz', 'zij', 'B00', 'f2', 'Cy'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('Cx*(B00 + Dz*zij + f2)',
                              ['Dz', 'zij', 'B00', 'Cx', 'f2'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('(B00 + Dz*zij + f2)',
                              ['Dz', 'zij', 'B00', 'f2'])),
                            (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cx*(Dy*yij + Qy)',
                              ['Dy', 'Qy', 'Cx', 'yij'])),
                            (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cz*(Dy*yij + Qy)',
                              ['Dy', 'Cz', 'Qy', 'yij'])),
                            (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('(Dy*yij + Qy)', ['Dy', 'Qy', 'yij'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*(B10 + Cx*sx)',
                              ['Dz', 'B10', 'Cx', 'sx'])),
                            (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Dy*(B10 + Cx*sx)',
                              ['Dy', 'B10', 'Cx', 'sx'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('(B10 + Cx*sx)', ['B10', 'Cx', 'sx'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*(B10 + Cy*sy)',
                              ['Dz', 'B10', 'sy', 'Cy'])),
                            (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('Dx*(B10 + Cy*sy)',
                              ['Dx', 'B10', 'Cy', 'sy'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('(B10 + Cy*sy)', ['B10', 'sy', 'Cy'])),
                            (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Dy*(B10 + Cz*sz)',
                              ['Dy', 'B10', 'Cz', 'sz'])),
                            (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('Dx*(B10 + Cz*sz)',
                              ['Dx', 'Cz', 'B10', 'sz'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('(B10 + Cz*sz)', ['B10', 'Cz', 'sz'])),
                            (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cz*Dx*sy', ['Dx', 'Cz', 'sy'])),
                            (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cz*Dx', ['Dx', 'Cz'])),
                            (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cz*Dy', ['Dy', 'Cz'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('Cy*sz', ['sz', 'Cy'])),
                            (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('sz*(B00 + f5)', ['f5', 'sz', 'B00'])),
                            (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('(B00 + f5)', ['B00', 'f5'])),
                            (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('sy*(B00 + f5)', ['B00', 'sy', 'f5'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('sy*(B00 + f2)', ['B00', 'f2', 'sy'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('sx*(B00 + f2)', ['B00', 'sx', 'f2'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('(B00 + f2)', ['B00', 'f2'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cx*sy', ['Cx', 'sy'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('Cx*sz', ['sz', 'Cx'])),
                            (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Qy*sz', ['sz', 'Qy'])),
                            (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Qy*sx', ['Qy', 'sx'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cy*sx', ['sx', 'Cy'])),
                            (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cy*Dx', ['Dx', 'Cy'])),
                            (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('Cy*Dx*sz', ['Dx', 'sz', 'Cy'])),
                            (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('Dx*sz', ['Dx', 'sz'])),
                            (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Dy*sz', ['Dy', 'sz'])),
                            (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Cx*Dy*sz', ['Dy', 'sz', 'Cx'])),
                            (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cx*Dy', ['Dy', 'Cx'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cx*Dz', ['Dz', 'Cx'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cx*Dz*sy', ['Dz', 'Cx', 'sy'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*sy', ['Dz', 'sy'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cy*Dz', ['Dz', 'Cy'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cy*Dz*sx', ['Dz', 'sx', 'Cy'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*sx', ['Dz', 'sx'])),
                            (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Dy*sx', ['Dy', 'sx'])),
                            (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cz*Dy*sx', ['Dy', 'Cz', 'sx'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cz*sx', ['Cz', 'sx'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cz*sy', ['Cz', 'sy'])),
                            (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('Dx*sy', ['Dx', 'sy'])),
                            (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Dx', ['Dx'])),
                            (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Dy', ['Dy'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz', ['Dz'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('sx', ['sx'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('sy', ['sy'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('sz', ['sz'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cx', ['Cx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cy', ['Cy'])),
                            (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Qy', ['Qy'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cz', ['Cz'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('1', []))))}
