# quadrature expressions: Q[ShellQuartet] = ( {Symbol:Expressions},
# ((i, j, k, l), (Expression, [Symbols])))
{('d', 'd', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f1': '(Dz*Pz + 2*B00*Cz)',
                         'f10': '(3*pow(B10,2) + pow(Cz,2)*pow(Iz,2) + B10*(6*Cz*Zij + pow(Zij,2) + 6*pow(Cz,2)))',
                         'f11': '(B00*(Iz*(3*Cz + Zij) + 3*B10) + Dz*(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2)))',
                         'f12': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'f13': '(3*pow(B10,2) + B10*(6*Cx*Xij + pow(Xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(Ix,2))',
                         'f14': '(Dy*(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij)) + B00*(3*B10 + Iy*(3*Cy + Yij)))',
                         'f2': '(Dz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)) + 3*B00*Pz + 2*B00*Cz*Zij)',
                         'f20': '(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                         'f21': '(3*pow(B10,2) + B10*(6*Cy*Yij + pow(Yij,2) + 6*pow(Cy,2)) + pow(Cy,2)*pow(Iy,2))',
                         'f22': '(Cy*Iy + B10)',
                         'f23': '(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                         'f24': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f25': '(B00*(3*B10 + Ix*(3*Cx + Xij)) + Dx*(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2)))',
                         'f28': '(B10 + pow(Iy,2))',
                         'f29': '(B10 + pow(Iz,2))',
                         'f37': '(2*B00*Cy*Yij + 3*B00*Py + Dy*(B10*(3*Cy + Yij) + Iy*pow(Cy,2)))',
                         'f38': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f39': '(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                         'f4': '(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                         'f5': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                         'f6': '(Dx*Px + 2*B00*Cx)',
                         'f9': '(Dy*Py + 2*B00*Cy)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((1, 1, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*(Qx*Xij + f6)',
                           ['f6', 'Qx', 'Iz', 'Cy', 'Xij'])),
                         (((0, 1, 1), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*(Cz*Zij + Pz)*(Dx*Xij + Qx)',
                           ['Dx', 'Xij', 'Zij', 'Cz', 'Pz', 'Qx', 'Cy'])),
                         (((1, 0, 1), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*(Px + Cx*Xij)*(Cz*Zij + Pz)',
                           ['Cx', 'Px', 'Zij', 'Dy', 'Xij', 'Cz', 'Pz'])),
                         (((1, 0, 1), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Iy*(f1 + Qz*Zij)',
                           ['Zij', 'f1', 'Iy', 'Cx', 'Qz'])),
                         (((1, 0, 1), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('(Px + Cx*Xij)*(f1 + Qz*Zij)',
                           ['f1', 'Cx', 'Px', 'Zij', 'Qz', 'Xij'])),
                         (((1, 1, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*(Px + Cx*Xij)*(Dz*Zij + Qz)',
                           ['Px', 'Xij', 'Zij', 'Qz', 'Dz', 'Cy', 'Cx'])),
                         (((0, 1, 1), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Qz*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cx', 'Px', 'Qz', 'Cy', 'Xij'])),
                         (((1, 0, 1), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Iy*Qz*(Px + Cx*Xij)',
                           ['Xij', 'Iy', 'Qz', 'Px', 'Cx'])),
                         (((1, 1, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f22*(Px + Cx*Xij)',
                           ['Dz', 'f22', 'Cx', 'Px', 'Xij'])),
                         (((0, 2, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Py*(Xij*(Xij + 2*Cx) + Px)',
                           ['Dz', 'Px', 'Py', 'Xij', 'Cx'])),
                         (((0, 2, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Ix*Py*(Dz*Zij + Qz)',
                           ['Dz', 'Zij', 'Ix', 'Py', 'Qz'])),
                         (((2, 0, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('Iy*Px*(Dz*Zij + Qz)',
                           ['Dz', 'Zij', 'Iy', 'Qz', 'Px'])),
                         (((1, 1, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*f22*(Dz*Zij + Qz)',
                           ['Dz', 'Zij', 'f22', 'Cx', 'Qz'])),
                         (((0, 0, 2), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('(Dz*(3*pow(B10,2) + pow(Cz,2)*pow(Iz,2) + B10*(6*Cz*Zij + pow(Zij,2) + 6*pow(Cz,2))) + 2*B00*(2*Cz + Zij)*(3*B10 + Cz*Iz))',
                           ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz'])),
                         (((0, 1, 1), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('f22*(f1 + Qz*Zij)', ['Zij', 'f1', 'f22', 'Qz'])),
                         (((0, 2, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('Py*(Zij*(2*B00 + Dz*(2*Cz + Zij)) + f1)',
                           ['f1', 'Cz', 'Zij', 'Py', 'Dz', 'B00'])),
                         (((2, 0, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('Px*(Zij*(2*B00 + Dz*(2*Cz + Zij)) + f1)',
                           ['f1', 'Px', 'Zij', 'Dz', 'B00', 'Cz'])),
                         (((0, 1, 1), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Ix*(f1 + Qz*Zij)',
                           ['Zij', 'f1', 'Ix', 'Qz', 'Cy'])),
                         (((1, 1, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Cy*(Zij*(2*B00 + Dz*(2*Cz + Zij)) + f1)',
                           ['f1', 'Cx', 'Cz', 'Zij', 'Dz', 'B00', 'Cy'])),
                         (((1, 0, 1), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Cz*(Yij*(2*B00 + Dy*(Yij + 2*Cy)) + f9)',
                           ['B00', 'Cx', 'Dy', 'Yij', 'Cz', 'f9', 'Cy'])),
                         (((0, 2, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('(2*B00*(Yij + 2*Cy)*(3*B10 + Cy*Iy) + Dy*(3*pow(B10,2) + B10*(6*Cy*Yij + pow(Yij,2) + 6*pow(Cy,2)) + pow(Cy,2)*pow(Iy,2)))',
                           ['B10', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                         (((0, 0, 2), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('Pz*(Yij*(2*B00 + Dy*(Yij + 2*Cy)) + f9)',
                           ['Dy', 'Yij', 'B00', 'Pz', 'f9', 'Cy'])),
                         (((2, 0, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('Px*(Yij*(2*B00 + Dy*(Yij + 2*Cy)) + f9)',
                           ['Px', 'Dy', 'Yij', 'B00', 'f9', 'Cy'])),
                         (((2, 0, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*Px*(Dy*Yij + Qy)',
                           ['Dy', 'Qy', 'Iz', 'Px', 'Yij'])),
                         (((1, 1, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*Qy*(Px + Cx*Xij)',
                           ['Xij', 'Qy', 'Iz', 'Px', 'Cx'])),
                         (((0, 1, 1), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Qy*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cz', 'Qy', 'Cx', 'Xij', 'Px'])),
                         (((1, 0, 1), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*(Px + Cx*Xij)*(Dy*Yij + Qy)',
                           ['Cx', 'Px', 'Dy', 'Xij', 'Yij', 'Cz', 'Qy'])),
                         (((1, 0, 1), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*(Cz*Zij + Pz)*(Dy*Yij + Qy)',
                           ['Cx', 'Zij', 'Dy', 'Yij', 'Cz', 'Pz', 'Qy'])),
                         (((0, 1, 1), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Ix*Qy*(Cz*Zij + Pz)',
                           ['Zij', 'Pz', 'Ix', 'Qy', 'Cz'])),
                         (((0, 1, 1), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f22*(Cz*Zij + Pz)',
                           ['Zij', 'Dx', 'f22', 'Pz', 'Cz'])),
                         (((1, 0, 1), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('(Cz*Zij + Pz)*(Qx*Xij + f6)',
                           ['Xij', 'Zij', 'f6', 'Cz', 'Pz', 'Qx'])),
                         (((1, 0, 1), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*(Qx*Xij + f6)',
                           ['Qx', 'f6', 'Cz', 'Iy', 'Xij'])),
                         (((0, 1, 1), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*(Xij*(2*B00 + Dx*(Xij + 2*Cx)) + f6)',
                           ['Dx', 'B00', 'Cx', 'Xij', 'f6', 'Cz', 'Cy'])),
                         (((2, 0, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(2*B00*(Xij + 2*Cx)*(Cx*Ix + 3*B10) + Dx*(3*pow(B10,2) + B10*(6*Cx*Xij + pow(Xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(Ix,2)))',
                           ['B10', 'Ix', 'Cx', 'Xij', 'Dx', 'B00'])),
                         (((1, 1, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('f22*(Qx*Xij + f6)', ['Qx', 'f6', 'f22', 'Xij'])),
                         (((0, 0, 2), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Pz*(Xij*(2*B00 + Dx*(Xij + 2*Cx)) + f6)',
                           ['Dx', 'Cx', 'Xij', 'f6', 'B00', 'Pz'])),
                         (((0, 2, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Py*(Xij*(2*B00 + Dx*(Xij + 2*Cx)) + f6)',
                           ['Dx', 'Cx', 'Xij', 'Py', 'f6', 'B00'])),
                         (((0, 2, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*Py*(Dx*Xij + Qx)',
                           ['Dx', 'Qx', 'Iz', 'Xij', 'Py'])),
                         (((0, 1, 1), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*f22*(Dx*Xij + Qx)',
                           ['Qx', 'Dx', 'Cz', 'f22', 'Xij'])),
                         (((0, 0, 2), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*Pz*(Dx*Xij + Qx)',
                           ['Pz', 'Dx', 'Qx', 'Iy', 'Xij'])),
                         (((1, 0, 1), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iy*Qx*(Cz*Zij + Pz)',
                           ['Zij', 'Pz', 'Qx', 'Iy', 'Cz'])),
                         (((0, 1, 1), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('f5*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'f5'])),
                         (((0, 1, 1), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Ix*f5', ['Cz', 'Ix', 'f5'])),
                         (((0, 0, 2), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*Pz*(Dy*Yij + Qy)',
                           ['Dy', 'Ix', 'Pz', 'Qy', 'Yij'])),
                         (((0, 0, 2), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('f38*(Dy*Yij + Qy)', ['Dy', 'f38', 'Qy', 'Yij'])),
                         (((2, 0, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('f24*(Dy*Yij + Qy)', ['Yij', 'f24', 'Qy', 'Dy'])),
                         (((2, 0, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Iz*f24', ['Dy', 'Iz', 'f24'])),
                         (((0, 2, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Ix*Iz*f9', ['f9', 'Ix', 'Iz'])),
                         (((0, 0, 2), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Ix*f38', ['Dy', 'Ix', 'f38'])),
                         (((1, 0, 1), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*f20', ['Dy', 'Cx', 'f20'])),
                         (((0, 0, 2), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Pz*(Xij*(Xij + 2*Cx) + Px)',
                           ['Dy', 'Pz', 'Cx', 'Xij', 'Px'])),
                         (((0, 0, 2), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('f1*(Xij*(Xij + 2*Cx) + Px)',
                           ['f1', 'Px', 'Cx', 'Xij'])),
                         (((0, 2, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('f9*(Xij*(Xij + 2*Cx) + Px)',
                           ['f9', 'Px', 'Cx', 'Xij'])),
                         (((1, 1, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('f5*(Px + Cx*Xij)', ['Xij', 'Cx', 'Px', 'f5'])),
                         (((1, 1, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Iz*f5', ['f5', 'Cx', 'Iz'])),
                         (((1, 1, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Qy*f29', ['Qy', 'Cx', 'f29'])),
                         (((2, 0, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Px*f29', ['Dy', 'f29', 'Px'])),
                         (((1, 0, 1), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*f4', ['f4', 'Dy', 'Cz'])),
                         (((1, 1, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*f4', ['Dz', 'f4', 'Cy'])),
                         (((2, 0, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Px*f28', ['Dz', 'f28', 'Px'])),
                         (((1, 1, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*f23', ['Dz', 'f23', 'Cx'])),
                         (((1, 0, 1), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Qz*f28', ['f28', 'Cx', 'Qz'])),
                         (((0, 2, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('f12*(Dz*Zij + Qz)', ['Dz', 'Zij', 'f12', 'Qz'])),
                         (((2, 0, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('f24*(Dz*Zij + Qz)', ['Dz', 'f24', 'Qz', 'Zij'])),
                         (((2, 0, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Iy*f24', ['Dz', 'f24', 'Iy'])),
                         (((0, 2, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Ix*f12', ['Dz', 'Ix', 'f12'])),
                         (((0, 0, 2), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Ix*Iy*f1', ['f1', 'Ix', 'Iy'])),
                         (((0, 1, 1), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Ix*Qz*f22', ['Ix', 'f22', 'Qz'])),
                         (((1, 1, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*Qx*f22', ['Qx', 'f22', 'Iz'])),
                         (((2, 0, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iy*Iz*f6', ['f6', 'Iy', 'Iz'])),
                         (((0, 0, 2), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iy*f38', ['f38', 'Dx', 'Iy'])),
                         (((0, 0, 2), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('f38*(Dx*Xij + Qx)', ['Dx', 'Qx', 'f38', 'Xij'])),
                         (((0, 2, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('f12*(Dx*Xij + Qx)', ['Dx', 'Qx', 'f12', 'Xij'])),
                         (((0, 2, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iz*f12', ['Dx', 'f12', 'Iz'])),
                         (((0, 1, 1), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*f20', ['Dx', 'f20', 'Cy'])),
                         (((1, 1, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Qx*f29', ['Qx', 'f29', 'Cy'])),
                         (((0, 2, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Py*f29', ['Dx', 'Py', 'f29'])),
                         (((0, 1, 1), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*f23', ['Dx', 'Cz', 'f23'])),
                         (((1, 0, 1), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Qx*f28', ['Qx', 'Cz', 'f28'])),
                         (((0, 0, 2), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Pz*f28', ['Dx', 'Pz', 'f28'])),
                         (((0, 2, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f21', ['Dx', 'f21'])),
                         (((0, 0, 2), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f10', ['Dx', 'f10'])),
                         (((0, 0, 2), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f10', ['Dy', 'f10'])),
                         (((2, 0, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f13', ['Dy', 'f13'])),
                         (((2, 0, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f13', ['Dz', 'f13'])),
                         (((0, 2, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f21', ['Dz', 'f21'])),
                         (((0, 2, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('f29*f9', ['f9', 'f29'])),
                         (((2, 0, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('f29*f6', ['f6', 'f29'])),
                         (((2, 0, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('f28*f6', ['f6', 'f28'])),
                         (((0, 0, 2), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('f1*f28', ['f1', 'f28'])),
                         (((1, 0, 1), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*f4', ['f4', 'Qz'])),
                         (((1, 1, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Qy*f4', ['f4', 'Qy'])),
                         (((0, 1, 1), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('Qy*f20', ['Qy', 'f20'])),
                         (((1, 0, 1), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('Qx*f20', ['Qx', 'f20'])),
                         (((1, 1, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('Qx*f23', ['Qx', 'f23'])),
                         (((0, 1, 1), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*f23', ['f23', 'Qz'])),
                         (((1, 1, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*f25', ['f25', 'Cy'])),
                         (((1, 0, 1), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*f25', ['f25', 'Cz'])),
                         (((0, 1, 1), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*f14', ['f14', 'Cz'])),
                         (((1, 1, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*f14', ['f14', 'Cx'])),
                         (((1, 0, 1), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('Cx*f11', ['Cx', 'f11'])),
                         (((0, 1, 1), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('Cy*f11', ['f11', 'Cy'])),
                         (((2, 0, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*f39', ['f39', 'Iy'])),
                         (((2, 0, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*f39', ['f39', 'Iz'])),
                         (((0, 2, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*f37', ['f37', 'Iz'])),
                         (((0, 2, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*f37', ['f37', 'Ix'])),
                         (((0, 0, 2), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Ix*f2', ['Ix', 'f2'])),
                         (((0, 0, 2), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('Iy*f2', ['Iy', 'f2'])))),
 ('d', 'd', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f1': '(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                         'f10': '(B10 + pow(Iz,2))',
                         'f11': '3*pow(B10,2)',
                         'f15': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f3': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'f6': '(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                         'f7': '(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                         'f8': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f9': '(B10 + pow(Iy,2))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 1, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('(Py + Cy*Yij)*(Cz*Zij + Pz)',
                           ['Zij', 'Py', 'Yij', 'Cz', 'Pz', 'Cy'])),
                         (((0, 1, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*(Py + Cy*Yij)',
                           ['Yij', 'Cz', 'Py', 'Ix', 'Cy'])),
                         (((1, 1, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*(Py + Cy*Yij)',
                           ['Yij', 'Cy', 'Cx', 'Py', 'Iz'])),
                         (((1, 1, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*(Px + Cx*Xij)',
                           ['Xij', 'Px', 'Iz', 'Cy', 'Cx'])),
                         (((1, 0, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(Px + Cx*Xij)*(Cz*Zij + Pz)',
                           ['Cx', 'Px', 'Zij', 'Xij', 'Cz', 'Pz'])),
                         (((1, 0, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*(Cz*Zij + Pz)',
                           ['Zij', 'Pz', 'Cz', 'Iy', 'Cx'])),
                         (((1, 0, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*(Px + Cx*Xij)',
                           ['Cz', 'Iy', 'Cx', 'Px', 'Xij'])),
                         (((0, 1, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cz', 'Px', 'Xij', 'Cy', 'Cx'])),
                         (((1, 1, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(Px + Cx*Xij)*(Py + Cy*Yij)',
                           ['Cx', 'Px', 'Py', 'Xij', 'Yij', 'Cy'])),
                         (((0, 2, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*(Xij*(Xij + 2*Cx) + Px)',
                           ['Px', 'Py', 'Xij', 'Cx'])),
                         (((0, 0, 2), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*(Xij*(Xij + 2*Cx) + Px)',
                           ['Pz', 'Cx', 'Xij', 'Px'])),
                         (((2, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(f11 + B10*(6*Cx*Xij + pow(Xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(Ix,2))',
                           ['B10', 'Ix', 'f11', 'Xij', 'Cx'])),
                         (((0, 2, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(6*Cy*Yij + pow(Yij,2) + 6*pow(Cy,2)) + f11 + pow(Cy,2)*pow(Iy,2))',
                           ['Yij', 'B10', 'Iy', 'f11', 'Cy'])),
                         (((0, 0, 2), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('(f11 + pow(Cz,2)*pow(Iz,2) + B10*(6*Cz*Zij + pow(Zij,2) + 6*pow(Cz,2)))',
                           ['Zij', 'B10', 'Cz', 'f11', 'Iz'])),
                         (((0, 1, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*(Cz*Zij + Pz)',
                           ['Zij', 'Ix', 'Pz', 'Cy', 'Cz'])),
                         (((0, 0, 2), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iy*Pz', ['Pz', 'Ix', 'Iy'])),
                         (((0, 2, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iz*Py', ['Ix', 'Iz', 'Py'])),
                         (((2, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Iz*Px', ['Iy', 'Iz', 'Px'])),
                         (((1, 1, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*f10', ['f10', 'Cx', 'Cy'])),
                         (((1, 0, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*f9', ['f9', 'Cz', 'Cx'])),
                         (((0, 0, 2), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f9', ['f9', 'Pz'])),
                         (((2, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*f9', ['f9', 'Px'])),
                         (((2, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Px*f10', ['f10', 'Px'])),
                         (((0, 2, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Py*f10', ['Py', 'f10'])),
                         (((1, 1, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f1', ['f1', 'Cy'])),
                         (((1, 0, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f1', ['f1', 'Cz'])),
                         (((0, 1, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f7', ['f7', 'Cz'])),
                         (((1, 1, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f7', ['f7', 'Cx'])),
                         (((1, 0, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f6', ['f6', 'Cx'])),
                         (((0, 1, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((0, 0, 2), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f15', ['f15', 'Ix'])),
                         (((0, 2, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f3', ['Ix', 'f3'])),
                         (((0, 2, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f3', ['Iz', 'f3'])),
                         (((2, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f8', ['f8', 'Iz'])),
                         (((2, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f8', ['f8', 'Iy'])),
                         (((0, 0, 2), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f15', ['f15', 'Iy'])))),
 ('d', 'd', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f1': '(Dz*Pz + 2*B00*Cz)',
                          'f11': '(Dz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)) + 3*B00*Pz + 2*B00*Cz*Zij)',
                          'f12': '(B00 + Dz*Iz)',
                          'f15': '(B00*(3*B10 + Ix*(3*Cx + Xij)) + Dx*(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2)))',
                          'f17': '(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                          'f18': '(B10 + pow(Iy,2))',
                          'f2': '(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                          'f22': '(2*B00*Cy*Yij + 3*B00*Py + Dy*(B10*(3*Cy + Yij) + Iy*pow(Cy,2)))',
                          'f25': '(B00*(Iz*(3*Cz + Zij) + 3*B10) + Dz*(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2)))',
                          'f27': '(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                          'f28': '(Cy*Iy + B10)',
                          'f29': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                          'f3': '(3*pow(B10,2) + pow(Cz,2)*pow(Iz,2) + B10*(6*Cz*Zij + pow(Zij,2) + 6*pow(Cz,2)))',
                          'f30': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                          'f35': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                          'f36': '(Dy*Py + 2*B00*Cy)',
                          'f37': '(Dy*(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij)) + B00*(3*B10 + Iy*(3*Cy + Yij)))',
                          'f38': '3*pow(B10,2)',
                          'f4': '(3*pow(B10,2) + B10*(6*Cx*Xij + pow(Xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(Ix,2))',
                          'f41': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                          'f5': '(3*pow(B10,2) + B10*(6*Cy*Yij + pow(Yij,2) + 6*pow(Cy,2)) + pow(Cy,2)*pow(Iy,2))',
                          'f6': '(2*B00*Iy + Dy*(B10 + pow(Iy,2)))',
                          'f7': '(Dx*Px + 2*B00*Cx)',
                          'f8': '(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 0, 1), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(Px + Cx*Xij)*(f1 + Qz*Zij)',
                            ['f1', 'Cx', 'Px', 'Zij', 'Qz', 'Xij'])),
                          (((0, 1, 1), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Ix*(f1 + Qz*Zij)',
                            ['Zij', 'f1', 'Ix', 'Qz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*(Zij*(2*B00 + Dz*(2*Cz + Zij)) + f1)',
                            ['f1', 'Cx', 'Cz', 'Zij', 'Dz', 'B00', 'Cy'])),
                          (((1, 0, 1), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Iy*(f1 + Qz*Zij)',
                            ['Zij', 'f1', 'Iy', 'Cx', 'Qz'])),
                          (((2, 0, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(2*B00*(Xij + 2*Cx)*(Cx*Ix + 3*B10) + Dx*(f38 + B10*(6*Cx*Xij + pow(Xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(Ix,2)))',
                            ['B10', 'Ix', 'f38', 'Cx', 'Xij', 'Dx', 'B00'])),
                          (((0, 2, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('(2*B00*(Yij + 2*Cy)*(3*B10 + Cy*Iy) + Dy*(B10*(6*Cy*Yij + pow(Yij,2) + 6*pow(Cy,2)) + f38 + pow(Cy,2)*pow(Iy,2)))',
                            ['B10', 'f38', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                          (((0, 0, 2), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('(2*B00*(2*Cz + Zij)*(3*B10 + Cz*Iz) + Dz*(f38 + pow(Cz,2)*pow(Iz,2) + B10*(6*Cz*Zij + pow(Zij,2) + 6*pow(Cz,2))))',
                            ['B10', 'f38', 'Cz', 'Zij', 'Dz', 'B00', 'Iz'])),
                          (((0, 2, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('Py*(Zij*(2*B00 + Dz*(2*Cz + Zij)) + f1)',
                            ['f1', 'Cz', 'Zij', 'Py', 'Dz', 'B00'])),
                          (((2, 0, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('Px*(Zij*(2*B00 + Dz*(2*Cz + Zij)) + f1)',
                            ['f1', 'Px', 'Zij', 'Dz', 'B00', 'Cz'])),
                          (((0, 1, 1), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('f28*(f1 + Qz*Zij)',
                            ['Zij', 'f1', 'f28', 'Qz'])),
                          (((0, 1, 1), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*(Cz*Zij + Pz)*(Dx*Xij + Qx)',
                            ['Dx', 'Xij', 'Zij', 'Cz', 'Pz', 'Qx', 'Cy'])),
                          (((0, 2, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*Py*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'Iz', 'Xij', 'Py'])),
                          (((1, 1, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*(Qx*Xij + f7)',
                            ['f7', 'Qx', 'Iz', 'Cy', 'Xij'])),
                          (((1, 0, 1), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*(Qx*Xij + f7)',
                            ['Qx', 'f7', 'Cz', 'Iy', 'Xij'])),
                          (((0, 1, 1), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*(Xij*(2*B00 + Dx*(Xij + 2*Cx)) + f7)',
                            ['Dx', 'B00', 'Cx', 'Xij', 'Cz', 'f7', 'Cy'])),
                          (((1, 1, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('f28*(Qx*Xij + f7)',
                            ['f7', 'Qx', 'f28', 'Xij'])),
                          (((0, 2, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Py*(Xij*(2*B00 + Dx*(Xij + 2*Cx)) + f7)',
                            ['Dx', 'Cx', 'Xij', 'Py', 'B00', 'f7'])),
                          (((0, 0, 2), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Pz*(Xij*(2*B00 + Dx*(Xij + 2*Cx)) + f7)',
                            ['Dx', 'Cx', 'Xij', 'B00', 'Pz', 'f7'])),
                          (((1, 0, 1), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('(Cz*Zij + Pz)*(Qx*Xij + f7)',
                            ['Xij', 'Zij', 'Cz', 'Pz', 'f7', 'Qx'])),
                          (((1, 0, 1), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*(Cz*Zij + Pz)*(Dy*Yij + Qy)',
                            ['Cx', 'Zij', 'Dy', 'Yij', 'Cz', 'Pz', 'Qy'])),
                          (((0, 0, 2), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Pz*(Dy*Yij + Qy)',
                            ['Dy', 'Ix', 'Pz', 'Qy', 'Yij'])),
                          (((2, 0, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*Px*(Dy*Yij + Qy)',
                            ['Dy', 'Qy', 'Iz', 'Px', 'Yij'])),
                          (((2, 0, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('f29*(Dy*Yij + Qy)',
                            ['Dy', 'Qy', 'f29', 'Yij'])),
                          (((0, 0, 2), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('f41*(Dy*Yij + Qy)',
                            ['Dy', 'f41', 'Qy', 'Yij'])),
                          (((1, 0, 1), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*(Px + Cx*Xij)*(Dy*Yij + Qy)',
                            ['Cx', 'Px', 'Dy', 'Xij', 'Yij', 'Cz', 'Qy'])),
                          (((1, 0, 1), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*(Px + Cx*Xij)*(Cz*Zij + Pz)',
                            ['Cx', 'Px', 'Zij', 'Dy', 'Xij', 'Cz', 'Pz'])),
                          (((1, 0, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(Px + Cx*Xij)*(Cz*Zij + Pz)',
                            ['Cx', 'Px', 'Zij', 'Xij', 'Cz', 'Pz'])),
                          (((1, 1, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f12*(Px + Cx*Xij)',
                            ['Xij', 'f12', 'Px', 'Cy', 'Cx'])),
                          (((1, 0, 1), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*Qz*(Px + Cx*Xij)',
                            ['Xij', 'Iy', 'Qz', 'Px', 'Cx'])),
                          (((0, 1, 1), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Qz*(Xij*(Xij + 2*Cx) + Px)',
                            ['Cx', 'Px', 'Qz', 'Cy', 'Xij'])),
                          (((1, 1, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*(Px + Cx*Xij)',
                            ['Xij', 'Px', 'Iz', 'Cy', 'Cx'])),
                          (((1, 1, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*Qy*(Px + Cx*Xij)',
                            ['Xij', 'Qy', 'Iz', 'Px', 'Cx'])),
                          (((0, 1, 1), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Qy*(Xij*(Xij + 2*Cx) + Px)',
                            ['Cz', 'Qy', 'Cx', 'Xij', 'Px'])),
                          (((1, 0, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*(Px + Cx*Xij)',
                            ['Cz', 'Iy', 'Cx', 'Px', 'Xij'])),
                          (((0, 1, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*(Xij*(Xij + 2*Cx) + Px)',
                            ['Cz', 'Px', 'Xij', 'Cy', 'Cx'])),
                          (((1, 1, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('f30*(Px + Cx*Xij)',
                            ['f30', 'Cx', 'Px', 'Xij'])),
                          (((0, 2, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('f36*(Xij*(Xij + 2*Cx) + Px)',
                            ['f36', 'Px', 'Cx', 'Xij'])),
                          (((0, 0, 2), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Pz*(Xij*(Xij + 2*Cx) + Px)',
                            ['Dy', 'Pz', 'Cx', 'Xij', 'Px'])),
                          (((0, 0, 2), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*(Xij*(Xij + 2*Cx) + Px)',
                            ['Pz', 'Cx', 'Xij', 'Px'])),
                          (((1, 1, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('f28*(Px + Cx*Xij)',
                            ['Xij', 'f28', 'Px', 'Cx'])),
                          (((1, 1, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f28*(Px + Cx*Xij)',
                            ['Dz', 'Xij', 'f28', 'Px', 'Cx'])),
                          (((0, 2, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Py*(Xij*(Xij + 2*Cx) + Px)',
                            ['Dz', 'Px', 'Py', 'Xij', 'Cx'])),
                          (((0, 2, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Xij*(Xij + 2*Cx) + Px)',
                            ['Px', 'Py', 'Xij', 'Cx'])),
                          (((0, 0, 2), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('f1*(Xij*(Xij + 2*Cx) + Px)',
                            ['f1', 'Px', 'Cx', 'Xij'])),
                          (((1, 0, 1), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*f6', ['f6', 'Cz', 'Cx'])),
                          (((0, 2, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Iz*f36', ['f36', 'Ix', 'Iz'])),
                          (((1, 1, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Iz*f30', ['f30', 'Cx', 'Iz'])),
                          (((1, 1, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*f8', ['Dz', 'f8', 'Cx'])),
                          (((1, 0, 1), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Qz*f18', ['Cx', 'f18', 'Qz'])),
                          (((1, 0, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz*f18', ['Cz', 'Cx', 'f18'])),
                          (((1, 0, 1), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Qx*f18', ['Qx', 'Cz', 'f18'])),
                          (((0, 1, 1), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f28*(Dx*Xij + Qx)',
                            ['Qx', 'Dx', 'Cz', 'f28', 'Xij'])),
                          (((0, 0, 2), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Pz*(Dx*Xij + Qx)',
                            ['Pz', 'Dx', 'Qx', 'Iy', 'Xij'])),
                          (((0, 0, 2), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('f41*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'f41', 'Xij'])),
                          (((0, 2, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('f35*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'Xij', 'f35'])),
                          (((0, 2, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz*f35', ['Dx', 'Iz', 'f35'])),
                          (((0, 2, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix*f35', ['Dz', 'Ix', 'f35'])),
                          (((0, 1, 1), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Qz*f28', ['Ix', 'Qz', 'f28'])),
                          (((0, 2, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Py*f12', ['Ix', 'f12', 'Py'])),
                          (((0, 2, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iz*Py', ['Ix', 'Iz', 'Py'])),
                          (((2, 0, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Iz*f7', ['f7', 'Iy', 'Iz'])),
                          (((2, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Iz*Px', ['Iy', 'Iz', 'Px'])),
                          (((2, 0, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('Iy*Px*f12', ['f12', 'Iy', 'Px'])),
                          (((0, 0, 2), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Iy*f1', ['f1', 'Ix', 'Iy'])),
                          (((0, 0, 2), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy*Pz', ['Pz', 'Ix', 'Iy'])),
                          (((0, 1, 1), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Qy*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Ix', 'Qy', 'Cz'])),
                          (((1, 1, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Qy*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'Pz', 'Cz', 'Qy', 'Cx'])),
                          (((1, 0, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Cz', 'Iy', 'Cx'])),
                          (((1, 0, 1), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Qx*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Qx', 'Iy', 'Cz'])),
                          (((1, 1, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Qx*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'Qx', 'Pz', 'Cy', 'Cz'])),
                          (((0, 1, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*(Cz*Zij + Pz)',
                            ['Zij', 'Ix', 'Pz', 'Cy', 'Cz'])),
                          (((1, 1, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'Cz', 'Pz', 'Cx', 'Cy'])),
                          (((0, 2, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('f36*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'f36', 'Cz', 'Pz'])),
                          (((2, 0, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('f7*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'f7', 'Cz', 'Pz'])),
                          (((0, 1, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('f28*(Cz*Zij + Pz)',
                            ['Zij', 'Cz', 'Pz', 'f28'])),
                          (((0, 1, 1), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f28*(Cz*Zij + Pz)',
                            ['Zij', 'Dx', 'Cz', 'Pz', 'f28'])),
                          (((0, 2, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Py*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'Dx', 'Cz', 'Pz', 'Py'])),
                          (((0, 2, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'Cz', 'Pz', 'Py'])),
                          (((2, 0, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Px*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'Dy', 'Cz', 'Pz', 'Px'])),
                          (((2, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Px*(Zij*(2*Cz + Zij) + Pz)',
                            ['Zij', 'Cz', 'Pz', 'Px'])),
                          (((0, 1, 1), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('f30*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Cz', 'f30'])),
                          (((0, 1, 1), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Ix*f30', ['Cz', 'f30', 'Ix'])),
                          (((0, 1, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*f28', ['Cz', 'f28', 'Ix'])),
                          (((1, 1, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*Qx*f28', ['Qx', 'Iz', 'f28'])),
                          (((1, 1, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz*f28', ['f28', 'Cx', 'Iz'])),
                          (((1, 1, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f12*f28', ['f12', 'Cx', 'f28'])),
                          (((1, 1, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f15', ['f15', 'Cy'])),
                          (((1, 0, 1), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f15', ['f15', 'Cz'])),
                          (((2, 0, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('Px*f6', ['f6', 'Px'])),
                          (((0, 0, 2), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('Pz*f6', ['f6', 'Pz'])),
                          (((1, 1, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*f37', ['f37', 'Cx'])),
                          (((0, 1, 1), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*f37', ['f37', 'Cz'])),
                          (((0, 1, 1), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('Qy*f27', ['f27', 'Qy'])),
                          (((1, 1, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy*f2', ['Qy', 'f2'])),
                          (((1, 0, 1), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f2', ['Qz', 'f2'])),
                          (((2, 0, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('f18*f7', ['f7', 'f18'])),
                          (((0, 0, 2), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Pz*f18', ['Dx', 'Pz', 'f18'])),
                          (((0, 0, 2), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*f18', ['Pz', 'f18'])),
                          (((2, 0, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Px*f18', ['Dz', 'f18', 'Px'])),
                          (((2, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px*f18', ['f18', 'Px'])),
                          (((0, 0, 2), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('f1*f18', ['f1', 'f18'])),
                          (((1, 1, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f8', ['Qx', 'f8'])),
                          (((1, 0, 1), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f27', ['f27', 'Qx'])),
                          (((1, 0, 1), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*f27', ['f27', 'Dy', 'Cx'])),
                          (((1, 0, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f27', ['f27', 'Cx'])),
                          (((0, 1, 1), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*f27', ['f27', 'Dx', 'Cy'])),
                          (((0, 1, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f27', ['f27', 'Cy'])),
                          (((1, 1, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*f2', ['Dz', 'f2', 'Cy'])),
                          (((1, 1, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f2', ['f2', 'Cy'])),
                          (((1, 0, 1), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*f2', ['Dy', 'Cz', 'f2'])),
                          (((1, 0, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f2', ['Cz', 'f2'])),
                          (((0, 1, 1), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f8', ['Dx', 'Cz', 'f8'])),
                          (((0, 1, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f8', ['Cz', 'f8'])),
                          (((0, 1, 1), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f8', ['f8', 'Qz'])),
                          (((1, 1, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f8', ['f8', 'Cx'])),
                          (((1, 0, 1), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f25', ['f25', 'Cx'])),
                          (((0, 1, 1), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f25', ['f25', 'Cy'])),
                          (((2, 0, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('f12*f29', ['f12', 'f29'])),
                          (((0, 2, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*f22', ['Ix', 'f22'])),
                          (((0, 2, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*f22', ['f22', 'Iz'])),
                          (((2, 0, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*f17', ['Iz', 'f17'])),
                          (((2, 0, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*f17', ['Iy', 'f17'])),
                          (((0, 0, 2), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy*f41', ['f41', 'Dx', 'Iy'])),
                          (((0, 0, 2), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f41', ['f41', 'Iy'])),
                          (((0, 0, 2), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix*f41', ['Dy', 'Ix', 'f41'])),
                          (((0, 0, 2), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f41', ['Ix', 'f41'])),
                          (((0, 0, 2), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 2, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f35', ['Ix', 'f35'])),
                          (((0, 2, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('f12*f35', ['f12', 'f35'])),
                          (((0, 2, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f35', ['Iz', 'f35'])),
                          (((2, 0, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz*f29', ['Dy', 'Iz', 'f29'])),
                          (((2, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f29', ['Iz', 'f29'])),
                          (((2, 0, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy*f29', ['Dz', 'Iy', 'f29'])),
                          (((2, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f29', ['Iy', 'f29'])),
                          (((0, 0, 2), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('Iy*f11', ['Iy', 'f11'])),
                          (((2, 0, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f4', ['Dz', 'f4'])),
                          (((0, 2, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f5', ['Dz', 'f5'])),
                          (((0, 2, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f5', ['Dx', 'f5'])),
                          (((0, 0, 2), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f3', ['Dx', 'f3'])),
                          (((0, 0, 2), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f3', ['Dy', 'f3'])),
                          (((2, 0, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f4', ['f4', 'Dy'])),
                          (((2, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('f4', ['f4'])),
                          (((0, 2, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('f5', ['f5'])),
                          (((0, 0, 2), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('f3', ['f3'])))),
 ('d', 'p', 'd', 's'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f0': '(Iz*Rz + 2*B00*Dz)',
                         'f1': '(Dz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)) + 3*B00*Pz + 2*B00*Cz*Zij)',
                         'f12': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                         'f15': '(Cy*Iy + B10)',
                         'f16': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f17': '(2*B00*Dx + Cx*Rx)',
                         'f2': '(4*B00*Cy*Dy + Py*Ry + 2*pow(B00,2))',
                         'f20': '(2*B00*Dx*(Xij + 2*Cx) + Rx*(Cx*Ix + B10) + 2*pow(B00,2))',
                         'f22': '(Px*Rx + 2*pow(B00,2) + 4*B00*Cx*Dx)',
                         'f24': '(2*B00*Cy*Yij + 3*B00*Py + Dy*(B10*(3*Cy + Yij) + Iy*pow(Cy,2)))',
                         'f26': '(Dy*Iy + B00)',
                         'f29': '(Dx*Px + 2*B00*Cx)',
                         'f3': '(Dy*Py + 2*B00*Cy)',
                         'f30': '(2*B00*Dy + Iy*Ry)',
                         'f31': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f32': '(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                         'f33': '(2*B00*Dy + Cy*Ry)',
                         'f39': '(Rz*(B10 + Cz*Iz) + 2*B00*Dz*(2*Cz + Zij) + 2*pow(B00,2))',
                         'f40': '(2*pow(B00,2) + Pz*Rz + 4*B00*Cz*Dz)',
                         'f5': '(2*B00*Dz + Cz*Rz)',
                         'f6': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'f9': '(Dz*Pz + 2*B00*Cz)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 1, 1), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dx*(f9 + Qz*Zij)',
                           ['Zij', 'Dx', 'f9', 'Qz', 'Cy'])),
                         (((0, 0, 2), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('(6*B00*Dz*Pz + 2*pow(B00,2)*(3*Cz + Zij) + 4*B00*Cz*Dz*Zij + Rz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)))',
                           ['B10',
                            'Cz',
                            'Zij',
                            'Rz',
                            'Dz',
                            'B00',
                            'Pz',
                            'Iz'])),
                         (((1, 0, 1), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('Qx*(f9 + Qz*Zij)', ['Zij', 'f9', 'Qx', 'Qz'])),
                         (((0, 1, 1), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('Qy*(f9 + Qz*Zij)', ['Zij', 'f9', 'Qy', 'Qz'])),
                         (((1, 0, 1), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dy*(f9 + Qz*Zij)',
                           ['Zij', 'Dy', 'f9', 'Cx', 'Qz'])),
                         (((1, 1, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dz*(Qy*Yij + f3)',
                           ['Dz', 'Yij', 'Qy', 'Cx', 'f3'])),
                         (((0, 1, 1), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('Qz*(Qy*Yij + f3)', ['Yij', 'Qy', 'Qz', 'f3'])),
                         (((1, 1, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('Qx*(Qy*Yij + f3)', ['Yij', 'Qx', 'Qy', 'f3'])),
                         (((0, 1, 1), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dx*(Qy*Yij + f3)',
                           ['Yij', 'Dx', 'Cz', 'Qy', 'f3'])),
                         (((0, 1, 1), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*(Yij*(2*B00*Dy + Cy*Ry) + f2)',
                           ['B00', 'Dy', 'f2', 'Yij', 'Cz', 'Cy', 'Ry'])),
                         (((1, 1, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*(Yij*(2*B00*Dy + Cy*Ry) + f2)',
                           ['Cx', 'Dy', 'f2', 'Yij', 'B00', 'Cy', 'Ry'])),
                         (((0, 2, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('(4*B00*Cy*Dy*Yij + 2*pow(B00,2)*(3*Cy + Yij) + Ry*(B10*(3*Cy + Yij) + Iy*pow(Cy,2)) + 6*B00*Dy*Py)',
                           ['B10',
                            'Dy',
                            'Py',
                            'Yij',
                            'B00',
                            'Iy',
                            'Cy',
                            'Ry'])),
                         (((2, 0, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('(6*B00*Dx*Px + Rx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 4*B00*Cx*Dx*Xij + 2*pow(B00,2)*(3*Cx + Xij))',
                           ['Dx',
                            'Ix',
                            'Cx',
                            'Px',
                            'B10',
                            'Xij',
                            'B00',
                            'Rx'])),
                         (((0, 0, 2), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*Pz*(Dx*Xij + Qx)',
                           ['Dy', 'Dx', 'Qx', 'Pz', 'Xij'])),
                         (((0, 1, 1), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Qy*(Cz*Zij + Pz)',
                           ['Zij', 'Pz', 'Dx', 'Cz', 'Qy'])),
                         (((0, 1, 1), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Qy*(Dx*Xij + Qx)',
                           ['Qx', 'Dx', 'Cz', 'Qy', 'Xij'])),
                         (((0, 1, 1), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*(f17 + Rx*Xij)',
                           ['Rx', 'Cz', 'Xij', 'Cy', 'f17'])),
                         (((0, 0, 2), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Pz*(f17 + Rx*Xij)', ['Rx', 'Pz', 'Xij', 'f17'])),
                         (((0, 2, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Py*(f17 + Rx*Xij)', ['Rx', 'Py', 'Xij', 'f17'])),
                         (((0, 2, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*Py*(Dx*Xij + Qx)',
                           ['Dz', 'Dx', 'Qx', 'Py', 'Xij'])),
                         (((0, 2, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Py*(Dz*Zij + Qz)',
                           ['Dz', 'Zij', 'Dx', 'Py', 'Qz'])),
                         (((1, 1, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Qx*(Dz*Zij + Qz)',
                           ['Dz', 'Zij', 'Qx', 'Qz', 'Cy'])),
                         (((0, 1, 1), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Qz*(Dx*Xij + Qx)',
                           ['Dx', 'Qx', 'Qz', 'Cy', 'Xij'])),
                         (((1, 1, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cy*Rz*(Px + Cx*Xij)',
                           ['Rz', 'Xij', 'Px', 'Cy', 'Cx'])),
                         (((1, 1, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*Qy*(Px + Cx*Xij)',
                           ['Dz', 'Qy', 'Cx', 'Px', 'Xij'])),
                         (((1, 0, 1), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Qz*(Px + Cx*Xij)',
                           ['Dy', 'Xij', 'Qz', 'Px', 'Cx'])),
                         (((2, 0, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Px*(Dz*Zij + Qz)',
                           ['Dz', 'Dy', 'Qz', 'Px', 'Zij'])),
                         (((1, 1, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Qy*(Dz*Zij + Qz)',
                           ['Dz', 'Zij', 'Qy', 'Cx', 'Qz'])),
                         (((0, 2, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('f3*(Dz*Zij + Qz)', ['Dz', 'Zij', 'f3', 'Qz'])),
                         (((2, 0, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('f29*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz', 'f29'])),
                         (((2, 0, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*Iy*f29', ['Dz', 'Iy', 'f29'])),
                         (((0, 2, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Dz*f6', ['Dz', 'Dx', 'f6'])),
                         (((1, 1, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*Qx*f15', ['Dz', 'f15', 'Qx'])),
                         (((1, 0, 1), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Iy*Qx*Qz', ['Qx', 'Iy', 'Qz'])),
                         (((0, 1, 1), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Qz*f15', ['f15', 'Dx', 'Qz'])),
                         (((1, 1, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Cy*f0', ['f0', 'Cx', 'Cy'])),
                         (((1, 1, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*f12', ['Dz', 'f12', 'Cy'])),
                         (((2, 0, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Dz*f16', ['Dz', 'Dy', 'f16'])),
                         (((0, 2, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*Ix*f3', ['Dz', 'Ix', 'f3'])),
                         (((0, 0, 2), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Ix*f9', ['Dy', 'f9', 'Ix'])),
                         (((0, 1, 1), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Ix*Qy*Qz', ['Ix', 'Qy', 'Qz'])),
                         (((1, 1, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Iz*Qx*Qy', ['Qx', 'Qy', 'Iz'])),
                         (((2, 0, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dy*Iz*f29', ['Dy', 'Iz', 'f29'])),
                         (((0, 0, 2), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Dy*f31', ['Dy', 'Dx', 'f31'])),
                         (((0, 0, 2), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Iy*f9', ['Dx', 'f9', 'Iy'])),
                         (((0, 0, 2), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('f9*(Dx*Xij + Qx)', ['Qx', 'Dx', 'f9', 'Xij'])),
                         (((0, 2, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('f3*(Dx*Xij + Qx)', ['Dx', 'Qx', 'f3', 'Xij'])),
                         (((0, 2, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Iz*f3', ['Dx', 'Iz', 'f3'])),
                         (((0, 0, 2), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Pz*f26', ['Dx', 'Pz', 'f26'])),
                         (((1, 0, 1), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Qx*f26', ['Qx', 'Cz', 'f26'])),
                         (((1, 0, 1), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*f12', ['Dy', 'Cz', 'f12'])),
                         (((1, 0, 1), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dy*Qx*(Cz*Zij + Pz)',
                           ['Zij', 'Dy', 'Qx', 'Pz', 'Cz'])),
                         (((0, 1, 1), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Rx*(Cz*Zij + Pz)',
                           ['Rx', 'Zij', 'Cz', 'Pz', 'Cy'])),
                         (((1, 0, 1), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Ry*(Cz*Zij + Pz)',
                           ['Zij', 'Cz', 'Pz', 'Cx', 'Ry'])),
                         (((1, 0, 1), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*Ry*(Px + Cx*Xij)',
                           ['Cz', 'Xij', 'Cx', 'Px', 'Ry'])),
                         (((1, 0, 1), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('f5*(Px + Cx*Xij)', ['Xij', 'Cx', 'Px', 'f5'])),
                         (((1, 1, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('f33*(Px + Cx*Xij)', ['Xij', 'f33', 'Px', 'Cx'])),
                         (((1, 1, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Iz*f33', ['Cx', 'f33', 'Iz'])),
                         (((1, 0, 1), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Cz*f30', ['Cz', 'f30', 'Cx'])),
                         (((1, 1, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Rz*f15', ['f15', 'Rz', 'Cx'])),
                         (((2, 0, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('Iy*Px*Rz', ['Rz', 'Iy', 'Px'])),
                         (((2, 0, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*Px*f26', ['Dz', 'Px', 'f26'])),
                         (((1, 0, 1), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Qz*f26', ['f26', 'Cx', 'Qz'])),
                         (((1, 0, 1), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Iy*f5', ['Iy', 'Cx', 'f5'])),
                         (((0, 1, 1), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cy*Ix*f5', ['Ix', 'Cy', 'f5'])),
                         (((0, 2, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Ix*Py*Rz', ['Rz', 'Ix', 'Py'])),
                         (((0, 0, 2), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Ix*Pz*Ry', ['Ix', 'Pz', 'Ry'])),
                         (((2, 0, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('Iz*Px*Ry', ['Iz', 'Px', 'Ry'])),
                         (((0, 2, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('Iz*Py*Rx', ['Rx', 'Iz', 'Py'])),
                         (((0, 0, 2), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('Iy*Pz*Rx', ['Rx', 'Pz', 'Iy'])),
                         (((0, 1, 1), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*Rx*f15', ['Rx', 'f15', 'Cz'])),
                         (((0, 1, 1), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*Ix*f33', ['Cz', 'f33', 'Ix'])),
                         (((0, 1, 1), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('f33*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'f33'])),
                         (((1, 0, 1), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('f17*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'f17'])),
                         (((1, 0, 1), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f17', ['Cz', 'Iy', 'f17'])),
                         (((1, 1, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f17', ['Iz', 'Cy', 'f17'])),
                         (((1, 1, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*f20', ['f20', 'Cy'])),
                         (((1, 0, 1), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*f20', ['Cz', 'f20'])),
                         (((0, 2, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('Rx*f6', ['Rx', 'f6'])),
                         (((0, 0, 2), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('Rx*f31', ['Rx', 'f31'])),
                         (((0, 0, 2), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('Ry*f31', ['f31', 'Ry'])),
                         (((2, 0, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Ry*f16', ['f16', 'Ry'])),
                         (((2, 0, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Rz*f16', ['f16', 'Rz'])),
                         (((0, 2, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('Rz*f6', ['Rz', 'f6'])),
                         (((0, 0, 2), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Ix*f40', ['Ix', 'f40'])),
                         (((0, 2, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Ix*f2', ['Ix', 'f2'])),
                         (((0, 2, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('Iz*f2', ['Iz', 'f2'])),
                         (((2, 0, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('Iz*f22', ['f22', 'Iz'])),
                         (((2, 0, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('Iy*f22', ['f22', 'Iy'])),
                         (((0, 0, 2), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('Iy*f40', ['f40', 'Iy'])),
                         (((1, 1, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('f15*f17', ['f15', 'f17'])),
                         (((0, 1, 1), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('f15*f5', ['f15', 'f5'])),
                         (((0, 0, 2), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('Pz*f30', ['f30', 'Pz'])),
                         (((2, 0, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('Px*f30', ['f30', 'Px'])),
                         (((2, 0, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('Px*f0', ['f0', 'Px'])),
                         (((0, 2, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('Py*f0', ['f0', 'Py'])),
                         (((1, 0, 1), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('Cx*f39', ['f39', 'Cx'])),
                         (((0, 1, 1), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('Cy*f39', ['f39', 'Cy'])),
                         (((1, 1, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Qy*f12', ['f12', 'Qy'])),
                         (((1, 0, 1), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Qz*f12', ['f12', 'Qz'])),
                         (((2, 0, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('f26*f29', ['f29', 'f26'])),
                         (((0, 0, 2), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('f26*f9', ['f9', 'f26'])),
                         (((0, 0, 2), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('Dx*f1', ['Dx', 'f1'])),
                         (((0, 2, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*f24', ['f24', 'Dx'])),
                         (((0, 2, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*f24', ['Dz', 'f24'])),
                         (((2, 0, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*f32', ['Dz', 'f32'])),
                         (((2, 0, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*f32', ['Dy', 'f32'])),
                         (((0, 0, 2), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('Dy*f1', ['Dy', 'f1'])))),
 ('d', 'p', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f1': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                         'f10': '(Dy*Iy + B00)',
                         'f11': '(Cy*Iy + B10)',
                         'f12': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f14': '(Dx*Px + 2*B00*Cx)',
                         'f15': '(Dx*Ix + B00)',
                         'f22': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f3': '3*B00*B10',
                         'f4': '(Dy*Py + 2*B00*Cy)',
                         'f5': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'f6': '(Dz*Pz + 2*B00*Cz)',
                         'f8': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('(Dy*Iy*pow(Cy,2) + f3 + B00*Cy*(3*Cy + 2*Yij) + B10*Dy*(3*Cy + Yij))',
                           ['B10', 'Dy', 'Yij', 'B00', 'f3', 'Iy', 'Cy'])),
                         (((1, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Cy*(Dz*Zij + Qz)',
                           ['Dz', 'Zij', 'Cx', 'Cy', 'Qz'])),
                         (((1, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*(Px + Cx*Xij)',
                           ['Dz', 'Xij', 'Px', 'Cy', 'Cx'])),
                         (((1, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*(Px + Cx*Xij)',
                           ['Dy', 'Cz', 'Cx', 'Px', 'Xij'])),
                         (((1, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Qy*(Px + Cx*Xij)', ['Qy', 'Cx', 'Px', 'Xij'])),
                         (((1, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*(Px + Cx*Xij)', ['Xij', 'Qz', 'Px', 'Cx'])),
                         (((2, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(Dx*Ix*pow(Cx,2) + B00*Cx*(3*Cx + 2*Xij) + B10*Dx*(3*Cx + Xij) + f3)',
                           ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00', 'f3'])),
                         (((0, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('(B00*Cz*(3*Cz + 2*Zij) + Dz*Iz*pow(Cz,2) + B10*Dz*(3*Cz + Zij) + f3)',
                           ['B10', 'Cz', 'Zij', 'Dz', 'B00', 'Iz', 'f3'])),
                         (((1, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*(f6 + Qz*Zij)', ['Zij', 'f6', 'Cx', 'Qz'])),
                         (((0, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*(f6 + Qz*Zij)', ['Zij', 'f6', 'Qz', 'Cy'])),
                         (((0, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*(Cz*Zij + Pz)',
                           ['Zij', 'Dx', 'Cz', 'Pz', 'Cy'])),
                         (((0, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Qy*(Cz*Zij + Pz)', ['Zij', 'Pz', 'Cz', 'Qy'])),
                         (((1, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Qx*(Cz*Zij + Pz)', ['Zij', 'Qx', 'Pz', 'Cz'])),
                         (((1, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*(Cz*Zij + Pz)',
                           ['Zij', 'Dy', 'Cz', 'Pz', 'Cx'])),
                         (((0, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Ix*Pz', ['Dy', 'Ix', 'Pz'])),
                         (((0, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Ix*Qy', ['Cz', 'Qy', 'Ix'])),
                         (((1, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Cz*f10', ['Cz', 'Cx', 'f10'])),
                         (((0, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*f11', ['Dx', 'Cz', 'f11'])),
                         (((0, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iy*Pz', ['Pz', 'Dx', 'Iy'])),
                         (((0, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iz*Py', ['Dx', 'Iz', 'Py'])),
                         (((2, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Iz*Px', ['Dy', 'Iz', 'Px'])),
                         (((1, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Iz*Qy', ['Qy', 'Cx', 'Iz'])),
                         (((1, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*Qx', ['Qx', 'Iz', 'Cy'])),
                         (((0, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Ix*Qz', ['Ix', 'Qz', 'Cy'])),
                         (((0, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Ix*Py', ['Dz', 'Ix', 'Py'])),
                         (((0, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Py*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Py', 'Qz'])),
                         (((2, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Px*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz', 'Px'])),
                         (((2, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Iy*Px', ['Dz', 'Iy', 'Px'])),
                         (((1, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*f11', ['Dz', 'Cx', 'f11'])),
                         (((1, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Iy*Qz', ['Iy', 'Cx', 'Qz'])),
                         (((1, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*Qx', ['Qx', 'Cz', 'Iy'])),
                         (((0, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f15', ['f15', 'Cz', 'Cy'])),
                         (((0, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Py*f15', ['f15', 'Py'])),
                         (((0, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Pz*f15', ['f15', 'Pz'])),
                         (((1, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*f8', ['f8', 'Cy'])),
                         (((1, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*f8', ['Cz', 'f8'])),
                         (((2, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Px*f10', ['f10', 'Px'])),
                         (((0, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Pz*f10', ['Pz', 'f10'])),
                         (((1, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*f1', ['f1', 'Cx'])),
                         (((0, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*f1', ['f1', 'Cz'])),
                         (((0, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f5', ['Dx', 'f5'])),
                         (((0, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f22', ['Dx', 'f22'])),
                         (((0, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f22', ['Dy', 'f22'])),
                         (((2, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f12', ['Dy', 'f12'])),
                         (((2, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f12', ['Dz', 'f12'])),
                         (((0, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f5', ['Dz', 'f5'])),
                         (((0, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Ix*f6', ['f6', 'Ix'])),
                         (((0, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*f4', ['f4', 'Ix'])),
                         (((0, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*f4', ['f4', 'Iz'])),
                         (((2, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*f14', ['f14', 'Iz'])),
                         (((2, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*f14', ['f14', 'Iy'])),
                         (((0, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Iy*f6', ['f6', 'Iy'])),
                         (((1, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Qx*f11', ['Qx', 'f11'])),
                         (((0, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*f11', ['Qz', 'f11'])))),
 ('d', 'p', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f2': '(B10 + Cz*Iz)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((1, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*(Py + Cy*Yij)', ['Yij', 'Cx', 'Cy', 'Py'])),
                         (((0, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*(Py + Cy*Yij)', ['Yij', 'Cz', 'Py', 'Cy'])),
                         (((0, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                           ['Yij', 'B10', 'Iy', 'Cy'])),
                         (((1, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*Iy', ['Cz', 'Iy', 'Cx'])),
                         (((0, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                           ['Zij', 'B10', 'Cz', 'Iz'])),
                         (((2, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                           ['B10', 'Ix', 'Cx', 'Xij'])),
                         (((1, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*(Px + Cx*Xij)', ['Cz', 'Cx', 'Px', 'Xij'])),
                         (((1, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*(Px + Cx*Xij)', ['Xij', 'Px', 'Cy', 'Cx'])),
                         (((1, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*Iz', ['Cx', 'Cy', 'Iz'])),
                         (((0, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*Ix', ['Cz', 'Ix', 'Cy'])),
                         (((0, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Py', ['Ix', 'Py'])),
                         (((0, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Pz', ['Ix', 'Pz'])),
                         (((0, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Pz', ['Pz', 'Iy'])),
                         (((2, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Px', ['Iy', 'Px'])),
                         (((2, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*Px', ['Iz', 'Px'])),
                         (((0, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*Py', ['Iz', 'Py'])),
                         (((1, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f2', ['Cx', 'f2'])),
                         (((0, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f2', ['f2', 'Cy'])))),
 ('d', 'p', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f1': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                          'f10': '(Cy*Iy + B10)',
                          'f11': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                          'f13': '(Dx*Px + 2*B00*Cx)',
                          'f14': '(Dx*Ix + B00)',
                          'f21': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                          'f24': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                          'f3': '3*B00*B10',
                          'f4': '(Dy*Py + 2*B00*Cy)',
                          'f5': '(Dz*Pz + 2*B00*Cz)',
                          'f7': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                          'f9': '(Dy*Iy + B00)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((2, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*Ix*pow(Cx,2) + B00*Cx*(3*Cx + 2*Xij) + B10*Dx*(3*Cx + Xij) + f3)',
                            ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00', 'f3'])),
                          (((0, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*Iy*pow(Cy,2) + f3 + B00*Cy*(3*Cy + 2*Yij) + B10*Dy*(3*Cy + Yij))',
                            ['B10', 'Dy', 'Yij', 'B00', 'f3', 'Iy', 'Cy'])),
                          (((0, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(B00*Cz*(3*Cz + 2*Zij) + Dz*Iz*pow(Cz,2) + B10*Dz*(3*Cz + Zij) + f3)',
                            ['B10', 'Cz', 'Zij', 'Dz', 'B00', 'Iz', 'f3'])),
                          (((1, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*(f5 + Qz*Zij)', ['Zij', 'Qz', 'Cx', 'f5'])),
                          (((0, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*(f5 + Qz*Zij)', ['Zij', 'Qz', 'Cy', 'f5'])),
                          (((1, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*(Dz*Zij + Qz)',
                            ['Dz', 'Zij', 'Cx', 'Cy', 'Qz'])),
                          (((0, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Py*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Py', 'Qz'])),
                          (((2, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Px*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz', 'Px'])),
                          (((1, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*(Px + Cx*Xij)', ['Xij', 'Qz', 'Px', 'Cx'])),
                          (((1, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy*(Px + Cx*Xij)', ['Qy', 'Cx', 'Px', 'Xij'])),
                          (((1, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*(Px + Cx*Xij)',
                            ['Dz', 'Xij', 'Px', 'Cy', 'Cx'])),
                          (((1, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(Px + Cx*Xij)', ['Xij', 'Px', 'Cy', 'Cx'])),
                          (((1, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*(Px + Cx*Xij)',
                            ['Dy', 'Cz', 'Cx', 'Px', 'Xij'])),
                          (((1, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*(Px + Cx*Xij)', ['Cz', 'Cx', 'Px', 'Xij'])),
                          (((1, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*f9', ['f9', 'Cz', 'Cx'])),
                          (((2, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz*Px', ['Dy', 'Iz', 'Px'])),
                          (((1, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*Qx', ['Qx', 'Iz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*Iz', ['Cx', 'Cy', 'Iz'])),
                          (((1, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Iz*Qy', ['Qy', 'Cx', 'Iz'])),
                          (((0, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Ix*Qy', ['Cz', 'Qy', 'Ix'])),
                          (((0, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Qy*(Cz*Zij + Pz)', ['Zij', 'Pz', 'Cz', 'Qy'])),
                          (((1, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Qx*(Cz*Zij + Pz)', ['Zij', 'Qx', 'Pz', 'Cz'])),
                          (((1, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*(Cz*Zij + Pz)',
                            ['Zij', 'Dy', 'Cz', 'Pz', 'Cx'])),
                          (((1, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Cx'])),
                          (((0, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*(Cz*Zij + Pz)',
                            ['Zij', 'Dx', 'Cz', 'Pz', 'Cy'])),
                          (((0, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Cy'])),
                          (((0, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*f14', ['f14', 'Cz', 'Cy'])),
                          (((0, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*Ix', ['Cz', 'Ix', 'Cy'])),
                          (((0, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Ix*Qz', ['Ix', 'Qz', 'Cy'])),
                          (((1, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Iy*Qz', ['Iy', 'Cx', 'Qz'])),
                          (((1, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz*Iy', ['Cz', 'Iy', 'Cx'])),
                          (((1, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*Qx', ['Qx', 'Cz', 'Iy'])),
                          (((1, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f10', ['Qx', 'f10'])),
                          (((2, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*f13', ['f13', 'Iy'])),
                          (((2, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*f13', ['f13', 'Iz'])),
                          (((0, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*f4', ['f4', 'Ix'])),
                          (((1, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*f1', ['f1', 'Cx'])),
                          (((0, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*f1', ['f1', 'Cz'])),
                          (((2, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Px*f9', ['f9', 'Px'])),
                          (((0, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Pz*f9', ['f9', 'Pz'])),
                          (((0, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Pz*f14', ['f14', 'Pz'])),
                          (((0, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Py*f14', ['f14', 'Py'])),
                          (((0, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz*Py', ['Dx', 'Iz', 'Py'])),
                          (((0, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*Py', ['Iz', 'Py'])),
                          (((0, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*f4', ['f4', 'Iz'])),
                          (((2, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*Px', ['Iz', 'Px'])),
                          (((2, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy*Px', ['Dz', 'Iy', 'Px'])),
                          (((2, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Px', ['Iy', 'Px'])),
                          (((0, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy*Pz', ['Pz', 'Dx', 'Iy'])),
                          (((0, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Pz', ['Pz', 'Iy'])),
                          (((0, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix*Pz', ['Dy', 'Ix', 'Pz'])),
                          (((0, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Pz', ['Ix', 'Pz'])),
                          (((0, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix*Py', ['Dz', 'Ix', 'Py'])),
                          (((0, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Py', ['Ix', 'Py'])),
                          (((0, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*f5', ['Ix', 'f5'])),
                          (((0, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*f5', ['Iy', 'f5'])),
                          (((1, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f7', ['f7', 'Cy'])),
                          (((1, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f7', ['f7', 'Cz'])),
                          (((0, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f10', ['Dx', 'Cz', 'f10'])),
                          (((0, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f10', ['Cz', 'f10'])),
                          (((1, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*f10', ['Dz', 'Cx', 'f10'])),
                          (((1, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f10', ['Cx', 'f10'])),
                          (((0, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f10', ['Qz', 'f10'])),
                          (((2, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f11', ['Dz', 'f11'])),
                          (((0, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f24', ['Dz', 'f24'])),
                          (((0, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f24', ['f24', 'Dx'])),
                          (((0, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f21', ['Dx', 'f21'])),
                          (((0, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f21', ['Dy', 'f21'])),
                          (((2, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f11', ['Dy', 'f11'])),
                          (((2, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('f11', ['f11'])),
                          (((0, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('f24', ['f24'])),
                          (((0, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('f21', ['f21'])))),
 ('d', 's', 'd', 's'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f0': '(Dz*Pz + 2*B00*Cz)',
                         'f1': '(Dy*Py + 2*B00*Cy)',
                         'f13': '2*pow(B00,2)',
                         'f15': '(2*B00*Dy + Cy*Ry)',
                         'f3': '(2*B00*Dz + Cz*Rz)',
                         'f7': 'B01*B10',
                         'f8': '(2*B00*Dx + Cx*Rx)',
                         'f9': '(Dx*Px + 2*B00*Cx)'},
                        ((((0, 2, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('(4*B00*Cy*Dy + f13 + B01*pow(Cy,2) + f7 + Py*pow(Dy,2))',
                           ['Dy', 'f13', 'B01', 'Py', 'B00', 'f7', 'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('(f13 + B01*pow(Cz,2) + Pz*pow(Dz,2) + f7 + 4*B00*Cz*Dz)',
                           ['B00', 'f13', 'B01', 'Dz', 'Cz', 'Pz', 'f7'])),
                         (((2, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('(B01*pow(Cx,2) + f13 + Px*pow(Dx,2) + 4*B00*Cx*Dx + f7)',
                           ['Dx', 'Cx', 'Px', 'f13', 'B01', 'B00', 'f7'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Cy*Rz', ['Rz', 'Cx', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*Qx', ['Qx', 'Dy', 'Cz'])),
                         (((0, 1, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dx*Qy', ['Dx', 'Cz', 'Qy'])),
                         (((0, 2, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Dz*Py', ['Dz', 'Dx', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*Qx', ['Dz', 'Qx', 'Cy'])),
                         (((0, 1, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dx*Qz', ['Dx', 'Qz', 'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Dy*Pz', ['Dy', 'Dx', 'Pz'])),
                         (((2, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Dz*Px', ['Dz', 'Dy', 'Px'])),
                         (((1, 1, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dz*Qy', ['Dz', 'Qy', 'Cx'])),
                         (((1, 0, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dy*Qz', ['Dy', 'Cx', 'Qz'])),
                         (((1, 0, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Cz*Ry', ['Cz', 'Cx', 'Ry'])),
                         (((0, 1, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*Rx', ['Rx', 'Cz', 'Cy'])),
                         (((0, 2, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Py*Rx', ['Rx', 'Py'])),
                         (((0, 0, 2), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Pz*Rx', ['Rx', 'Pz'])),
                         (((0, 0, 2), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Pz*Ry', ['Pz', 'Ry'])),
                         (((2, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Px*Ry', ['Px', 'Ry'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Px*Rz', ['Rz', 'Px'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Py*Rz', ['Rz', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*f8', ['f8', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*f8', ['Cz', 'f8'])),
                         (((0, 1, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*f15', ['f15', 'Cz'])),
                         (((1, 1, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*f15', ['f15', 'Cx'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*f3', ['Cx', 'f3'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cy*f3', ['f3', 'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*f0', ['Dx', 'f0'])),
                         (((0, 2, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*f1', ['Dx', 'f1'])),
                         (((0, 2, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*f1', ['Dz', 'f1'])),
                         (((2, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*f9', ['Dz', 'f9'])),
                         (((2, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*f9', ['Dy', 'f9'])),
                         (((0, 0, 2), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*f0', ['Dy', 'f0'])),
                         (((1, 0, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Qx*Qz', ['Qx', 'Qz'])),
                         (((1, 1, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Qx*Qy', ['Qx', 'Qy'])),
                         (((0, 1, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Qy*Qz', ['Qy', 'Qz'])))),
 ('d', 's', 'p', 'p'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f0': '(Dy*Py + 2*B00*Cy)',
                         'f1': '(Dz*Pz + 2*B00*Cz)',
                         'f10': 'B01*B10',
                         'f13': '(Dx*Px + 2*B00*Cx)',
                         'f15': '(Dz*Kz + B01)',
                         'f16': '(B00 + Cx*Kx)',
                         'f17': '(B00 + Cy*Ky)',
                         'f2': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                         'f20': '2*pow(B00,2)',
                         'f22': '(B01 + Dy*Ky)',
                         'f4': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                         'f6': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                         'f7': '(B01 + Dx*Kx)',
                         'f9': '(Kx*Px + 2*B00*Cx)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((2, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('(B01*pow(Cx,2) + f10 + f20 + 2*B00*Cx*(Xkl + 2*Dx) + Dx*Kx*Px)',
                           ['Dx',
                            'Cx',
                            'Px',
                            'B01',
                            'Xkl',
                            'B00',
                            'f10',
                            'Kx',
                            'f20'])),
                         (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('(f10 + f20 + Dy*Ky*Py + B01*pow(Cy,2) + 2*B00*Cy*(Ykl + 2*Dy))',
                           ['f20',
                            'Dy',
                            'B01',
                            'Py',
                            'Ykl',
                            'B00',
                            'Ky',
                            'f10',
                            'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('(f10 + f20 + B01*pow(Cz,2) + Dz*Kz*Pz + 2*B00*Cz*(2*Dz + Zkl))',
                           ['B00',
                            'f20',
                            'Kz',
                            'B01',
                            'Dz',
                            'Cz',
                            'Pz',
                            'f10',
                            'Zkl'])),
                         (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Dx*(Cz*Zkl + Qz)',
                           ['Dx', 'Cz', 'Zkl', 'Qz', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Dy*(Cz*Zkl + Qz)',
                           ['Dy', 'Cz', 'Zkl', 'Cx', 'Qz'])),
                         (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*(Pz*Zkl + f1)', ['Dy', 'f1', 'Pz', 'Zkl'])),
                         (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*(Pz*Zkl + f1)', ['Zkl', 'Dx', 'f1', 'Pz'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*(f0 + Py*Ykl)', ['Dz', 'Ykl', 'f0', 'Py'])),
                         (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*(f0 + Py*Ykl)', ['Ykl', 'Dx', 'f0', 'Py'])),
                         (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*Ky*Pz', ['Dx', 'Pz', 'Ky'])),
                         (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Dx*f17', ['Dx', 'Cz', 'f17'])),
                         (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*Cz*f22', ['Cz', 'f22', 'Cx'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Kx*Qz', ['Kx', 'Cy', 'Qz'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Dz*f16', ['Dz', 'f16', 'Cy'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*Ky*Px', ['Dz', 'Px', 'Ky'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Dz*f17', ['Dz', 'Cx', 'f17'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Ky*Qz', ['Cx', 'Ky', 'Qz'])),
                         (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Ky*Qx', ['Qx', 'Cz', 'Ky'])),
                         (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Qx*(Cz*Zkl + Qz)', ['Qx', 'Zkl', 'Qz', 'Cz'])),
                         (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Qy*(Cz*Zkl + Qz)', ['Zkl', 'Cz', 'Qy', 'Qz'])),
                         (((0, 1, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Kx*Qy', ['Cz', 'Qy', 'Kx'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*Kx*Py', ['Dz', 'Kx', 'Py'])),
                         (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*Kz*Py', ['Dx', 'Kz', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Kz*Qx', ['Qx', 'Kz', 'Cy'])),
                         (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*Kz*Px', ['Dy', 'Kz', 'Px'])),
                         (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Kz*Qy', ['Kz', 'Qy', 'Cx'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*Cy*f15', ['f15', 'Cx', 'Cy'])),
                         (((0, 1, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*Cz*f7', ['f7', 'Cz', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Dy*f16', ['f16', 'Dy', 'Cz'])),
                         (((0, 0, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*Kx*Pz', ['Dy', 'Pz', 'Kx'])),
                         (((2, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*f9', ['Dy', 'f9'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*f9', ['Dz', 'f9'])),
                         (((1, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Qy*f16', ['f16', 'Qy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Qz*f16', ['f16', 'Qz'])),
                         (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Qx*f17', ['Qx', 'f17'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Qz*f17', ['Qz', 'f17'])),
                         (((0, 2, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Kx*f0', ['f0', 'Kx'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Kx*f1', ['f1', 'Kx'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Ky*f1', ['f1', 'Ky'])),
                         (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Ky*f13', ['f13', 'Ky'])),
                         (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Kz*f13', ['f13', 'Kz'])),
                         (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Kz*f0', ['Kz', 'f0'])),
                         (((0, 2, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Py*f7', ['f7', 'Py'])),
                         (((0, 0, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Pz*f7', ['f7', 'Pz'])),
                         (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Pz*f22', ['f22', 'Pz'])),
                         (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Px*f22', ['f22', 'Px'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Px*f15', ['f15', 'Px'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Py*f15', ['f15', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*f4', ['f4', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cz*f4', ['f4', 'Cz'])),
                         (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cz*f2', ['Cz', 'f2'])),
                         (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*f2', ['Cx', 'f2'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*f6', ['f6', 'Cx'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cy*f6', ['f6', 'Cy'])))),
 ('d', 's', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)'},
                        ((((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(Dx*Px + 2*B00*Cx)', ['Dx', 'B00', 'Cx', 'Px'])),
                         (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('(Dy*Py + 2*B00*Cy)', ['Dy', 'B00', 'Py', 'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('(Dz*Pz + 2*B00*Cz)', ['Dz', 'B00', 'Pz', 'Cz'])),
                         (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Cz*Dy', ['Dy', 'Cz', 'Cx'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Cy*Dz', ['Dz', 'Cx', 'Cy'])),
                         (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*Dx', ['Dx', 'Cz', 'Cy'])),
                         (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Py', ['Dx', 'Py'])),
                         (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Pz', ['Dx', 'Pz'])),
                         (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Pz', ['Dy', 'Pz'])),
                         (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Px', ['Dy', 'Px'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Px', ['Dz', 'Px'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Py', ['Dz', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Qx', ['Qx', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Qx', ['Qx', 'Cz'])),
                         (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Qy', ['Cz', 'Qy'])),
                         (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Qy', ['Qy', 'Cx'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Qz', ['Cx', 'Qz'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Qz', ['Qz', 'Cy'])))),
 ('d', 's', 's', 'd'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f0': '(2*B00*Ky + Cy*(pow(Ky,2) + B01))',
                         'f10': '(2*B00*Kx + Cx*(pow(Kx,2) + B01))',
                         'f11': '(B00 + Cx*Kx)',
                         'f12': '(B00 + Cy*Ky)',
                         'f14': '2*pow(B00,2)',
                         'f15': '(pow(Ky,2) + B01)',
                         'f16': '(Kz*Pz + 2*B00*Cz)',
                         'f18': '(B00 + Cz*Kz)',
                         'f19': '(Ky*Py + 2*B00*Cy)',
                         'f3': '(Kx*Px + 2*B00*Cx)',
                         'f4': '(pow(Kz,2) + B01)',
                         'f6': '(2*B00*Kz + Cz*(pow(Kz,2) + B01))',
                         'f7': 'B01*B10',
                         'f9': '(pow(Kx,2) + B01)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('(f14 + B01*pow(Cy,2) + f7 + Py*pow(Ky,2) + 4*B00*Cy*Ky)',
                           ['B01', 'Py', 'B00', 'Ky', 'f7', 'f14', 'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('(Pz*pow(Kz,2) + f14 + B01*pow(Cz,2) + f7 + 4*B00*Cz*Kz)',
                           ['B00', 'Kz', 'B01', 'Cz', 'Pz', 'f7', 'f14'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('(B01*pow(Cx,2) + f14 + Px*pow(Kx,2) + f7 + 4*B00*Cx*Kx)',
                           ['Cx', 'Px', 'B01', 'B00', 'f7', 'f14', 'Kx'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Cx*Cy*f4', ['f4', 'Cx', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Cz*Ky*f11', ['Cz', 'f11', 'Ky'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Cz*Kx*f12', ['Cz', 'f12', 'Kx'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kx*Kz*Py', ['Kz', 'Kx', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Cy*Kz*f11', ['Kz', 'f11', 'Cy'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Cy*Kx*f18', ['Kx', 'Cy', 'f18'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Kx*Ky*Pz', ['Pz', 'Kx', 'Ky'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Ky*Kz*Px', ['Kz', 'Px', 'Ky'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Cx*Kz*f12', ['Kz', 'f12', 'Cx'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Cx*Ky*f18', ['Cx', 'Ky', 'f18'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Cx*Cz*f15', ['f15', 'Cz', 'Cx'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('Cy*Cz*f9', ['f9', 'Cz', 'Cy'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('Py*f9', ['f9', 'Py'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('Pz*f9', ['f9', 'Pz'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Pz*f15', ['f15', 'Pz'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Px*f15', ['f15', 'Px'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Px*f4', ['f4', 'Px'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Py*f4', ['f4', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('Cy*f10', ['f10', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('Cz*f10', ['Cz', 'f10'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Cz*f0', ['Cz', 'f0'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Cx*f0', ['f0', 'Cx'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Cx*f6', ['f6', 'Cx'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kx*f16', ['f16', 'Kx'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Kx*f19', ['Kx', 'f19'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Kz*f19', ['Kz', 'f19'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kz*f3', ['Kz', 'f3'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Ky*f3', ['f3', 'Ky'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Ky*f16', ['f16', 'Ky'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('f11*f18', ['f11', 'f18'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('f11*f12', ['f12', 'f11'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('f12*f18', ['f12', 'f18'])))),
 ('d', 's', 's', 'p'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f4': '(B00 + Cx*Kx)',
                         'f6': '(B00 + Cy*Ky)',
                         'f8': '(B00 + Cz*Kz)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((2, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('(Kx*Px + 2*B00*Cx)', ['B00', 'Kx', 'Px', 'Cx'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('(Ky*Py + 2*B00*Cy)', ['B00', 'Py', 'Ky', 'Cy'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('(Kz*Pz + 2*B00*Cz)', ['Kz', 'Pz', 'Cz', 'B00'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*Cz*Ky', ['Cz', 'Cx', 'Ky'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*Cy*Kz', ['Kz', 'Cx', 'Cy'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*Cz*Kx', ['Cz', 'Kx', 'Cy'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Kx*Py', ['Kx', 'Py'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Kx*Pz', ['Pz', 'Kx'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ky*Pz', ['Pz', 'Ky'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ky*Px', ['Px', 'Ky'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Kz*Px', ['Kz', 'Px'])),
                         (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Kz*Py', ['Kz', 'Py'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*f4', ['f4', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cz*f4', ['f4', 'Cz'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cz*f6', ['f6', 'Cz'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*f6', ['f6', 'Cx'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*f8', ['f8', 'Cx'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cy*f8', ['f8', 'Cy'])))),
 ('d', 's', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))'},
                        ((((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py', ['Py'])),
                         (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz', ['Pz'])),
                         (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px', ['Px'])),
                         (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy', ['Cx', 'Cy'])),
                         (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz', ['Cz', 'Cx'])),
                         (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz', ['Cz', 'Cy'])))),
 ('d', 's', 's', 'sp'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'f5': '(B00 + Cx*Kx)',
                          'f7': '(B00 + Cy*Ky)',
                          'f9': '(B00 + Cz*Kz)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((2, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(Kx*Px + 2*B00*Cx)',
                            ['B00', 'Kx', 'Px', 'Cx'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('(Ky*Py + 2*B00*Cy)',
                            ['B00', 'Py', 'Ky', 'Cy'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(Kz*Pz + 2*B00*Cz)',
                            ['Kz', 'Pz', 'Cz', 'B00'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Cz*Kx', ['Cz', 'Kx', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Cz*Ky', ['Cz', 'Cx', 'Ky'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz', ['Cz', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz', ['Cz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*f5', ['Cy', 'f5'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*f5', ['Cz', 'f5'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*Pz', ['Pz', 'Kx'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*Py', ['Kx', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py', ['Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*Py', ['Kz', 'Py'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*Px', ['Kz', 'Px'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Cy*Kz', ['Kz', 'Cx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy', ['Cx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*f7', ['f7', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*f7', ['f7', 'Cz'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz', ['Pz'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*Pz', ['Pz', 'Ky'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*Px', ['Px', 'Ky'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px', ['Px'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*f9', ['f9', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*f9', ['f9', 'Cy'])))),
 ('d', 's', 'sp', 'p'): ({'B00': '',
                          'B01': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f0': '(Dy*Py + 2*B00*Cy)',
                          'f1': '(Dz*Pz + 2*B00*Cz)',
                          'f10': 'B01*B10',
                          'f13': '(Dx*Px + 2*B00*Cx)',
                          'f15': '(Dz*Kz + B01)',
                          'f16': '(B00 + Cx*Kx)',
                          'f17': '(B00 + Cy*Ky)',
                          'f19': '2*pow(B00,2)',
                          'f2': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                          'f21': '(B01 + Dy*Ky)',
                          'f4': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                          'f6': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                          'f7': '(B01 + Dx*Kx)',
                          'f9': '(Kx*Px + 2*B00*Cx)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((2, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01*pow(Cx,2) + f10 + f19 + 2*B00*Cx*(Xkl + 2*Dx) + Dx*Kx*Px)',
                            ['Dx',
                             'Cx',
                             'Px',
                             'B01',
                             'Xkl',
                             'B00',
                             'f10',
                             'Kx',
                             'f19'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(f10 + f19 + B01*pow(Cz,2) + Dz*Kz*Pz + 2*B00*Cz*(2*Dz + Zkl))',
                            ['B00',
                             'f19',
                             'Kz',
                             'B01',
                             'Dz',
                             'Cz',
                             'Pz',
                             'f10',
                             'Zkl'])),
                          (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(f10 + f19 + Dy*Ky*Py + B01*pow(Cy,2) + 2*B00*Cy*(Ykl + 2*Dy))',
                            ['f19',
                             'Dy',
                             'B01',
                             'Py',
                             'Ykl',
                             'B00',
                             'Ky',
                             'f10',
                             'Cy'])),
                          (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*(f0 + Py*Ykl)', ['Ykl', 'Dx', 'f0', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*(f0 + Py*Ykl)', ['Dz', 'Ykl', 'f0', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('(f0 + Py*Ykl)', ['Ykl', 'f0', 'Py'])),
                          (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*(Pz*Zkl + f1)', ['Dy', 'f1', 'Pz', 'Zkl'])),
                          (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*(Pz*Zkl + f1)', ['Zkl', 'Dx', 'f1', 'Pz'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(Pz*Zkl + f1)', ['Zkl', 'f1', 'Pz'])),
                          (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*Cz*f21', ['Cz', 'Cx', 'f21'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Ky*Qz', ['Cx', 'Ky', 'Qz'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Kx*Qz', ['Kx', 'Cy', 'Qz'])),
                          (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Kz*Qx', ['Qx', 'Kz', 'Cy'])),
                          (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Kz*Px', ['Dy', 'Kz', 'Px'])),
                          (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Kz*Qy', ['Kz', 'Qy', 'Cx'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Cy*Kz', ['Kz', 'Cx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*Cy*f15', ['f15', 'Cx', 'Cy'])),
                          (((0, 1, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*Cz*f7', ['f7', 'Cz', 'Cy'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Cz*Kx', ['Cz', 'Kx', 'Cy'])),
                          (((0, 1, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Kx*Qy', ['Cz', 'Qy', 'Kx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Qy*(Cz*Zkl + Qz)', ['Zkl', 'Cz', 'Qy', 'Qz'])),
                          (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Dx*(Cz*Zkl + Qz)',
                            ['Dx', 'Cz', 'Zkl', 'Qz', 'Cy'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Qz', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Dy*(Cz*Zkl + Qz)',
                            ['Dy', 'Cz', 'Zkl', 'Cx', 'Qz'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Cx', 'Qz'])),
                          (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Qx*(Cz*Zkl + Qz)', ['Qx', 'Zkl', 'Qz', 'Cz'])),
                          (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Ky*Qx', ['Qx', 'Cz', 'Ky'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Cz*Ky', ['Cz', 'Cx', 'Ky'])),
                          (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*f13', ['f13', 'Ky'])),
                          (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Qx*f17', ['Qx', 'f17'])),
                          (((0, 2, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*f0', ['f0', 'Kx'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Kx*f1', ['f1', 'Kx'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Ky*f1', ['f1', 'Ky'])),
                          (((1, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Qy*f16', ['f16', 'Qy'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Qz*f16', ['f16', 'Qz'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Qz*f17', ['Qz', 'f17'])),
                          (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Kz*Py', ['Dx', 'Kz', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*Py', ['Kz', 'Py'])),
                          (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*f13', ['f13', 'Kz'])),
                          (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*f0', ['Kz', 'f0'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*Px', ['Kz', 'Px'])),
                          (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Px*f21', ['f21', 'Px'])),
                          (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Pz*f21', ['Pz', 'f21'])),
                          (((0, 0, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Pz*f7', ['f7', 'Pz'])),
                          (((0, 2, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Py*f7', ['f7', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Kx*Py', ['Dz', 'Kx', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*Py', ['Kx', 'Py'])),
                          (((0, 0, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Kx*Pz', ['Dy', 'Pz', 'Kx'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*Pz', ['Pz', 'Kx'])),
                          (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Ky*Pz', ['Dx', 'Pz', 'Ky'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*Pz', ['Pz', 'Ky'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ky*Px', ['Dz', 'Px', 'Ky'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*Px', ['Px', 'Ky'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Px*f15', ['f15', 'Px'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Py*f15', ['f15', 'Py'])),
                          (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*f2', ['Cx', 'f2'])),
                          (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*f2', ['Cz', 'f2'])),
                          (((1, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*f4', ['f4', 'Cz'])),
                          (((1, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*f4', ['f4', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Dz*f16', ['Dz', 'f16', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*f16', ['f16', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Dy*f16', ['f16', 'Dy', 'Cz'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*f16', ['f16', 'Cz'])),
                          (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Dx*f17', ['Dx', 'Cz', 'f17'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*f17', ['Cz', 'f17'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Dz*f17', ['Dz', 'Cx', 'f17'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*f17', ['Cx', 'f17'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*f6', ['f6', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*f6', ['f6', 'Cy'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f9', ['Dz', 'f9'])),
                          (((2, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f9', ['Dy', 'f9'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('f9', ['f9'])))),
 ('d', 's', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)'},
                         ((((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*Px + 2*B00*Cx)',
                            ['Dx', 'B00', 'Cx', 'Px'])),
                          (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*Py + 2*B00*Cy)',
                            ['Dy', 'B00', 'Py', 'Cy'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('(Dz*Pz + 2*B00*Cz)',
                            ['Dz', 'B00', 'Pz', 'Cz'])),
                          (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*Dx', ['Dx', 'Cz', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*Dy', ['Dy', 'Cz', 'Cx'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz', ['Cz', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz', ['Cz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Qx', ['Qx', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Qx', ['Qx', 'Cz'])),
                          (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Pz', ['Dx', 'Pz'])),
                          (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Py', ['Dx', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py', ['Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Py', ['Dz', 'Py'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Px', ['Dz', 'Px'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*Dz', ['Dz', 'Cx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy', ['Cx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Qy', ['Qy', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Qy', ['Cz', 'Qy'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz', ['Pz'])),
                          (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Pz', ['Dy', 'Pz'])),
                          (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Px', ['Dy', 'Px'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px', ['Px'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Qz', ['Cx', 'Qz'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Qz', ['Qz', 'Cy'])))),
 ('d', 's', 'sp', 'sp'): ({'B00': '',
                           'B01': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Kx': '(Xkl + Dx)',
                           'Ky': '(Ykl + Dy)',
                           'Kz': '(Dz + Zkl)',
                           'Px': '(B10 + pow(Cx,2))',
                           'Py': '(B10 + pow(Cy,2))',
                           'Pz': '(B10 + pow(Cz,2))',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)',
                           'f10': '2*B00*Cx',
                           'f11': '(B01 + Dx*Kx)',
                           'f19': '2*B00*Cz',
                           'f2': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                           'f20': '(Dz*Kz + B01)',
                           'f21': 'Dx*pow(Cx,2)',
                           'f22': '(B00 + Cx*Kx)',
                           'f23': '(B00 + Cy*Ky)',
                           'f25': 'B10*Dz',
                           'f27': '2*pow(B00,2)',
                           'f29': '(B01 + Dy*Ky)',
                           'f31': 'B10*Dx',
                           'f33': 'Dy*pow(Cy,2)',
                           'f35': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                           'f4': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                           'f5': '2*B00*Cy',
                           'f7': 'B10*Dy',
                           'f8': 'Dz*pow(Cz,2)',
                           'Xkl': '',
                           'Ykl': '',
                           'Zkl': ''},
                          ((((2, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(f27 + Xkl*(f10 + f21 + f31) + B01*Px + Dx*(2*f10 + Dx*Px))',
                             ['Dx',
                              'Px',
                              'B01',
                              'f27',
                              'Xkl',
                              'f31',
                              'f10',
                              'f21'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('(f27 + Dz*(Dz*Pz + 2*f19) + B01*Pz + Zkl*(f19 + f25 + f8))',
                             ['Dz',
                              'f25',
                              'f19',
                              'B01',
                              'f27',
                              'Pz',
                              'f8',
                              'Zkl'])),
                           (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('(f27 + B01*Py + Dy*(2*f5 + Dy*Py) + Ykl*(f33 + f5 + f7))',
                             ['f33',
                              'f5',
                              'Dy',
                              'B01',
                              'Py',
                              'f27',
                              'Ykl',
                              'f7'])),
                           (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*(f33 + B10*Ky + Ykl*pow(Cy,2) + f5)',
                             ['Dx', 'f33', 'f5', 'B10', 'Ykl', 'Ky', 'Cy'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*(f33 + B10*Ky + Ykl*pow(Cy,2) + f5)',
                             ['B10', 'f33', 'f5', 'Dz', 'Ykl', 'Ky', 'Cy'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('(f33 + B10*Ky + Ykl*pow(Cy,2) + f5)',
                             ['B10', 'f33', 'f5', 'Ykl', 'Ky', 'Cy'])),
                           (((0, 2, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*(f33 + f5 + f7)',
                             ['f7', 'f5', 'Kx', 'f33'])),
                           (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*(f33 + f5 + f7)',
                             ['f7', 'Kz', 'f33', 'f5'])),
                           (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('(f33 + f5 + f7)', ['f7', 'f33', 'f5'])),
                           (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*(Zkl*pow(Cz,2) + f19 + B10*Kz + f8)',
                             ['B10', 'f19', 'Dy', 'Kz', 'Cz', 'f8', 'Zkl'])),
                           (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*(Zkl*pow(Cz,2) + f19 + B10*Kz + f8)',
                             ['B10', 'f19', 'Kz', 'Dx', 'Cz', 'f8', 'Zkl'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('(Zkl*pow(Cz,2) + f19 + B10*Kz + f8)',
                             ['B10', 'f19', 'Kz', 'Cz', 'f8', 'Zkl'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Ky*(f19 + f25 + f8)',
                             ['f25', 'f8', 'f19', 'Ky'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Kx*(f19 + f25 + f8)',
                             ['f25', 'f8', 'Kx', 'f19'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('(f19 + f25 + f8)', ['f25', 'f8', 'f19'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*(f10 + f21 + B10*Kx + Xkl*pow(Cx,2))',
                             ['B10',
                              'Cx',
                              'Dz',
                              'Xkl',
                              'f10',
                              'Kx',
                              'f21'])),
                           (((2, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*(f10 + f21 + B10*Kx + Xkl*pow(Cx,2))',
                             ['B10',
                              'Cx',
                              'Dy',
                              'Xkl',
                              'f10',
                              'Kx',
                              'f21'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('(f10 + f21 + B10*Kx + Xkl*pow(Cx,2))',
                             ['B10', 'Cx', 'Xkl', 'f10', 'Kx', 'f21'])),
                           (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*(f10 + f21 + f31)',
                             ['f31', 'Kz', 'f21', 'f10'])),
                           (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*(f10 + f21 + f31)',
                             ['f21', 'f31', 'f10', 'Ky'])),
                           (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(f10 + f21 + f31)', ['f31', 'f21', 'f10'])),
                           (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Dx*(Cz*Zkl + Qz)',
                             ['Dx', 'Cz', 'Zkl', 'Qz', 'Cy'])),
                           (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Dy*(Cz*Zkl + Qz)',
                             ['Dy', 'Cz', 'Zkl', 'Cx', 'Qz'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Cx', 'Qz'])),
                           (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Qx*(Cz*Zkl + Qz)', ['Qx', 'Zkl', 'Qz', 'Cz'])),
                           (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Qy*(Cz*Zkl + Qz)', ['Zkl', 'Cz', 'Qy', 'Qz'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cy*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Qz', 'Cy'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Kx*Qz', ['Kx', 'Cy', 'Qz'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Px*f20', ['f20', 'Px'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Py*f20', ['Py', 'f20'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*Cy*f20', ['Cx', 'Cy', 'f20'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Dz*f23', ['Dz', 'f23', 'Cx'])),
                           (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Dx*f23', ['Dx', 'Cz', 'f23'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cz*f23', ['Cz', 'f23'])),
                           (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Qx*f23', ['Qx', 'f23'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*f23', ['f23', 'Cx'])),
                           (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*f2', ['Cx', 'f2'])),
                           (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*f2', ['Cz', 'f2'])),
                           (((1, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Qy*f22', ['f22', 'Qy'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Qz*f22', ['f22', 'Qz'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Ky*Qz', ['Cx', 'Ky', 'Qz'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Qz', ['Cx', 'Qz'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Qz*f23', ['f23', 'Qz'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Qz', ['Qz', 'Cy'])),
                           (((1, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*f4', ['f4', 'Cy'])),
                           (((1, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*f4', ['f4', 'Cz'])),
                           (((1, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Dy*f22', ['Dy', 'Cz', 'f22'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cz*f22', ['Cz', 'f22'])),
                           (((0, 1, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Kx*Qy', ['Cz', 'Qy', 'Kx'])),
                           (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Qy', ['Cz', 'Qy'])),
                           (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Qy', ['Qy', 'Cx'])),
                           (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Kz*Qy', ['Kz', 'Qy', 'Cx'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*Cy*Kz', ['Kz', 'Cx', 'Cy'])),
                           (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Kz*Py', ['Dx', 'Kz', 'Py'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Kz*Py', ['Kz', 'Py'])),
                           (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Kz*Qx', ['Qx', 'Kz', 'Cy'])),
                           (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Qx', ['Qx', 'Cy'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*f22', ['f22', 'Cy'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Dz*f22', ['Dz', 'f22', 'Cy'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Cy*Dz', ['Dz', 'Cx', 'Cy'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cy', ['Cx', 'Cy'])),
                           (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*Cz*f29', ['Cz', 'Cx', 'f29'])),
                           (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Px*f29', ['f29', 'Px'])),
                           (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Pz*f29', ['Pz', 'f29'])),
                           (((0, 0, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Pz*f11', ['Pz', 'f11'])),
                           (((0, 2, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Py*f11', ['Py', 'f11'])),
                           (((0, 1, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*Cz*f11', ['Cz', 'f11', 'Cy'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*Cz*Kx', ['Cz', 'Kx', 'Cy'])),
                           (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*Dx', ['Dx', 'Cz', 'Cy'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Cz', ['Cz', 'Cy'])),
                           (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Qx', ['Qx', 'Cz'])),
                           (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Ky*Qx', ['Qx', 'Cz', 'Ky'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*Cz*Ky', ['Cz', 'Cx', 'Ky'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cz', ['Cz', 'Cx'])),
                           (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Cz*Dy', ['Dy', 'Cz', 'Cx'])),
                           (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Pz', ['Dy', 'Pz'])),
                           (((0, 0, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Kx*Pz', ['Dy', 'Pz', 'Kx'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Kx*Pz', ['Pz', 'Kx'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Kx*Py', ['Kx', 'Py'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Kx*Py', ['Dz', 'Kx', 'Py'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Py', ['Dz', 'Py'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Py', ['Py'])),
                           (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Py', ['Dx', 'Py'])),
                           (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Ky*Pz', ['Dx', 'Pz', 'Ky'])),
                           (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Pz', ['Dx', 'Pz'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Pz', ['Pz'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ky*Pz', ['Pz', 'Ky'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ky*Px', ['Px', 'Ky'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ky*Px', ['Dz', 'Px', 'Ky'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Px', ['Dz', 'Px'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Kz*Px', ['Kz', 'Px'])),
                           (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Kz*Px', ['Dy', 'Kz', 'Px'])),
                           (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Px', ['Dy', 'Px'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Px', ['Px'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*f35', ['Cx', 'f35'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cy*f35', ['Cy', 'f35'])))),
 ('d', 'sp', 'd', 's'): ({'B00': '',
                          'B01': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'Rx': '(B01 + pow(Dx,2))',
                          'Ry': '(B01 + pow(Dy,2))',
                          'Rz': '(pow(Dz,2) + B01)',
                          'f1': '(Dz*Pz + 2*B00*Cz)',
                          'f14': '(2*B00*Dx + Ix*Rx)',
                          'f16': '(2*B00*Cy*Yij + 3*B00*Py + Dy*(B10*(3*Cy + Yij) + Iy*pow(Cy,2)))',
                          'f2': '(4*B00*Cy*Dy + Py*Ry + 2*pow(B00,2))',
                          'f21': '(Cy*Iy + B10)',
                          'f22': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                          'f23': '(2*B00*Dx + Cx*Rx)',
                          'f24': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                          'f28': '(2*B00*Dy + Iy*Ry)',
                          'f29': '(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                          'f3': 'B01*B10',
                          'f30': '(Iz*Rz + 2*B00*Dz)',
                          'f31': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                          'f32': '(Dy*Py + 2*B00*Cy)',
                          'f33': '(2*B00*Dz + Cz*Rz)',
                          'f36': '2*pow(B00,2)',
                          'f4': '(Dx*Px + 2*B00*Cx)',
                          'f40': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                          'f42': '(2*B00*Dy + Cy*Ry)',
                          'f7': '(Dz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)) + 3*B00*Pz + 2*B00*Cz*Zij)',
                          'f8': '(B00 + Dz*Iz)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 0, 1), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cz*(f36 + 2*B00*Dx*(Xij + 2*Cx) + B01*Cx*Ix + pow(Dx,2)*(Cx*Ix + B10) + f3)',
                            ['f36',
                             'B00',
                             'Cx',
                             'Xij',
                             'B10',
                             'B01',
                             'Dx',
                             'Cz',
                             'f3',
                             'Ix'])),
                          (((1, 1, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cx*(Yij*(2*B00*Dy + Cy*Ry) + f2)',
                            ['Cx', 'Dy', 'f2', 'Yij', 'B00', 'Cy', 'Ry'])),
                          (((0, 1, 1), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cz*(Yij*(2*B00*Dy + Cy*Ry) + f2)',
                            ['B00', 'Dy', 'f2', 'Yij', 'Cz', 'Cy', 'Ry'])),
                          (((0, 2, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                           ('(B01*Iy*pow(Cy,2) + 4*B00*Cy*Dy*Yij + 6*B00*Dy*Py + Yij*(f36 + f3 + Py*pow(Dy,2)) + Cy*(3*f36 + 3*f3 + pow(Dy,2)*(3*B10 + pow(Cy,2))))',
                            ['f36',
                             'Dy',
                             'B10',
                             'B01',
                             'Py',
                             'Yij',
                             'B00',
                             'f3',
                             'Iy',
                             'Cy'])),
                          (((0, 1, 1), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                           ('Cy*(f36 + pow(Dz,2)*(B10 + Cz*Iz) + 2*B00*Dz*(2*Cz + Zij) + f3 + B01*Cz*Iz)',
                            ['f36',
                             'B00',
                             'Zij',
                             'B01',
                             'B10',
                             'Dz',
                             'Cz',
                             'Iz',
                             'Cy',
                             'f3'])),
                          (((1, 0, 1), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                           ('Cx*(f36 + pow(Dz,2)*(B10 + Cz*Iz) + 2*B00*Dz*(2*Cz + Zij) + f3 + B01*Cz*Iz)',
                            ['f36',
                             'B00',
                             'Cx',
                             'Zij',
                             'B01',
                             'B10',
                             'Dz',
                             'Cz',
                             'Iz',
                             'f3'])),
                          (((0, 0, 2), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                           ('(6*B00*Dz*Pz + B01*Iz*pow(Cz,2) + Cz*(3*f36 + 3*f3 + pow(Dz,2)*(3*B10 + pow(Cz,2))) + Zij*(f36 + Pz*pow(Dz,2) + f3) + 4*B00*Cz*Dz*Zij)',
                            ['f36',
                             'Cz',
                             'Zij',
                             'B01',
                             'B10',
                             'Dz',
                             'B00',
                             'Pz',
                             'Iz',
                             'f3'])),
                          (((0, 0, 2), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                           ('Iy*(f36 + B01*pow(Cz,2) + Pz*pow(Dz,2) + f3 + 4*B00*Cz*Dz)',
                            ['f36',
                             'B00',
                             'B01',
                             'Dz',
                             'Cz',
                             'Pz',
                             'f3',
                             'Iy'])),
                          (((0, 0, 2), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Ix*(f36 + B01*pow(Cz,2) + Pz*pow(Dz,2) + f3 + 4*B00*Cz*Dz)',
                            ['f36',
                             'Ix',
                             'B01',
                             'Dz',
                             'Cz',
                             'Pz',
                             'f3',
                             'B00'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('(f36 + B01*pow(Cz,2) + Pz*pow(Dz,2) + f3 + 4*B00*Cz*Dz)',
                            ['f36', 'B00', 'B01', 'Dz', 'Cz', 'Pz', 'f3'])),
                          (((2, 0, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                           ('Iz*(B01*pow(Cx,2) + f36 + Px*pow(Dx,2) + 4*B00*Cx*Dx + f3)',
                            ['Dx',
                             'Cx',
                             'Px',
                             'B01',
                             'f36',
                             'B00',
                             'Iz',
                             'f3'])),
                          (((2, 0, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                           ('Iy*(B01*pow(Cx,2) + f36 + Px*pow(Dx,2) + 4*B00*Cx*Dx + f3)',
                            ['Dx',
                             'Cx',
                             'Px',
                             'B01',
                             'f36',
                             'B00',
                             'f3',
                             'Iy'])),
                          (((2, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('(B01*pow(Cx,2) + f36 + Px*pow(Dx,2) + 4*B00*Cx*Dx + f3)',
                            ['Dx', 'Cx', 'Px', 'B01', 'f36', 'B00', 'f3'])),
                          (((2, 0, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('(B01*Ix*pow(Cx,2) + 6*B00*Dx*Px + Cx*(3*f36 + 3*f3 + pow(Dx,2)*(3*B10 + pow(Cx,2))) + 4*B00*Cx*Dx*Xij + Xij*(f36 + Px*pow(Dx,2) + f3))',
                            ['Dx',
                             'Ix',
                             'Cx',
                             'Px',
                             'B10',
                             'B01',
                             'f36',
                             'Xij',
                             'B00',
                             'f3'])),
                          (((1, 1, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cy*(f36 + 2*B00*Dx*(Xij + 2*Cx) + B01*Cx*Ix + pow(Dx,2)*(Cx*Ix + B10) + f3)',
                            ['f36',
                             'Ix',
                             'Cx',
                             'Xij',
                             'B10',
                             'B01',
                             'Dx',
                             'B00',
                             'f3',
                             'Cy'])),
                          (((1, 1, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*(Qx*Xij + f4)',
                            ['Dz', 'f4', 'Qx', 'Xij', 'Cy'])),
                          (((1, 1, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Qy*(Qx*Xij + f4)', ['f4', 'Qx', 'Qy', 'Xij'])),
                          (((1, 0, 1), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Qz*(Qx*Xij + f4)', ['f4', 'Qx', 'Qz', 'Xij'])),
                          (((1, 0, 1), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*(Qx*Xij + f4)',
                            ['Qx', 'Dy', 'f4', 'Cz', 'Xij'])),
                          (((1, 0, 1), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                           ('Cx*Dy*(f1 + Qz*Zij)',
                            ['Zij', 'Dy', 'f1', 'Cx', 'Qz'])),
                          (((0, 1, 1), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                           ('Cy*Dx*(f1 + Qz*Zij)',
                            ['Zij', 'Dx', 'f1', 'Qz', 'Cy'])),
                          (((1, 0, 1), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                           ('Qx*(f1 + Qz*Zij)', ['Zij', 'f1', 'Qx', 'Qz'])),
                          (((0, 1, 1), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                           ('Qy*(f1 + Qz*Zij)', ['Zij', 'f1', 'Qy', 'Qz'])),
                          (((1, 0, 1), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                           ('Cz*Qx*(Dy*Yij + Qy)',
                            ['Qx', 'Dy', 'Cz', 'Qy', 'Yij'])),
                          (((0, 1, 1), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Qy*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Dx', 'Cz', 'Qy'])),
                          (((0, 2, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dz*Py*(Dx*Xij + Qx)',
                            ['Dz', 'Dx', 'Qx', 'Py', 'Xij'])),
                          (((0, 1, 1), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Cy*Qz*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'Qz', 'Cy', 'Xij'])),
                          (((1, 1, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cy*Rz*(Px + Cx*Xij)',
                            ['Rz', 'Xij', 'Px', 'Cy', 'Cx'])),
                          (((1, 1, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dz*Qy*(Px + Cx*Xij)',
                            ['Dz', 'Qy', 'Cx', 'Px', 'Xij'])),
                          (((2, 0, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dz*Px*(Dy*Yij + Qy)',
                            ['Dz', 'Dy', 'Qy', 'Px', 'Yij'])),
                          (((1, 0, 1), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                           ('Cx*Qz*(Dy*Yij + Qy)',
                            ['Yij', 'Dy', 'Qy', 'Cx', 'Qz'])),
                          (((2, 0, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                           ('f4*(Dy*Yij + Qy)', ['f4', 'Dy', 'Qy', 'Yij'])),
                          (((0, 0, 2), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                           ('f1*(Dy*Yij + Qy)', ['Dy', 'f1', 'Qy', 'Yij'])),
                          (((0, 0, 2), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Pz*(Dy*Yij + Qy)',
                            ['Dy', 'Dx', 'Pz', 'Qy', 'Yij'])),
                          (((0, 0, 2), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dy*Pz*(Dx*Xij + Qx)',
                            ['Dy', 'Dx', 'Qx', 'Pz', 'Xij'])),
                          (((0, 0, 2), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('f1*(Dx*Xij + Qx)', ['Qx', 'Dx', 'f1', 'Xij'])),
                          (((0, 2, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('f32*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'Xij', 'f32'])),
                          (((0, 1, 1), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Cz*Qy*(Dx*Xij + Qx)',
                            ['Qx', 'Dx', 'Cz', 'Qy', 'Xij'])),
                          (((0, 1, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Cz*Dx*Qy', ['Dx', 'Cz', 'Qy'])),
                          (((0, 1, 1), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                           ('Cz*Dx*f24', ['f24', 'Dx', 'Cz'])),
                          (((0, 0, 2), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Dy*Pz', ['Dy', 'Dx', 'Pz'])),
                          (((0, 0, 2), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Dy*f40', ['Dy', 'Dx', 'f40'])),
                          (((0, 2, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Dz*f31', ['Dz', 'Dx', 'f31'])),
                          (((0, 2, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Dz*Py', ['Dz', 'Dx', 'Py'])),
                          (((0, 2, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Py*f8', ['Dx', 'f8', 'Py'])),
                          (((0, 1, 1), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Qz*f21', ['Dx', 'Qz', 'f21'])),
                          (((0, 1, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Cy*Dx*Qz', ['Dx', 'Qz', 'Cy'])),
                          (((0, 1, 1), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cy*Ix*f33', ['Ix', 'f33', 'Cy'])),
                          (((1, 1, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                           ('Cx*Cy*f30', ['f30', 'Cx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cx*Cy*Rz', ['Rz', 'Cx', 'Cy'])),
                          (((1, 1, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cx*Rz*f21', ['Rz', 'Cx', 'f21'])),
                          (((1, 1, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dz*Qx*f21', ['Dz', 'Qx', 'f21'])),
                          (((1, 1, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Qx', ['Dz', 'Qx', 'Cy'])),
                          (((1, 1, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                           ('Cy*Qx*f8', ['Qx', 'f8', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Qx', ['Qx', 'Dy', 'Cz'])),
                          (((1, 0, 1), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                           ('Dy*Qx*(Cz*Zij + Pz)',
                            ['Zij', 'Dy', 'Qx', 'Pz', 'Cz'])),
                          (((1, 0, 1), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                           ('Cx*Ry*(Cz*Zij + Pz)',
                            ['Zij', 'Cz', 'Pz', 'Cx', 'Ry'])),
                          (((1, 0, 1), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cz*Ry*(Px + Cx*Xij)',
                            ['Cz', 'Xij', 'Cx', 'Px', 'Ry'])),
                          (((1, 0, 1), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Qz*(Px + Cx*Xij)',
                            ['Dy', 'Xij', 'Qz', 'Px', 'Cx'])),
                          (((1, 0, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Cx*Dy*Qz', ['Dy', 'Cx', 'Qz'])),
                          (((2, 0, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Dz*f22', ['Dz', 'Dy', 'f22'])),
                          (((2, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Dz*Px', ['Dz', 'Dy', 'Px'])),
                          (((2, 0, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Px*f8', ['Dy', 'f8', 'Px'])),
                          (((1, 0, 1), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('f33*(Px + Cx*Xij)',
                            ['Xij', 'f33', 'Px', 'Cx'])),
                          (((1, 1, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('f42*(Px + Cx*Xij)',
                            ['Xij', 'f42', 'Px', 'Cx'])),
                          (((1, 1, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                           ('Cx*Iz*f42', ['f42', 'Cx', 'Iz'])),
                          (((1, 1, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                           ('Cx*Dz*f24', ['Dz', 'f24', 'Cx'])),
                          (((1, 1, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Cx*Dz*Qy', ['Dz', 'Qy', 'Cx'])),
                          (((1, 1, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                           ('Cx*Qy*f8', ['f8', 'Qy', 'Cx'])),
                          (((1, 0, 1), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cx*Cz*f28', ['Cz', 'Cx', 'f28'])),
                          (((1, 0, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cx*Cz*Ry', ['Cz', 'Cx', 'Ry'])),
                          (((0, 1, 1), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cz*Rx*f21', ['Rx', 'Cz', 'f21'])),
                          (((0, 1, 1), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                           ('Cy*Rx*(Cz*Zij + Pz)',
                            ['Rx', 'Zij', 'Cz', 'Pz', 'Cy'])),
                          (((0, 1, 1), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                           ('f42*(Cz*Zij + Pz)',
                            ['Zij', 'Cz', 'Pz', 'f42'])),
                          (((1, 0, 1), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                           ('f23*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Cz', 'f23'])),
                          (((1, 0, 1), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*f23', ['f23', 'Cz', 'Iy'])),
                          (((0, 1, 1), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*f14', ['f14', 'Cz', 'Cy'])),
                          (((0, 1, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*Rx', ['Rx', 'Cz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*f23', ['f23', 'Iz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cy*f23', ['f23', 'Cy'])),
                          (((1, 1, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                           ('f21*f23', ['f23', 'f21'])),
                          (((1, 0, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cz*f23', ['Cz', 'f23'])),
                          (((0, 1, 1), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cz*Ix*f42', ['Cz', 'f42', 'Ix'])),
                          (((0, 1, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cz*f42', ['Cz', 'f42'])),
                          (((1, 1, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cx*f42', ['Cx', 'f42'])),
                          (((1, 0, 1), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cx*Iy*f33', ['Iy', 'Cx', 'f33'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cx*f33', ['Cx', 'f33'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cy*f33', ['f33', 'Cy'])),
                          (((0, 1, 1), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                           ('f21*f33', ['f33', 'f21'])),
                          (((0, 2, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                           ('Rz*f31', ['Rz', 'f31'])),
                          (((0, 2, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                           ('Rx*f31', ['Rx', 'f31'])),
                          (((0, 0, 2), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                           ('Rx*f40', ['Rx', 'f40'])),
                          (((0, 0, 2), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                           ('Ry*f40', ['f40', 'Ry'])),
                          (((2, 0, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Ry*f22', ['f22', 'Ry'])),
                          (((2, 0, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Rz*f22', ['Rz', 'f22'])),
                          (((0, 2, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Ix*Py*Rz', ['Rz', 'Ix', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Py*Rz', ['Rz', 'Py'])),
                          (((2, 0, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                           ('Iy*Px*Rz', ['Rz', 'Iy', 'Px'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Px*Rz', ['Rz', 'Px'])),
                          (((2, 0, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                           ('Px*f28', ['f28', 'Px'])),
                          (((0, 0, 2), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                           ('Pz*f28', ['Pz', 'f28'])),
                          (((0, 0, 2), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Pz*f14', ['f14', 'Pz'])),
                          (((0, 2, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Py*f14', ['f14', 'Py'])),
                          (((0, 2, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                           ('Iz*Py*Rx', ['Rx', 'Iz', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Py*Rx', ['Rx', 'Py'])),
                          (((0, 0, 2), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                           ('Iy*Pz*Rx', ['Rx', 'Pz', 'Iy'])),
                          (((0, 0, 2), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Pz*Rx', ['Rx', 'Pz'])),
                          (((0, 0, 2), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Ix*Pz*Ry', ['Ix', 'Pz', 'Ry'])),
                          (((0, 0, 2), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Pz*Ry', ['Pz', 'Ry'])),
                          (((2, 0, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                           ('Iz*Px*Ry', ['Iz', 'Px', 'Ry'])),
                          (((2, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Px*Ry', ['Px', 'Ry'])),
                          (((2, 0, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                           ('Px*f30', ['f30', 'Px'])),
                          (((0, 2, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                           ('Py*f30', ['f30', 'Py'])),
                          (((0, 0, 2), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Ix*f1', ['Dy', 'Ix', 'f1'])),
                          (((0, 0, 2), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*f1', ['Dy', 'f1'])),
                          (((0, 2, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dz*Ix*f32', ['Dz', 'Ix', 'f32'])),
                          (((0, 2, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dz*f32', ['Dz', 'f32'])),
                          (((0, 2, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dz*f16', ['Dz', 'f16'])),
                          (((0, 1, 1), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Ix*Qy*Qz', ['Ix', 'Qy', 'Qz'])),
                          (((0, 1, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Qy*Qz', ['Qy', 'Qz'])),
                          (((1, 0, 1), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                           ('Iy*Qx*Qz', ['Qx', 'Iy', 'Qz'])),
                          (((1, 0, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Qx*Qz', ['Qx', 'Qz'])),
                          (((1, 1, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                           ('Iz*Qx*Qy', ['Qx', 'Qy', 'Iz'])),
                          (((1, 1, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Qx*Qy', ['Qx', 'Qy'])),
                          (((1, 1, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                           ('Qx*f24', ['f24', 'Qx'])),
                          (((0, 1, 1), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                           ('Qz*f24', ['f24', 'Qz'])),
                          (((0, 0, 2), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                           ('Dx*f7', ['f7', 'Dx'])),
                          (((0, 0, 2), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Iy*f1', ['Dx', 'f1', 'Iy'])),
                          (((0, 0, 2), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*f1', ['Dx', 'f1'])),
                          (((0, 2, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*f16', ['f16', 'Dx'])),
                          (((0, 2, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Iz*f32', ['Dx', 'Iz', 'f32'])),
                          (((0, 2, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*f32', ['Dx', 'f32'])),
                          (((0, 2, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                           ('f32*f8', ['f8', 'f32'])),
                          (((2, 0, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                           ('f4*f8', ['f4', 'f8'])),
                          (((2, 0, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dz*Iy*f4', ['Dz', 'f4', 'Iy'])),
                          (((2, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dz*f4', ['Dz', 'f4'])),
                          (((2, 0, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dz*f29', ['Dz', 'f29'])),
                          (((2, 0, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dy*f29', ['Dy', 'f29'])),
                          (((2, 0, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                           ('Dy*Iz*f4', ['f4', 'Dy', 'Iz'])),
                          (((2, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dy*f4', ['f4', 'Dy'])),
                          (((0, 0, 2), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                           ('Dy*f7', ['Dy', 'f7'])),
                          (((0, 2, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                           ('Iz*f2', ['Iz', 'f2'])),
                          (((0, 2, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Ix*f2', ['Ix', 'f2'])),
                          (((0, 2, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('f2', ['f2'])))),
 ('d', 'sp', 'p', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f1': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                          'f10': '(Dy*Iy + B00)',
                          'f11': '(Cy*Iy + B10)',
                          'f12': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                          'f14': '(Dx*Px + 2*B00*Cx)',
                          'f15': '(Dx*Ix + B00)',
                          'f22': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                          'f3': '3*B00*B10',
                          'f4': '(Dy*Py + 2*B00*Cy)',
                          'f5': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                          'f6': '(Dz*Pz + 2*B00*Cz)',
                          'f8': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((2, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*Ix*pow(Cx,2) + B00*Cx*(3*Cx + 2*Xij) + B10*Dx*(3*Cx + Xij) + f3)',
                            ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00', 'f3'])),
                          (((0, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*Iy*pow(Cy,2) + f3 + B00*Cy*(3*Cy + 2*Yij) + B10*Dy*(3*Cy + Yij))',
                            ['B10', 'Dy', 'Yij', 'B00', 'f3', 'Iy', 'Cy'])),
                          (((0, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(B00*Cz*(3*Cz + 2*Zij) + Dz*Iz*pow(Cz,2) + B10*Dz*(3*Cz + Zij) + f3)',
                            ['B10', 'Cz', 'Zij', 'Dz', 'B00', 'Iz', 'f3'])),
                          (((1, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*(f6 + Qz*Zij)', ['Zij', 'f6', 'Cx', 'Qz'])),
                          (((0, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*(f6 + Qz*Zij)', ['Zij', 'f6', 'Qz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*(Dz*Zij + Qz)',
                            ['Dz', 'Zij', 'Cx', 'Cy', 'Qz'])),
                          (((1, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*(Px + Cx*Xij)',
                            ['Dz', 'Xij', 'Px', 'Cy', 'Cx'])),
                          (((1, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy*(Px + Cx*Xij)', ['Qy', 'Cx', 'Px', 'Xij'])),
                          (((1, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*(Px + Cx*Xij)', ['Xij', 'Qz', 'Px', 'Cx'])),
                          (((1, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*(Px + Cx*Xij)',
                            ['Dy', 'Cz', 'Cx', 'Px', 'Xij'])),
                          (((1, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*(Cz*Zij + Pz)',
                            ['Zij', 'Dy', 'Cz', 'Pz', 'Cx'])),
                          (((0, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Qy*(Cz*Zij + Pz)', ['Zij', 'Pz', 'Cz', 'Qy'])),
                          (((1, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Qx*(Cz*Zij + Pz)', ['Zij', 'Qx', 'Pz', 'Cz'])),
                          (((0, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*(Cz*Zij + Pz)',
                            ['Zij', 'Dx', 'Cz', 'Pz', 'Cy'])),
                          (((0, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy*Pz', ['Pz', 'Dx', 'Iy'])),
                          (((1, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*f10', ['Cz', 'Cx', 'f10'])),
                          (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*Dy', ['Dy', 'Cz', 'Cx'])),
                          (((2, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz*Px', ['Dy', 'Iz', 'Px'])),
                          (((2, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Px*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz', 'Px'])),
                          (((0, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Py*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Py', 'Qz'])),
                          (((0, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix*Py', ['Dz', 'Ix', 'Py'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*Dz', ['Dz', 'Cx', 'Cy'])),
                          (((1, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*f11', ['Dz', 'Cx', 'f11'])),
                          (((0, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f11', ['Dx', 'Cz', 'f11'])),
                          (((0, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*f15', ['f15', 'Cz', 'Cy'])),
                          (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*Dx', ['Dx', 'Cz', 'Cy'])),
                          (((0, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f5', ['Dx', 'f5'])),
                          (((0, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Py*f15', ['f15', 'Py'])),
                          (((0, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Pz*f15', ['f15', 'Pz'])),
                          (((0, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix*Pz', ['Dy', 'Ix', 'Pz'])),
                          (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Pz', ['Dy', 'Pz'])),
                          (((2, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f12', ['Dy', 'f12'])),
                          (((2, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Px*f10', ['f10', 'Px'])),
                          (((0, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Pz*f10', ['Pz', 'f10'])),
                          (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Pz', ['Dx', 'Pz'])),
                          (((0, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz*Py', ['Dx', 'Iz', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Py', ['Dx', 'Py'])),
                          (((0, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f22', ['Dx', 'f22'])),
                          (((0, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f22', ['Dy', 'f22'])),
                          (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Px', ['Dy', 'Px'])),
                          (((2, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy*Px', ['Dz', 'Iy', 'Px'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Px', ['Dz', 'Px'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Py', ['Dz', 'Py'])),
                          (((2, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f12', ['Dz', 'f12'])),
                          (((0, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f5', ['Dz', 'f5'])),
                          (((1, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*f1', ['f1', 'Cx'])),
                          (((0, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*f1', ['f1', 'Cz'])),
                          (((0, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Ix*Qy', ['Cz', 'Qy', 'Ix'])),
                          (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Qy', ['Cz', 'Qy'])),
                          (((1, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Iz*Qy', ['Qy', 'Cx', 'Iz'])),
                          (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Qy', ['Qy', 'Cx'])),
                          (((1, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Iy*Qz', ['Iy', 'Cx', 'Qz'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Qz', ['Cx', 'Qz'])),
                          (((0, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Ix*Qz', ['Ix', 'Qz', 'Cy'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Qz', ['Qz', 'Cy'])),
                          (((1, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f8', ['f8', 'Cy'])),
                          (((1, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f8', ['Cz', 'f8'])),
                          (((1, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*Qx', ['Qx', 'Cz', 'Iy'])),
                          (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Qx', ['Qx', 'Cz'])),
                          (((1, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*Qx', ['Qx', 'Iz', 'Cy'])),
                          (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Qx', ['Qx', 'Cy'])),
                          (((1, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f11', ['Qx', 'f11'])),
                          (((0, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f11', ['Qz', 'f11'])),
                          (((0, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*f6', ['f6', 'Iy'])),
                          (((0, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*f6', ['f6', 'Ix'])),
                          (((0, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*f4', ['f4', 'Ix'])),
                          (((0, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*f4', ['f4', 'Iz'])),
                          (((2, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*f14', ['f14', 'Iz'])),
                          (((2, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*f14', ['f14', 'Iy'])),
                          (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('f14', ['f14'])),
                          (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('f4', ['f4'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('f6', ['f6'])))),
 ('d', 'sp', 's', 's'): ({'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((2, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Px', ['Iy', 'Px'])),
                          (((0, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Pz', ['Pz', 'Iy'])),
                          (((1, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz*Iy', ['Cz', 'Iy', 'Cx'])),
                          (((0, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*Ix', ['Cz', 'Ix', 'Cy'])),
                          (((0, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz', 'Cy'])),
                          (((0, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*(Cy*Iy + B10)', ['B10', 'Cz', 'Iy', 'Cy'])),
                          (((1, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*(Cy*Iy + B10)', ['B10', 'Iy', 'Cx', 'Cy'])),
                          (((0, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                            ['Yij', 'B10', 'Iy', 'Cy'])),
                          (((0, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*Py', ['Iz', 'Py'])),
                          (((1, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(Cx*Ix + B10)', ['B10', 'Ix', 'Cx', 'Cy'])),
                          (((2, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                            ['B10', 'Ix', 'Cx', 'Xij'])),
                          (((1, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*(Cx*Ix + B10)', ['B10', 'Cz', 'Cx', 'Ix'])),
                          (((1, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*(B10 + Cz*Iz)', ['B10', 'Cz', 'Cx', 'Iz'])),
                          (((0, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                            ['Zij', 'B10', 'Cz', 'Iz'])),
                          (((0, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Pz', ['Ix', 'Pz'])),
                          (((0, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Py', ['Ix', 'Py'])),
                          (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py', ['Py'])),
                          (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz', ['Pz'])),
                          (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px', ['Px'])),
                          (((2, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*Px', ['Iz', 'Px'])),
                          (((1, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*Iz', ['Cx', 'Cy', 'Iz'])),
                          (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy', ['Cx', 'Cy'])),
                          (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz', ['Cz', 'Cx'])),
                          (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz', ['Cz', 'Cy'])))),
 ('d', 'sp', 'sp', 's'): ({'B00': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Px': '(B10 + pow(Cx,2))',
                           'Py': '(B10 + pow(Cy,2))',
                           'Pz': '(B10 + pow(Cz,2))',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)',
                           'f10': '(Dy*Iy + B00)',
                           'f15': '(Dx*Ix + B00)',
                           'Xij': '',
                           'Yij': '',
                           'Zij': ''},
                          ((((0, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Py*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Py', 'Qz'])),
                           (((1, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Cy*(Dz*Zij + Qz)',
                             ['Dz', 'Zij', 'Cx', 'Cy', 'Qz'])),
                           (((1, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Qy*(Cx*Ix + B10)', ['B10', 'Ix', 'Qy', 'Cx'])),
                           (((1, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Qz*(Cx*Ix + B10)', ['B10', 'Ix', 'Qz', 'Cx'])),
                           (((2, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Px*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz', 'Px'])),
                           (((1, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['B10', 'B00', 'Cx', 'Zij', 'Dz', 'Cz', 'Iz'])),
                           (((0, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cy*(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz', 'Cy'])),
                           (((0, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                             ['B10', 'B00', 'Dy', 'Yij', 'Cz', 'Iy', 'Cy'])),
                           (((1, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                             ['B10', 'Cx', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                           (((0, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Iz*(Dy*Py + 2*B00*Cy)',
                             ['Dy', 'B00', 'Iz', 'Cy', 'Py'])),
                           (((0, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Ix*(Dy*Py + 2*B00*Cy)',
                             ['Dy', 'Ix', 'Py', 'Cy', 'B00'])),
                           (((0, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('(Dy*Py + 2*B00*Cy)',
                             ['Dy', 'B00', 'Py', 'Cy'])),
                           (((0, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(2*B00*Cy*Yij + 3*B00*Py + Dy*(B10*(3*Cy + Yij) + Iy*pow(Cy,2)))',
                             ['B10', 'Dy', 'Py', 'Yij', 'B00', 'Iy', 'Cy'])),
                           (((1, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Qx*(Cy*Iy + B10)', ['B10', 'Qx', 'Iy', 'Cy'])),
                           (((0, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Qz*(Cy*Iy + B10)', ['B10', 'Iy', 'Qz', 'Cy'])),
                           (((0, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*Dx', ['Dx', 'Cz', 'Cy'])),
                           (((0, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*f15', ['f15', 'Cz', 'Cy'])),
                           (((1, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Iz*Qx', ['Qx', 'Iz', 'Cy'])),
                           (((2, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Iz*(Dx*Px + 2*B00*Cx)',
                             ['Dx', 'B00', 'Iz', 'Px', 'Cx'])),
                           (((2, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Iy*(Dx*Px + 2*B00*Cx)',
                             ['Dx', 'B00', 'Iy', 'Cx', 'Px'])),
                           (((2, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Iy*Px', ['Dz', 'Iy', 'Px'])),
                           (((0, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Iy*(Dz*Pz + 2*B00*Cz)',
                             ['Dz', 'Pz', 'B00', 'Iy', 'Cz'])),
                           (((0, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Ix*(Dz*Pz + 2*B00*Cz)',
                             ['Dz', 'Ix', 'Pz', 'Cz', 'B00'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('(Dz*Pz + 2*B00*Cz)',
                             ['Dz', 'B00', 'Pz', 'Cz'])),
                           (((0, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(Dz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)) + 3*B00*Pz + 2*B00*Cz*Zij)',
                             ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Pz', 'Iz'])),
                           (((0, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Qy*(B10 + Cz*Iz)', ['B10', 'Cz', 'Qy', 'Iz'])),
                           (((1, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Qx*(B10 + Cz*Iz)', ['B10', 'Qx', 'Iz', 'Cz'])),
                           (((0, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                             ['Zij', 'Dx', 'Cz', 'B10', 'Iz'])),
                           (((0, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*(B10 + Cz*Iz)',
                             ['Dx', 'Cz', 'B10', 'Cy', 'Iz'])),
                           (((0, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cy*(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz', 'Cy'])),
                           (((1, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*(B10 + Cz*Iz)',
                             ['Dy', 'B10', 'Cz', 'Cx', 'Iz'])),
                           (((1, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Cz*Dy', ['Dy', 'Cz', 'Cx'])),
                           (((0, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Ix*Qy', ['Cz', 'Qy', 'Ix'])),
                           (((1, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Iy*Qx', ['Qx', 'Cz', 'Iy'])),
                           (((1, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cz*Iy', ['Cz', 'Iy', 'Cx'])),
                           (((0, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Iy*Pz', ['Pz', 'Iy'])),
                           (((0, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iy*Pz', ['Pz', 'Dx', 'Iy'])),
                           (((0, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Pz', ['Dx', 'Pz'])),
                           (((1, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'Cz', 'B00'])),
                           (((1, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00', 'Cy'])),
                           (((2, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                             ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00', 'Px'])),
                           (((2, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(Dx*Px + 2*B00*Cx)',
                             ['Dx', 'B00', 'Cx', 'Px'])),
                           (((2, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Px*f10', ['f10', 'Px'])),
                           (((0, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Pz*f10', ['Pz', 'f10'])),
                           (((1, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Cz*f10', ['Cz', 'Cx', 'f10'])),
                           (((1, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*(B10 + Cz*Iz)', ['B10', 'Cz', 'Cx', 'Iz'])),
                           (((0, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                             ['Zij', 'B10', 'Cz', 'Iz'])),
                           (((0, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                             ['Zij', 'Dy', 'B10', 'Cz', 'Iz'])),
                           (((0, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Pz', ['Dy', 'Pz'])),
                           (((0, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Ix*Pz', ['Dy', 'Ix', 'Pz'])),
                           (((0, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Ix*Pz', ['Ix', 'Pz'])),
                           (((0, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Pz*f15', ['f15', 'Pz'])),
                           (((0, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Py*f15', ['f15', 'Py'])),
                           (((0, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Iz*Py', ['Iz', 'Py'])),
                           (((0, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iz*Py', ['Dx', 'Iz', 'Py'])),
                           (((0, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Py', ['Dx', 'Py'])),
                           (((0, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                             ['Yij', 'Dx', 'Iy', 'B10', 'Cy'])),
                           (((0, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*(Cy*Iy + B10)',
                             ['Dx', 'Cz', 'Iy', 'B10', 'Cy'])),
                           (((0, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*(Cy*Iy + B10)', ['B10', 'Cz', 'Iy', 'Cy'])),
                           (((1, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*(Cy*Iy + B10)',
                             ['Dz', 'B10', 'Iy', 'Cx', 'Cy'])),
                           (((1, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*(Cx*Ix + B10)',
                             ['Dz', 'B10', 'Ix', 'Cx', 'Cy'])),
                           (((2, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                             ['Dz', 'B10', 'Ix', 'Cx', 'Xij'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Px', ['Dz', 'Px'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Cy*Dz', ['Dz', 'Cx', 'Cy'])),
                           (((0, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Ix*Qz', ['Ix', 'Qz', 'Cy'])),
                           (((0, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*Ix', ['Cz', 'Ix', 'Cy'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Cz', ['Cz', 'Cy'])),
                           (((1, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Qx', ['Qx', 'Cy'])),
                           (((1, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Qx', ['Qx', 'Cz'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cz', ['Cz', 'Cx'])),
                           (((1, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Iz*Qy', ['Qy', 'Cx', 'Iz'])),
                           (((1, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Qy', ['Qy', 'Cx'])),
                           (((0, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Qy', ['Cz', 'Qy'])),
                           (((0, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Pz', ['Pz'])),
                           (((1, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*(Cx*Ix + B10)', ['B10', 'Cz', 'Cx', 'Ix'])),
                           (((1, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*(Cx*Ix + B10)',
                             ['Dy', 'B10', 'Cz', 'Cx', 'Ix'])),
                           (((2, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                             ['Dy', 'B10', 'Ix', 'Cx', 'Xij'])),
                           (((2, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Px', ['Dy', 'Px'])),
                           (((2, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Iz*Px', ['Dy', 'Iz', 'Px'])),
                           (((2, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Iz*Px', ['Iz', 'Px'])),
                           (((1, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cy*Iz', ['Cx', 'Cy', 'Iz'])),
                           (((1, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cy', ['Cx', 'Cy'])),
                           (((1, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*(Cy*Iy + B10)', ['B10', 'Iy', 'Cx', 'Cy'])),
                           (((0, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                             ['Yij', 'B10', 'Iy', 'Cy'])),
                           (((0, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                             ['Dz', 'Yij', 'B10', 'Iy', 'Cy'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Py', ['Dz', 'Py'])),
                           (((0, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Ix*Py', ['Dz', 'Ix', 'Py'])),
                           (((0, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Ix*Py', ['Ix', 'Py'])),
                           (((0, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Py', ['Py'])),
                           (((1, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*(Cx*Ix + B10)', ['B10', 'Ix', 'Cx', 'Cy'])),
                           (((2, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                             ['B10', 'Ix', 'Cx', 'Xij'])),
                           (((2, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Px', ['Px'])),
                           (((2, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Iy*Px', ['Iy', 'Px'])),
                           (((1, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Iy*Qz', ['Iy', 'Cx', 'Qz'])),
                           (((1, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Qz', ['Cx', 'Qz'])),
                           (((0, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Qz', ['Qz', 'Cy'])))),
 ('f', 'd', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f10': '(Cy*Iy + B10)',
                         'f11': '(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                         'f12': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f13': '(B10 + Cz*Iz)',
                         'f14': '(3*pow(B10,2) + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                         'f15': '(B10 + pow(Iy,2))',
                         'f16': '(B10 + pow(Iz,2))',
                         'f19': '(3*pow(B10,2) + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3))',
                         'f2': '(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                         'f21': '(3*B10 + pow(Cz,2))',
                         'f22': '(3*B10 + pow(Cy,2))',
                         'f23': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f26': '(3*pow(B10,2) + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy))',
                         'f3': '(3*pow(B10,2) + pow(Cz,2)*pow(Iz,2) + B10*(6*Cz*Zij + pow(Zij,2) + 6*pow(Cz,2)))',
                         'f4': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'f5': '(3*pow(B10,2) + B10*(6*Cx*Xij + pow(Xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(Ix,2))',
                         'f7': '(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                         'f9': '(3*pow(B10,2) + B10*(6*Cy*Yij + pow(Yij,2) + 6*pow(Cy,2)) + pow(Cy,2)*pow(Iy,2))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 3), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f21*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cz', 'Px', 'Xij', 'f21', 'Cx'])),
                         (((1, 1, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f10*(Px + Cx*Xij)',
                           ['Cz', 'Xij', 'Px', 'f10', 'Cx'])),
                         (((0, 2, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Py*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cz', 'Px', 'Py', 'Xij', 'Cx'])),
                         (((1, 2, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*Py*(Px + Cx*Xij)',
                           ['Cx', 'Xij', 'Iz', 'Px', 'Py'])),
                         (((0, 3, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f22*(Xij*(Xij + 2*Cx) + Px)',
                           ['f22', 'Px', 'Xij', 'Cy', 'Cx'])),
                         (((1, 1, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f13*(Px + Cx*Xij)',
                           ['f13', 'Xij', 'Px', 'Cy', 'Cx'])),
                         (((0, 1, 2), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Pz*(Xij*(Xij + 2*Cx) + Px)',
                           ['Px', 'Pz', 'Xij', 'Cy', 'Cx'])),
                         (((1, 0, 2), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Pz*(Px + Cx*Xij)',
                           ['Pz', 'Iy', 'Cx', 'Px', 'Xij'])),
                         (((3, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*Iz*f0', ['f0', 'Iy', 'Cx', 'Iz'])),
                         (((1, 1, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*f7', ['f7', 'Cx', 'Cy'])),
                         (((0, 1, 2), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Pz*f10', ['Ix', 'Pz', 'f10'])),
                         (((0, 3, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*Iz*f22', ['Ix', 'f22', 'Iz', 'Cy'])),
                         (((2, 1, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f12', ['f12', 'Iz', 'Cy'])),
                         (((0, 0, 3), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('(3*pow(B10,2)*(5*Cz + 2*Zij) + B10*Cz*(3*pow(Zij,2) + 10*pow(Cz,2) + 12*Cz*Zij) + pow(Cz,3)*pow(Iz,2))',
                           ['Zij', 'B10', 'Cz', 'Iz'])),
                         (((0, 2, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*f4', ['f4', 'Cz', 'Ix'])),
                         (((0, 2, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Py*f13', ['f13', 'Ix', 'Py'])),
                         (((0, 1, 2), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*f23', ['Ix', 'f23', 'Cy'])),
                         (((2, 1, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Px*f16', ['f16', 'Px', 'Cy'])),
                         (((0, 3, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f16*f22', ['f16', 'f22', 'Cy'])),
                         (((1, 2, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Py*f16', ['f16', 'Cx', 'Py'])),
                         (((3, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f0*f16', ['f16', 'f0', 'Cx'])),
                         (((1, 0, 2), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Pz*f15', ['f15', 'Pz', 'Cx'])),
                         (((3, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f0*f15', ['f15', 'f0', 'Cx'])),
                         (((1, 1, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*f11', ['Cz', 'Cx', 'f11'])),
                         (((2, 0, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f12', ['f12', 'Cz', 'Iy'])),
                         (((0, 0, 3), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*Iy*f21', ['Cz', 'Iy', 'f21', 'Ix'])),
                         (((0, 0, 3), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f15*f21', ['f15', 'Cz', 'f21'])),
                         (((2, 0, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Px*f15', ['f15', 'Cz', 'Px'])),
                         (((2, 1, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*Px*f10', ['f10', 'Iz', 'Px'])),
                         (((2, 0, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Px*f13', ['f13', 'Iy', 'Px'])),
                         (((1, 0, 2), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f23*(Px + Cx*Xij)', ['f23', 'Cx', 'Px', 'Xij'])),
                         (((1, 2, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f4*(Px + Cx*Xij)', ['f4', 'Cx', 'Px', 'Xij'])),
                         (((1, 2, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*f4', ['f4', 'Cx', 'Iz'])),
                         (((1, 0, 2), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*f23', ['f23', 'Iy', 'Cx'])),
                         (((1, 1, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f10*f13', ['f13', 'Cx', 'f10'])),
                         (((3, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*Cx*(12*Cx*Xij + 10*pow(Cx,2) + 3*pow(Xij,2)) + 3*pow(B10,2)*(5*Cx + 2*Xij) + pow(Cx,3)*pow(Ix,2))',
                           ['B10', 'Ix', 'Cx', 'Xij'])),
                         (((0, 3, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*pow(B10,2)*(5*Cy + 2*Yij) + B10*Cy*(12*Cy*Yij + 3*pow(Yij,2) + 10*pow(Cy,2)) + pow(Cy,3)*pow(Iy,2))',
                           ['Yij', 'B10', 'Iy', 'Cy'])),
                         (((1, 1, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f2', ['Cz', 'f2', 'Cy'])),
                         (((1, 2, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*f2', ['Py', 'f2'])),
                         (((1, 0, 2), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f2', ['Pz', 'f2'])),
                         (((0, 1, 2), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f11', ['Pz', 'f11'])),
                         (((2, 1, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*f11', ['f11', 'Px'])),
                         (((2, 0, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Px*f7', ['f7', 'Px'])),
                         (((0, 2, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Py*f7', ['f7', 'Py'])),
                         (((2, 1, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f5', ['Cy', 'f5'])),
                         (((2, 0, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f5', ['Cz', 'f5'])),
                         (((0, 2, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f9', ['f9', 'Cz'])),
                         (((1, 2, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f9', ['f9', 'Cx'])),
                         (((1, 0, 2), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f3', ['Cx', 'f3'])),
                         (((0, 1, 2), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f3', ['f3', 'Cy'])),
                         (((0, 0, 3), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f19', ['Ix', 'f19'])),
                         (((0, 3, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f26', ['Ix', 'f26'])),
                         (((0, 3, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f26', ['Iz', 'f26'])),
                         (((3, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f14', ['f14', 'Iz'])),
                         (((3, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f14', ['f14', 'Iy'])),
                         (((0, 0, 3), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f19', ['Iy', 'f19'])),
                         (((0, 2, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f13*f4', ['f4', 'f13'])),
                         (((2, 0, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f12*f13', ['f13', 'f12'])),
                         (((2, 1, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f10*f12', ['f12', 'f10'])),
                         (((0, 1, 2), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f10*f23', ['f23', 'f10'])))),
 ('f', 'f', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f10': '(3*pow(B10,2) + B10*(6*Cx*Xij + pow(Xij,2) + 6*pow(Cx,2)) + pow(Cx,2)*pow(Ix,2))',
                         'f12': '(3*B10 + pow(Iy,2))',
                         'f13': '(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                         'f14': '(3*pow(B10,2) + B10*(6*Cy*Yij + pow(Yij,2) + 6*pow(Cy,2)) + pow(Cy,2)*pow(Iy,2))',
                         'f15': '(Cy*Iy + B10)',
                         'f18': '(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                         'f19': '(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                         'f2': '(3*pow(B10,2)*(5*Cz + 2*Zij) + B10*Cz*(3*pow(Zij,2) + 10*pow(Cz,2) + 12*Cz*Zij) + pow(Cz,3)*pow(Iz,2))',
                         'f20': '(B10 + pow(Iy,2))',
                         'f21': '(pow(Cy,2)*pow(Iy,3) + B10*Iy*(8*Cy*Yij + 10*pow(Cy,2) + pow(Yij,2)) + 3*pow(B10,2)*(5*Cy + 3*Yij))',
                         'f22': '(3*pow(B10,2)*(3*Zij + 5*Cz) + B10*Iz*(8*Cz*Zij + 10*pow(Cz,2) + pow(Zij,2)) + pow(Cz,2)*pow(Iz,3))',
                         'f23': '(3*pow(B10,2) + Cy*pow(Iy,3) + 3*B10*Iy*(Yij + 2*Cy))',
                         'f25': '(pow(Cx,2)*pow(Ix,3) + B10*Ix*(8*Cx*Xij + pow(Xij,2) + 10*pow(Cx,2)) + 3*pow(B10,2)*(5*Cx + 3*Xij))',
                         'f27': '(3*pow(B10,2) + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3))',
                         'f28': '(B10 + pow(Iz,2))',
                         'f29': '(3*B10 + pow(Iz,2))',
                         'f3': '(B10*Cx*(12*Cx*Xij + 10*pow(Cx,2) + 3*pow(Xij,2)) + 3*pow(B10,2)*(5*Cx + 2*Xij) + pow(Cx,3)*pow(Ix,2))',
                         'f30': '(3*pow(B10,2) + 3*B10*Ix*(Xij + 2*Cx) + Cx*pow(Ix,3))',
                         'f31': '(3*pow(B10,2) + Cz*pow(Iz,3) + 3*B10*Iz*(2*Cz + Zij))',
                         'f32': '(3*B10 + pow(Cz,2))',
                         'f33': '(3*B10 + pow(Cy,2))',
                         'f34': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f35': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f36': '15*pow(B10,3)',
                         'f39': '(3*pow(B10,2) + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy))',
                         'f6': '(3*pow(B10,2) + pow(Cz,2)*pow(Iz,2) + B10*(6*Cz*Zij + pow(Zij,2) + 6*pow(Cz,2)))',
                         'f7': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'f8': '(3*pow(B10,2) + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                         'f9': '(3*pow(B10,2)*(5*Cy + 2*Yij) + B10*Cy*(12*Cy*Yij + 3*pow(Yij,2) + 10*pow(Cy,2)) + pow(Cy,3)*pow(Iy,2))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 2, 1), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Py*(Cz*Zij + Pz)*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cx', 'Xij', 'Zij', 'Py', 'Cz', 'Pz', 'Px'])),
                         (((1, 1, 1), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('f15*(Px + Cx*Xij)*(Cz*Zij + Pz)',
                           ['f15', 'Cx', 'Px', 'Zij', 'Xij', 'Cz', 'Pz'])),
                         (((1, 1, 1), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f18*(Cz*Zij + Pz)',
                           ['Zij', 'Cz', 'Pz', 'f18', 'Cy'])),
                         (((1, 1, 1), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f19*(Cz*Zij + Pz)',
                           ['Zij', 'Cz', 'Pz', 'Cx', 'f19'])),
                         (((2, 0, 1), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f34*(Cz*Zij + Pz)',
                           ['f34', 'Zij', 'Cz', 'Iy', 'Pz'])),
                         (((0, 2, 1), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f7*(Cz*Zij + Pz)',
                           ['Zij', 'f7', 'Ix', 'Pz', 'Cz'])),
                         (((0, 2, 1), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*Py*(Xij*(Xij + 2*Cx) + f0)',
                           ['Ix', 'Cx', 'Xij', 'Py', 'Cz', 'f0'])),
                         (((0, 0, 3), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*f32*(Xij*(Xij + 2*Cx) + f0)',
                           ['Ix', 'Cx', 'Xij', 'Cz', 'f0', 'f32'])),
                         (((0, 1, 2), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*Pz*(Xij*(Xij + 2*Cx) + f0)',
                           ['Ix', 'Cx', 'Xij', 'Pz', 'f0', 'Cy'])),
                         (((0, 3, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*f33*(Xij*(Xij + 2*Cx) + f0)',
                           ['Ix', 'Cx', 'Xij', 'f0', 'Cy', 'f33'])),
                         (((3, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cx*Ix*(5*Cx*Xij + 5*pow(Cx,2) + pow(Xij,2)) + f36 + 9*pow(B10,2)*(5*Cx*Xij + 5*pow(Cx,2) + pow(Xij,2)) + pow(Cx,3)*pow(Ix,3))',
                           ['B10', 'Ix', 'f36', 'Cx', 'Xij'])),
                         (((0, 3, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('(9*pow(B10,2)*(5*Cy*Yij + 5*pow(Cy,2) + pow(Yij,2)) + f36 + pow(Cy,3)*pow(Iy,3) + 3*B10*Cy*Iy*(5*Cy*Yij + 5*pow(Cy,2) + pow(Yij,2)))',
                           ['Yij', 'B10', 'Iy', 'f36', 'Cy'])),
                         (((0, 0, 3), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('(f36 + 3*B10*Cz*Iz*(5*pow(Cz,2) + 5*Cz*Zij + pow(Zij,2)) + pow(Cz,3)*pow(Iz,3) + 9*pow(B10,2)*(5*pow(Cz,2) + 5*Cz*Zij + pow(Zij,2)))',
                           ['Zij', 'f36', 'Cz', 'B10', 'Iz'])),
                         (((2, 0, 1), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f10*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'f10'])),
                         (((0, 2, 1), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('f14*(Cz*Zij + Pz)', ['Zij', 'f14', 'Cz', 'Pz'])),
                         (((2, 0, 1), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Px*f20*(Cz*Zij + Pz)',
                           ['Zij', 'Cz', 'Pz', 'f20', 'Px'])),
                         (((1, 0, 2), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f20*(Px + Cx*Xij)',
                           ['Xij', 'Pz', 'f20', 'Px', 'Cx'])),
                         (((0, 1, 2), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f15*(Xij*(Xij + 2*Cx) + Px)',
                           ['f15', 'Pz', 'Cx', 'Xij', 'Px'])),
                         (((1, 2, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f7*(Px + Cx*Xij)',
                           ['f7', 'Xij', 'Iz', 'Px', 'Cx'])),
                         (((0, 3, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f33*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cx', 'Px', 'Xij', 'Iz', 'Cy', 'f33'])),
                         (((1, 1, 1), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f13*(Px + Cx*Xij)',
                           ['f13', 'Xij', 'Px', 'Cy', 'Cx'])),
                         (((0, 1, 2), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f35*(Xij*(Xij + 2*Cx) + Px)',
                           ['Cx', 'Px', 'Xij', 'Cy', 'f35'])),
                         (((1, 0, 2), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f35*(Px + Cx*Xij)',
                           ['Xij', 'Iy', 'Cx', 'Px', 'f35'])),
                         (((0, 0, 3), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f32*(Xij*(Xij + 2*Cx) + Px)',
                           ['Xij', 'Px', 'Cz', 'Iy', 'f32', 'Cx'])),
                         (((1, 1, 1), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f19*(Px + Cx*Xij)',
                           ['Cz', 'Xij', 'f19', 'Px', 'Cx'])),
                         (((0, 2, 1), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f7*(Xij*(Xij + 2*Cx) + Px)',
                           ['f7', 'Cz', 'Px', 'Cx', 'Xij'])),
                         (((1, 2, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Py*f28*(Px + Cx*Xij)',
                           ['Cx', 'Xij', 'Py', 'Px', 'f28'])),
                         (((3, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*f0*f28', ['f0', 'Iy', 'Cx', 'f28'])),
                         (((1, 0, 2), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f20*f35', ['f35', 'Cx', 'f20'])),
                         (((0, 1, 2), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Pz*f19', ['Ix', 'Pz', 'f19'])),
                         (((0, 3, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*f28*f33', ['Ix', 'f28', 'Cy', 'f33'])),
                         (((0, 1, 2), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*f6', ['f6', 'Ix', 'Cy'])),
                         (((2, 1, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f28*f34', ['f34', 'f28', 'Cy'])),
                         (((2, 1, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Px*f15*f28', ['f15', 'f28', 'Px'])),
                         (((1, 2, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f28*f7', ['f7', 'Cx', 'f28'])),
                         (((1, 1, 1), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f13*f15', ['f15', 'f13', 'Cx'])),
                         (((3, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Iz*f8', ['f8', 'Iy', 'Iz'])),
                         (((0, 3, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iz*f39', ['Ix', 'f39', 'Iz'])),
                         (((0, 0, 3), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iy*f27', ['f27', 'Ix', 'Iy'])),
                         (((0, 2, 1), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*f14', ['f14', 'Cz', 'Ix'])),
                         (((0, 0, 3), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*f20*f32', ['Cz', 'f20', 'Ix', 'f32'])),
                         (((2, 0, 1), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f20*f34', ['f34', 'Cz', 'f20'])),
                         (((1, 1, 1), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f15*f18', ['f15', 'Cz', 'f18'])),
                         (((2, 1, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f15*f34', ['f34', 'f15', 'Iz'])),
                         (((0, 1, 2), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f15*f35', ['f15', 'Ix', 'f35'])),
                         (((0, 2, 1), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Py*f13', ['f13', 'Ix', 'Py'])),
                         (((2, 0, 1), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Px*f13', ['f13', 'Iy', 'Px'])),
                         (((2, 0, 1), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*Px*f12', ['f12', 'Cz', 'Iy', 'Px'])),
                         (((0, 0, 3), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f12*f32', ['f12', 'Cz', 'Iy', 'f32'])),
                         (((2, 0, 1), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f10', ['Cz', 'Iy', 'f10'])),
                         (((1, 0, 2), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Pz*f18', ['Pz', 'Iy', 'f18'])),
                         (((1, 0, 2), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*Pz*f12', ['Pz', 'Iy', 'Cx', 'f12'])),
                         (((3, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*f0*f12', ['f0', 'Iy', 'Cx', 'f12'])),
                         (((1, 0, 2), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*f6', ['f6', 'Iy', 'Cx'])),
                         (((1, 0, 2), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('f6*(Px + Cx*Xij)', ['f6', 'Cx', 'Px', 'Xij'])),
                         (((0, 0, 3), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f27*(Xij*(Xij + 2*Cx) + Px)',
                           ['f27', 'Px', 'Cx', 'Xij'])),
                         (((0, 3, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f39*(Xij*(Xij + 2*Cx) + Px)',
                           ['f39', 'Px', 'Cx', 'Xij'])),
                         (((1, 2, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('f14*(Px + Cx*Xij)', ['f14', 'Cx', 'Px', 'Xij'])),
                         (((1, 2, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*f14', ['f14', 'Cx', 'Iz'])),
                         (((3, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*f0*f20', ['f20', 'f0', 'Cx', 'Iz'])),
                         (((3, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*f0*f29', ['f0', 'Cx', 'f29', 'Iz'])),
                         (((1, 2, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*Py*f29', ['f29', 'Cx', 'Py', 'Iz'])),
                         (((1, 2, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*Py*f18', ['Iz', 'f18', 'Py'])),
                         (((2, 1, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*Px*f19', ['Iz', 'Px', 'f19'])),
                         (((2, 1, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*Px*f29', ['Px', 'Iz', 'Cy', 'f29'])),
                         (((0, 3, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f29*f33', ['f33', 'Iz', 'Cy', 'f29'])),
                         (((2, 1, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f10', ['f10', 'Iz', 'Cy'])),
                         (((1, 1, 1), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*f31', ['f31', 'Cx', 'Cy'])),
                         (((1, 1, 1), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*f23', ['Cz', 'f23', 'Cx'])),
                         (((1, 1, 1), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f30', ['Cz', 'f30', 'Cy'])),
                         (((1, 2, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*f30', ['f30', 'Py'])),
                         (((1, 0, 2), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f30', ['f30', 'Pz'])),
                         (((0, 1, 2), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f23', ['f23', 'Pz'])),
                         (((2, 1, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*f23', ['f23', 'Px'])),
                         (((2, 0, 1), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Px*f31', ['f31', 'Px'])),
                         (((0, 2, 1), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Py*f31', ['f31', 'Py'])),
                         (((2, 1, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f25', ['f25', 'Cy'])),
                         (((2, 0, 1), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f25', ['f25', 'Cz'])),
                         (((0, 2, 1), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f21', ['Cz', 'f21'])),
                         (((1, 2, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f21', ['Cx', 'f21'])),
                         (((1, 0, 2), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f22', ['f22', 'Cx'])),
                         (((0, 1, 2), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f22', ['f22', 'Cy'])),
                         (((0, 0, 3), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('f20*f27', ['f27', 'f20'])),
                         (((3, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('f20*f8', ['f8', 'f20'])),
                         (((3, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('f28*f8', ['f8', 'f28'])),
                         (((0, 3, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('f28*f39', ['f39', 'f28'])),
                         (((0, 0, 3), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f2', ['Ix', 'f2'])),
                         (((0, 3, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f9', ['f9', 'Ix'])),
                         (((0, 3, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f9', ['f9', 'Iz'])),
                         (((3, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f3', ['Iz', 'f3'])),
                         (((3, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f3', ['Iy', 'f3'])),
                         (((0, 0, 3), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f2', ['Iy', 'f2'])),
                         (((2, 0, 1), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('f13*f34', ['f34', 'f13'])),
                         (((2, 1, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('f19*f34', ['f34', 'f19'])),
                         (((0, 1, 2), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('f19*f35', ['f19', 'f35'])),
                         (((1, 0, 2), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f18*f35', ['f18', 'f35'])),
                         (((1, 2, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f18*f7', ['f7', 'f18'])),
                         (((0, 2, 1), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('f13*f7', ['f7', 'f13'])),
                         (((2, 1, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f10*f15', ['f15', 'f10'])),
                         (((0, 1, 2), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('f15*f6', ['f15', 'f6'])))),
 ('f', 'p', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f10': '(3*B00*Pz + Cz*Dz*(3*B10 + pow(Cz,2)))',
                         'f11': '(3*pow(B10,2) + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3))',
                         'f12': '(B00 + Dz*Iz)',
                         'f14': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                         'f16': '(Dy*Iy + B00)',
                         'f17': '(Cy*Iy + B10)',
                         'f18': '(3*pow(B10,2) + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                         'f2': '(Dz*Pz + 2*B00*Cz)',
                         'f20': '(Dx*Px + 2*B00*Cx)',
                         'f22': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f28': '(Cx*Dx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                         'f3': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f31': '(3*B10 + pow(Cz,2))',
                         'f32': '(3*B10 + pow(Cy,2))',
                         'f35': '(3*pow(B10,2) + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy))',
                         'f4': '(Dz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)) + 3*B00*Pz + 2*B00*Cz*Zij)',
                         'f5': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                         'f6': '(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                         'f7': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                         'f8': '(Dy*Py + 2*B00*Cy)',
                         'f9': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((1, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*(f7 + Yij*(Dy*Py + 2*B00*Cy))',
                           ['Cx', 'Dy', 'Py', 'Yij', 'B00', 'f7', 'Cy'])),
                         (((0, 2, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*(f7 + Yij*(Dy*Py + 2*B00*Cy))',
                           ['Cz', 'Dy', 'Py', 'Yij', 'B00', 'f7', 'Cy'])),
                         (((0, 3, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('(3*B00*Py*Yij + Dy*(3*pow(B10,2) + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy)) + 4*B00*Cy*f32)',
                           ['B10',
                            'Dy',
                            'Py',
                            'Yij',
                            'B00',
                            'f32',
                            'Iy',
                            'Cy'])),
                         (((1, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Py*(Px + Cx*Xij)',
                           ['Dz', 'Xij', 'Py', 'Px', 'Cx'])),
                         (((1, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Qz*(Px + Cx*Xij)',
                           ['Xij', 'Px', 'Qz', 'Cy', 'Cx'])),
                         (((1, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Qy*(Px + Cx*Xij)',
                           ['Cz', 'Qy', 'Cx', 'Px', 'Xij'])),
                         (((1, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Qy*(Cz*Zij + Pz)',
                           ['Zij', 'Pz', 'Cz', 'Qy', 'Cx'])),
                         (((1, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Cy*(f2 + Qz*Zij)',
                           ['Zij', 'f2', 'Cx', 'Cy', 'Qz'])),
                         (((0, 2, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Py*(f2 + Qz*Zij)', ['Zij', 'Py', 'f2', 'Qz'])),
                         (((2, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Px*(f2 + Qz*Zij)', ['Zij', 'f2', 'Px', 'Qz'])),
                         (((0, 0, 3), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('(3*B00*Pz*Zij + Dz*(3*pow(B10,2) + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3)) + 4*B00*Cz*f31)',
                           ['B10',
                            'Cz',
                            'Zij',
                            'Dz',
                            'B00',
                            'Pz',
                            'Iz',
                            'f31'])),
                         (((3, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(3*B00*Px*Xij + 4*B00*Cx*f0 + Dx*(3*pow(B10,2) + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3)))',
                           ['Dx',
                            'Ix',
                            'Px',
                            'Xij',
                            'B10',
                            'B00',
                            'f0',
                            'Cx'])),
                         (((3, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*Iz*f0', ['Dy', 'f0', 'Cx', 'Iz'])),
                         (((1, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Pz*(Px + Cx*Xij)',
                           ['Dy', 'Pz', 'Cx', 'Px', 'Xij'])),
                         (((2, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Px*(Cz*Zij + Pz)',
                           ['Zij', 'Dy', 'Cz', 'Pz', 'Px'])),
                         (((1, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Qx*(Cz*Zij + Pz)',
                           ['Zij', 'Qx', 'Pz', 'Cy', 'Cz'])),
                         (((0, 1, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Pz*(Dx*Xij + Qx)',
                           ['Dx', 'Qx', 'Pz', 'Xij', 'Cy'])),
                         (((0, 3, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*f32*(Dx*Xij + Qx)',
                           ['Dx', 'Qx', 'f32', 'Cy', 'Xij'])),
                         (((0, 0, 3), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*f31*(Dx*Xij + Qx)',
                           ['Qx', 'f31', 'Cz', 'Dx', 'Xij'])),
                         (((0, 2, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Py*(Dx*Xij + Qx)',
                           ['Qx', 'Dx', 'Cz', 'Py', 'Xij'])),
                         (((0, 2, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Py*(Cz*Zij + Pz)',
                           ['Zij', 'Dx', 'Cz', 'Pz', 'Py'])),
                         (((2, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('f20*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'f20'])),
                         (((0, 2, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('f8*(Cz*Zij + Pz)', ['Zij', 'Pz', 'Cz', 'f8'])),
                         (((1, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Cz*f5', ['Cz', 'Cx', 'f5'])),
                         (((0, 3, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*Ix*f32', ['Dz', 'Ix', 'f32', 'Cy'])),
                         (((2, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*f22', ['Dz', 'f22', 'Cy'])),
                         (((0, 2, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Ix*Py*Qz', ['Ix', 'Py', 'Qz'])),
                         (((0, 1, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Ix*f2', ['Ix', 'f2', 'Cy'])),
                         (((1, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('f2*(Px + Cx*Xij)', ['Xij', 'Px', 'f2', 'Cx'])),
                         (((1, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('f8*(Px + Cx*Xij)', ['f8', 'Cx', 'Px', 'Xij'])),
                         (((1, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Iz*f8', ['f8', 'Cx', 'Iz'])),
                         (((2, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*Px*Qy', ['Qy', 'Iz', 'Px'])),
                         (((2, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Px*f17', ['Dz', 'Px', 'f17'])),
                         (((2, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Iy*Px*Qz', ['Iy', 'Qz', 'Px'])),
                         (((3, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*Iy*f0', ['Dz', 'f0', 'Iy', 'Cx'])),
                         (((1, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*f9', ['Dz', 'f9', 'Cx'])),
                         (((1, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Iy*f2', ['Iy', 'Cx', 'f2'])),
                         (((1, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Qz*f17', ['f17', 'Cx', 'Qz'])),
                         (((1, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*f3', ['Dy', 'Cx', 'f3'])),
                         (((0, 1, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*f3', ['Dx', 'f3', 'Cy'])),
                         (((2, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f20', ['Iz', 'Cy', 'f20'])),
                         (((0, 3, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*Iz*f32', ['Dx', 'f32', 'Iz', 'Cy'])),
                         (((0, 3, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*f12*f32', ['f12', 'f32', 'Cy'])),
                         (((2, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Px*f12', ['f12', 'Px', 'Cy'])),
                         (((2, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Px*f16', ['f16', 'Cz', 'Px'])),
                         (((0, 0, 3), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*f16*f31', ['f16', 'f31', 'Cz'])),
                         (((2, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*f22', ['Dy', 'Cz', 'f22'])),
                         (((0, 0, 3), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*Ix*f31', ['Dy', 'f31', 'Cz', 'Ix'])),
                         (((0, 2, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Ix*f8', ['Cz', 'f8', 'Ix'])),
                         (((0, 1, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*Pz*Qy', ['Qy', 'Ix', 'Pz'])),
                         (((1, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Pz*f16', ['f16', 'Pz', 'Cx'])),
                         (((3, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*f0*f16', ['f16', 'f0', 'Cx'])),
                         (((3, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*f0*f12', ['f12', 'f0', 'Cx'])),
                         (((1, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Py*f12', ['f12', 'Cx', 'Py'])),
                         (((1, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*Py*Qx', ['Qx', 'Iz', 'Py'])),
                         (((1, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Qx*f17', ['Qx', 'Cz', 'f17'])),
                         (((1, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*Pz*Qx', ['Pz', 'Qx', 'Iy'])),
                         (((0, 1, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Pz*f17', ['Dx', 'Pz', 'f17'])),
                         (((0, 2, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*f9', ['Dx', 'Cz', 'f9'])),
                         (((0, 0, 3), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*Iy*f31', ['f31', 'Dx', 'Cz', 'Iy'])),
                         (((2, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f20', ['Cz', 'Iy', 'f20'])),
                         (((1, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f14', ['f14', 'Cz', 'Cy'])),
                         (((2, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((2, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*f6', ['f6', 'Cz'])),
                         (((1, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Py*f14', ['f14', 'Py'])),
                         (((1, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Pz*f14', ['f14', 'Pz'])),
                         (((2, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Px*f5', ['Px', 'f5'])),
                         (((0, 1, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Pz*f5', ['Pz', 'f5'])),
                         (((0, 3, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f35', ['Dx', 'f35'])),
                         (((0, 0, 3), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f11', ['Dx', 'f11'])),
                         (((0, 0, 3), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f11', ['Dy', 'f11'])),
                         (((3, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f18', ['Dy', 'f18'])),
                         (((3, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f18', ['Dz', 'f18'])),
                         (((0, 3, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f35', ['Dz', 'f35'])),
                         (((0, 0, 3), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Ix*f10', ['Ix', 'f10'])),
                         (((0, 3, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*f7', ['f7', 'Ix'])),
                         (((0, 3, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*f7', ['f7', 'Iz'])),
                         (((3, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*f28', ['Iz', 'f28'])),
                         (((3, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*f28', ['Iy', 'f28'])),
                         (((0, 0, 3), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Iy*f10', ['Iy', 'f10'])),
                         (((2, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*f22', ['f22', 'Qz'])),
                         (((2, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Qy*f22', ['f22', 'Qy'])),
                         (((0, 1, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Qy*f3', ['Qy', 'f3'])),
                         (((1, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Qx*f3', ['Qx', 'f3'])),
                         (((1, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Qx*f9', ['f9', 'Qx'])),
                         (((0, 2, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz*f9', ['f9', 'Qz'])),
                         (((2, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('f17*f20', ['f20', 'f17'])),
                         (((0, 1, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('f17*f2', ['f2', 'f17'])),
                         (((1, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*f4', ['f4', 'Cx'])),
                         (((0, 1, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*f4', ['f4', 'Cy'])))),
 ('f', 'p', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f11': '(3*B10 + pow(Cz,2))',
                         'f12': '(3*B10 + pow(Cy,2))',
                         'f13': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                         'f2': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                         'f5': '(Cy*Iy + B10)',
                         'f6': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                         'f8': '3*pow(B10,2)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((1, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*(Cz*Zij + Pz)',
                           ['Zij', 'Cz', 'Pz', 'Cx', 'Cy'])),
                         (((1, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*(Px + Cx*Xij)',
                           ['Cz', 'Xij', 'Px', 'Cy', 'Cx'])),
                         (((3, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3) + f8)',
                           ['B10', 'Ix', 'f8', 'Cx', 'Xij'])),
                         (((0, 3, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(Iy*pow(Cy,3) + f8 + 3*B10*Cy*(Yij + 2*Cy))',
                           ['f8', 'B10', 'Iy', 'Cy', 'Yij'])),
                         (((0, 0, 3), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cz*(2*Cz + Zij) + f8 + Iz*pow(Cz,3))',
                           ['Zij', 'B10', 'Cz', 'f8', 'Iz'])),
                         (((2, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Px*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Px'])),
                         (((0, 2, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Py*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Py'])),
                         (((1, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cz*f5', ['Cz', 'Cx', 'f5'])),
                         (((0, 1, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*Pz', ['Ix', 'Pz', 'Cy'])),
                         (((0, 3, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*f12', ['Ix', 'f12', 'Cy'])),
                         (((0, 3, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f12', ['f12', 'Iz', 'Cy'])),
                         (((2, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*Px', ['Px', 'Iz', 'Cy'])),
                         (((1, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Py*(Px + Cx*Xij)', ['Xij', 'Py', 'Px', 'Cx'])),
                         (((1, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*(Px + Cx*Xij)', ['Pz', 'Cx', 'Px', 'Xij'])),
                         (((1, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*Pz', ['Pz', 'Iy', 'Cx'])),
                         (((3, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*f0', ['f0', 'Iy', 'Cx'])),
                         (((3, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*f0', ['f0', 'Cx', 'Iz'])),
                         (((1, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*Py', ['Cx', 'Py', 'Iz'])),
                         (((0, 2, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*Py', ['Cz', 'Py', 'Ix'])),
                         (((0, 0, 3), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*f11', ['Cz', 'f11', 'Ix'])),
                         (((0, 0, 3), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f11', ['Cz', 'Iy', 'f11'])),
                         (((2, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*Px', ['Cz', 'Iy', 'Px'])),
                         (((2, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Px*f5', ['Px', 'f5'])),
                         (((0, 1, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Pz*f5', ['Pz', 'f5'])),
                         (((2, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((2, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f6', ['f6', 'Cz'])),
                         (((0, 2, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f2', ['Cz', 'f2'])),
                         (((1, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f2', ['Cx', 'f2'])),
                         (((1, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f13', ['f13', 'Cx'])),
                         (((0, 1, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f13', ['f13', 'Cy'])))),
 ('f', 'p', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f0': '(3*B10 + pow(Cx,2))',
                          'f10': '(3*B00*Pz + Cz*Dz*(3*B10 + pow(Cz,2)))',
                          'f15': '(Dy*Iy + B00)',
                          'f16': '(3*pow(B10,2) + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3))',
                          'f17': '(Cy*Iy + B10)',
                          'f18': '(3*pow(B10,2) + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy))',
                          'f19': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                          'f2': '(Dz*Pz + 2*B00*Cz)',
                          'f21': '(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                          'f24': '3*pow(B10,2)',
                          'f28': '(Cx*Dx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                          'f3': '(Dz*(Iz*pow(Cz,2) + B10*(3*Cz + Zij)) + 3*B00*Pz + 2*B00*Cz*Zij)',
                          'f32': '(3*B10 + pow(Cz,2))',
                          'f33': '(3*B10 + pow(Cy,2))',
                          'f34': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                          'f4': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                          'f5': '(Dx*Px + 2*B00*Cx)',
                          'f6': '(B00 + Dz*Iz)',
                          'f7': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                          'f8': '(Dy*Py + 2*B00*Cy)',
                          'f9': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*(f2 + Qz*Zij)',
                            ['Zij', 'f2', 'Cx', 'Cy', 'Qz'])),
                          (((0, 2, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*(f7 + Yij*(Dy*Py + 2*B00*Cy))',
                            ['Cz', 'Dy', 'Py', 'Yij', 'B00', 'f7', 'Cy'])),
                          (((1, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*(f7 + Yij*(Dy*Py + 2*B00*Cy))',
                            ['Cx', 'Dy', 'Py', 'Yij', 'B00', 'f7', 'Cy'])),
                          (((0, 3, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*(f24 + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy)) + 3*B00*Py*Yij + 4*B00*Cy*f33)',
                            ['B10',
                             'f33',
                             'Dy',
                             'Py',
                             'Yij',
                             'B00',
                             'f24',
                             'Iy',
                             'Cy'])),
                          (((0, 0, 3), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(Dz*(f24 + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3)) + 3*B00*Pz*Zij + 4*B00*Cz*f32)',
                            ['B10',
                             'B00',
                             'Zij',
                             'f24',
                             'Dz',
                             'Cz',
                             'Pz',
                             'Iz',
                             'f32'])),
                          (((2, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Px*(f2 + Qz*Zij)', ['Zij', 'f2', 'Px', 'Qz'])),
                          (((0, 2, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Py*(f2 + Qz*Zij)', ['Zij', 'Py', 'f2', 'Qz'])),
                          (((0, 0, 3), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f32*(Dx*Xij + Qx)',
                            ['Qx', 'Dx', 'Cz', 'Xij', 'f32'])),
                          (((0, 2, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Py*(Dx*Xij + Qx)',
                            ['Qx', 'Dx', 'Cz', 'Py', 'Xij'])),
                          (((0, 3, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f33*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'f33', 'Cy', 'Xij'])),
                          (((0, 1, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Pz*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'Pz', 'Xij', 'Cy'])),
                          (((1, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Qx*(Cz*Zij + Pz)',
                            ['Zij', 'Qx', 'Pz', 'Cy', 'Cz'])),
                          (((1, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*(Cz*Zij + Pz)',
                            ['Zij', 'Cz', 'Pz', 'Cx', 'Cy'])),
                          (((1, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Qy*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Cz', 'Qy', 'Cx'])),
                          (((1, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Qy*(Px + Cx*Xij)',
                            ['Cz', 'Qy', 'Cx', 'Px', 'Xij'])),
                          (((1, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Qz*(Px + Cx*Xij)',
                            ['Xij', 'Px', 'Qz', 'Cy', 'Cx'])),
                          (((1, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*(Px + Cx*Xij)',
                            ['Cz', 'Xij', 'Px', 'Cy', 'Cx'])),
                          (((1, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*(Qx*Xij + f5)',
                            ['Qx', 'Cz', 'Xij', 'Cy', 'f5'])),
                          (((1, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Pz*(Qx*Xij + f5)', ['Qx', 'Pz', 'Xij', 'f5'])),
                          (((1, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Py*(Qx*Xij + f5)', ['Qx', 'Py', 'Xij', 'f5'])),
                          (((3, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*(f24 + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3)) + 3*B00*Px*Xij + 4*B00*Cx*f0)',
                            ['Dx',
                             'Ix',
                             'Cx',
                             'Xij',
                             'f24',
                             'B10',
                             'B00',
                             'f0',
                             'Px'])),
                          (((3, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*(f24 + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                            ['B10', 'Ix', 'Cx', 'Xij', 'f24', 'Dz'])),
                          (((3, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*(f24 + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                            ['B10', 'Ix', 'Cx', 'Xij', 'Dy', 'f24'])),
                          (((3, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(f24 + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                            ['f24', 'B10', 'Ix', 'Cx', 'Xij'])),
                          (((0, 1, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Ix*f2', ['Ix', 'f2', 'Cy'])),
                          (((0, 2, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Py*Qz', ['Ix', 'Py', 'Qz'])),
                          (((1, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Qz*f17', ['f17', 'Cx', 'Qz'])),
                          (((2, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*Px*Qz', ['Iy', 'Qz', 'Px'])),
                          (((2, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*Px*Qy', ['Qy', 'Iz', 'Px'])),
                          (((1, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*Py*Qx', ['Qx', 'Iz', 'Py'])),
                          (((2, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*f5', ['Iz', 'Cy', 'f5'])),
                          (((0, 3, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f33*f6', ['f6', 'f33', 'Cy'])),
                          (((2, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Px*f6', ['f6', 'Px', 'Cy'])),
                          (((2, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*Px', ['Px', 'Iz', 'Cy'])),
                          (((0, 3, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*Iz*f33', ['Dx', 'Iz', 'Cy', 'f33'])),
                          (((0, 3, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*f33', ['Iz', 'Cy', 'f33'])),
                          (((1, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Iz*f8', ['f8', 'Cx', 'Iz'])),
                          (((1, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*f4', ['f4', 'Cz', 'Cx'])),
                          (((1, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Iy*f2', ['Iy', 'Cx', 'f2'])),
                          (((1, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('f2*(Px + Cx*Xij)', ['Xij', 'Px', 'f2', 'Cx'])),
                          (((1, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('f8*(Px + Cx*Xij)', ['f8', 'Cx', 'Px', 'Xij'])),
                          (((1, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Py*(Px + Cx*Xij)',
                            ['Dz', 'Xij', 'Py', 'Px', 'Cx'])),
                          (((1, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Px + Cx*Xij)', ['Xij', 'Py', 'Px', 'Cx'])),
                          (((1, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Pz*(Px + Cx*Xij)',
                            ['Dy', 'Pz', 'Cx', 'Px', 'Xij'])),
                          (((1, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*(Px + Cx*Xij)', ['Pz', 'Cx', 'Px', 'Xij'])),
                          (((1, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Pz*f15', ['f15', 'Pz', 'Cx'])),
                          (((3, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*f0*f15', ['f15', 'f0', 'Cx'])),
                          (((3, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f0*f6', ['f6', 'f0', 'Cx'])),
                          (((1, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Py*f6', ['f6', 'Cx', 'Py'])),
                          (((1, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz*Py', ['Cx', 'Py', 'Iz'])),
                          (((3, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*Iz*f0', ['Dy', 'f0', 'Cx', 'Iz'])),
                          (((3, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz*f0', ['f0', 'Cx', 'Iz'])),
                          (((3, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*Iy*f0', ['Dz', 'f0', 'Iy', 'Cx'])),
                          (((3, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*f0', ['f0', 'Iy', 'Cx'])),
                          (((1, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*Pz', ['Pz', 'Iy', 'Cx'])),
                          (((1, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Pz*Qx', ['Pz', 'Qx', 'Iy'])),
                          (((1, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Qx*f17', ['Qx', 'Cz', 'f17'])),
                          (((1, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz*f17', ['Cz', 'Cx', 'f17'])),
                          (((0, 0, 3), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*f15*f32', ['f15', 'Cz', 'f32'])),
                          (((2, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Px*f15', ['f15', 'Cz', 'Px'])),
                          (((2, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*Px', ['Cz', 'Iy', 'Px'])),
                          (((0, 0, 3), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*Iy*f32', ['Dx', 'Cz', 'Iy', 'f32'])),
                          (((0, 0, 3), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*f32', ['Cz', 'Iy', 'f32'])),
                          (((2, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*f5', ['Cz', 'Iy', 'f5'])),
                          (((2, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('f5*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'f5'])),
                          (((0, 2, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Py*(Cz*Zij + Pz)',
                            ['Zij', 'Dx', 'Cz', 'Pz', 'Py'])),
                          (((0, 2, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Py'])),
                          (((2, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Px*(Cz*Zij + Pz)',
                            ['Zij', 'Dy', 'Cz', 'Pz', 'Px'])),
                          (((2, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Px*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Px'])),
                          (((0, 2, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('f8*(Cz*Zij + Pz)', ['Zij', 'Pz', 'Cz', 'f8'])),
                          (((0, 2, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Ix*f8', ['Cz', 'f8', 'Ix'])),
                          (((0, 2, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*Py', ['Cz', 'Py', 'Ix'])),
                          (((0, 0, 3), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Ix*f32', ['Dy', 'Cz', 'f32', 'Ix'])),
                          (((0, 0, 3), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*f32', ['Cz', 'f32', 'Ix'])),
                          (((0, 1, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Pz*Qy', ['Qy', 'Ix', 'Pz'])),
                          (((0, 1, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*Pz', ['Ix', 'Pz', 'Cy'])),
                          (((0, 3, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Ix*f33', ['Dz', 'Ix', 'f33', 'Cy'])),
                          (((0, 3, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*f33', ['Ix', 'f33', 'Cy'])),
                          (((2, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f21', ['f21', 'Cy'])),
                          (((2, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f21', ['Cz', 'f21'])),
                          (((2, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Px*f4', ['f4', 'Px'])),
                          (((0, 1, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Pz*f4', ['f4', 'Pz'])),
                          (((0, 3, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f18', ['Dz', 'f18'])),
                          (((0, 0, 3), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*f10', ['Ix', 'f10'])),
                          (((0, 3, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*f7', ['f7', 'Ix'])),
                          (((0, 3, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*f7', ['f7', 'Iz'])),
                          (((3, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*f28', ['Iz', 'f28'])),
                          (((3, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*f28', ['Iy', 'f28'])),
                          (((0, 0, 3), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*f10', ['Iy', 'f10'])),
                          (((2, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('f17*f5', ['f5', 'f17'])),
                          (((0, 1, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Pz*f17', ['Dx', 'Pz', 'f17'])),
                          (((0, 1, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*f17', ['Pz', 'f17'])),
                          (((2, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Px*f17', ['Dz', 'Px', 'f17'])),
                          (((2, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px*f17', ['Px', 'f17'])),
                          (((0, 1, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('f17*f2', ['f2', 'f17'])),
                          (((0, 1, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Qy*f34', ['f34', 'Qy'])),
                          (((2, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy*f19', ['Qy', 'f19'])),
                          (((2, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f19', ['Qz', 'f19'])),
                          (((0, 2, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f9', ['f9', 'Qz'])),
                          (((1, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f9', ['f9', 'Qx'])),
                          (((1, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f34', ['f34', 'Qx'])),
                          (((1, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*f34', ['f34', 'Dy', 'Cx'])),
                          (((1, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f34', ['f34', 'Cx'])),
                          (((0, 1, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*f34', ['f34', 'Dx', 'Cy'])),
                          (((0, 1, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f34', ['f34', 'Cy'])),
                          (((2, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*f19', ['Dz', 'f19', 'Cy'])),
                          (((2, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f19', ['f19', 'Cy'])),
                          (((2, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*f19', ['Dy', 'Cz', 'f19'])),
                          (((2, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f19', ['Cz', 'f19'])),
                          (((0, 2, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f9', ['Dx', 'Cz', 'f9'])),
                          (((0, 2, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f9', ['f9', 'Cz'])),
                          (((1, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*f9', ['Dz', 'f9', 'Cx'])),
                          (((1, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f9', ['f9', 'Cx'])),
                          (((1, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f3', ['Cx', 'f3'])),
                          (((0, 1, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f3', ['f3', 'Cy'])),
                          (((0, 0, 3), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f16', ['f16', 'Dy'])),
                          (((0, 0, 3), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f16', ['f16', 'Dx'])),
                          (((0, 3, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f18', ['Dx', 'f18'])),
                          (((0, 3, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('f18', ['f18'])),
                          (((0, 0, 3), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('f16', ['f16'])))),
 ('f', 's', 'd', 's'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f1': '(Dy*Py + 2*B00*Cy)',
                         'f11': '(2*B00*Dx + Cx*Rx)',
                         'f12': '(Dx*Px + 2*B00*Cx)',
                         'f14': '(Px*Rx + 2*pow(B00,2) + 4*B00*Cx*Dx)',
                         'f17': '(Cx*Dx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                         'f19': '(3*B10 + pow(Cz,2))',
                         'f2': '(Dz*Pz + 2*B00*Cz)',
                         'f20': '(3*B10 + pow(Cy,2))',
                         'f21': '(2*pow(B00,2) + Pz*Rz + 4*B00*Cz*Dz)',
                         'f22': '(2*B00*Dy + Cy*Ry)',
                         'f3': '(4*B00*Cy*Dy + Py*Ry + 2*pow(B00,2))',
                         'f4': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                         'f7': '(2*B00*Dz + Cz*Rz)',
                         'f8': '(3*B00*Pz + Cz*Dz*(3*B10 + pow(Cz,2)))'},
                        ((((3, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('(6*Cx*pow(B00,2) + Cx*Rx*f0 + 6*B00*Dx*Px)',
                           ['Dx', 'Cx', 'Px', 'B00', 'Rx', 'f0'])),
                         (((0, 3, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('(6*Cy*pow(B00,2) + Cy*Ry*f20 + 6*B00*Dy*Py)',
                           ['f20', 'Dy', 'Py', 'B00', 'Cy', 'Ry'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('(6*B00*Dz*Pz + 6*Cz*pow(B00,2) + Cz*Rz*f19)',
                           ['f19', 'Cz', 'Rz', 'Dz', 'B00', 'Pz'])),
                         (((0, 0, 3), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dx*Dy*f19', ['Dy', 'Dx', 'Cz', 'f19'])),
                         (((0, 2, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dx*f1', ['f1', 'Dx', 'Cz'])),
                         (((2, 0, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*f12', ['Dy', 'Cz', 'f12'])),
                         (((1, 0, 2), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*Pz*Qx', ['Dy', 'Qx', 'Pz'])),
                         (((0, 1, 2), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Pz*Qy', ['Qy', 'Dx', 'Pz'])),
                         (((1, 1, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Qx*Qy', ['Qx', 'Cz', 'Qy'])),
                         (((1, 1, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Cz*f22', ['Cz', 'f22', 'Cx'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Cy*f7', ['f7', 'Cx', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dx*Dz*f20', ['Dz', 'Dx', 'f20', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*f12', ['Dz', 'f12', 'Cy'])),
                         (((1, 2, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*Py*Qx', ['Dz', 'Qx', 'Py'])),
                         (((0, 2, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Py*Qz', ['Dx', 'Py', 'Qz'])),
                         (((0, 1, 2), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dx*f2', ['Dx', 'f2', 'Cy'])),
                         (((1, 1, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Qx*Qz', ['Qx', 'Qz', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cy*Rz*f20', ['Rz', 'f20', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cy*Px*Rz', ['Rz', 'Px', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*Px*Qy', ['Dz', 'Qy', 'Px'])),
                         (((2, 0, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Px*Qz', ['Dy', 'Qz', 'Px'])),
                         (((3, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dy*Dz*f0', ['Dz', 'Dy', 'f0', 'Cx'])),
                         (((1, 2, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dz*f1', ['Dz', 'f1', 'Cx'])),
                         (((1, 0, 2), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dy*f2', ['Dy', 'Cx', 'f2'])),
                         (((1, 1, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Qy*Qz', ['Qy', 'Cx', 'Qz'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Py*Rz', ['Rz', 'Cx', 'Py'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Rz*f0', ['Rz', 'f0', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Ry*f0', ['f0', 'Cx', 'Ry'])),
                         (((1, 0, 2), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Pz*Ry', ['Pz', 'Cx', 'Ry'])),
                         (((0, 1, 2), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Pz*Rx', ['Rx', 'Pz', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Rx*f20', ['Rx', 'f20', 'Cy'])),
                         (((1, 1, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f11', ['Cz', 'f11', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*Px*Ry', ['Cz', 'Px', 'Ry'])),
                         (((0, 0, 3), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*Ry*f19', ['Cz', 'f19', 'Ry'])),
                         (((0, 0, 3), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*Rx*f19', ['Rx', 'Cz', 'f19'])),
                         (((0, 2, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*Py*Rx', ['Rx', 'Cz', 'Py'])),
                         (((1, 2, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Py*f11', ['Py', 'f11'])),
                         (((1, 0, 2), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Pz*f11', ['Pz', 'f11'])),
                         (((0, 1, 2), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Pz*f22', ['f22', 'Pz'])),
                         (((2, 1, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Px*f22', ['f22', 'Px'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Px*f7', ['f7', 'Px'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Py*f7', ['f7', 'Py'])),
                         (((2, 1, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*f14', ['f14', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*f14', ['f14', 'Cz'])),
                         (((0, 2, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*f3', ['Cz', 'f3'])),
                         (((1, 2, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*f3', ['Cx', 'f3'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*f21', ['Cx', 'f21'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cy*f21', ['f21', 'Cy'])),
                         (((0, 0, 3), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*f8', ['Dx', 'f8'])),
                         (((0, 3, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*f4', ['f4', 'Dx'])),
                         (((0, 3, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*f4', ['Dz', 'f4'])),
                         (((3, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*f17', ['Dz', 'f17'])),
                         (((3, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*f17', ['Dy', 'f17'])),
                         (((0, 0, 3), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*f8', ['Dy', 'f8'])),
                         (((1, 0, 2), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Qx*f2', ['Qx', 'f2'])),
                         (((1, 2, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Qx*f1', ['f1', 'Qx'])),
                         (((0, 2, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Qz*f1', ['f1', 'Qz'])),
                         (((2, 0, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Qz*f12', ['f12', 'Qz'])),
                         (((2, 1, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Qy*f12', ['f12', 'Qy'])),
                         (((0, 1, 2), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Qy*f2', ['Qy', 'f2'])))),
 ('f', 's', 'f', 's'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f0': '(4*B00*Cy*Dy + Py*Ry + 2*pow(B00,2))',
                         'f1': '(3*B10 + pow(Cx,2))',
                         'f11': '(2*B00*Dz + Cz*Rz)',
                         'f12': '(pow(Dz,2) + 3*B01)',
                         'f13': '(6*Cy*pow(B00,2) + Cy*Ry*(3*B10 + pow(Cy,2)) + 6*B00*Dy*Py)',
                         'f15': '(3*B01 + pow(Dy,2))',
                         'f16': '9*B00*B01*B10',
                         'f19': '6*pow(B00,3)',
                         'f2': '(6*Dz*pow(B00,2) + Dz*Pz*(pow(Dz,2) + 3*B01) + 6*B00*Cz*Rz)',
                         'f21': '(3*B01 + pow(Dx,2))',
                         'f22': '(3*B00*Pz + Cz*Dz*(3*B10 + pow(Cz,2)))',
                         'f23': '(Dy*Py + 2*B00*Cy)',
                         'f25': '(2*B00*Dx + Cx*Rx)',
                         'f26': '(3*B00*Rx + Cx*Dx*(3*B01 + pow(Dx,2)))',
                         'f27': '(Dx*Px + 2*B00*Cx)',
                         'f28': '(Cy*Dy*(3*B01 + pow(Dy,2)) + 3*B00*Ry)',
                         'f29': '(6*Cx*pow(B00,2) + Cx*Rx*(3*B10 + pow(Cx,2)) + 6*B00*Dx*Px)',
                         'f3': '(Dz*Pz + 2*B00*Cz)',
                         'f32': '(Cx*Dx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                         'f33': '(3*B10 + pow(Cz,2))',
                         'f34': '(3*B10 + pow(Cy,2))',
                         'f35': '(2*pow(B00,2) + Pz*Rz + 4*B00*Cz*Dz)',
                         'f36': '(6*B00*Dz*Pz + Cz*Rz*(3*B10 + pow(Cz,2)) + 6*Cz*pow(B00,2))',
                         'f4': '(2*B00*Dy + Cy*Ry)',
                         'f5': '(Dx*Px*(3*B01 + pow(Dx,2)) + 6*Dx*pow(B00,2) + 6*B00*Cx*Rx)',
                         'f6': '(Px*Rx + 2*pow(B00,2) + 4*B00*Cx*Dx)',
                         'f7': '(6*B00*Cy*Ry + 6*Dy*pow(B00,2) + Dy*Py*(3*B01 + pow(Dy,2)))',
                         'f8': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                         'f9': '(Cz*Dz*(pow(Dz,2) + 3*B01) + 3*B00*Rz)'},
                        ((((0, 3, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('(f16 + f19 + Cy*Dy*f15*f34 + 9*B00*(B01*pow(Cy,2) + Py*pow(Dy,2)) + 18*Cy*Dy*pow(B00,2))',
                           ['f15',
                            'f19',
                            'f16',
                            'Dy',
                            'B01',
                            'Py',
                            'f34',
                            'B00',
                            'Cy'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('(Cz*Dz*f12*f33 + f16 + f19 + 9*B00*(B01*pow(Cz,2) + Pz*pow(Dz,2)) + 18*Cz*Dz*pow(B00,2))',
                           ['B00',
                            'f12',
                            'f33',
                            'f16',
                            'B01',
                            'Dz',
                            'Cz',
                            'Pz',
                            'f19'])),
                         (((3, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('(18*Cx*Dx*pow(B00,2) + f16 + f19 + Cx*Dx*f1*f21 + 9*B00*(B01*pow(Cx,2) + Px*pow(Dx,2)))',
                           ['Dx',
                            'f1',
                            'Cx',
                            'Px',
                            'f16',
                            'B01',
                            'B00',
                            'f21',
                            'f19'])),
                         (((1, 0, 2), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Cx*Ry*f3', ['f3', 'Cx', 'Ry'])),
                         (((1, 1, 1), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Cx*Qz*f4', ['f4', 'Cx', 'Qz'])),
                         (((1, 1, 1), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Cz*Qx*f4', ['Qx', 'f4', 'Cz'])),
                         (((1, 2, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Py*Qx*Rz', ['Rz', 'Qx', 'Py'])),
                         (((2, 1, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Cy*Rz*f27', ['f27', 'Rz', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Cy*Dx*Rz*f34', ['f34', 'Dx', 'Rz', 'Cy'])),
                         (((0, 1, 2), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Cy*Dx*f35', ['Dx', 'Cy', 'f35'])),
                         (((1, 1, 1), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Cy*Qx*f11', ['Qx', 'f11', 'Cy'])),
                         (((1, 0, 2), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Pz*Qx*Ry', ['Qx', 'Pz', 'Ry'])),
                         (((0, 0, 3), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Cz*Dx*Ry*f33', ['Dx', 'Cz', 'f33', 'Ry'])),
                         (((2, 0, 1), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Cz*Ry*f27', ['f27', 'Cz', 'Ry'])),
                         (((2, 0, 1), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Px*Qz*Ry', ['Qz', 'Px', 'Ry'])),
                         (((2, 1, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Px*Qy*Rz', ['Rz', 'Qy', 'Px'])),
                         (((1, 1, 1), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Cx*Qy*f11', ['Qy', 'Cx', 'f11'])),
                         (((1, 0, 2), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Cx*Dy*f35', ['Dy', 'Cx', 'f35'])),
                         (((3, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dy*Dz*f32', ['Dz', 'Dy', 'f32'])),
                         (((0, 3, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Dz*f8', ['Dz', 'Dx', 'f8'])),
                         (((0, 0, 3), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Dy*f22', ['Dy', 'Dx', 'f22'])),
                         (((0, 1, 2), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Dx*Pz*f4', ['f4', 'Dx', 'Pz'])),
                         (((0, 1, 2), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*Pz*f21', ['Dx', 'Pz', 'f21', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*f21*f34', ['f34', 'Dx', 'f21', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*Rx*f34', ['Dz', 'Rx', 'Cy', 'f34'])),
                         (((0, 1, 2), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Cy*Rx*f3', ['Rx', 'f3', 'Cy'])),
                         (((1, 1, 1), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Cy*Qz*f25', ['f25', 'Qz', 'Cy'])),
                         (((1, 1, 1), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Cz*Qy*f25', ['f25', 'Cz', 'Qy'])),
                         (((0, 1, 2), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Pz*Qy*Rx', ['Rx', 'Qy', 'Pz'])),
                         (((2, 1, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dz*Qy*f27', ['Dz', 'f27', 'Qy'])),
                         (((2, 0, 1), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dy*Qz*f27', ['f27', 'Dy', 'Qz'])),
                         (((0, 0, 3), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*Rx*f33', ['Rx', 'Dy', 'Cz', 'f33'])),
                         (((0, 2, 1), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Cz*Rx*f23', ['Rx', 'Cz', 'f23'])),
                         (((1, 2, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dz*Qx*f23', ['Dz', 'Qx', 'f23'])),
                         (((0, 2, 1), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Qz*f23', ['Dx', 'f23', 'Qz'])),
                         (((1, 2, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Cx*Rz*f23', ['Rz', 'f23', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Cx*Dy*Rz*f1', ['Dy', 'Rz', 'f1', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cx*Dy*f1*f15', ['Dy', 'f1', 'Cx', 'f15'])),
                         (((1, 0, 2), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cx*Dy*Pz*f15', ['Dy', 'Pz', 'Cx', 'f15'])),
                         (((1, 0, 2), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Dy*Pz*f25', ['Dy', 'f25', 'Pz'])),
                         (((2, 0, 1), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Dy*Px*f11', ['Dy', 'f11', 'Px'])),
                         (((2, 0, 1), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cz*Dy*Px*f15', ['Dy', 'Cz', 'Px', 'f15'])),
                         (((0, 0, 3), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cz*Dy*f15*f33', ['Dy', 'Cz', 'f33', 'f15'])),
                         (((2, 0, 1), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*f6', ['Dy', 'f6', 'Cz'])),
                         (((1, 0, 2), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dy*Qx*f3', ['Dy', 'Qx', 'f3'])),
                         (((0, 1, 2), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Qy*f3', ['Dx', 'Qy', 'f3'])),
                         (((1, 1, 1), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Qx*Qy*Qz', ['Qx', 'Qy', 'Qz'])),
                         (((0, 2, 1), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Py*Qz*Rx', ['Rx', 'Py', 'Qz'])),
                         (((0, 2, 1), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Dx*Py*f11', ['Dx', 'Py', 'f11'])),
                         (((0, 2, 1), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*Py*f21', ['Dx', 'Cz', 'Py', 'f21'])),
                         (((0, 0, 3), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*f21*f33', ['Dx', 'Cz', 'f33', 'f21'])),
                         (((0, 2, 1), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Cz*Dx*f0', ['Dx', 'Cz', 'f0'])),
                         (((1, 2, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Cx*Dz*f0', ['Dz', 'f0', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Cx*Dz*Ry*f1', ['Dz', 'f1', 'Cx', 'Ry'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cx*Dz*f1*f12', ['Dz', 'f1', 'f12', 'Cx'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cx*Dz*Py*f12', ['Dz', 'f12', 'Cx', 'Py'])),
                         (((1, 2, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Dz*Py*f25', ['Dz', 'f25', 'Py'])),
                         (((2, 1, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Dz*Px*f4', ['Dz', 'f4', 'Px'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cy*Dz*Px*f12', ['Dz', 'f12', 'Px', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cy*Dz*f12*f34', ['Dz', 'f34', 'f12', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*f6', ['Dz', 'f6', 'Cy'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cx*Cy*f9', ['f9', 'Cx', 'Cy'])),
                         (((1, 1, 1), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cx*Cz*f28', ['Cz', 'Cx', 'f28'])),
                         (((1, 1, 1), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*f26', ['Cz', 'Cy', 'f26'])),
                         (((1, 2, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Py*f26', ['Py', 'f26'])),
                         (((1, 0, 2), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Pz*f26', ['Pz', 'f26'])),
                         (((0, 1, 2), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Pz*f28', ['Pz', 'f28'])),
                         (((2, 1, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Px*f28', ['f28', 'Px'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Px*f9', ['f9', 'Px'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Py*f9', ['f9', 'Py'])),
                         (((2, 1, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cy*f5', ['Cy', 'f5'])),
                         (((2, 0, 1), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cz*f5', ['Cz', 'f5'])),
                         (((0, 2, 1), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cz*f7', ['f7', 'Cz'])),
                         (((1, 2, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cx*f7', ['f7', 'Cx'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cx*f2', ['Cx', 'f2'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cy*f2', ['f2', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Rx*f8', ['Rx', 'f8'])),
                         (((0, 0, 3), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Rx*f22', ['Rx', 'f22'])),
                         (((0, 0, 3), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Ry*f22', ['f22', 'Ry'])),
                         (((3, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Ry*f32', ['f32', 'Ry'])),
                         (((3, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Rz*f32', ['Rz', 'f32'])),
                         (((0, 3, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Rz*f8', ['Rz', 'f8'])),
                         (((0, 0, 3), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Dx*f36', ['Dx', 'f36'])),
                         (((0, 3, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Dx*f13', ['Dx', 'f13'])),
                         (((0, 3, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Dz*f13', ['Dz', 'f13'])),
                         (((3, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Dz*f29', ['Dz', 'f29'])),
                         (((3, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Dy*f29', ['Dy', 'f29'])),
                         (((0, 0, 3), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Dy*f36', ['Dy', 'f36'])),
                         (((2, 0, 1), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('f11*f27', ['f27', 'f11'])),
                         (((2, 1, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('f27*f4', ['f27', 'f4'])),
                         (((0, 1, 2), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('f3*f4', ['f4', 'f3'])),
                         (((1, 0, 2), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('f25*f3', ['f25', 'f3'])),
                         (((1, 2, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('f23*f25', ['f25', 'f23'])),
                         (((0, 2, 1), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('f11*f23', ['f23', 'f11'])),
                         (((1, 0, 2), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Qx*f35', ['Qx', 'f35'])),
                         (((1, 2, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Qx*f0', ['Qx', 'f0'])),
                         (((0, 2, 1), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Qz*f0', ['f0', 'Qz'])),
                         (((2, 0, 1), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Qz*f6', ['f6', 'Qz'])),
                         (((2, 1, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Qy*f6', ['f6', 'Qy'])),
                         (((0, 1, 2), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Qy*f35', ['Qy', 'f35'])))),
 ('f', 's', 'p', 'p'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f1': '(Cx*Kx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                         'f10': '(Cz*Kz*(3*B10 + pow(Cz,2)) + 3*B00*Pz)',
                         'f11': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                         'f12': '(B01 + Dx*Kx)',
                         'f14': '(3*B00*Pz + Cz*Dz*(3*B10 + pow(Cz,2)))',
                         'f15': '(Kx*Px + 2*B00*Cx)',
                         'f16': '(Dy*Py + 2*B00*Cy)',
                         'f17': '(2*pow(B00,2) + Pz*(Dz*Kz + B01) + 2*B00*Cz*(2*Dz + Zkl))',
                         'f2': '(Dz*Pz + 2*B00*Cz)',
                         'f20': '(Dx*Px + 2*B00*Cx)',
                         'f22': '(Dz*Kz + B01)',
                         'f23': '(B00 + Cx*Kx)',
                         'f29': '(Cx*Dx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                         'f3': '(Py*(B01 + Dy*Ky) + 2*pow(B00,2) + 2*B00*Cy*(Ykl + 2*Dy))',
                         'f30': '(B01 + Dy*Ky)',
                         'f31': '(3*B10 + pow(Cz,2))',
                         'f32': '(3*B10 + pow(Cy,2))',
                         'f4': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                         'f5': '(3*B00*Py + Cy*Ky*(3*B10 + pow(Cy,2)))',
                         'f6': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                         'f7': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                         'f9': '(2*B00*Cx*(Xkl + 2*Dx) + 2*pow(B00,2) + Px*(B01 + Dx*Kx))',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((3, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('(3*B00*Px*(Xkl + 2*Dx) + Cx*f0*(B01 + Dx*Kx) + 6*Cx*pow(B00,2))',
                           ['Dx',
                            'Cx',
                            'Px',
                            'B01',
                            'Xkl',
                            'B00',
                            'f0',
                            'Kx'])),
                         (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('(6*Cy*pow(B00,2) + 3*B00*Py*(Ykl + 2*Dy) + Cy*f32*(B01 + Dy*Ky))',
                           ['Dy',
                            'B01',
                            'Py',
                            'Ykl',
                            'B00',
                            'Cy',
                            'Ky',
                            'f32'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('(Cz*f31*(Dz*Kz + B01) + 3*B00*Pz*(2*Dz + Zkl) + 6*Cz*pow(B00,2))',
                           ['B00',
                            'Cz',
                            'Kz',
                            'B01',
                            'Dz',
                            'f31',
                            'Pz',
                            'Zkl'])),
                         (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*Py*(Cz*Zkl + Qz)',
                           ['Dx', 'Cz', 'Zkl', 'Py', 'Qz'])),
                         (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Qx*(Cz*Zkl + Qz)',
                           ['Qx', 'Zkl', 'Qz', 'Cy', 'Cz'])),
                         (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*Px*(Cz*Zkl + Qz)',
                           ['Dy', 'Cz', 'Zkl', 'Qz', 'Px'])),
                         (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Dy*(Pz*Zkl + f2)',
                           ['Dy', 'Zkl', 'Pz', 'Cx', 'f2'])),
                         (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Dx*(Pz*Zkl + f2)',
                           ['Zkl', 'Dx', 'Pz', 'f2', 'Cy'])),
                         (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Qx*(Pz*Zkl + f2)', ['Zkl', 'Qx', 'Pz', 'f2'])),
                         (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Qy*(Pz*Zkl + f2)', ['Pz', 'Qy', 'Zkl', 'f2'])),
                         (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Qy*(Cz*Zkl + Qz)',
                           ['Zkl', 'Cz', 'Qy', 'Cx', 'Qz'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Qz*(Cy*Ykl + Qy)',
                           ['Ykl', 'Qy', 'Cx', 'Cy', 'Qz'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*Px*(Cy*Ykl + Qy)',
                           ['Dz', 'Ykl', 'Qy', 'Cy', 'Px'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Dz*(f16 + Py*Ykl)',
                           ['Dz', 'f16', 'Ykl', 'Cx', 'Py'])),
                         (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Dx*(f16 + Py*Ykl)',
                           ['f16', 'Ykl', 'Dx', 'Cz', 'Py'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Qz*(f16 + Py*Ykl)', ['f16', 'Ykl', 'Qz', 'Py'])),
                         (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Qx*(f16 + Py*Ykl)', ['f16', 'Ykl', 'Qx', 'Py'])),
                         (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Qx*(Cy*Ykl + Qy)',
                           ['Qx', 'Ykl', 'Cz', 'Qy', 'Cy'])),
                         (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*Pz*(Cy*Ykl + Qy)',
                           ['Ykl', 'Dx', 'Pz', 'Qy', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Dx*Kz*f32', ['Dx', 'Kz', 'f32', 'Cy'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Dz*Ky*f0', ['Dz', 'f0', 'Cx', 'Ky'])),
                         (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Dy*Kz*f0', ['Dy', 'Kz', 'f0', 'Cx'])),
                         (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*Cz*f4', ['f4', 'Cz', 'Cx'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Qz*f23', ['f23', 'Qz', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Ky*Px*Qz', ['Px', 'Ky', 'Qz'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Ky*f2', ['f2', 'Cx', 'Ky'])),
                         (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Ky*Pz*Qx', ['Qx', 'Pz', 'Ky'])),
                         (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Kz*Py*Qx', ['Qx', 'Kz', 'Py'])),
                         (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Kz*Px*Qy', ['Kz', 'Qy', 'Px'])),
                         (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Kz*f16', ['f16', 'Kz', 'Cx'])),
                         (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Kz*f20', ['Kz', 'f20', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('f20*(Cy*Ykl + Qy)', ['Ykl', 'Qy', 'f20', 'Cy'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('f2*(Cy*Ykl + Qy)', ['Ykl', 'Qy', 'Cy', 'f2'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Kx*f2', ['f2', 'Kx', 'Cy'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Kx*Py*Qz', ['Qz', 'Kx', 'Py'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*Py*f23', ['Dz', 'f23', 'Py'])),
                         (((1, 1, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Qy*f23', ['f23', 'Cz', 'Qy'])),
                         (((1, 1, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*Cz*f7', ['f7', 'Cz', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Dz*f15', ['Dz', 'f15', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Dz*Kx*f32', ['Dz', 'f32', 'Kx', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cy*f22*f32', ['f22', 'f32', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cy*Px*f22', ['f22', 'Px', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cz*Px*f30', ['Cz', 'f30', 'Px'])),
                         (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cz*f30*f31', ['f31', 'Cz', 'f30'])),
                         (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Dx*Ky*f31', ['f31', 'Dx', 'Cz', 'Ky'])),
                         (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Ky*f20', ['Cz', 'f20', 'Ky'])),
                         (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('f20*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'f20', 'Qz'])),
                         (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('f16*(Cz*Zkl + Qz)', ['f16', 'Cz', 'Zkl', 'Qz'])),
                         (((0, 2, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Kx*f16', ['f16', 'Cz', 'Kx'])),
                         (((0, 1, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Kx*Pz*Qy', ['Qy', 'Pz', 'Kx'])),
                         (((1, 0, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*Pz*f23', ['Dy', 'f23', 'Pz'])),
                         (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*Pz*f30', ['f30', 'Pz', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*f0*f30', ['f30', 'f0', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*f0*f22', ['f22', 'f0', 'Cx'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*Py*f22', ['f22', 'Cx', 'Py'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*Cy*f11', ['Cx', 'Cy', 'f11'])),
                         (((0, 1, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*Pz*f12', ['f12', 'Pz', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*f12*f32', ['f12', 'f32', 'Cy'])),
                         (((0, 2, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cz*Py*f12', ['Cz', 'f12', 'Py'])),
                         (((0, 0, 3), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cz*f12*f31', ['f31', 'Cz', 'f12'])),
                         (((0, 0, 3), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Dy*Kx*f31', ['Dy', 'f31', 'Cz', 'Kx'])),
                         (((2, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Dy*f15', ['Dy', 'Cz', 'f15'])),
                         (((2, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Qy*f15', ['f15', 'Qy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Qz*f15', ['f15', 'Qz'])),
                         (((1, 2, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('f16*f23', ['f16', 'f23'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('f2*f23', ['f23', 'f2'])),
                         (((0, 3, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Kx*f6', ['f6', 'Kx'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Kx*f14', ['f14', 'Kx'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Ky*f14', ['f14', 'Ky'])),
                         (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Ky*f29', ['f29', 'Ky'])),
                         (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Kz*f29', ['Kz', 'f29'])),
                         (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Kz*f6', ['f6', 'Kz'])),
                         (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*f10', ['Dx', 'f10'])),
                         (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*f5', ['Dx', 'f5'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*f5', ['Dz', 'f5'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*f1', ['Dz', 'f1'])),
                         (((3, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*f1', ['Dy', 'f1'])),
                         (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*f10', ['Dy', 'f10'])),
                         (((1, 2, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Py*f7', ['f7', 'Py'])),
                         (((1, 0, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Pz*f7', ['f7', 'Pz'])),
                         (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Pz*f4', ['f4', 'Pz'])),
                         (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Px*f4', ['f4', 'Px'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Px*f11', ['f11', 'Px'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Py*f11', ['Py', 'f11'])),
                         (((2, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*f9', ['f9', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cz*f9', ['f9', 'Cz'])),
                         (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cz*f3', ['Cz', 'f3'])),
                         (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*f3', ['Cx', 'f3'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*f17', ['Cx', 'f17'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cy*f17', ['Cy', 'f17'])))),
 ('f', 's', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f1': '(Dz*Pz + 2*B00*Cz)',
                         'f10': '(3*B10 + pow(Cz,2))',
                         'f11': '(3*B10 + pow(Cy,2))',
                         'f3': '3*B00*B10',
                         'f4': '(Dy*Py + 2*B00*Cy)',
                         'f6': '(Dx*Px + 2*B00*Cx)'},
                        ((((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(Dx*pow(Cx,3) + 3*B00*pow(Cx,2) + 3*B10*Cx*Dx + f3)',
                           ['Dx', 'B00', 'B10', 'Cx', 'f3'])),
                         (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('(3*B00*pow(Cy,2) + f3 + Dy*pow(Cy,3) + 3*B10*Cy*Dy)',
                           ['Dy', 'B10', 'B00', 'f3', 'Cy'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('(3*B10*Cz*Dz + f3 + 3*B00*pow(Cz,2) + Dz*pow(Cz,3))',
                           ['Dz', 'B10', 'Cz', 'f3', 'B00'])),
                         (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Cz*Qy', ['Cz', 'Qy', 'Cx'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*Px', ['Dz', 'Px', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*f11', ['Dz', 'f11', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*f11', ['Dx', 'f11', 'Cy'])),
                         (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*Pz', ['Dx', 'Pz', 'Cy'])),
                         (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*Pz', ['Dy', 'Pz', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*f0', ['Dy', 'f0', 'Cx'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*f0', ['Dz', 'f0', 'Cx'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*Py', ['Dz', 'Cx', 'Py'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Cy*Qz', ['Cx', 'Cy', 'Qz'])),
                         (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Cz*Qx', ['Qx', 'Cz', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*Px', ['Dy', 'Cz', 'Px'])),
                         (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*f10', ['Dy', 'Cz', 'f10'])),
                         (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*f10', ['Dx', 'Cz', 'f10'])),
                         (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*Py', ['Dx', 'Cz', 'Py'])),
                         (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Py*Qx', ['Qx', 'Py'])),
                         (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Pz*Qx', ['Qx', 'Pz'])),
                         (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Pz*Qy', ['Qy', 'Pz'])),
                         (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Px*Qy', ['Qy', 'Px'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Px*Qz', ['Qz', 'Px'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Py*Qz', ['Py', 'Qz'])),
                         (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*f6', ['f6', 'Cz'])),
                         (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*f4', ['f4', 'Cz'])),
                         (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*f4', ['f4', 'Cx'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*f1', ['f1', 'Cx'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*f1', ['f1', 'Cy'])))),
 ('f', 's', 's', 'p'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))',
                         'f0': '(3*B10 + pow(Cx,2))',
                         'f11': '(B00 + Cy*Ky)',
                         'f12': '(3*B10 + pow(Cz,2))',
                         'f13': '(3*B10 + pow(Cy,2))',
                         'f14': '(Kz*Pz + 2*B00*Cz)',
                         'f15': '(B00 + Cz*Kz)',
                         'f2': '3*B00*B10',
                         'f5': '(Kx*Px + 2*B00*Cx)',
                         'f7': '(Ky*Py + 2*B00*Cy)',
                         'f9': '(B00 + Cx*Kx)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((3, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('(Cx*Kx*f0 + 3*B00*pow(Cx,2) + f2)',
                           ['B00', 'f0', 'Cx', 'f2', 'Kx'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('(3*B00*pow(Cy,2) + Cy*Ky*f13 + f2)',
                           ['f13', 'f2', 'B00', 'Ky', 'Cy'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('(f2 + 3*B00*pow(Cz,2) + Cz*Kz*f12)',
                           ['Kz', 'B00', 'f12', 'f2', 'Cz'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*Cz*f11', ['Cz', 'Cx', 'f11'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cy*Kz*Px', ['Kz', 'Px', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cy*Kz*f13', ['f13', 'Kz', 'Cy'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*Kx*f13', ['f13', 'Kx', 'Cy'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*Kx*Pz', ['Pz', 'Kx', 'Cy'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*Ky*Pz', ['Pz', 'Cx', 'Ky'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*Ky*f0', ['f0', 'Cx', 'Ky'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*Kz*f0', ['Kz', 'f0', 'Cx'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*Kz*Py', ['Kz', 'Cx', 'Py'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*Cy*f15', ['f15', 'Cx', 'Cy'])),
                         (((1, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*Cz*f9', ['f9', 'Cz', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cz*Ky*Px', ['Cz', 'Px', 'Ky'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cz*Ky*f12', ['Cz', 'f12', 'Ky'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cz*Kx*f12', ['Cz', 'f12', 'Kx'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cz*Kx*Py', ['Cz', 'Kx', 'Py'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Py*f9', ['f9', 'Py'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Pz*f9', ['f9', 'Pz'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Pz*f11', ['Pz', 'f11'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Px*f11', ['f11', 'Px'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Px*f15', ['f15', 'Px'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Py*f15', ['f15', 'Py'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*f5', ['Cy', 'f5'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cz*f5', ['Cz', 'f5'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cz*f7', ['f7', 'Cz'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*f7', ['f7', 'Cx'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*f14', ['f14', 'Cx'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cy*f14', ['f14', 'Cy'])))),
 ('f', 's', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Px': '(B10 + pow(Cx,2))',
                         'Py': '(B10 + pow(Cy,2))',
                         'Pz': '(B10 + pow(Cz,2))'},
                        ((((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                         (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Px', ['Px', 'Cy'])),
                         (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Px', ['Cz', 'Px'])),
                         (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Py', ['Cx', 'Py'])),
                         (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Py', ['Cz', 'Py'])),
                         (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cz + pow(Cz,3))', ['B10', 'Cz'])),
                         (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cy + pow(Cy,3))', ['B10', 'Cy'])),
                         (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(3*B10*Cx + pow(Cx,3))', ['B10', 'Cx'])),
                         (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Pz', ['Pz', 'Cx'])),
                         (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Pz', ['Pz', 'Cy'])))),
 ('f', 's', 's', 'sp'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'f0': '(3*B10 + pow(Cx,2))',
                          'f11': '(B00 + Cy*Ky)',
                          'f12': '(3*B10 + pow(Cz,2))',
                          'f13': '(3*B10 + pow(Cy,2))',
                          'f14': '(Kz*Pz + 2*B00*Cz)',
                          'f15': '(B00 + Cz*Kz)',
                          'f2': '3*B00*B10',
                          'f5': '(Kx*Px + 2*B00*Cx)',
                          'f7': '(Ky*Py + 2*B00*Cy)',
                          'f9': '(B00 + Cx*Kx)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((3, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(Cx*Kx*f0 + 3*B00*pow(Cx,2) + f2)',
                            ['B00', 'f0', 'Cx', 'f2', 'Kx'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('(3*B00*pow(Cy,2) + Cy*Ky*f13 + f2)',
                            ['f13', 'f2', 'B00', 'Ky', 'Cy'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(f2 + 3*B00*pow(Cz,2) + Cz*Kz*f12)',
                            ['Kz', 'B00', 'f12', 'f2', 'Cz'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Cz*f9', ['f9', 'Cz', 'Cy'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky*f12', ['Cz', 'f12', 'Ky'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky*Px', ['Cz', 'Px', 'Ky'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Cz*f11', ['Cz', 'Cx', 'f11'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz*f0', ['Kz', 'f0', 'Cx'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz*Py', ['Kz', 'Cx', 'Py'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Cy*f15', ['f15', 'Cx', 'Cy'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx*Py', ['Cz', 'Kx', 'Py'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx*f12', ['Cz', 'f12', 'Kx'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f12', ['Cz', 'f12'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*f5', ['Cy', 'f5'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*f5', ['Cz', 'f5'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Px', ['Cz', 'Px'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Px*f11', ['f11', 'Px'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*f7', ['f7', 'Cx'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*f7', ['f7', 'Cz'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Py', ['Cz', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Py*f9', ['f9', 'Py'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Pz*f9', ['f9', 'Pz'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Pz*f11', ['Pz', 'f11'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Pz', ['Pz', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx*Pz', ['Pz', 'Kx', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx*f13', ['f13', 'Kx', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f13', ['f13', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz*f13', ['f13', 'Kz', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz*Px', ['Kz', 'Px', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Px', ['Px', 'Cy'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Px*f15', ['f15', 'Px'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Py*f15', ['f15', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Py', ['Cx', 'Py'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Pz', ['Pz', 'Cx'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky*Pz', ['Pz', 'Cx', 'Ky'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky*f0', ['f0', 'Cx', 'Ky'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f0', ['f0', 'Cx'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*f14', ['f14', 'Cx'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*f14', ['f14', 'Cy'])))),
 ('f', 's', 'sp', 'p'): ({'B00': '',
                          'B01': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f0': '(3*B10 + pow(Cx,2))',
                          'f1': '(Cx*Kx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                          'f10': '(2*B00*Cx*(Xkl + 2*Dx) + 2*pow(B00,2) + Px*(B01 + Dx*Kx))',
                          'f11': '(B01 + Dx*Kx)',
                          'f14': '(Kx*Px + 2*B00*Cx)',
                          'f16': '(Dy*Py + 2*B00*Cy)',
                          'f17': '(2*pow(B00,2) + Pz*(Dz*Kz + B01) + 2*B00*Cz*(2*Dz + Zkl))',
                          'f2': '(Dz*Pz + 2*B00*Cz)',
                          'f21': '(Dx*Px + 2*B00*Cx)',
                          'f22': '(Dz*Kz + B01)',
                          'f23': '(B01 + Dy*Ky)',
                          'f25': '(B00 + Cx*Kx)',
                          'f3': '(Py*(B01 + Dy*Ky) + 2*pow(B00,2) + 2*B00*Cy*(Ykl + 2*Dy))',
                          'f31': '(3*B10 + pow(Cz,2))',
                          'f32': '(3*B10 + pow(Cy,2))',
                          'f36': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                          'f4': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                          'f5': '(3*B00*Py + Cy*Ky*(3*B10 + pow(Cy,2)))',
                          'f6': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                          'f7': '3*B00*B10',
                          'f8': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(Dy*(2*f7 + Dy*pow(Cy,3) + 3*B10*Cy*Dy) + 6*Cy*pow(B00,2) + Ykl*(f7 + Dy*pow(Cy,3) + 3*B10*Cy*Dy) + B01*(3*B10*Cy + pow(Cy,3)) + 3*B00*pow(Cy,2)*(Ykl + 2*Dy))',
                            ['B10', 'Dy', 'B01', 'Ykl', 'B00', 'f7', 'Cy'])),
                          (((3, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(Xkl*(Dx*pow(Cx,3) + 3*B10*Cx*Dx + f7) + Dx*(Dx*pow(Cx,3) + 3*B10*Cx*Dx + 2*f7) + 3*B00*pow(Cx,2)*(Xkl + 2*Dx) + 6*Cx*pow(B00,2) + B01*(3*B10*Cx + pow(Cx,3)))',
                            ['B10', 'Cx', 'B01', 'Dx', 'Xkl', 'B00', 'f7'])),
                          (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*(Dx*pow(Cx,3) + 3*B00*pow(Cx,2) + 3*B10*Cx*Dx + f7)',
                            ['Dx', 'Cx', 'Kz', 'B10', 'B00', 'f7'])),
                          (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*(Dx*pow(Cx,3) + 3*B00*pow(Cx,2) + 3*B10*Cx*Dx + f7)',
                            ['Dx', 'Cx', 'B10', 'B00', 'Ky', 'f7'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Ky*(3*B10*Cz*Dz + f7 + 3*B00*pow(Cz,2) + Dz*pow(Cz,3))',
                            ['B10', 'B00', 'Dz', 'Cz', 'Ky', 'f7'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Kx*(3*B10*Cz*Dz + f7 + 3*B00*pow(Cz,2) + Dz*pow(Cz,3))',
                            ['B10', 'B00', 'Dz', 'Cz', 'f7', 'Kx'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(Dz*(3*B10*Cz*Dz + 2*f7 + Dz*pow(Cz,3)) + 3*B00*pow(Cz,2)*(2*Dz + Zkl) + Zkl*(3*B10*Cz*Dz + f7 + Dz*pow(Cz,3)) + B01*(3*B10*Cz + pow(Cz,3)) + 6*Cz*pow(B00,2))',
                            ['B10', 'B00', 'B01', 'Dz', 'Cz', 'f7', 'Zkl'])),
                          (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*(Cz*Kz*f31 + f7 + 3*B00*pow(Cz,2))',
                            ['Cz', 'Dy', 'Kz', 'B00', 'f7', 'f31'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(Cz*Kz*f31 + f7 + 3*B00*pow(Cz,2))',
                            ['B00', 'Kz', 'f31', 'Cz', 'f7'])),
                          (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*(Cz*Kz*f31 + f7 + 3*B00*pow(Cz,2))',
                            ['Dx', 'Cz', 'Kz', 'B00', 'f7', 'f31'])),
                          (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Dx*(Pz*Zkl + f2)',
                            ['Zkl', 'Dx', 'Pz', 'f2', 'Cy'])),
                          (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Dy*(Pz*Zkl + f2)',
                            ['Dy', 'Zkl', 'Pz', 'Cx', 'f2'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*(Pz*Zkl + f2)', ['Zkl', 'Pz', 'Cx', 'f2'])),
                          (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Qx*(Pz*Zkl + f2)', ['Zkl', 'Qx', 'Pz', 'f2'])),
                          (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Qy*(Pz*Zkl + f2)', ['Pz', 'Qy', 'Zkl', 'f2'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*(Pz*Zkl + f2)', ['Zkl', 'Pz', 'f2', 'Cy'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Qz*(f16 + Py*Ykl)',
                            ['f16', 'Ykl', 'Qz', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Qx*(f16 + Py*Ykl)',
                            ['f16', 'Ykl', 'Qx', 'Py'])),
                          (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Dx*(f16 + Py*Ykl)',
                            ['f16', 'Ykl', 'Dx', 'Cz', 'Py'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*(f16 + Py*Ykl)',
                            ['f16', 'Ykl', 'Cz', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Dz*(f16 + Py*Ykl)',
                            ['Dz', 'f16', 'Ykl', 'Cx', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*(f16 + Py*Ykl)',
                            ['f16', 'Ykl', 'Cx', 'Py'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Qz*(Cy*Ykl + Qy)',
                            ['Ykl', 'Qy', 'Cx', 'Cy', 'Qz'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Cz*(Cy*Ykl + Qy)',
                            ['Ykl', 'Cz', 'Qy', 'Cx', 'Cy'])),
                          (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Qx*(Cy*Ykl + Qy)',
                            ['Qx', 'Ykl', 'Cz', 'Qy', 'Cy'])),
                          (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Qx*(Cz*Zkl + Qz)',
                            ['Qx', 'Zkl', 'Qz', 'Cy', 'Cz'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Cy*(Cz*Zkl + Qz)',
                            ['Cz', 'Zkl', 'Cx', 'Cy', 'Qz'])),
                          (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Qy*(Cz*Zkl + Qz)',
                            ['Zkl', 'Cz', 'Qy', 'Cx', 'Qz'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Ky*Px*Qz', ['Px', 'Ky', 'Qz'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Ky*f2', ['f2', 'Cx', 'Ky'])),
                          (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*Py*Qx', ['Qx', 'Kz', 'Py'])),
                          (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*Px*Qy', ['Kz', 'Qy', 'Px'])),
                          (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Kz*f16', ['f16', 'Kz', 'Cx'])),
                          (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*Pz*f23', ['f23', 'Pz', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*f0*f23', ['f23', 'f0', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*f0*f22', ['f22', 'f0', 'Cx'])),
                          (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*Cz*f4', ['f4', 'Cz', 'Cx'])),
                          (((1, 1, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Qy*f25', ['f25', 'Cz', 'Qy'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Qz*f25', ['f25', 'Qz', 'Cy'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Kx*Py*Qz', ['Qz', 'Kx', 'Py'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Kx*f2', ['f2', 'Kx', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('f2*(Cy*Ykl + Qy)', ['Ykl', 'Qy', 'Cy', 'f2'])),
                          (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Pz*(Cy*Ykl + Qy)',
                            ['Ykl', 'Dx', 'Pz', 'Qy', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Pz*(Cy*Ykl + Qy)', ['Ykl', 'Pz', 'Qy', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Px*(Cy*Ykl + Qy)',
                            ['Dz', 'Ykl', 'Qy', 'Cy', 'Px'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Px*(Cy*Ykl + Qy)', ['Ykl', 'Qy', 'Cy', 'Px'])),
                          (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('f21*(Cy*Ykl + Qy)',
                            ['Ykl', 'Qy', 'Cy', 'f21'])),
                          (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Kz*f21', ['Kz', 'f21', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz*Px', ['Kz', 'Px', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Dx*Kz*f32', ['Dx', 'Kz', 'f32', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz*f32', ['Kz', 'f32', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*f22*f32', ['f22', 'f32', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*Px*f22', ['f22', 'Px', 'Cy'])),
                          (((1, 1, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*Cz*f8', ['Cz', 'f8', 'Cy'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Cz*f25', ['f25', 'Cz', 'Cy'])),
                          (((0, 2, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Kx*f16', ['f16', 'Cz', 'Kx'])),
                          (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('f16*(Cz*Zkl + Qz)',
                            ['f16', 'Cz', 'Zkl', 'Qz'])),
                          (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Py*(Cz*Zkl + Qz)',
                            ['Dx', 'Cz', 'Zkl', 'Py', 'Qz'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Py*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Py', 'Qz'])),
                          (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Px*(Cz*Zkl + Qz)',
                            ['Dy', 'Cz', 'Zkl', 'Qz', 'Px'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Px*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Qz', 'Px'])),
                          (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('f21*(Cz*Zkl + Qz)',
                            ['Cz', 'Zkl', 'Qz', 'f21'])),
                          (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Ky*f21', ['Cz', 'f21', 'Ky'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky*Px', ['Cz', 'Px', 'Ky'])),
                          (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*Px*f23', ['Cz', 'f23', 'Px'])),
                          (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*f23*f31', ['f31', 'Cz', 'f23'])),
                          (((0, 0, 3), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*f11*f31', ['f31', 'Cz', 'f11'])),
                          (((0, 2, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*Py*f11', ['Cz', 'Py', 'f11'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx*Py', ['Cz', 'Kx', 'Py'])),
                          (((0, 0, 3), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Dy*Kx*f31', ['Dy', 'f31', 'Cz', 'Kx'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx*f31', ['f31', 'Cz', 'Kx'])),
                          (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Dx*Ky*f31', ['f31', 'Dx', 'Cz', 'Ky'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky*f31', ['f31', 'Cz', 'Ky'])),
                          (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*Pz*Qx', ['Qx', 'Pz', 'Ky'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky*Pz', ['Pz', 'Cx', 'Ky'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Dz*Ky*f0', ['Dz', 'f0', 'Cx', 'Ky'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky*f0', ['f0', 'Cx', 'Ky'])),
                          (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Dy*Kz*f0', ['Dy', 'Kz', 'f0', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz*f0', ['Kz', 'f0', 'Cx'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz*Py', ['Kz', 'Cx', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*Py*f22', ['f22', 'Cx', 'Py'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*Cy*f36', ['f36', 'Cx', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*Pz*f11', ['Pz', 'f11', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*f11*f32', ['f32', 'f11', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Dz*Kx*f32', ['Dz', 'f32', 'Kx', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx*f32', ['f32', 'Kx', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx*Pz', ['Pz', 'Kx', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*Pz*Qy', ['Qy', 'Pz', 'Kx'])),
                          (((2, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Qy*f14', ['f14', 'Qy'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Qz*f14', ['f14', 'Qz'])),
                          (((1, 2, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('f16*f25', ['f16', 'f25'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('f2*f25', ['f25', 'f2'])),
                          (((0, 3, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*f6', ['f6', 'Kx'])),
                          (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*f6', ['f6', 'Kz'])),
                          (((1, 0, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Pz*f8', ['f8', 'Pz'])),
                          (((1, 2, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Py*f8', ['f8', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Py*f25', ['Dz', 'f25', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Py*f25', ['f25', 'Py'])),
                          (((1, 0, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Pz*f25', ['Dy', 'f25', 'Pz'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Pz*f25', ['f25', 'Pz'])),
                          (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Pz*f4', ['f4', 'Pz'])),
                          (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Px*f4', ['f4', 'Px'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Px*f36', ['f36', 'Px'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Py*f36', ['f36', 'Py'])),
                          (((2, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*f10', ['Cz', 'f10'])),
                          (((2, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*f10', ['f10', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Dz*f14', ['Dz', 'f14', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*f14', ['f14', 'Cy'])),
                          (((2, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Dy*f14', ['Dy', 'f14', 'Cz'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*f14', ['f14', 'Cz'])),
                          (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*f3', ['Cz', 'f3'])),
                          (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*f3', ['Cx', 'f3'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*f17', ['Cx', 'f17'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*f17', ['Cy', 'f17'])),
                          (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f5', ['Dx', 'f5'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f5', ['Dz', 'f5'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f1', ['Dz', 'f1'])),
                          (((3, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f1', ['Dy', 'f1'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('f1', ['f1'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('f5', ['f5'])))),
 ('f', 's', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f0': '(3*B10 + pow(Cx,2))',
                          'f1': '(Dz*Pz + 2*B00*Cz)',
                          'f10': '(3*B10 + pow(Cz,2))',
                          'f11': '(3*B10 + pow(Cy,2))',
                          'f3': '3*B00*B10',
                          'f4': '(Dy*Py + 2*B00*Cy)',
                          'f6': '(Dx*Px + 2*B00*Cx)'},
                         ((((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*pow(Cx,3) + 3*B00*pow(Cx,2) + 3*B10*Cx*Dx + f3)',
                            ['Dx', 'B00', 'B10', 'Cx', 'f3'])),
                          (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('(3*B00*pow(Cy,2) + f3 + Dy*pow(Cy,3) + 3*B10*Cy*Dy)',
                            ['Dy', 'B10', 'B00', 'f3', 'Cy'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('(3*B10*Cz*Dz + f3 + 3*B00*pow(Cz,2) + Dz*pow(Cz,3))',
                            ['Dz', 'B10', 'Cz', 'f3', 'B00'])),
                          (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*Qx', ['Qx', 'Cz', 'Cy'])),
                          (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*f10', ['Dy', 'Cz', 'f10'])),
                          (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Px', ['Dy', 'Cz', 'Px'])),
                          (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*Qy', ['Cz', 'Qy', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*f0', ['Dz', 'f0', 'Cx'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*Py', ['Dz', 'Cx', 'Py'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*Qz', ['Cx', 'Cy', 'Qz'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                          (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*Py', ['Dx', 'Cz', 'Py'])),
                          (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f10', ['Dx', 'Cz', 'f10'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f10', ['Cz', 'f10'])),
                          (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f6', ['f6', 'Cy'])),
                          (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f6', ['f6', 'Cz'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Px', ['Cz', 'Px'])),
                          (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Px*Qy', ['Qy', 'Px'])),
                          (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*f4', ['f4', 'Cx'])),
                          (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*f4', ['f4', 'Cz'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Py', ['Cz', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Py*Qx', ['Qx', 'Py'])),
                          (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Pz*Qx', ['Qx', 'Pz'])),
                          (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Pz*Qy', ['Qy', 'Pz'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Pz', ['Pz', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*Pz', ['Dx', 'Pz', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*f11', ['Dx', 'f11', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f11', ['f11', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*f11', ['Dz', 'f11', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Px', ['Dz', 'Px', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Px', ['Px', 'Cy'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Px*Qz', ['Qz', 'Px'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Py*Qz', ['Py', 'Qz'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Py', ['Cx', 'Py'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Pz', ['Pz', 'Cx'])),
                          (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*Pz', ['Dy', 'Pz', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*f0', ['Dy', 'f0', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f0', ['f0', 'Cx'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f1', ['f1', 'Cx'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f1', ['f1', 'Cy'])))),
 ('f', 's', 'sp', 'sp'): ({'B00': '',
                           'B01': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Kx': '(Xkl + Dx)',
                           'Ky': '(Ykl + Dy)',
                           'Kz': '(Dz + Zkl)',
                           'Px': '(B10 + pow(Cx,2))',
                           'Py': '(B10 + pow(Cy,2))',
                           'Pz': '(B10 + pow(Cz,2))',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)',
                           'f0': '(3*B10 + pow(Cx,2))',
                           'f1': '3*B00*pow(Cy,2)',
                           'f11': '3*B00*B10',
                           'f12': '(Dy*Py + 2*B00*Cy)',
                           'f14': '(2*B00*Cx*(Xkl + 2*Dx) + 2*pow(B00,2) + Px*(B01 + Dx*Kx))',
                           'f15': '3*B10*Cy*Dy',
                           'f16': '(B01 + Dx*Kx)',
                           'f19': '(Kx*Px + 2*B00*Cx)',
                           'f2': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                           'f20': '3*B00*pow(Cz,2)',
                           'f21': '(2*pow(B00,2) + Pz*(Dz*Kz + B01) + 2*B00*Cz*(2*Dz + Zkl))',
                           'f22': '3*B00*pow(Cx,2)',
                           'f25': '(Dx*Px + 2*B00*Cx)',
                           'f26': '3*B10*Cx*Dx',
                           'f27': '(Dz*Kz + B01)',
                           'f28': '(B01 + Dy*Ky)',
                           'f29': '(B00 + Cx*Kx)',
                           'f3': '(Dz*Pz + 2*B00*Cz)',
                           'f36': 'Dx*pow(Cx,3)',
                           'f37': '(3*B10 + pow(Cz,2))',
                           'f38': '(3*B10 + pow(Cy,2))',
                           'f4': '3*B10*Cz*Dz',
                           'f42': 'Dy*pow(Cy,3)',
                           'f45': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                           'f5': '(Py*(B01 + Dy*Ky) + 2*pow(B00,2) + 2*B00*Cy*(Ykl + 2*Dy))',
                           'f6': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                           'f7': 'Dz*pow(Cz,3)',
                           'Xkl': '',
                           'Ykl': '',
                           'Zkl': ''},
                          ((((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('(6*Cy*pow(B00,2) + B01*(3*B10*Cy + pow(Cy,3)) + Dy*(2*f11 + Cy*Dy*f38 + 2*f1) + Ykl*(f11 + f15 + f42 + f1))',
                             ['f15',
                              'B10',
                              'f1',
                              'f38',
                              'Dy',
                              'B01',
                              'Ykl',
                              'B00',
                              'f42',
                              'f11',
                              'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*(f11 + f15 + f42 + Ykl*pow(Cy,3) + f1 + 3*B10*Cy*Ykl)',
                             ['f15',
                              'Dx',
                              'f1',
                              'B10',
                              'Ykl',
                              'f42',
                              'f11',
                              'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*(f11 + f15 + f42 + Ykl*pow(Cy,3) + f1 + 3*B10*Cy*Ykl)',
                             ['f15',
                              'B10',
                              'f1',
                              'Dz',
                              'Ykl',
                              'f42',
                              'f11',
                              'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('(f11 + f15 + f42 + Ykl*pow(Cy,3) + f1 + 3*B10*Cy*Ykl)',
                             ['f15',
                              'B10',
                              'f1',
                              'Ykl',
                              'f42',
                              'f11',
                              'Cy'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('(Dz*(2*f20 + Cz*Dz*f37 + 2*f11) + Zkl*(f11 + f20 + f4 + f7) + B01*(3*B10*Cz + pow(Cz,3)) + 6*Cz*pow(B00,2))',
                             ['f4',
                              'B10',
                              'B00',
                              'f20',
                              'f37',
                              'B01',
                              'Dz',
                              'Cz',
                              'f7',
                              'Zkl',
                              'f11'])),
                           (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*(f11 + f20 + 3*B10*Cz*Zkl + f4 + f7 + Zkl*pow(Cz,3))',
                             ['f4',
                              'B10',
                              'f20',
                              'Dy',
                              'Cz',
                              'f7',
                              'Zkl',
                              'f11'])),
                           (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*(f11 + f20 + 3*B10*Cz*Zkl + f4 + f7 + Zkl*pow(Cz,3))',
                             ['f4',
                              'Dx',
                              'f20',
                              'B10',
                              'Cz',
                              'f7',
                              'Zkl',
                              'f11'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('(f11 + f20 + 3*B10*Cz*Zkl + f4 + f7 + Zkl*pow(Cz,3))',
                             ['f4',
                              'B10',
                              'f20',
                              'Cz',
                              'f7',
                              'Zkl',
                              'f11'])),
                           (((3, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(6*Cx*pow(B00,2) + B01*(3*B10*Cx + pow(Cx,3)) + Xkl*(f11 + f22 + f26 + f36) + Dx*(Cx*Dx*f0 + 2*f22 + 2*f11))',
                             ['B10',
                              'Cx',
                              'f0',
                              'B01',
                              'f36',
                              'Dx',
                              'Xkl',
                              'B00',
                              'f26',
                              'f22',
                              'f11'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*(f11 + f22 + f26 + f36 + 3*B10*Cx*Xkl + Xkl*pow(Cx,3))',
                             ['f36',
                              'Cx',
                              'B10',
                              'Dz',
                              'Xkl',
                              'f22',
                              'f26',
                              'f11'])),
                           (((3, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*(f11 + f22 + f26 + f36 + 3*B10*Cx*Xkl + Xkl*pow(Cx,3))',
                             ['f36',
                              'Cx',
                              'Dy',
                              'B10',
                              'Xkl',
                              'f22',
                              'f26',
                              'f11'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('(f11 + f22 + f26 + f36 + 3*B10*Cx*Xkl + Xkl*pow(Cx,3))',
                             ['f36',
                              'Cx',
                              'B10',
                              'Xkl',
                              'f22',
                              'f26',
                              'f11'])),
                           (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*(f11 + f22 + f26 + f36)',
                             ['f36', 'f22', 'f11', 'Ky', 'f26'])),
                           (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*(f11 + f22 + f26 + f36)',
                             ['f36', 'Kz', 'f22', 'f11', 'f26'])),
                           (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(f11 + f22 + f26 + f36)',
                             ['f36', 'f22', 'f11', 'f26'])),
                           (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*(f11 + f15 + f42 + f1)',
                             ['f15', 'Kz', 'f1', 'f11', 'f42'])),
                           (((0, 3, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*(f11 + f15 + f42 + f1)',
                             ['f15', 'f42', 'f1', 'Kx', 'f11'])),
                           (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('(f11 + f15 + f42 + f1)',
                             ['f15', 'f1', 'f11', 'f42'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Ky*(f11 + f20 + f4 + f7)',
                             ['f4', 'f7', 'f11', 'Ky', 'f20'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Kx*(f11 + f20 + f4 + f7)',
                             ['f20', 'f4', 'f7', 'Kx', 'f11'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('(f11 + f20 + f4 + f7)',
                             ['f4', 'f7', 'f11', 'f20'])),
                           (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Py*(Cz*Zkl + Qz)',
                             ['Dx', 'Cz', 'Zkl', 'Py', 'Qz'])),
                           (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Qy*(Cz*Zkl + Qz)',
                             ['Zkl', 'Cz', 'Qy', 'Cx', 'Qz'])),
                           (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Qy*(Pz*Zkl + f3)', ['Pz', 'Qy', 'Zkl', 'f3'])),
                           (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Qx*(Pz*Zkl + f3)', ['Zkl', 'Qx', 'Pz', 'f3'])),
                           (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Dy*(Pz*Zkl + f3)',
                             ['Dy', 'Zkl', 'Pz', 'Cx', 'f3'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*(Pz*Zkl + f3)', ['Zkl', 'Pz', 'Cx', 'f3'])),
                           (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Dx*(Pz*Zkl + f3)',
                             ['Zkl', 'Dx', 'Pz', 'f3', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cy*(Pz*Zkl + f3)', ['Zkl', 'Pz', 'f3', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Qx*(Cz*Zkl + Qz)',
                             ['Qx', 'Zkl', 'Qz', 'Cy', 'Cz'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*Cy*(Cz*Zkl + Qz)',
                             ['Cz', 'Zkl', 'Cx', 'Cy', 'Qz'])),
                           (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Px*(Cz*Zkl + Qz)',
                             ['Dy', 'Cz', 'Zkl', 'Qz', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Px*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Qz', 'Px'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Py*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Py', 'Qz'])),
                           (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('f25*(Cz*Zkl + Qz)',
                             ['f25', 'Cz', 'Zkl', 'Qz'])),
                           (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('f12*(Cz*Zkl + Qz)',
                             ['Zkl', 'Cz', 'f12', 'Qz'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cy*f27*f38', ['f27', 'f38', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cy*Px*f27', ['f27', 'Px', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*Cz*f6', ['f6', 'Cz', 'Cx'])),
                           (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*Pz*f28', ['Pz', 'Cx', 'f28'])),
                           (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*f0*f28', ['f0', 'Cx', 'f28'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*f0*f27', ['f27', 'f0', 'Cx'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*Py*f27', ['f27', 'Cx', 'Py'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Qz*(Cy*Ykl + Qy)',
                             ['Ykl', 'Qy', 'Cx', 'Cy', 'Qz'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Qz*(f12 + Py*Ykl)',
                             ['Ykl', 'f12', 'Qz', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Qx*(f12 + Py*Ykl)',
                             ['Ykl', 'Qx', 'f12', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Dz*(f12 + Py*Ykl)',
                             ['Dz', 'Ykl', 'f12', 'Cx', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*(f12 + Py*Ykl)',
                             ['Ykl', 'f12', 'Cx', 'Py'])),
                           (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Dx*(f12 + Py*Ykl)',
                             ['Ykl', 'Dx', 'Cz', 'f12', 'Py'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cz*(f12 + Py*Ykl)',
                             ['Ykl', 'Cz', 'f12', 'Py'])),
                           (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Qx*(Cy*Ykl + Qy)',
                             ['Qx', 'Ykl', 'Cz', 'Qy', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*Cz*(Cy*Ykl + Qy)',
                             ['Ykl', 'Cz', 'Qy', 'Cx', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('f3*(Cy*Ykl + Qy)', ['Ykl', 'Qy', 'f3', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('f25*(Cy*Ykl + Qy)',
                             ['Ykl', 'f25', 'Qy', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Px*(Cy*Ykl + Qy)',
                             ['Dz', 'Ykl', 'Qy', 'Cy', 'Px'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Px*(Cy*Ykl + Qy)', ['Ykl', 'Qy', 'Cy', 'Px'])),
                           (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Pz*(Cy*Ykl + Qy)',
                             ['Ykl', 'Dx', 'Pz', 'Qy', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Pz*(Cy*Ykl + Qy)', ['Ykl', 'Pz', 'Qy', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*Pz*Qy', ['Qy', 'Pz', 'Kx'])),
                           (((1, 1, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Qy*f29', ['Cz', 'Qy', 'f29'])),
                           (((1, 1, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*Cz*f2', ['Cz', 'f2', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*Qx', ['Qx', 'Cz', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*Cz*f29', ['Cz', 'f29', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Qz*f29', ['Qz', 'Cy', 'f29'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Cy*Qz', ['Cx', 'Cy', 'Qz'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*Cy*f45', ['f45', 'Cx', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Cz*Qy', ['Cz', 'Qy', 'Cx'])),
                           (((2, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Qy*f19', ['Qy', 'f19'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Qz*f19', ['Qz', 'f19'])),
                           (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Px*f6', ['f6', 'Px'])),
                           (((1, 2, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('f12*f29', ['f12', 'f29'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('f29*f3', ['f3', 'f29'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Ky*f3', ['Cx', 'Ky', 'f3'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*f3', ['Cx', 'f3'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Kx*f3', ['Kx', 'Cy', 'f3'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*f3', ['f3', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*f14', ['f14', 'Cy'])),
                           (((2, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*f14', ['f14', 'Cz'])),
                           (((2, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Dy*f19', ['Dy', 'Cz', 'f19'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cz*f19', ['Cz', 'f19'])),
                           (((0, 2, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Kx*f12', ['Cz', 'f12', 'Kx'])),
                           (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*f12', ['Cz', 'f12'])),
                           (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Kz*f12', ['Kz', 'f12', 'Cx'])),
                           (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*f12', ['f12', 'Cx'])),
                           (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*f5', ['Cx', 'f5'])),
                           (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*f5', ['Cz', 'f5'])),
                           (((1, 0, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Pz*f2', ['Pz', 'f2'])),
                           (((1, 2, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Py*f2', ['Py', 'f2'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Kx*Py*Qz', ['Qz', 'Kx', 'Py'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Py*Qz', ['Py', 'Qz'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Py*f29', ['Py', 'f29'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Py*f29', ['Dz', 'Py', 'f29'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*Py', ['Dz', 'Cx', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Py', ['Cx', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*Kz*Py', ['Kz', 'Cx', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*Py*Qx', ['Qx', 'Kz', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Py*Qx', ['Qx', 'Py'])),
                           (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*Pz*Qx', ['Qx', 'Pz', 'Ky'])),
                           (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Pz*Qx', ['Qx', 'Pz'])),
                           (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Pz*f6', ['f6', 'Pz'])),
                           (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Pz*Qy', ['Qy', 'Pz'])),
                           (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*Px*Qy', ['Kz', 'Qy', 'Px'])),
                           (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Px*Qy', ['Qy', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Px*Qz', ['Qz', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Ky*Px*Qz', ['Px', 'Ky', 'Qz'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cz*Ky*Px', ['Cz', 'Px', 'Ky'])),
                           (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*Px*f28', ['Cz', 'f28', 'Px'])),
                           (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*f28*f37', ['f37', 'Cz', 'f28'])),
                           (((0, 0, 3), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*f16*f37', ['f16', 'f37', 'Cz'])),
                           (((0, 2, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*Py*f16', ['f16', 'Cz', 'Py'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cz*Kx*Py', ['Cz', 'Kx', 'Py'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cz*Kx*f37', ['f37', 'Cz', 'Kx'])),
                           (((0, 0, 3), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Dy*Kx*f37', ['Dy', 'Cz', 'Kx', 'f37'])),
                           (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*f37', ['Dy', 'Cz', 'f37'])),
                           (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*Px', ['Dy', 'Cz', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Px', ['Cz', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Px*f45', ['f45', 'Px'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Py*f45', ['f45', 'Py'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Py', ['Cz', 'Py'])),
                           (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*Py', ['Dx', 'Cz', 'Py'])),
                           (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Dx*Ky*f37', ['f37', 'Dx', 'Cz', 'Ky'])),
                           (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*f37', ['f37', 'Dx', 'Cz'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*f37', ['f37', 'Cz'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cz*Ky*f37', ['f37', 'Cz', 'Ky'])),
                           (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Ky*f25', ['f25', 'Cz', 'Ky'])),
                           (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*f25', ['f25', 'Cz'])),
                           (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Kz*f25', ['f25', 'Kz', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*f25', ['f25', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*f19', ['f19', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Dz*f19', ['Dz', 'f19', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*Px', ['Dz', 'Px', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Px', ['Px', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cy*Kz*Px', ['Kz', 'Px', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Dx*Kz*f38', ['Dx', 'Kz', 'f38', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cy*Kz*f38', ['Kz', 'f38', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*f16*f38', ['f16', 'f38', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*Pz*f16', ['f16', 'Pz', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*Kx*Pz', ['Pz', 'Kx', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*Kx*f38', ['f38', 'Kx', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Dz*Kx*f38', ['Dz', 'f38', 'Kx', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*f38', ['Dz', 'f38', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*f38', ['f38', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*f38', ['Dx', 'f38', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*Pz', ['Dx', 'Pz', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Pz', ['Pz', 'Cy'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Pz*f29', ['Pz', 'f29'])),
                           (((1, 0, 2), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Pz*f29', ['Dy', 'Pz', 'f29'])),
                           (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*Pz', ['Dy', 'Pz', 'Cx'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Pz', ['Pz', 'Cx'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*Ky*Pz', ['Pz', 'Cx', 'Ky'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*Ky*f0', ['f0', 'Cx', 'Ky'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Dz*Ky*f0', ['Dz', 'f0', 'Cx', 'Ky'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*f0', ['Dz', 'f0', 'Cx'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*Kz*f0', ['Kz', 'f0', 'Cx'])),
                           (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Dy*Kz*f0', ['Dy', 'Kz', 'f0', 'Cx'])),
                           (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*f0', ['Dy', 'f0', 'Cx'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*f0', ['f0', 'Cx'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*f21', ['Cx', 'f21'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cy*f21', ['f21', 'Cy'])))),
 ('f', 'sp', 'p', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f0': '(3*B10 + pow(Cx,2))',
                          'f10': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                          'f12': '(3*pow(B10,2) + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3))',
                          'f15': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                          'f17': '(Dy*Iy + B00)',
                          'f18': '(Cy*Iy + B10)',
                          'f19': '(3*pow(B10,2) + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy))',
                          'f2': '(Dz*Pz + 2*B00*Cz)',
                          'f20': '(3*pow(B10,2) + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                          'f22': '(Dx*Px + 2*B00*Cx)',
                          'f23': '(Dx*Ix + B00)',
                          'f24': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                          'f3': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                          'f33': '(3*B10 + pow(Cz,2))',
                          'f34': '(3*B10 + pow(Cy,2))',
                          'f4': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                          'f5': '(Dx*(B10*(3*Cx + Xij) + Ix*pow(Cx,2)) + 2*B00*Cx*Xij + 3*B00*Px)',
                          'f6': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                          'f8': '3*B00*B10',
                          'f9': '(Dy*Py + 2*B00*Cy)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*(f6 + Yij*(Dy*Py + 2*B00*Cy))',
                            ['Cx', 'Dy', 'Py', 'Yij', 'f6', 'B00', 'Cy'])),
                          (((0, 2, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*(f6 + Yij*(Dy*Py + 2*B00*Cy))',
                            ['Cz', 'Dy', 'Py', 'Yij', 'f6', 'B00', 'Cy'])),
                          (((0, 3, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(B00*pow(Cy,2)*(4*Cy + 3*Yij) + 3*Dy*pow(B10,2) + 4*Cy*f8 + Dy*pow(Cy,4) + Dy*Yij*pow(Cy,3) + f8*Yij + 3*B10*Cy*Dy*(Yij + 2*Cy))',
                            ['B10', 'Dy', 'Yij', 'B00', 'f8', 'Cy'])),
                          (((1, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*(f2 + Qz*Zij)',
                            ['Zij', 'f2', 'Cx', 'Cy', 'Qz'])),
                          (((2, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Px*(f2 + Qz*Zij)', ['Zij', 'f2', 'Px', 'Qz'])),
                          (((0, 2, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Py*(f2 + Qz*Zij)', ['Zij', 'Py', 'f2', 'Qz'])),
                          (((0, 1, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*(B00*Cz*(3*Cz + 2*Zij) + Dz*Iz*pow(Cz,2) + B10*Dz*(3*Cz + Zij) + f8)',
                            ['B10',
                             'Cz',
                             'Zij',
                             'Dz',
                             'B00',
                             'f8',
                             'Iz',
                             'Cy'])),
                          (((1, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*(B00*Cz*(3*Cz + 2*Zij) + Dz*Iz*pow(Cz,2) + B10*Dz*(3*Cz + Zij) + f8)',
                            ['B10',
                             'Cx',
                             'Cz',
                             'Zij',
                             'Dz',
                             'B00',
                             'f8',
                             'Iz'])),
                          (((0, 0, 3), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(f8*Zij + 3*Dz*pow(B10,2) + B00*pow(Cz,2)*(4*Cz + 3*Zij) + Dz*pow(Cz,4) + 3*B10*Cz*Dz*(2*Cz + Zij) + 4*Cz*f8 + Dz*Zij*pow(Cz,3))',
                            ['B10', 'Cz', 'Zij', 'Dz', 'B00', 'f8'])),
                          (((0, 0, 3), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*(3*B10*Cz*Dz + f8 + 3*B00*pow(Cz,2) + Dz*pow(Cz,3))',
                            ['B10', 'B00', 'Dz', 'Cz', 'f8', 'Iy'])),
                          (((0, 0, 3), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*(3*B10*Cz*Dz + f8 + 3*B00*pow(Cz,2) + Dz*pow(Cz,3))',
                            ['B10', 'Ix', 'Dz', 'Cz', 'f8', 'B00'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('(3*B10*Cz*Dz + f8 + 3*B00*pow(Cz,2) + Dz*pow(Cz,3))',
                            ['Dz', 'B10', 'Cz', 'f8', 'B00'])),
                          (((3, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*(Dx*pow(Cx,3) + 3*B00*pow(Cx,2) + 3*B10*Cx*Dx + f8)',
                            ['Dx', 'Cx', 'B10', 'B00', 'f8', 'Iz'])),
                          (((3, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*(Dx*pow(Cx,3) + 3*B00*pow(Cx,2) + 3*B10*Cx*Dx + f8)',
                            ['B10', 'Cx', 'Dx', 'B00', 'f8', 'Iy'])),
                          (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*pow(Cx,3) + 3*B00*pow(Cx,2) + 3*B10*Cx*Dx + f8)',
                            ['f8', 'Dx', 'B00', 'B10', 'Cx'])),
                          (((3, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*Xij*pow(Cx,3) + f8*Xij + 3*Dx*pow(B10,2) + Dx*pow(Cx,4) + 4*Cx*f8 + B00*pow(Cx,2)*(4*Cx + 3*Xij) + 3*B10*Cx*Dx*(Xij + 2*Cx))',
                            ['Dx', 'Cx', 'Xij', 'B10', 'B00', 'f8'])),
                          (((1, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Qz*(Px + Cx*Xij)',
                            ['Xij', 'Px', 'Qz', 'Cy', 'Cx'])),
                          (((0, 3, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f34*(Dz*Zij + Qz)',
                            ['f34', 'Dz', 'Qz', 'Cy', 'Zij'])),
                          (((2, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Px*(Dz*Zij + Qz)',
                            ['Dz', 'Zij', 'Px', 'Cy', 'Qz'])),
                          (((3, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f0*(Dz*Zij + Qz)',
                            ['Dz', 'Zij', 'f0', 'Cx', 'Qz'])),
                          (((1, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Py*(Dz*Zij + Qz)',
                            ['Dz', 'Zij', 'Qz', 'Cx', 'Py'])),
                          (((1, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Py*(Px + Cx*Xij)',
                            ['Dz', 'Xij', 'Py', 'Px', 'Cx'])),
                          (((1, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Pz*(Px + Cx*Xij)',
                            ['Dy', 'Pz', 'Cx', 'Px', 'Xij'])),
                          (((1, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('f9*(Px + Cx*Xij)', ['f9', 'Cx', 'Px', 'Xij'])),
                          (((1, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('f2*(Px + Cx*Xij)', ['Xij', 'Px', 'f2', 'Cx'])),
                          (((1, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Qy*(Px + Cx*Xij)',
                            ['Cz', 'Qy', 'Cx', 'Px', 'Xij'])),
                          (((1, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Qy*(Cz*Zij + Pz)',
                            ['Zij', 'Pz', 'Cz', 'Qy', 'Cx'])),
                          (((1, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Qx*(Cz*Zij + Pz)',
                            ['Zij', 'Qx', 'Pz', 'Cy', 'Cz'])),
                          (((0, 2, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Py*(Cz*Zij + Pz)',
                            ['Zij', 'Dx', 'Cz', 'Pz', 'Py'])),
                          (((0, 2, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('f9*(Cz*Zij + Pz)', ['Zij', 'f9', 'Pz', 'Cz'])),
                          (((2, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('f22*(Cz*Zij + Pz)',
                            ['Zij', 'f22', 'Pz', 'Cz'])),
                          (((2, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Px*(Cz*Zij + Pz)',
                            ['Zij', 'Dy', 'Cz', 'Pz', 'Px'])),
                          (((2, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*f24', ['Dy', 'Cz', 'f24'])),
                          (((1, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*f3', ['Dy', 'Cx', 'f3'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*Py', ['Dz', 'Cx', 'Py'])),
                          (((2, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Px*f18', ['Dz', 'f18', 'Px'])),
                          (((1, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Qx*f18', ['Qx', 'Cz', 'f18'])),
                          (((1, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*f4', ['f4', 'Cz', 'Cx'])),
                          (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Cz*Qy', ['Cz', 'Qy', 'Cx'])),
                          (((3, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*f0*f17', ['f0', 'Cx', 'f17'])),
                          (((1, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Pz*f17', ['Pz', 'Cx', 'f17'])),
                          (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*Pz', ['Dy', 'Pz', 'Cx'])),
                          (((3, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*Iz*f0', ['Dy', 'f0', 'Cx', 'Iz'])),
                          (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*f0', ['Dy', 'f0', 'Cx'])),
                          (((3, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*Iy*f0', ['Dz', 'f0', 'Iy', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*f0', ['Dz', 'f0', 'Cx'])),
                          (((1, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*f10', ['Dz', 'Cx', 'f10'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Cy*Qz', ['Cx', 'Cy', 'Qz'])),
                          (((1, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Qz*f18', ['Cx', 'f18', 'Qz'])),
                          (((0, 1, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Pz*f18', ['Dx', 'Pz', 'f18'])),
                          (((0, 2, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f10', ['Dx', 'Cz', 'f10'])),
                          (((0, 1, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*f3', ['Dx', 'f3', 'Cy'])),
                          (((2, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*f24', ['Dz', 'f24', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Px', ['Dz', 'Px', 'Cy'])),
                          (((0, 3, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Ix*f34', ['Dz', 'f34', 'Ix', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*f34', ['Dz', 'f34', 'Cy'])),
                          (((0, 3, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f23*f34', ['f34', 'f23', 'Cy'])),
                          (((0, 1, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Pz*f23', ['f23', 'Pz', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*Pz', ['Dx', 'Pz', 'Cy'])),
                          (((0, 3, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*Iz*f34', ['f34', 'Dx', 'Iz', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*f34', ['f34', 'Dx', 'Cy'])),
                          (((1, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*f15', ['f15', 'Cz', 'Cy'])),
                          (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*Qx', ['Qx', 'Cz', 'Cy'])),
                          (((2, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Px*f17', ['Cz', 'Px', 'f17'])),
                          (((0, 0, 3), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*f17*f33', ['Cz', 'f33', 'f17'])),
                          (((0, 0, 3), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f23*f33', ['Cz', 'f23', 'f33'])),
                          (((0, 2, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Py*f23', ['Cz', 'f23', 'Py'])),
                          (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*Py', ['Dx', 'Cz', 'Py'])),
                          (((0, 0, 3), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*Iy*f33', ['Dx', 'Cz', 'Iy', 'f33'])),
                          (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f33', ['Dx', 'Cz', 'f33'])),
                          (((0, 0, 3), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Ix*f33', ['Dy', 'Cz', 'f33', 'Ix'])),
                          (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*f33', ['Dy', 'Cz', 'f33'])),
                          (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Px', ['Dy', 'Cz', 'Px'])),
                          (((2, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Px*f4', ['f4', 'Px'])),
                          (((0, 1, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Pz*f4', ['f4', 'Pz'])),
                          (((2, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f24', ['f24', 'Qz'])),
                          (((3, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f20', ['Dz', 'f20'])),
                          (((3, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f20', ['Dy', 'f20'])),
                          (((0, 0, 3), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f12', ['Dy', 'f12'])),
                          (((0, 0, 3), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f12', ['Dx', 'f12'])),
                          (((0, 3, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f19', ['Dx', 'f19'])),
                          (((0, 3, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f19', ['Dz', 'f19'])),
                          (((1, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f3', ['Qx', 'f3'])),
                          (((0, 1, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Qy*f3', ['Qy', 'f3'])),
                          (((2, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy*f24', ['f24', 'Qy'])),
                          (((0, 1, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Pz*Qy', ['Qy', 'Ix', 'Pz'])),
                          (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Pz*Qy', ['Qy', 'Pz'])),
                          (((2, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*Px*Qy', ['Qy', 'Iz', 'Px'])),
                          (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Px*Qy', ['Qy', 'Px'])),
                          (((2, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*Px*Qz', ['Iy', 'Qz', 'Px'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Px*Qz', ['Qz', 'Px'])),
                          (((0, 2, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Py*Qz', ['Ix', 'Py', 'Qz'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Py*Qz', ['Py', 'Qz'])),
                          (((1, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Py*f15', ['f15', 'Py'])),
                          (((1, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Pz*f15', ['f15', 'Pz'])),
                          (((1, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Pz*Qx', ['Pz', 'Qx', 'Iy'])),
                          (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Pz*Qx', ['Qx', 'Pz'])),
                          (((1, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*Py*Qx', ['Qx', 'Iz', 'Py'])),
                          (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Py*Qx', ['Qx', 'Py'])),
                          (((1, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx*f10', ['Qx', 'f10'])),
                          (((0, 2, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz*f10', ['Qz', 'f10'])),
                          (((0, 2, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Ix*f9', ['f9', 'Cz', 'Ix'])),
                          (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*f9', ['f9', 'Cz'])),
                          (((1, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Iz*f9', ['f9', 'Cx', 'Iz'])),
                          (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*f9', ['f9', 'Cx'])),
                          (((1, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Iy*f2', ['Iy', 'Cx', 'f2'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f2', ['Cx', 'f2'])),
                          (((0, 1, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Ix*f2', ['Ix', 'f2', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f2', ['f2', 'Cy'])),
                          (((2, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f5', ['Cy', 'f5'])),
                          (((2, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f5', ['Cz', 'f5'])),
                          (((2, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*f22', ['Cz', 'Iy', 'f22'])),
                          (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*f22', ['Cz', 'f22'])),
                          (((2, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*f22', ['f22', 'Iz', 'Cy'])),
                          (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*f22', ['f22', 'Cy'])),
                          (((2, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('f18*f22', ['f22', 'f18'])),
                          (((0, 1, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('f18*f2', ['f2', 'f18'])),
                          (((0, 3, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*f6', ['f6', 'Iz'])),
                          (((0, 3, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*f6', ['f6', 'Ix'])),
                          (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('f6', ['f6'])))),
 ('f', 'sp', 's', 's'): ({'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Px': '(B10 + pow(Cx,2))',
                          'Py': '(B10 + pow(Cy,2))',
                          'Pz': '(B10 + pow(Cz,2))',
                          'f0': '(3*B10 + pow(Cx,2))',
                          'f11': '(3*B10 + pow(Cz,2))',
                          'f12': '(3*B10 + pow(Cy,2))',
                          'f13': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                          'f2': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                          'f5': '(Cy*Iy + B10)',
                          'f6': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                          'f8': '3*pow(B10,2)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*(Cz*Zij + Pz)',
                            ['Zij', 'Cz', 'Pz', 'Cx', 'Cy'])),
                          (((1, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Cz*(Px + Cx*Xij)',
                            ['Cz', 'Xij', 'Px', 'Cy', 'Cx'])),
                          (((1, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Px + Cx*Xij)', ['Xij', 'Py', 'Px', 'Cx'])),
                          (((1, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*(Px + Cx*Xij)', ['Pz', 'Cx', 'Px', 'Xij'])),
                          (((3, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3) + f8)',
                            ['B10', 'Ix', 'f8', 'Cx', 'Xij'])),
                          (((0, 3, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Iy*pow(Cy,3) + f8 + 3*B10*Cy*(Yij + 2*Cy))',
                            ['f8', 'B10', 'Iy', 'Cy', 'Yij'])),
                          (((0, 0, 3), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(3*B10*Cz*(2*Cz + Zij) + f8 + Iz*pow(Cz,3))',
                            ['Zij', 'B10', 'Cz', 'f8', 'Iz'])),
                          (((2, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Px*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Px'])),
                          (((0, 2, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Py*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Py'])),
                          (((0, 0, 3), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*f11', ['Cz', 'Iy', 'f11'])),
                          (((2, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*Px', ['Cz', 'Iy', 'Px'])),
                          (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                          (((1, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Cz*f5', ['Cz', 'Cx', 'f5'])),
                          (((0, 2, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*Py', ['Cz', 'Py', 'Ix'])),
                          (((0, 0, 3), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*f11', ['Cz', 'f11', 'Ix'])),
                          (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f11', ['Cz', 'f11'])),
                          (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Py', ['Cz', 'Py'])),
                          (((2, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f6', ['f6', 'Cy'])),
                          (((2, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f6', ['f6', 'Cz'])),
                          (((2, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Px*f5', ['Px', 'f5'])),
                          (((3, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz*f0', ['f0', 'Cx', 'Iz'])),
                          (((1, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz*Py', ['Cx', 'Py', 'Iz'])),
                          (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Py', ['Cx', 'Py'])),
                          (((1, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f2', ['Cx', 'f2'])),
                          (((0, 2, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*f2', ['Cz', 'f2'])),
                          (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Px', ['Cz', 'Px'])),
                          (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Px', ['Px', 'Cy'])),
                          (((2, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*Px', ['Px', 'Iz', 'Cy'])),
                          (((0, 3, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*f12', ['f12', 'Iz', 'Cy'])),
                          (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f12', ['f12', 'Cy'])),
                          (((0, 3, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*f12', ['Ix', 'f12', 'Cy'])),
                          (((0, 1, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*Pz', ['Ix', 'Pz', 'Cy'])),
                          (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Pz', ['Pz', 'Cy'])),
                          (((0, 1, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Pz*f5', ['Pz', 'f5'])),
                          (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Pz', ['Pz', 'Cx'])),
                          (((1, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*Pz', ['Pz', 'Iy', 'Cx'])),
                          (((3, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*f0', ['f0', 'Iy', 'Cx'])),
                          (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f0', ['f0', 'Cx'])),
                          (((1, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*f13', ['f13', 'Cx'])),
                          (((0, 1, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*f13', ['f13', 'Cy'])))),
 ('f', 'sp', 'sp', 's'): ({'B00': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Px': '(B10 + pow(Cx,2))',
                           'Py': '(B10 + pow(Cy,2))',
                           'Pz': '(B10 + pow(Cz,2))',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)',
                           'f0': '(3*B10 + pow(Cx,2))',
                           'f12': '(B00 + Dz*Iz)',
                           'f2': '(Dz*Pz + 2*B00*Cz)',
                           'f20': '(3*B10 + pow(Cz,2))',
                           'f21': '(3*pow(B10,2) + Iy*pow(Cy,3) + 3*B10*Cy*(Yij + 2*Cy))',
                           'f23': '(Cy*Iy + B10)',
                           'f24': '(B10*(3*Cx + Xij) + Ix*pow(Cx,2))',
                           'f25': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                           'f28': '(2*B00*Cy*Yij + 3*B00*Py + Dy*(B10*(3*Cy + Yij) + Iy*pow(Cy,2)))',
                           'f29': '(B10*(3*Cy + Yij) + Iy*pow(Cy,2))',
                           'f3': '(3*B00*Pz + Cz*Dz*(3*B10 + pow(Cz,2)))',
                           'f30': '(Cy*Dy*(3*B10 + pow(Cy,2)) + 3*B00*Py)',
                           'f31': '3*B00*B10',
                           'f32': '(Dy*Py + 2*B00*Cy)',
                           'f33': '3*pow(B10,2)',
                           'f36': '(Iz*pow(Cz,2) + B10*(3*Cz + Zij))',
                           'f4': '(3*pow(B10,2) + 3*B10*Cx*(Xij + 2*Cx) + Ix*pow(Cx,3))',
                           'f5': '(Dx*Px + 2*B00*Cx)',
                           'f7': '(3*pow(B10,2) + 3*B10*Cz*(2*Cz + Zij) + Iz*pow(Cz,3))',
                           'f8': '(Cx*Dx*(3*B10 + pow(Cx,2)) + 3*B00*Px)',
                           'f9': '(3*B10 + pow(Cy,2))',
                           'Xij': '',
                           'Yij': '',
                           'Zij': ''},
                          ((((0, 3, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(B00*pow(Cy,2)*(4*Cy + 3*Yij) + f31*Yij + Dy*f33 + Dy*pow(Cy,4) + Dy*Yij*pow(Cy,3) + 4*Cy*f31 + 3*B10*Cy*Dy*(Yij + 2*Cy))',
                             ['B10',
                              'B00',
                              'f33',
                              'Dy',
                              'Yij',
                              'f31',
                              'Cy'])),
                           (((2, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*(Xij*(Dx*Px + 2*B00*Cx) + f8)',
                             ['Dx', 'B00', 'Cx', 'Px', 'Xij', 'Cz', 'f8'])),
                           (((2, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*(Xij*(Dx*Px + 2*B00*Cx) + f8)',
                             ['Dx', 'Xij', 'Px', 'B00', 'f8', 'Cy', 'Cx'])),
                           (((1, 1, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*(Qx*Xij + f5)',
                             ['Qx', 'Cz', 'Xij', 'Cy', 'f5'])),
                           (((1, 2, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Py*(Qx*Xij + f5)', ['Qx', 'Py', 'Xij', 'f5'])),
                           (((1, 0, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Pz*(Qx*Xij + f5)', ['Qx', 'Pz', 'Xij', 'f5'])),
                           (((3, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(Dx*f33 + Dx*Xij*pow(Cx,3) + f31*Xij + Dx*pow(Cx,4) + 4*Cx*f31 + B00*pow(Cx,2)*(4*Cx + 3*Xij) + 3*B10*Cx*Dx*(Xij + 2*Cx))',
                             ['Dx',
                              'f33',
                              'Xij',
                              'B10',
                              'B00',
                              'f31',
                              'Cx'])),
                           (((0, 0, 3), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(Dz*f33 + B00*pow(Cz,2)*(4*Cz + 3*Zij) + Dz*pow(Cz,4) + 3*B10*Cz*Dz*(2*Cz + Zij) + 4*Cz*f31 + Dz*Zij*pow(Cz,3) + f31*Zij)',
                             ['B10',
                              'f33',
                              'Cz',
                              'Zij',
                              'Dz',
                              'B00',
                              'f31'])),
                           (((0, 1, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cy*(f3 + Zij*(Dz*Pz + 2*B00*Cz))',
                             ['Cz', 'Zij', 'Dz', 'B00', 'Pz', 'f3', 'Cy'])),
                           (((1, 0, 2), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*(f3 + Zij*(Dz*Pz + 2*B00*Cz))',
                             ['Cx', 'Cz', 'Zij', 'Dz', 'B00', 'Pz', 'f3'])),
                           (((1, 1, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Cy*(f2 + Qz*Zij)',
                             ['Zij', 'f2', 'Cx', 'Cy', 'Qz'])),
                           (((2, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Px*(f2 + Qz*Zij)', ['Zij', 'f2', 'Px', 'Qz'])),
                           (((0, 2, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Py*(f2 + Qz*Zij)', ['Zij', 'Py', 'f2', 'Qz'])),
                           (((0, 0, 3), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*f20*(Dy*Yij + Qy)',
                             ['Dy', 'Cz', 'Qy', 'f20', 'Yij'])),
                           (((2, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Px*(Dy*Yij + Qy)',
                             ['Dy', 'Cz', 'Qy', 'Px', 'Yij'])),
                           (((3, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*f0*(Dy*Yij + Qy)',
                             ['Dy', 'f0', 'Cx', 'Qy', 'Yij'])),
                           (((1, 0, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Pz*(Dy*Yij + Qy)',
                             ['Dy', 'Pz', 'Cx', 'Qy', 'Yij'])),
                           (((1, 1, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Qz*(Px + Cx*Xij)',
                             ['Xij', 'Px', 'Qz', 'Cy', 'Cx'])),
                           (((1, 1, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*(Px + Cx*Xij)',
                             ['Cz', 'Xij', 'Px', 'Cy', 'Cx'])),
                           (((1, 1, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Qy*(Px + Cx*Xij)',
                             ['Cz', 'Qy', 'Cx', 'Px', 'Xij'])),
                           (((1, 1, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Qy*(Cz*Zij + Pz)',
                             ['Zij', 'Pz', 'Cz', 'Qy', 'Cx'])),
                           (((0, 2, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Py*(Cz*Zij + Pz)',
                             ['Zij', 'Dx', 'Cz', 'Pz', 'Py'])),
                           (((0, 2, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Py*(Dx*Xij + Qx)',
                             ['Qx', 'Dx', 'Cz', 'Py', 'Xij'])),
                           (((0, 0, 3), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*f20*(Dx*Xij + Qx)',
                             ['Qx', 'Dx', 'Cz', 'f20', 'Xij'])),
                           (((0, 3, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*f9*(Dx*Xij + Qx)',
                             ['Qx', 'Dx', 'f9', 'Xij', 'Cy'])),
                           (((0, 1, 2), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Pz*(Dx*Xij + Qx)',
                             ['Dx', 'Qx', 'Pz', 'Xij', 'Cy'])),
                           (((1, 1, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Qx*(Cz*Zij + Pz)',
                             ['Zij', 'Qx', 'Pz', 'Cy', 'Cz'])),
                           (((1, 1, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cy*(Cz*Zij + Pz)',
                             ['Zij', 'Cz', 'Pz', 'Cx', 'Cy'])),
                           (((2, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Px*(Cz*Zij + Pz)',
                             ['Zij', 'Dy', 'Cz', 'Pz', 'Px'])),
                           (((2, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Px*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Px'])),
                           (((0, 2, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Py*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'Py'])),
                           (((2, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('f5*(Cz*Zij + Pz)', ['Zij', 'Cz', 'Pz', 'f5'])),
                           (((0, 2, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('f32*(Cz*Zij + Pz)',
                             ['Zij', 'Cz', 'Pz', 'f32'])),
                           (((2, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*f24', ['Dz', 'f24', 'Cy'])),
                           (((0, 2, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Ix*Py*Qz', ['Ix', 'Py', 'Qz'])),
                           (((0, 1, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Ix*f2', ['Ix', 'f2', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Cy*Qz', ['Cx', 'Cy', 'Qz'])),
                           (((1, 1, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Cz*f25', ['f25', 'Cz', 'Cx'])),
                           (((1, 1, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Cz*Qy', ['Cz', 'Qy', 'Cx'])),
                           (((1, 1, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Qx*f23', ['Qx', 'Cz', 'f23'])),
                           (((1, 1, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Cz*Qx', ['Qx', 'Cz', 'Cy'])),
                           (((1, 1, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cy*Cz', ['Cz', 'Cx', 'Cy'])),
                           (((1, 1, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Cz*f23', ['Cz', 'f23', 'Cx'])),
                           (((1, 1, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Qz*f23', ['f23', 'Cx', 'Qz'])),
                           (((3, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*f0*f12', ['f12', 'f0', 'Cx'])),
                           (((0, 3, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cy*f12*f9', ['f9', 'f12', 'Cy'])),
                           (((2, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Px*f12', ['f12', 'Px', 'Cy'])),
                           (((1, 0, 2), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('f2*(Px + Cx*Xij)', ['Xij', 'Px', 'f2', 'Cx'])),
                           (((1, 2, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('f32*(Px + Cx*Xij)',
                             ['Xij', 'Px', 'f32', 'Cx'])),
                           (((1, 0, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Pz*(Px + Cx*Xij)',
                             ['Dy', 'Pz', 'Cx', 'Px', 'Xij'])),
                           (((1, 0, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Pz*(Px + Cx*Xij)', ['Pz', 'Cx', 'Px', 'Xij'])),
                           (((1, 2, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Py*(Px + Cx*Xij)', ['Xij', 'Py', 'Px', 'Cx'])),
                           (((1, 2, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Py*(Px + Cx*Xij)',
                             ['Dz', 'Xij', 'Py', 'Px', 'Cx'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*Py', ['Dz', 'Cx', 'Py'])),
                           (((1, 2, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Py*f12', ['f12', 'Cx', 'Py'])),
                           (((1, 2, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*f28', ['Cx', 'f28'])),
                           (((0, 2, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*f28', ['Cz', 'f28'])),
                           (((0, 1, 2), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Pz*f25', ['f25', 'Pz'])),
                           (((2, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Px*f25', ['f25', 'Px'])),
                           (((2, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Iy*Px*Qz', ['Iy', 'Qz', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Px*Qz', ['Qz', 'Px'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Py*Qz', ['Py', 'Qz'])),
                           (((1, 0, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Qx*f36', ['f36', 'Qx'])),
                           (((1, 2, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Qx*f29', ['Qx', 'f29'])),
                           (((1, 0, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Iy*Pz*Qx', ['Pz', 'Qx', 'Iy'])),
                           (((1, 0, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Pz*Qx', ['Qx', 'Pz'])),
                           (((0, 1, 2), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Pz*f23', ['f23', 'Dx', 'Pz'])),
                           (((0, 1, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Pz*f23', ['f23', 'Pz'])),
                           (((2, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('f23*f5', ['f23', 'f5'])),
                           (((2, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Iz*f5', ['Iz', 'Cy', 'f5'])),
                           (((2, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*f5', ['Cy', 'f5'])),
                           (((0, 1, 2), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*f36', ['Dx', 'f36', 'Cy'])),
                           (((0, 1, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cy*f36', ['f36', 'Cy'])),
                           (((0, 1, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Qy*f36', ['f36', 'Qy'])),
                           (((2, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Qy*f24', ['f24', 'Qy'])),
                           (((2, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Iz*Px*Qy', ['Qy', 'Iz', 'Px'])),
                           (((2, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Px*Qy', ['Qy', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*Px', ['Dy', 'Cz', 'Px'])),
                           (((0, 0, 3), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*Ix*f20', ['Dy', 'Cz', 'f20', 'Ix'])),
                           (((0, 0, 3), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*f20', ['Dy', 'Cz', 'f20'])),
                           (((2, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*f24', ['Dy', 'Cz', 'f24'])),
                           (((2, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*f24', ['f24', 'Cz'])),
                           (((2, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*f5', ['Cz', 'f5'])),
                           (((2, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Iy*f5', ['Cz', 'Iy', 'f5'])),
                           (((2, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Iy*Px', ['Cz', 'Iy', 'Px'])),
                           (((2, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Px', ['Cz', 'Px'])),
                           (((0, 2, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Ix*f32', ['Cz', 'f32', 'Ix'])),
                           (((0, 2, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*f32', ['Cz', 'f32'])),
                           (((1, 2, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Iz*f32', ['Cx', 'f32', 'Iz'])),
                           (((1, 2, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*f32', ['Cx', 'f32'])),
                           (((1, 0, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Iy*f2', ['Iy', 'Cx', 'f2'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*f2', ['Cx', 'f2'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*f2', ['f2', 'Cy'])),
                           (((2, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*f24', ['f24', 'Cy'])),
                           (((2, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Qz*f24', ['f24', 'Qz'])),
                           (((0, 0, 3), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Ix*f3', ['Ix', 'f3'])),
                           (((0, 3, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Ix*f30', ['Ix', 'f30'])),
                           (((0, 3, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Iz*f30', ['f30', 'Iz'])),
                           (((3, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Iz*f8', ['f8', 'Iz'])),
                           (((3, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Iy*f8', ['f8', 'Iy'])),
                           (((0, 0, 3), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Iy*f3', ['Iy', 'f3'])),
                           (((3, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*Iy*f0', ['Dz', 'f0', 'Iy', 'Cx'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*f0', ['Dz', 'f0', 'Cx'])),
                           (((1, 2, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*f29', ['Dz', 'Cx', 'f29'])),
                           (((1, 2, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*f29', ['Cx', 'f29'])),
                           (((0, 2, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Qz*f29', ['Qz', 'f29'])),
                           (((0, 2, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*f29', ['Cz', 'f29'])),
                           (((0, 2, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*f29', ['Dx', 'Cz', 'f29'])),
                           (((0, 2, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*Py', ['Dx', 'Cz', 'Py'])),
                           (((0, 0, 3), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*f20', ['Dx', 'Cz', 'f20'])),
                           (((0, 0, 3), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*Iy*f20', ['Dx', 'Cz', 'Iy', 'f20'])),
                           (((0, 0, 3), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Iy*f20', ['Cz', 'Iy', 'f20'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*f20', ['Cz', 'f20'])),
                           (((0, 0, 3), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Ix*f20', ['Cz', 'f20', 'Ix'])),
                           (((0, 2, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Ix*Py', ['Cz', 'Py', 'Ix'])),
                           (((0, 2, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Py', ['Cz', 'Py'])),
                           (((1, 2, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Py*Qx', ['Qx', 'Py'])),
                           (((1, 2, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Iz*Py*Qx', ['Qx', 'Iz', 'Py'])),
                           (((1, 2, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iz*Py', ['Cx', 'Py', 'Iz'])),
                           (((1, 2, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Py', ['Cx', 'Py'])),
                           (((1, 0, 2), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*f36', ['f36', 'Cx'])),
                           (((1, 0, 2), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*f36', ['Dy', 'f36', 'Cx'])),
                           (((1, 0, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*Pz', ['Dy', 'Pz', 'Cx'])),
                           (((3, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*f0', ['Dy', 'f0', 'Cx'])),
                           (((3, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*Iz*f0', ['Dy', 'f0', 'Cx', 'Iz'])),
                           (((3, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iz*f0', ['f0', 'Cx', 'Iz'])),
                           (((3, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*f0', ['f0', 'Cx'])),
                           (((3, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iy*f0', ['f0', 'Iy', 'Cx'])),
                           (((1, 0, 2), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iy*Pz', ['Pz', 'Iy', 'Cx'])),
                           (((1, 0, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Pz', ['Pz', 'Cx'])),
                           (((0, 1, 2), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Pz*Qy', ['Qy', 'Pz'])),
                           (((0, 1, 2), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Ix*Pz*Qy', ['Qy', 'Ix', 'Pz'])),
                           (((0, 1, 2), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Ix*Pz', ['Ix', 'Pz', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Pz', ['Pz', 'Cy'])),
                           (((0, 1, 2), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*Pz', ['Dx', 'Pz', 'Cy'])),
                           (((0, 3, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*Iz*f9', ['Dx', 'f9', 'Iz', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*f9', ['Dx', 'f9', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*f9', ['Dz', 'f9', 'Cy'])),
                           (((0, 3, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*Ix*f9', ['Dz', 'f9', 'Ix', 'Cy'])),
                           (((0, 3, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Ix*f9', ['f9', 'Ix', 'Cy'])),
                           (((0, 3, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*f9', ['f9', 'Cy'])),
                           (((0, 3, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Iz*f9', ['f9', 'Iz', 'Cy'])),
                           (((2, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Iz*Px', ['Px', 'Iz', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Px', ['Px', 'Cy'])),
                           (((2, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*Px', ['Dz', 'Px', 'Cy'])),
                           (((2, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Px*f23', ['Dz', 'f23', 'Px'])),
                           (((2, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Px*f23', ['f23', 'Px'])),
                           (((0, 1, 2), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('f2*f23', ['f23', 'f2'])),
                           (((3, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*f4', ['Dz', 'f4'])),
                           (((0, 3, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*f21', ['Dz', 'f21'])),
                           (((0, 3, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*f21', ['Dx', 'f21'])),
                           (((0, 0, 3), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*f7', ['f7', 'Dx'])),
                           (((0, 0, 3), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*f7', ['Dy', 'f7'])),
                           (((3, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*f4', ['f4', 'Dy'])),
                           (((3, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('f4', ['f4'])),
                           (((0, 3, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('f21', ['f21'])),
                           (((0, 0, 3), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('f7', ['f7'])),
                           (((3, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('f8', ['f8'])),
                           (((0, 3, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('f30', ['f30'])),
                           (((0, 0, 3), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('f3', ['f3'])))),
 ('p', 'd', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'f1': '(Cx*Ix + B10)',
                         'f3': '(Cy*Iy + B10)',
                         'f5': '(B10 + pow(Iy,2))',
                         'f6': '(B10 + pow(Iz,2))',
                         'f7': '(B10 + pow(Ix,2))',
                         'f8': '(B10 + Cz*Iz)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                           ['Zij', 'B10', 'Cz', 'Iz'])),
                         (((0, 0, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*Iy', ['Cz', 'Iy', 'Ix'])),
                         (((0, 1, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*Iz', ['Ix', 'Iz', 'Cy'])),
                         (((1, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*Iz', ['Iy', 'Cx', 'Iz'])),
                         (((1, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                           ['B10', 'Ix', 'Cx', 'Xij'])),
                         (((0, 1, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                           ['Yij', 'B10', 'Iy', 'Cy'])),
                         (((0, 1, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f7', ['f7', 'Cy'])),
                         (((0, 0, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f7', ['f7', 'Cz'])),
                         (((0, 0, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*f5', ['Cz', 'f5'])),
                         (((1, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f5', ['Cx', 'f5'])),
                         (((1, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*f6', ['f6', 'Cx'])),
                         (((0, 1, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*f6', ['f6', 'Cy'])),
                         (((0, 0, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f8', ['Ix', 'f8'])),
                         (((0, 1, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f3', ['Ix', 'f3'])),
                         (((0, 1, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f3', ['Iz', 'f3'])),
                         (((1, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f1', ['f1', 'Iz'])),
                         (((1, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f1', ['f1', 'Iy'])),
                         (((0, 0, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f8', ['f8', 'Iy'])))),
 ('p', 'f', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'f1': '(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                         'f10': '(B10 + pow(Iz,2))',
                         'f11': '3*pow(B10,2)',
                         'f12': '(Cx*Ix + B10)',
                         'f13': '(3*B10 + pow(Iz,2))',
                         'f14': '(3*B10 + pow(Ix,2))',
                         'f15': '(B10 + Cz*Iz)',
                         'f3': '(3*B10 + pow(Iy,2))',
                         'f4': '(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                         'f5': '(Cy*Iy + B10)',
                         'f6': '(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                         'f8': '(B10 + pow(Iy,2))',
                         'f9': '(B10 + pow(Ix,2))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 1, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('(f11 + Cy*pow(Iy,3) + 3*B10*Iy*(Yij + 2*Cy))',
                           ['Yij', 'B10', 'Iy', 'f11', 'Cy'])),
                         (((0, 0, 1), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('(f11 + Cz*pow(Iz,3) + 3*B10*Iz*(2*Cz + Zij))',
                           ['Zij', 'B10', 'Cz', 'f11', 'Iz'])),
                         (((1, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(f11 + 3*B10*Ix*(Xij + 2*Cx) + Cx*pow(Ix,3))',
                           ['B10', 'Ix', 'f11', 'Xij', 'Cx'])),
                         (((1, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*f8', ['f8', 'Cx', 'Iz'])),
                         (((0, 0, 1), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*f8', ['Cz', 'f8', 'Ix'])),
                         (((0, 0, 1), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix*f14', ['f14', 'Cz', 'Ix'])),
                         (((0, 1, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*f14', ['f14', 'Ix', 'Cy'])),
                         (((0, 1, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix*f10', ['Ix', 'f10', 'Cy'])),
                         (((0, 1, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f9', ['f9', 'Iz', 'Cy'])),
                         (((0, 1, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz*f13', ['f13', 'Iz', 'Cy'])),
                         (((1, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz*f13', ['f13', 'Cx', 'Iz'])),
                         (((1, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Iz*f12', ['f12', 'Iy', 'Iz'])),
                         (((0, 1, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iz*f5', ['Ix', 'Iz', 'f5'])),
                         (((0, 0, 1), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iy*f15', ['f15', 'Ix', 'Iy'])),
                         (((1, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*f10', ['Iy', 'Cx', 'f10'])),
                         (((1, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy*f3', ['Iy', 'Cx', 'f3'])),
                         (((0, 0, 1), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f3', ['Cz', 'Iy', 'f3'])),
                         (((0, 0, 1), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy*f9', ['f9', 'Cz', 'Iy'])),
                         (((0, 1, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('f5*f9', ['f9', 'f5'])),
                         (((0, 0, 1), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('f15*f9', ['f15', 'f9'])),
                         (((0, 0, 1), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('f15*f8', ['f15', 'f8'])),
                         (((1, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('f12*f8', ['f8', 'f12'])),
                         (((1, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('f10*f12', ['f12', 'f10'])),
                         (((0, 1, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('f10*f5', ['f10', 'f5'])),
                         (((0, 0, 1), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f4', ['f4', 'Ix'])),
                         (((0, 1, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f6', ['f6', 'Ix'])),
                         (((0, 1, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f6', ['f6', 'Iz'])),
                         (((1, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f1', ['f1', 'Iz'])),
                         (((1, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f1', ['f1', 'Iy'])),
                         (((0, 0, 1), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f4', ['f4', 'Iy'])))),
 ('p', 'p', 'p', 'p'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f1': '(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                         'f10': '(B00 + Dz*Iz)',
                         'f12': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                         'f13': '(B01 + Dx*Kx)',
                         'f14': '(Cy*Iy + B10)',
                         'f15': 'B01*B10',
                         'f16': '(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                         'f18': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                         'f19': '(B00 + Iy*Ky)',
                         'f2': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                         'f21': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                         'f23': '(Dz*Kz + B01)',
                         'f24': '(B01 + Dy*Ky)',
                         'f26': '(B00 + Cy*Ky)',
                         'f27': '2*pow(B00,2)',
                         'f28': '(Cx*Ix + B10)',
                         'f29': '(Dy*Iy + B00)',
                         'f31': '(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                         'f34': '(B10 + Cz*Iz)',
                         'f4': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                         'f5': '(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                         'f7': '(B00 + Ix*Kx)',
                         'f9': '(Iz*Kz + B00)',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((1, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('(B00*(Xij + 2*Cx)*(Xkl + 2*Dx) + f15 + f27 + B01*Cx*Ix + Dx*Kx*(Cx*Ix + B10))',
                           ['f15',
                            'Dx',
                            'Ix',
                            'Cx',
                            'Xij',
                            'B01',
                            'B10',
                            'f27',
                            'Xkl',
                            'B00',
                            'Kx'])),
                         (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                          ('(f15 + f27 + Dy*Ky*(Cy*Iy + B10) + B01*Cy*Iy + B00*(Yij + 2*Cy)*(Ykl + 2*Dy))',
                           ['f15',
                            'B10',
                            'Ykl',
                            'Dy',
                            'B01',
                            'f27',
                            'Yij',
                            'B00',
                            'Ky',
                            'Iy',
                            'Cy'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                          ('(Dz*Kz*(B10 + Cz*Iz) + f15 + f27 + B00*(2*Cz + Zij)*(2*Dz + Zkl) + B01*Cz*Iz)',
                           ['f15',
                            'B10',
                            'B00',
                            'Zij',
                            'Kz',
                            'B01',
                            'Dz',
                            'Cz',
                            'Iz',
                            'f27',
                            'Zkl'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                          ('Cx*(Zij*(Dz*Kz + B01) + f18)',
                           ['Cx', 'Zij', 'Kz', 'B01', 'Dz', 'f18'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                          ('Cy*(Zij*(Dz*Kz + B01) + f18)',
                           ['Zij', 'Kz', 'B01', 'Dz', 'Cy', 'f18'])),
                         (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                          ('Dy*(f31 + Zkl*(B10 + Cz*Iz))',
                           ['B10', 'Cz', 'Dy', 'f31', 'Iz', 'Zkl'])),
                         (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                          ('Dx*(f31 + Zkl*(B10 + Cz*Iz))',
                           ['Dx', 'Cz', 'B10', 'f31', 'Iz', 'Zkl'])),
                         (((0, 0, 1), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cz*(f4 + Xij*(B01 + Dx*Kx))',
                           ['f4', 'Dx', 'Xij', 'B01', 'Cz', 'Kx'])),
                         (((0, 1, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*(f4 + Xij*(B01 + Dx*Kx))',
                           ['f4', 'Dx', 'Xij', 'B01', 'Kx', 'Cy'])),
                         (((1, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                          ('Dy*Iz*(Cx*Xkl + Qx)',
                           ['Dy', 'Xkl', 'Qx', 'Iz', 'Cx'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*Iy*(Cx*Xkl + Qx)',
                           ['Dz', 'Xkl', 'Qx', 'Iy', 'Cx'])),
                         (((1, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                          ('f29*(Cx*Xkl + Qx)', ['Xkl', 'Qx', 'Cx', 'f29'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                          ('f10*(Cx*Xkl + Qx)', ['Xkl', 'Qx', 'Cx', 'f10'])),
                         (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Kz*(Dx*Xij + Qx)',
                           ['Qx', 'Dx', 'Kz', 'Xij', 'Cy'])),
                         (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Ky*(Dx*Xij + Qx)',
                           ['Qx', 'Dx', 'Cz', 'Xij', 'Ky'])),
                         (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('f26*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'f26'])),
                         (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('(Cz*Zkl + Qz)*(Dx*Xij + Qx)',
                           ['Dx', 'Xij', 'Qz', 'Cz', 'Qx', 'Zkl'])),
                         (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*Ix*(Cz*Zkl + Qz)',
                           ['Dy', 'Ix', 'Zkl', 'Qz', 'Cz'])),
                         (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cz*Ix*f24', ['f24', 'Cz', 'Ix'])),
                         (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                          ('Cx*Iz*f24', ['f24', 'Cx', 'Iz'])),
                         (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                          ('Dx*Iz*f26', ['Dx', 'Iz', 'f26'])),
                         (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                          ('Dx*Ky*f34', ['f34', 'Dx', 'Ky'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*Ky*f28', ['Dz', 'f28', 'Ky'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*Ix*f26', ['Dz', 'Ix', 'f26'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Ix*Ky*Qz', ['Ix', 'Qz', 'Ky'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Kx*f10', ['f10', 'Kx', 'Cy'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*Kx*f14', ['Dz', 'f14', 'Kx'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Dz*f19', ['Dz', 'Cx', 'f19'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Ky*f10', ['f10', 'Cx', 'Ky'])),
                         (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                          ('Iz*Ky*Qx', ['Qx', 'Iz', 'Ky'])),
                         (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                          ('Iy*Kz*Qx', ['Qx', 'Kz', 'Iy'])),
                         (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*Kz*f14', ['Dx', 'Kz', 'f14'])),
                         (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Dx*f9', ['Dx', 'f9', 'Cy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Dz*f7', ['Dz', 'f7', 'Cy'])),
                         (((0, 0, 1), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Dy*f7', ['Dy', 'Cz', 'f7'])),
                         (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*Kz*f28', ['Dy', 'Kz', 'f28'])),
                         (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Ix*Kz*Qy', ['Kz', 'Ix', 'Qy'])),
                         (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Kz*f29', ['Kz', 'Cx', 'f29'])),
                         (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Dy*f9', ['Dy', 'f9', 'Cx'])),
                         (((0, 0, 1), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                          ('Dy*Kx*f34', ['f34', 'Dy', 'Kx'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                          ('Iy*Kx*Qz', ['Iy', 'Kx', 'Qz'])),
                         (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*Iy*(Cz*Zkl + Qz)',
                           ['Zkl', 'Dx', 'Cz', 'Iy', 'Qz'])),
                         (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                          ('f29*(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Qz', 'f29'])),
                         (((0, 0, 1), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Kx*f29', ['Cz', 'Kx', 'f29'])),
                         (((0, 1, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                          ('Iz*Kx*Qy', ['Qy', 'Iz', 'Kx'])),
                         (((0, 1, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                          ('Cy*Iz*f13', ['f13', 'Iz', 'Cy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cy*Ix*f23', ['Ix', 'f23', 'Cy'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*Iy*f23', ['f23', 'Iy', 'Cx'])),
                         (((0, 0, 1), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cz*Iy*f13', ['f13', 'Cz', 'Iy'])),
                         (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Dx*f19', ['Dx', 'Cz', 'f19'])),
                         (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*f16', ['f16', 'Dx'])),
                         (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*f1', ['f1', 'Cx'])),
                         (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cz*f1', ['f1', 'Cz'])),
                         (((1, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*f5', ['Dy', 'f5'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*f5', ['Dz', 'f5'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*f16', ['Dz', 'f16'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                          ('f10*f26', ['f10', 'f26'])),
                         (((0, 1, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                          ('Kx*f21', ['Kx', 'f21'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                          ('Kx*f31', ['f31', 'Kx'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                          ('Ky*f31', ['f31', 'Ky'])),
                         (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Ky*f12', ['f12', 'Ky'])),
                         (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Kz*f12', ['Kz', 'f12'])),
                         (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                          ('Kz*f21', ['Kz', 'f21'])),
                         (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                          ('Qx*f9', ['f9', 'Qx'])),
                         (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                          ('Qx*f19', ['Qx', 'f19'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                          ('Qz*f19', ['Qz', 'f19'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Qz*f7', ['f7', 'Qz'])),
                         (((0, 1, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Qy*f7', ['f7', 'Qy'])),
                         (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                          ('Qy*f9', ['f9', 'Qy'])),
                         (((0, 1, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                          ('f13*f14', ['f14', 'f13'])),
                         (((0, 0, 1), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                          ('f13*f34', ['f34', 'f13'])),
                         (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                          ('f24*f34', ['f34', 'f24'])),
                         (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('f24*f28', ['f24', 'f28'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('f23*f28', ['f23', 'f28'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                          ('f14*f23', ['f14', 'f23'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Ix*f18', ['Ix', 'f18'])),
                         (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Ix*f2', ['Ix', 'f2'])),
                         (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                          ('Iz*f2', ['Iz', 'f2'])),
                         (((1, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                          ('Iz*f4', ['f4', 'Iz'])),
                         (((1, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                          ('Iy*f4', ['f4', 'Iy'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                          ('Iy*f18', ['Iy', 'f18'])))),
 ('p', 'p', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f1': '(B00 + Dz*Iz)',
                         'f11': '(B10 + Cz*Iz)',
                         'f3': '(Cy*Iy + B10)',
                         'f7': '(Cx*Ix + B10)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                           ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz'])),
                         (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'Cy'])),
                         (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*(Dx*Xij + Qx)', ['Qx', 'Dx', 'Cz', 'Xij'])),
                         (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                           ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00'])),
                         (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                           ['B10', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                         (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*(Dy*Yij + Qy)', ['Dy', 'Qy', 'Cx', 'Yij'])),
                         (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*(Dy*Yij + Qy)', ['Dy', 'Cz', 'Qy', 'Yij'])),
                         (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                         (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                         (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                         (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                         (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f3', ['Dx', 'f3'])),
                         (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f11', ['Dx', 'f11'])),
                         (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f11', ['Dy', 'f11'])),
                         (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f7', ['Dy', 'f7'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f7', ['Dz', 'f7'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f3', ['Dz', 'f3'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Ix*Qz', ['Ix', 'Qz'])),
                         (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*Qy', ['Ix', 'Qy'])),
                         (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*Qy', ['Qy', 'Iz'])),
                         (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*Qx', ['Qx', 'Iz'])),
                         (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*Qx', ['Qx', 'Iy'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Iy*Qz', ['Iy', 'Qz'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cx*f1', ['f1', 'Cx'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Cy*f1', ['f1', 'Cy'])))),
 ('p', 'p', 's', 'p'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f10': '(B00 + Cx*Kx)',
                         'f11': '(B00 + Cy*Ky)',
                         'f12': '(Cx*Ix + B10)',
                         'f13': '(B10 + Cz*Iz)',
                         'f14': '(B00 + Cz*Kz)',
                         'f3': '(B00 + Ix*Kx)',
                         'f4': '(Iz*Kz + B00)',
                         'f6': '(Cy*Iy + B10)',
                         'f8': '(B00 + Iy*Ky)',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                           ['B10', 'Ix', 'Cx', 'Xij', 'B00', 'Kx'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                          ('(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                           ['B10', 'Yij', 'B00', 'Ky', 'Iy', 'Cy'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                          ('(Kz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                           ['B10', 'B00', 'Zij', 'Kz', 'Cz', 'Iz'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cz*Ix*Ky', ['Cz', 'Ky', 'Ix'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                          ('Cx*Iz*Ky', ['Cx', 'Ky', 'Iz'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                          ('Cy*Iz*Kx', ['Iz', 'Cy', 'Kx'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cy*Ix*Kz', ['Kz', 'Ix', 'Cy'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*Iy*Kz', ['Kz', 'Iy', 'Cx'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cz*Iy*Kx', ['Cz', 'Iy', 'Kx'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                          ('Kx*f6', ['f6', 'Kx'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                          ('Kx*f13', ['f13', 'Kx'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                          ('Ky*f13', ['f13', 'Ky'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ky*f12', ['f12', 'Ky'])),
                         (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Kz*f12', ['Kz', 'f12'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                          ('Kz*f6', ['f6', 'Kz'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Ix*f14', ['f14', 'Ix'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ix*f11', ['Ix', 'f11'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                          ('Iz*f11', ['Iz', 'f11'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                          ('Iz*f10', ['Iz', 'f10'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                          ('Iy*f10', ['Iy', 'f10'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                          ('Iy*f14', ['f14', 'Iy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*f3', ['f3', 'Cy'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cz*f3', ['Cz', 'f3'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cz*f8', ['Cz', 'f8'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*f8', ['f8', 'Cx'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                          ('Cx*f4', ['f4', 'Cx'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                          ('Cy*f4', ['f4', 'Cy'])))),
 ('p', 'p', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                         (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                         (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                         (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Ix', ['Ix', 'Cy'])),
                         (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Ix', ['Cz', 'Ix'])),
                         (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz*Iy', ['Cz', 'Iy'])),
                         (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iy', ['Iy', 'Cx'])),
                         (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cx*Iz', ['Cx', 'Iz'])),
                         (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Cy*Iz', ['Iz', 'Cy'])))),
 ('p', 'p', 's', 'sp'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f10': '(B00 + Cx*Kx)',
                          'f11': '(B00 + Cy*Ky)',
                          'f15': '(B00 + Cz*Kz)',
                          'f4': '(B00 + Ix*Kx)',
                          'f5': '(Iz*Kz + B00)',
                          'f8': '(B00 + Iy*Ky)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                            ['B10', 'Ix', 'Cx', 'Xij', 'B00', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('(Kz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                            ['B10', 'B00', 'Zij', 'Kz', 'Cz', 'Iz'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                            ['B10', 'Yij', 'B00', 'Ky', 'Iy', 'Cy'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*(Cy*Iy + B10)', ['B10', 'Iy', 'Kx', 'Cy'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*(Cy*Iy + B10)', ['B10', 'Kz', 'Iy', 'Cy'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Iz*Kx', ['Iz', 'Cy', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Kx*(B10 + Cz*Iz)', ['B10', 'Cz', 'Kx', 'Iz'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Ky*(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz', 'Ky'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*(Cx*Ix + B10)', ['B10', 'Ix', 'Cx', 'Ky'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*(Cx*Ix + B10)', ['B10', 'Kz', 'Cx', 'Ix'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Iy*Kz', ['Kz', 'Iy', 'Cx'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*f8', ['f8', 'Cx'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*f8', ['Cz', 'f8'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*f10', ['Iy', 'f10'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*f10', ['Iz', 'f10'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Iz*Ky', ['Cx', 'Ky', 'Iz'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz', ['Cx', 'Iz'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*f11', ['Iz', 'f11'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz', ['Iz', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*f4', ['f4', 'Cy'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*f4', ['f4', 'Cz'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Iy*Kx', ['Cz', 'Iy', 'Kx'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy', ['Cz', 'Iy'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ix*Ky', ['Cz', 'Ky', 'Ix'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix', ['Cz', 'Ix'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Ix*Kz', ['Kz', 'Ix', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix', ['Ix', 'Cy'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*f15', ['f15', 'Ix'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*f15', ['f15', 'Iy'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy', ['Iy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('Cx*f5', ['Cx', 'f5'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('Cy*f5', ['Cy', 'f5'])))),
 ('p', 'p', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'Cy'])),
                          (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*(Dx*Xij + Qx)', ['Qx', 'Dx', 'Cz', 'Xij'])),
                          (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                            ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00'])),
                          (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                            ['B10', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                          (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*(Dy*Yij + Qy)', ['Dy', 'Qy', 'Cx', 'Yij'])),
                          (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*(Dy*Yij + Qy)', ['Dy', 'Cz', 'Qy', 'Yij'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                            ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Cx', 'Qz'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz', 'Cy'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*(Cy*Iy + B10)', ['Dz', 'B10', 'Iy', 'Cy'])),
                          (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*(Cy*Iy + B10)', ['Dx', 'Iy', 'B10', 'Cy'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*(B10 + Cz*Iz)', ['Dy', 'B10', 'Cz', 'Iz'])),
                          (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*(B10 + Cz*Iz)', ['Dx', 'Cz', 'B10', 'Iz'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*(Cx*Ix + B10)', ['Dz', 'B10', 'Ix', 'Cx'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                          (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*(Cx*Ix + B10)', ['Dy', 'B10', 'Ix', 'Cx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                          (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz', ['Iz', 'Cy'])),
                          (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Qx', ['Qx', 'Iy'])),
                          (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*Qx', ['Qx', 'Iz'])),
                          (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Qy', ['Ix', 'Qy'])),
                          (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*Qy', ['Qy', 'Iz'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz', ['Cx', 'Iz'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy', ['Iy', 'Cx'])),
                          (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy', ['Cz', 'Iy'])),
                          (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix', ['Cz', 'Ix'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix', ['Ix', 'Cy'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Qz', ['Ix', 'Qz'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*Qz', ['Iy', 'Qz'])))),
 ('p', 's', 'd', 's'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)'},
                        ((((1, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('(2*B00*Dx + Cx*Rx)', ['Rx', 'Dx', 'B00', 'Cx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('(2*B00*Dy + Cy*Ry)', ['Dy', 'B00', 'Cy', 'Ry'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('(2*B00*Dz + Cz*Rz)', ['Dz', 'Rz', 'B00', 'Cz'])),
                         (((0, 0, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Cz*Dx*Dy', ['Dy', 'Dx', 'Cz'])),
                         (((1, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Cx*Dy*Dz', ['Dz', 'Dy', 'Cx'])),
                         (((0, 1, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Cy*Dx*Dz', ['Dz', 'Dx', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cy*Rx', ['Rx', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Cz*Rx', ['Rx', 'Cz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cz*Ry', ['Cz', 'Ry'])),
                         (((1, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Cx*Ry', ['Cx', 'Ry'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cx*Rz', ['Rz', 'Cx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Cy*Rz', ['Rz', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Qz', ['Dx', 'Qz'])),
                         (((0, 1, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Qy', ['Dx', 'Qy'])),
                         (((0, 1, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*Qy', ['Dz', 'Qy'])),
                         (((1, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*Qx', ['Dz', 'Qx'])),
                         (((1, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*Qx', ['Dy', 'Qx'])),
                         (((0, 0, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Qz', ['Dy', 'Qz'])))),
 ('p', 's', 'f', 's'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f1': '(2*B00*Dz + Cz*Rz)',
                         'f10': '3*B00*B01',
                         'f12': '(2*B00*Dy + Cy*Ry)',
                         'f2': '(pow(Dz,2) + 3*B01)',
                         'f4': '(3*B01 + pow(Dy,2))',
                         'f6': '(3*B01 + pow(Dx,2))',
                         'f7': '(2*B00*Dx + Cx*Rx)'},
                        ((((1, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('(f10 + Cx*pow(Dx,3) + 3*B00*pow(Dx,2) + 3*B01*Cx*Dx)',
                           ['Dx', 'B00', 'B01', 'Cx', 'f10'])),
                         (((0, 1, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('(3*B01*Cy*Dy + f10 + Cy*pow(Dy,3) + 3*B00*pow(Dy,2))',
                           ['Dy', 'B00', 'B01', 'f10', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('(f10 + 3*B00*pow(Dz,2) + 3*B01*Cz*Dz + Cz*pow(Dz,3))',
                           ['Dz', 'B00', 'B01', 'f10', 'Cz'])),
                         (((1, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Cx*Dz*Ry', ['Dz', 'Cx', 'Ry'])),
                         (((0, 0, 1), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Cz*Dx*Ry', ['Dx', 'Cz', 'Ry'])),
                         (((0, 0, 1), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cz*Dx*f6', ['Dx', 'Cz', 'f6'])),
                         (((0, 1, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('Cy*Dx*f6', ['Dx', 'f6', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Cy*Dx*Rz', ['Dx', 'Rz', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Cy*Dz*Rx', ['Dz', 'Rx', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cy*Dz*f2', ['Dz', 'f2', 'Cy'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Cx*Dz*f2', ['Dz', 'Cx', 'f2'])),
                         (((1, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dy*Dz*Qx', ['Dz', 'Dy', 'Qx'])),
                         (((0, 1, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Dz*Qy', ['Dz', 'Dx', 'Qy'])),
                         (((0, 0, 1), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Dy*Qz', ['Dy', 'Dx', 'Qz'])),
                         (((1, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Cx*Dy*Rz', ['Dy', 'Rz', 'Cx'])),
                         (((1, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cx*Dy*f4', ['f4', 'Dy', 'Cx'])),
                         (((0, 0, 1), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Cz*Dy*f4', ['f4', 'Dy', 'Cz'])),
                         (((0, 0, 1), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Cz*Dy*Rx', ['Rx', 'Dy', 'Cz'])),
                         (((0, 1, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Qy*Rx', ['Rx', 'Qy'])),
                         (((0, 0, 1), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Qz*Rx', ['Rx', 'Qz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Qz*Ry', ['Qz', 'Ry'])),
                         (((1, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Qx*Ry', ['Qx', 'Ry'])),
                         (((1, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Qx*Rz', ['Rz', 'Qx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Qy*Rz', ['Rz', 'Qy'])),
                         (((0, 0, 1), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Dx*f1', ['Dx', 'f1'])),
                         (((0, 1, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Dx*f12', ['Dx', 'f12'])),
                         (((0, 1, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Dz*f12', ['Dz', 'f12'])),
                         (((1, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Dz*f7', ['Dz', 'f7'])),
                         (((1, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Dy*f7', ['Dy', 'f7'])),
                         (((0, 0, 1), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Dy*f1', ['Dy', 'f1'])))),
 ('p', 's', 'p', 'p'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)',
                         'f10': '(B01 + Dy*Ky)',
                         'f2': '(B01 + Dx*Kx)',
                         'f5': '(Dz*Kz + B01)',
                         'f6': '(B00 + Cy*Ky)',
                         'f8': '(B00 + Cx*Kx)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((1, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                           ['Dx', 'Cx', 'B01', 'Xkl', 'B00', 'Kx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                           ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                           ['B00', 'Kz', 'B01', 'Dz', 'Cz', 'Zkl'])),
                         (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*(Cz*Zkl + Qz)', ['Dx', 'Cz', 'Zkl', 'Qz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*(Cz*Zkl + Qz)', ['Dy', 'Cz', 'Zkl', 'Qz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Cz*Dy*Kx', ['Dy', 'Cz', 'Kx'])),
                         (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Cz*Dx*Ky', ['Dx', 'Cz', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Cx*Dz*Ky', ['Dz', 'Cx', 'Ky'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Cy*Dz*Kx', ['Dz', 'Kx', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Cy*Dx*Kz', ['Dx', 'Kz', 'Cy'])),
                         (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Cx*Dy*Kz', ['Dy', 'Kz', 'Cx'])),
                         (((1, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*f8', ['Dy', 'f8'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*f8', ['Dz', 'f8'])),
                         (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*f6', ['Dx', 'f6'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*f6', ['Dz', 'f6'])),
                         (((0, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Kx*Qy', ['Qy', 'Kx'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Kx*Qz', ['Kx', 'Qz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Ky*Qz', ['Qz', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Ky*Qx', ['Qx', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Kz*Qx', ['Qx', 'Kz'])),
                         (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Kz*Qy', ['Kz', 'Qy'])),
                         (((0, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cy*f2', ['f2', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('Cz*f2', ['Cz', 'f2'])),
                         (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cz*f10', ['Cz', 'f10'])),
                         (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Cx*f10', ['Cx', 'f10'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cx*f5', ['Cx', 'f5'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Cy*f5', ['Cy', 'f5'])))),
 ('p', 's', 'p', 's'): ({'B00': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Qx': '(Cx*Dx + B00)',
                         'Qy': '(Cy*Dy + B00)',
                         'Qz': '(Cz*Dz + B00)'},
                        ((((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Qy', ['Qy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Qz', ['Qz'])),
                         (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Qx', ['Qx'])),
                         (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cy*Dx', ['Dx', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Cz*Dx', ['Dx', 'Cz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cz*Dy', ['Dy', 'Cz'])),
                         (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Cx*Dy', ['Dy', 'Cx'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cx*Dz', ['Dz', 'Cx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Cy*Dz', ['Dz', 'Cy'])))),
 ('p', 's', 'p', 'sp'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f10': '(B01 + Dy*Ky)',
                          'f2': '(B01 + Dx*Kx)',
                          'f5': '(Dz*Kz + B01)',
                          'f6': '(B00 + Cx*Kx)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                            ['Dx', 'Cx', 'B01', 'Xkl', 'B00', 'Kx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                            ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                            ['B00', 'Kz', 'B01', 'Dz', 'Cz', 'Zkl'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*(Cz*Zkl + Qz)', ['Dx', 'Cz', 'Zkl', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*(Cz*Zkl + Qz)', ['Dy', 'Cz', 'Zkl', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Dy*Kx', ['Dy', 'Cz', 'Kx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Dz*Ky', ['Dz', 'Cx', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*(Cy*Ykl + Qy)', ['Dz', 'Ykl', 'Qy', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*(Cy*Ykl + Qy)', ['Ykl', 'Dx', 'Qy', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Dx*Kz', ['Dx', 'Kz', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Dx*Ky', ['Dx', 'Cz', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx', ['Dx', 'Cz'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx', ['Dx', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Dz*Kx', ['Dz', 'Kx', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz', ['Dz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*f2', ['f2', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*f2', ['Cz', 'f2'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f6', ['Dy', 'f6'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f6', ['Dz', 'f6'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz', ['Dz', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*f10', ['Cx', 'f10'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*f10', ['Cz', 'f10'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy', ['Dy', 'Cz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Dy*Kz', ['Dy', 'Kz', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy', ['Dy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*f5', ['Cx', 'f5'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*f5', ['Cy', 'f5'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*Qx', ['Qx', 'Kz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*Qy', ['Kz', 'Qy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*Qy', ['Qy', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Kx*Qz', ['Kx', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Ky*Qz', ['Qz', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*Qx', ['Qx', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx', ['Qx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy', ['Qy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz', ['Qz'])))),
 ('p', 's', 's', 'd'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f2': '(pow(Kz,2) + B01)',
                         'f4': '(pow(Kx,2) + B01)',
                         'f5': '(B00 + Cy*Ky)',
                         'f6': '(B00 + Cx*Kx)',
                         'f7': '(pow(Ky,2) + B01)',
                         'f8': '(B00 + Cz*Kz)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('(2*B00*Kx + Cx*(pow(Kx,2) + B01))',
                           ['B00', 'B01', 'Kx', 'Cx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('(2*B00*Ky + Cy*(pow(Ky,2) + B01))',
                           ['B00', 'B01', 'Cy', 'Ky'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('(2*B00*Kz + Cz*(pow(Kz,2) + B01))',
                           ['Kz', 'B00', 'B01', 'Cz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Cz*Kx*Ky', ['Cz', 'Kx', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Cx*Ky*Kz', ['Kz', 'Cx', 'Ky'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Cy*Kx*Kz', ['Kz', 'Kx', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('Cy*f4', ['f4', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('Cz*f4', ['f4', 'Cz'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Cz*f7', ['f7', 'Cz'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Cx*f7', ['f7', 'Cx'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Cx*f2', ['Cx', 'f2'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Cy*f2', ['f2', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kx*f8', ['f8', 'Kx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Kx*f5', ['Kx', 'f5'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Kz*f5', ['Kz', 'f5'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kz*f6', ['f6', 'Kz'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Ky*f6', ['f6', 'Ky'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Ky*f8', ['f8', 'Ky'])))),
 ('p', 's', 's', 'f'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f0': '(2*B00*Ky + Cy*(pow(Ky,2) + B01))',
                         'f10': '(pow(Kz,2) + 3*B01)',
                         'f11': '(B00 + Cy*Ky)',
                         'f12': '(B00 + Cx*Kx)',
                         'f13': '(3*B01 + pow(Kx,2))',
                         'f14': '(2*B00*Kx + Cx*(pow(Kx,2) + B01))',
                         'f15': '(B00 + Cz*Kz)',
                         'f3': '(pow(Ky,2) + B01)',
                         'f4': '(pow(Ky,2) + 3*B01)',
                         'f5': '3*B00*B01',
                         'f6': '(pow(Kz,2) + B01)',
                         'f7': '(2*B00*Kz + Cz*(pow(Kz,2) + B01))',
                         'f9': '(pow(Kx,2) + B01)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                          ('(3*B01*Cy*Ky + Cy*pow(Ky,3) + 3*B00*pow(Ky,2) + f5)',
                           ['B00', 'B01', 'Ky', 'Cy', 'f5'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                          ('(f5 + 3*B00*pow(Kz,2) + 3*B01*Cz*Kz + Cz*pow(Kz,3))',
                           ['Kz', 'B00', 'B01', 'Cz', 'f5'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                          ('(3*B00*pow(Kx,2) + 3*B01*Cx*Kx + f5 + Cx*pow(Kx,3))',
                           ['f5', 'B00', 'B01', 'Kx', 'Cx'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                          ('Cx*Kz*f3', ['Kz', 'Cx', 'f3'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                          ('Cz*Kx*f3', ['Cz', 'Kx', 'f3'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                          ('Cz*Kx*f13', ['f13', 'Cz', 'Kx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                          ('Cy*Kx*f13', ['f13', 'Kx', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                          ('Cy*Kx*f6', ['f6', 'Kx', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                          ('Cy*Kz*f9', ['f9', 'Kz', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                          ('Cy*Kz*f10', ['Kz', 'f10', 'Cy'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                          ('Cx*Kz*f10', ['Kz', 'Cx', 'f10'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                          ('Ky*Kz*f12', ['Kz', 'f12', 'Ky'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                          ('Kx*Kz*f11', ['Kz', 'Kx', 'f11'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                          ('Kx*Ky*f15', ['f15', 'Kx', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                          ('Cx*Ky*f6', ['f6', 'Cx', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                          ('Cx*Ky*f4', ['f4', 'Cx', 'Ky'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                          ('Cz*Ky*f4', ['f4', 'Cz', 'Ky'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                          ('Cz*Ky*f9', ['f9', 'Cz', 'Ky'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                          ('f11*f9', ['f9', 'f11'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                          ('f15*f9', ['f15', 'f9'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                          ('f15*f3', ['f15', 'f3'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                          ('f12*f3', ['f12', 'f3'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                          ('f12*f6', ['f6', 'f12'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                          ('f11*f6', ['f6', 'f11'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                          ('Kx*f7', ['f7', 'Kx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                          ('Kx*f0', ['f0', 'Kx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                          ('Kz*f0', ['Kz', 'f0'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                          ('Kz*f14', ['f14', 'Kz'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                          ('Ky*f14', ['f14', 'Ky'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                          ('Ky*f7', ['f7', 'Ky'])))),
 ('p', 's', 's', 'p'): ({'B00': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('(B00 + Cx*Kx)', ['B00', 'Cx', 'Kx'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('(B00 + Cz*Kz)', ['Kz', 'B00', 'Cz'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('(B00 + Cy*Ky)', ['B00', 'Ky', 'Cy'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cy*Kx', ['Kx', 'Cy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Cz*Kx', ['Cz', 'Kx'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cz*Ky', ['Cz', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Cx*Ky', ['Cx', 'Ky'])),
                         (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cx*Kz', ['Kz', 'Cx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Cy*Kz', ['Kz', 'Cy'])))),
 ('p', 's', 's', 's'): ({'Cx': '', 'Cy': '', 'Cz': ''},
                        ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cx', ['Cx'])),
                         (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cy', ['Cy'])),
                         (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Cz', ['Cz'])))),
 ('p', 's', 's', 'sp'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('(B00 + Cy*Ky)', ['B00', 'Ky', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(B00 + Cz*Kz)', ['Kz', 'B00', 'Cz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(B00 + Cx*Kx)', ['B00', 'Cx', 'Kx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz', ['Kz', 'Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz', ['Kz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx', ['Kx', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx', ['Cz', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky', ['Cz', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky', ['Cx', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx', ['Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy', ['Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz', ['Cz'])))),
 ('p', 's', 'sp', 'p'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f10': '(B01 + Dy*Ky)',
                          'f2': '(B01 + Dx*Kx)',
                          'f5': '(Dz*Kz + B01)',
                          'f6': '(B00 + Cy*Ky)',
                          'f8': '(B00 + Cx*Kx)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                            ['Dx', 'Cx', 'B01', 'Xkl', 'B00', 'Kx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                            ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                            ['B00', 'Kz', 'B01', 'Dz', 'Cz', 'Zkl'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*(Cz*Zkl + Qz)', ['Dx', 'Cz', 'Zkl', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*(Cz*Zkl + Qz)', ['Dy', 'Cz', 'Zkl', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(Cz*Zkl + Qz)', ['Cz', 'Zkl', 'Qz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Dy*Kz', ['Dy', 'Kz', 'Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*Qy', ['Qy', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Kx*Qz', ['Kx', 'Qz'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*Qx', ['Qx', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Ky*Qz', ['Qz', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Dx*Kz', ['Dx', 'Kz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz', ['Kz', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*Qx', ['Qx', 'Kz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*Qy', ['Kz', 'Qy'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz', ['Kz', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*f10', ['Cx', 'f10'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*f10', ['Cz', 'f10'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*f2', ['Cz', 'f2'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*f2', ['f2', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Dz*Kx', ['Dz', 'Kx', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx', ['Kx', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Dy*Kx', ['Dy', 'Cz', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx', ['Cz', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Dx*Ky', ['Dx', 'Cz', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky', ['Cz', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Dz*Ky', ['Dz', 'Cx', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky', ['Cx', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*f5', ['Cx', 'f5'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*f5', ['Cy', 'f5'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f6', ['Dx', 'f6'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f6', ['Dz', 'f6'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f8', ['Dz', 'f8'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f8', ['Dy', 'f8'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('f8', ['f8'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('f6', ['f6'])))),
 ('p', 's', 'sp', 's'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)'},
                         ((((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx', ['Qx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy', ['Qy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz', ['Qz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz', ['Dz', 'Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz', ['Dz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx', ['Dx', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx', ['Dx', 'Cz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy', ['Dy', 'Cz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy', ['Dy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx', ['Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy', ['Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz', ['Cz'])))),
 ('p', 'sp', 'p', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f1': '(B00 + Dz*Iz)',
                          'f12': '(B10 + Cz*Iz)',
                          'f3': '(Cy*Iy + B10)',
                          'f7': '(Cx*Ix + B10)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                            ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                            ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz'])),
                          (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                            ['B10', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                          (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*(Dy*Yij + Qy)', ['Dy', 'Qy', 'Cx', 'Yij'])),
                          (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*(Dy*Yij + Qy)', ['Dy', 'Cz', 'Qy', 'Yij'])),
                          (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*(Dx*Xij + Qx)', ['Qx', 'Dx', 'Cz', 'Xij'])),
                          (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f12', ['Dx', 'f12'])),
                          (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f7', ['Dy', 'f7'])),
                          (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f12', ['Dy', 'f12'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz', ['Dz', 'Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz', ['Dz', 'Cy'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f7', ['Dz', 'f7'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f3', ['Dz', 'f3'])),
                          (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f3', ['Dx', 'f3'])),
                          (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx', ['Dx', 'Cy'])),
                          (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx', ['Dx', 'Cz'])),
                          (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy', ['Dy', 'Cz'])),
                          (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy', ['Dy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f1', ['f1', 'Cx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f1', ['f1', 'Cy'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*Qz', ['Iy', 'Qz'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Qz', ['Ix', 'Qz'])),
                          (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Qy', ['Ix', 'Qy'])),
                          (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*Qy', ['Qy', 'Iz'])),
                          (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*Qx', ['Qx', 'Iz'])),
                          (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Qx', ['Qx', 'Iy'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx', ['Qx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy', ['Qy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz', ['Qz'])))),
 ('p', 'sp', 's', 'p'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f10': '(B00 + Cx*Kx)',
                          'f11': '(B00 + Cy*Ky)',
                          'f12': '(Cx*Ix + B10)',
                          'f14': '(B10 + Cz*Iz)',
                          'f3': '(B00 + Ix*Kx)',
                          'f4': '(Iz*Kz + B00)',
                          'f6': '(Cy*Iy + B10)',
                          'f8': '(B00 + Iy*Ky)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                            ['B10', 'Ix', 'Cx', 'Xij', 'B00', 'Kx'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                            ['B10', 'Yij', 'B00', 'Ky', 'Iy', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('(Kz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                            ['B10', 'B00', 'Zij', 'Kz', 'Cz', 'Iz'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*(B00 + Cz*Kz)', ['Kz', 'Ix', 'Cz', 'B00'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*(B00 + Cz*Kz)', ['Kz', 'B00', 'Iy', 'Cz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(B00 + Cz*Kz)', ['Kz', 'B00', 'Cz'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Iy*Kz', ['Kz', 'Iy', 'Cx'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*f6', ['f6', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Kx*f14', ['f14', 'Kx'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*f12', ['f12', 'Ky'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Ky*f14', ['f14', 'Ky'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Ix*Kz', ['Kz', 'Ix', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz', ['Kz', 'Cy'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*f12', ['Kz', 'f12'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*f6', ['f6', 'Kz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz', ['Kz', 'Cx'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*f8', ['f8', 'Cx'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*f8', ['Cz', 'f8'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*f3', ['Cz', 'f3'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*f3', ['f3', 'Cy'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Iz*Kx', ['Iz', 'Cy', 'Kx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx', ['Kx', 'Cy'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Iy*Kx', ['Cz', 'Iy', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx', ['Cz', 'Kx'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ix*Ky', ['Cz', 'Ky', 'Ix'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky', ['Cz', 'Ky'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Iz*Ky', ['Cx', 'Ky', 'Iz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky', ['Cx', 'Ky'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('Cx*f4', ['f4', 'Cx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('Cy*f4', ['f4', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*f11', ['Iz', 'f11'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*f10', ['Iz', 'f10'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*f10', ['Iy', 'f10'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('f10', ['f10'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('f11', ['f11'])))),
 ('p', 'sp', 's', 's'): ({'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz', ['Cx', 'Iz'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz', ['Iz', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix', ['Ix', 'Cy'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix', ['Cz', 'Ix'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy', ['Cz', 'Iy'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy', ['Iy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx', ['Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy', ['Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz', ['Cz'])))),
 ('s', 'd', 'd', 's'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f1': '(Iz*Rz + 2*B00*Dz)',
                         'f10': '(Dx*Ix + B00)',
                         'f11': '(B10 + pow(Iy,2))',
                         'f12': '(B10 + pow(Iz,2))',
                         'f13': '2*pow(B00,2)',
                         'f14': '(2*B00*Dx + Ix*Rx)',
                         'f15': '(Dy*Iy + B00)',
                         'f16': '(B00 + Dz*Iz)',
                         'f17': '(B10 + pow(Ix,2))',
                         'f19': '(2*B00*Dy + Iy*Ry)',
                         'f2': '(2*B00*Iz + Dz*(B10 + pow(Iz,2)))',
                         'f3': '(2*B00*Ix + Dx*(B10 + pow(Ix,2)))',
                         'f7': 'B01*B10',
                         'f8': '(2*B00*Iy + Dy*(B10 + pow(Iy,2)))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (2, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('(f13 + B01*pow(Ix,2) + f7 + pow(Dx,2)*(B10 + pow(Ix,2)) + 4*B00*Dx*Ix)',
                           ['Dx', 'Ix', 'f13', 'B01', 'B10', 'B00', 'f7'])),
                         (((0, 0, 0), (0, 2, 0), (0, 2, 0), (0, 0, 0)),
                          ('(f13 + pow(Dy,2)*(B10 + pow(Iy,2)) + B01*pow(Iy,2) + f7 + 4*B00*Dy*Iy)',
                           ['B10', 'Dy', 'f13', 'B01', 'B00', 'f7', 'Iy'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 2), (0, 0, 0)),
                          ('(f13 + B01*pow(Iz,2) + pow(Dz,2)*(B10 + pow(Iz,2)) + 4*B00*Dz*Iz + f7)',
                           ['B10', 'f13', 'B01', 'Dz', 'B00', 'Iz', 'f7'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('Ix*Iy*Rz', ['Rz', 'Ix', 'Iy'])),
                         (((0, 0, 0), (1, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dy*Iz*f10', ['Dy', 'Iz', 'f10'])),
                         (((0, 0, 0), (0, 1, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Iz*f15', ['f15', 'Dx', 'Iz'])),
                         (((0, 0, 0), (0, 2, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Dz*f11', ['Dz', 'Dx', 'f11'])),
                         (((0, 0, 0), (1, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*Iy*f10', ['Dz', 'Iy', 'f10'])),
                         (((0, 0, 0), (0, 1, 1), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Iy*f16', ['f16', 'Dx', 'Iy'])),
                         (((0, 0, 0), (0, 0, 2), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Dy*f12', ['Dy', 'Dx', 'f12'])),
                         (((0, 0, 0), (2, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Dz*f17', ['Dz', 'Dy', 'f17'])),
                         (((0, 0, 0), (1, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*Ix*f15', ['Dz', 'f15', 'Ix'])),
                         (((0, 0, 0), (1, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Ix*f16', ['f16', 'Dy', 'Ix'])),
                         (((0, 0, 0), (1, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('Ix*Iz*Ry', ['Ix', 'Iz', 'Ry'])),
                         (((0, 0, 0), (0, 1, 1), (2, 0, 0), (0, 0, 0)),
                          ('Iy*Iz*Rx', ['Rx', 'Iy', 'Iz'])),
                         (((0, 0, 0), (0, 2, 0), (2, 0, 0), (0, 0, 0)),
                          ('Rx*f11', ['Rx', 'f11'])),
                         (((0, 0, 0), (0, 0, 2), (2, 0, 0), (0, 0, 0)),
                          ('Rx*f12', ['Rx', 'f12'])),
                         (((0, 0, 0), (0, 0, 2), (0, 2, 0), (0, 0, 0)),
                          ('Ry*f12', ['f12', 'Ry'])),
                         (((0, 0, 0), (2, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Ry*f17', ['f17', 'Ry'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Rz*f17', ['Rz', 'f17'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 2), (0, 0, 0)),
                          ('Rz*f11', ['Rz', 'f11'])),
                         (((0, 0, 0), (1, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('Iy*f14', ['f14', 'Iy'])),
                         (((0, 0, 0), (1, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('Iz*f14', ['f14', 'Iz'])),
                         (((0, 0, 0), (0, 1, 1), (0, 2, 0), (0, 0, 0)),
                          ('Iz*f19', ['Iz', 'f19'])),
                         (((0, 0, 0), (1, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('Ix*f19', ['Ix', 'f19'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('Ix*f1', ['f1', 'Ix'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 2), (0, 0, 0)),
                          ('Iy*f1', ['f1', 'Iy'])),
                         (((0, 0, 0), (0, 0, 2), (1, 0, 1), (0, 0, 0)),
                          ('Dx*f2', ['Dx', 'f2'])),
                         (((0, 0, 0), (0, 2, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*f8', ['Dx', 'f8'])),
                         (((0, 0, 0), (0, 2, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*f8', ['Dz', 'f8'])),
                         (((0, 0, 0), (2, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*f3', ['Dz', 'f3'])),
                         (((0, 0, 0), (2, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*f3', ['Dy', 'f3'])),
                         (((0, 0, 0), (0, 0, 2), (0, 1, 1), (0, 0, 0)),
                          ('Dy*f2', ['Dy', 'f2'])),
                         (((0, 0, 0), (1, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('f10*f16', ['f16', 'f10'])),
                         (((0, 0, 0), (1, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('f10*f15', ['f15', 'f10'])),
                         (((0, 0, 0), (0, 1, 1), (0, 1, 1), (0, 0, 0)),
                          ('f15*f16', ['f16', 'f15'])))),
 ('s', 'd', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'f1': '(B00 + Dz*Iz)',
                         'f4': '(B10 + pow(Iy,2))',
                         'f5': '(B10 + pow(Iz,2))',
                         'f6': '(Dy*Iy + B00)',
                         'f7': '(Dx*Ix + B00)',
                         'f8': '(B10 + pow(Ix,2))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(2*B00*Ix + Dx*(B10 + pow(Ix,2)))',
                           ['Dx', 'B00', 'B10', 'Ix'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('(2*B00*Iz + Dz*(B10 + pow(Iz,2)))',
                           ['Dz', 'B10', 'B00', 'Iz'])),
                         (((0, 0, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('(2*B00*Iy + Dy*(B10 + pow(Iy,2)))',
                           ['Dy', 'B10', 'B00', 'Iy'])),
                         (((0, 0, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Ix*Iz', ['Dy', 'Ix', 'Iz'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Ix*Iy', ['Dz', 'Ix', 'Iy'])),
                         (((0, 0, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iy*Iz', ['Dx', 'Iy', 'Iz'])),
                         (((0, 0, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f4', ['f4', 'Dx'])),
                         (((0, 0, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('Dx*f5', ['Dx', 'f5'])),
                         (((0, 0, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f5', ['Dy', 'f5'])),
                         (((0, 0, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*f8', ['Dy', 'f8'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f8', ['Dz', 'f8'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*f4', ['Dz', 'f4'])),
                         (((0, 0, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*f7', ['f7', 'Iy'])),
                         (((0, 0, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*f7', ['f7', 'Iz'])),
                         (((0, 0, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*f6', ['f6', 'Iz'])),
                         (((0, 0, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*f6', ['f6', 'Ix'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('Ix*f1', ['f1', 'Ix'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('Iy*f1', ['f1', 'Iy'])))),
 ('s', 'd', 's', 'd'): ({'B00': '',
                         'B01': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f0': '(Iz*(pow(Kz,2) + B01) + 2*B00*Kz)',
                         'f10': '(2*B00*Iz + Kz*(B10 + pow(Iz,2)))',
                         'f11': 'B01*B10',
                         'f13': '(pow(Kx,2) + B01)',
                         'f14': '(B00 + Ix*Kx)',
                         'f15': '(B10 + pow(Iy,2))',
                         'f16': '(B00 + Iy*Ky)',
                         'f17': '(B10 + pow(Iz,2))',
                         'f18': '2*pow(B00,2)',
                         'f19': '(pow(Ky,2) + B01)',
                         'f20': '(B10 + pow(Ix,2))',
                         'f21': '(Ix*(pow(Kx,2) + B01) + 2*B00*Kx)',
                         'f22': '(2*B00*Iy + Ky*(B10 + pow(Iy,2)))',
                         'f3': '(2*B00*Ky + Iy*(pow(Ky,2) + B01))',
                         'f4': '(Iz*Kz + B00)',
                         'f8': '(pow(Kz,2) + B01)',
                         'f9': '(2*B00*Ix + Kx*(B10 + pow(Ix,2)))',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (2, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('(f11 + f18 + B01*pow(Ix,2) + pow(Kx,2)*(B10 + pow(Ix,2)) + 4*B00*Ix*Kx)',
                           ['B10', 'Ix', 'B01', 'Kx', 'B00', 'f11', 'f18'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 2, 0)),
                          ('(f11 + f18 + B01*pow(Iy,2) + pow(Ky,2)*(B10 + pow(Iy,2)) + 4*B00*Iy*Ky)',
                           ['B10', 'B01', 'B00', 'Ky', 'Iy', 'f11', 'f18'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 2)),
                          ('(f11 + f18 + 4*B00*Iz*Kz + B01*pow(Iz,2) + pow(Kz,2)*(B10 + pow(Iz,2)))',
                           ['B10', 'Kz', 'B01', 'B00', 'Iz', 'f11', 'f18'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 2)),
                          ('Ix*Iy*f8', ['f8', 'Ix', 'Iy'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (1, 1, 0)),
                          ('Iz*Ky*f14', ['f14', 'Iz', 'Ky'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (1, 1, 0)),
                          ('Iz*Kx*f16', ['f16', 'Iz', 'Kx'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kx*Kz*f15', ['f15', 'Kz', 'Kx'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (1, 0, 1)),
                          ('Iy*Kz*f14', ['f14', 'Kz', 'Iy'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (1, 0, 1)),
                          ('Iy*Kx*f4', ['f4', 'Iy', 'Kx'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (1, 1, 0)),
                          ('Kx*Ky*f17', ['Kx', 'Ky', 'f17'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Ky*Kz*f20', ['Kz', 'f20', 'Ky'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 1, 1)),
                          ('Ix*Kz*f16', ['f16', 'Kz', 'Ix'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 1, 1)),
                          ('Ix*Ky*f4', ['f4', 'Ix', 'Ky'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 2, 0)),
                          ('Ix*Iz*f19', ['Ix', 'Iz', 'f19'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (2, 0, 0)),
                          ('Iy*Iz*f13', ['f13', 'Iy', 'Iz'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (2, 0, 0)),
                          ('f13*f15', ['f15', 'f13'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (2, 0, 0)),
                          ('f13*f17', ['f13', 'f17'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 2, 0)),
                          ('f17*f19', ['f19', 'f17'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('f19*f20', ['f19', 'f20'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('f20*f8', ['f8', 'f20'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 2)),
                          ('f15*f8', ['f15', 'f8'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (2, 0, 0)),
                          ('Iy*f21', ['Iy', 'f21'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (2, 0, 0)),
                          ('Iz*f21', ['Iz', 'f21'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 2, 0)),
                          ('Iz*f3', ['Iz', 'f3'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 2, 0)),
                          ('Ix*f3', ['Ix', 'f3'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 2)),
                          ('Ix*f0', ['Ix', 'f0'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 2)),
                          ('Iy*f0', ['f0', 'Iy'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (1, 0, 1)),
                          ('Kx*f10', ['Kx', 'f10'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (1, 1, 0)),
                          ('Kx*f22', ['f22', 'Kx'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 1, 1)),
                          ('Kz*f22', ['Kz', 'f22'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kz*f9', ['f9', 'Kz'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Ky*f9', ['f9', 'Ky'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 1, 1)),
                          ('Ky*f10', ['f10', 'Ky'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (1, 0, 1)),
                          ('f14*f4', ['f4', 'f14'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (1, 1, 0)),
                          ('f14*f16', ['f16', 'f14'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 1, 1)),
                          ('f16*f4', ['f16', 'f4'])))),
 ('s', 'd', 's', 'p'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f10': '(Iz*Kz + B00)',
                         'f11': '(B10 + pow(Ix,2))',
                         'f3': '(B00 + Ix*Kx)',
                         'f7': '(B10 + pow(Iy,2))',
                         'f8': '(B00 + Iy*Ky)',
                         'f9': '(B10 + pow(Iz,2))',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (2, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('(2*B00*Ix + Kx*(B10 + pow(Ix,2)))',
                           ['B10', 'B00', 'Kx', 'Ix'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 1, 0)),
                          ('(2*B00*Iy + Ky*(B10 + pow(Iy,2)))',
                           ['B10', 'B00', 'Iy', 'Ky'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 1)),
                          ('(2*B00*Iz + Kz*(B10 + pow(Iz,2)))',
                           ['Kz', 'B10', 'B00', 'Iz'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 1, 0)),
                          ('Ix*Iz*Ky', ['Ix', 'Iz', 'Ky'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 1)),
                          ('Ix*Iy*Kz', ['Kz', 'Ix', 'Iy'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (1, 0, 0)),
                          ('Iy*Iz*Kx', ['Iy', 'Iz', 'Kx'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (1, 0, 0)),
                          ('Kx*f7', ['f7', 'Kx'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (1, 0, 0)),
                          ('Kx*f9', ['f9', 'Kx'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 1, 0)),
                          ('Ky*f9', ['f9', 'Ky'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ky*f11', ['f11', 'Ky'])),
                         (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Kz*f11', ['Kz', 'f11'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 1)),
                          ('Kz*f7', ['f7', 'Kz'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (1, 0, 0)),
                          ('Iy*f3', ['Iy', 'f3'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (1, 0, 0)),
                          ('Iz*f3', ['Iz', 'f3'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 1, 0)),
                          ('Iz*f8', ['f8', 'Iz'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ix*f8', ['Ix', 'f8'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 1)),
                          ('Ix*f10', ['Ix', 'f10'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 1)),
                          ('Iy*f10', ['Iy', 'f10'])))),
 ('s', 'd', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10 + pow(Ix,2))', ['B10', 'Ix'])),
                         (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('(B10 + pow(Iy,2))', ['B10', 'Iy'])),
                         (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('(B10 + pow(Iz,2))', ['B10', 'Iz'])),
                         (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iy', ['Ix', 'Iy'])),
                         (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iz', ['Ix', 'Iz'])),
                         (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iy*Iz', ['Iy', 'Iz'])))),
 ('s', 'd', 's', 'sp'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f11': '(Iz*Kz + B00)',
                          'f4': '(B00 + Ix*Kx)',
                          'f9': '(B00 + Iy*Ky)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 1, 0)),
                           ('(2*B00*Iy + Ky*(B10 + pow(Iy,2)))',
                            ['B10', 'B00', 'Iy', 'Ky'])),
                          (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 1)),
                           ('(2*B00*Iz + Kz*(B10 + pow(Iz,2)))',
                            ['Kz', 'B10', 'B00', 'Iz'])),
                          (((0, 0, 0), (2, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(2*B00*Ix + Kx*(B10 + pow(Ix,2)))',
                            ['B10', 'B00', 'Kx', 'Ix'])),
                          (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*(B10 + pow(Ix,2))', ['B10', 'Ix', 'Ky'])),
                          (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*(B10 + pow(Ix,2))', ['B10', 'Kz', 'Ix'])),
                          (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Ix,2))', ['B10', 'Ix'])),
                          (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*(B10 + pow(Iy,2))', ['B10', 'Kz', 'Iy'])),
                          (((0, 0, 0), (0, 2, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*(B10 + pow(Iy,2))', ['B10', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Iy,2))', ['B10', 'Iy'])),
                          (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 1, 0)),
                           ('Ky*(B10 + pow(Iz,2))', ['B10', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 2), (0, 0, 0), (1, 0, 0)),
                           ('Kx*(B10 + pow(Iz,2))', ['B10', 'Kx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Iz,2))', ['B10', 'Iz'])),
                          (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Iz*Ky', ['Ix', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 1, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Iz*Kx', ['Iy', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Iz', ['Iy', 'Iz'])),
                          (((0, 0, 0), (1, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*f4', ['f4', 'Iy'])),
                          (((0, 0, 0), (1, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*f4', ['f4', 'Iz'])),
                          (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*f9', ['f9', 'Ix'])),
                          (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*f9', ['f9', 'Iz'])),
                          (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iz', ['Ix', 'Iz'])),
                          (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Iy*Kz', ['Kz', 'Ix', 'Iy'])),
                          (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy', ['Ix', 'Iy'])),
                          (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 1)),
                           ('Iy*f11', ['Iy', 'f11'])))),
 ('s', 'd', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'f6': '(Dy*Iy + B00)',
                          'f7': '(B00 + Dz*Iz)',
                          'f8': '(Dx*Ix + B00)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 0), (0, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('(2*B00*Iy + Dy*(B10 + pow(Iy,2)))',
                            ['Dy', 'B10', 'B00', 'Iy'])),
                          (((0, 0, 0), (0, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('(2*B00*Iz + Dz*(B10 + pow(Iz,2)))',
                            ['Dz', 'B10', 'B00', 'Iz'])),
                          (((0, 0, 0), (2, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(2*B00*Ix + Dx*(B10 + pow(Ix,2)))',
                            ['Dx', 'B00', 'B10', 'Ix'])),
                          (((0, 0, 0), (2, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*(B10 + pow(Ix,2))', ['Dy', 'B10', 'Ix'])),
                          (((0, 0, 0), (2, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*(B10 + pow(Ix,2))', ['Dz', 'B10', 'Ix'])),
                          (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Ix,2))', ['B10', 'Ix'])),
                          (((0, 0, 0), (0, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*(B10 + pow(Iy,2))', ['Dz', 'B10', 'Iy'])),
                          (((0, 0, 0), (0, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*(B10 + pow(Iy,2))', ['Dx', 'Iy', 'B10'])),
                          (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Iy,2))', ['B10', 'Iy'])),
                          (((0, 0, 0), (0, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('Dy*(B10 + pow(Iz,2))', ['Dy', 'B10', 'Iz'])),
                          (((0, 0, 0), (0, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('Dx*(B10 + pow(Iz,2))', ['Dx', 'B10', 'Iz'])),
                          (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Iz,2))', ['B10', 'Iz'])),
                          (((0, 0, 0), (1, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix*Iz', ['Dy', 'Ix', 'Iz'])),
                          (((0, 0, 0), (0, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy*Iz', ['Dx', 'Iy', 'Iz'])),
                          (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Iz', ['Iy', 'Iz'])),
                          (((0, 0, 0), (1, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*f8', ['f8', 'Iy'])),
                          (((0, 0, 0), (1, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*f8', ['f8', 'Iz'])),
                          (((0, 0, 0), (1, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*f6', ['f6', 'Ix'])),
                          (((0, 0, 0), (0, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*f6', ['f6', 'Iz'])),
                          (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iz', ['Ix', 'Iz'])),
                          (((0, 0, 0), (1, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix*Iy', ['Dz', 'Ix', 'Iy'])),
                          (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy', ['Ix', 'Iy'])),
                          (((0, 0, 0), (1, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Ix*f7', ['f7', 'Ix'])),
                          (((0, 0, 0), (0, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('Iy*f7', ['f7', 'Iy'])))),
 ('s', 'f', 'p', 's'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'f1': '(2*B00*Iz + Dz*(B10 + pow(Iz,2)))',
                         'f10': '(B10 + pow(Iy,2))',
                         'f11': '(B10 + pow(Iz,2))',
                         'f12': '(Dy*Iy + B00)',
                         'f13': '(3*B10 + pow(Iz,2))',
                         'f14': '(B10 + pow(Ix,2))',
                         'f15': '(3*B10 + pow(Ix,2))',
                         'f2': '(2*B00*Ix + Dx*(B10 + pow(Ix,2)))',
                         'f3': '3*B00*B10',
                         'f4': '(B00 + Dz*Iz)',
                         'f6': '(3*B10 + pow(Iy,2))',
                         'f7': '(2*B00*Iy + Dy*(B10 + pow(Iy,2)))',
                         'f9': '(Dx*Ix + B00)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (3, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(3*B10*Dx*Ix + f3 + 3*B00*pow(Ix,2) + Dx*pow(Ix,3))',
                           ['B00', 'B10', 'Ix', 'Dx', 'f3'])),
                         (((0, 0, 0), (0, 3, 0), (0, 1, 0), (0, 0, 0)),
                          ('(Dy*pow(Iy,3) + f3 + 3*B00*pow(Iy,2) + 3*B10*Dy*Iy)',
                           ['Dy', 'B10', 'B00', 'Iy', 'f3'])),
                         (((0, 0, 0), (0, 0, 3), (0, 0, 1), (0, 0, 0)),
                          ('(Dz*pow(Iz,3) + 3*B00*pow(Iz,2) + 3*B10*Dz*Iz + f3)',
                           ['Dz', 'B10', 'B00', 'Iz', 'f3'])),
                         (((0, 0, 0), (1, 1, 1), (0, 1, 0), (0, 0, 0)),
                          ('Ix*Iz*f12', ['Ix', 'f12', 'Iz'])),
                         (((0, 0, 0), (2, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Iy*f14', ['Dz', 'f14', 'Iy'])),
                         (((0, 0, 0), (0, 3, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Iy*f6', ['Dz', 'f6', 'Iy'])),
                         (((0, 0, 0), (0, 3, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iy*f6', ['Dx', 'Iy', 'f6'])),
                         (((0, 0, 0), (0, 1, 2), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iy*f11', ['Dx', 'Iy', 'f11'])),
                         (((0, 0, 0), (1, 0, 2), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Ix*f11', ['Dy', 'Ix', 'f11'])),
                         (((0, 0, 0), (3, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Ix*f15', ['Dy', 'Ix', 'f15'])),
                         (((0, 0, 0), (3, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Ix*f15', ['Dz', 'f15', 'Ix'])),
                         (((0, 0, 0), (1, 2, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Ix*f10', ['Dz', 'Ix', 'f10'])),
                         (((0, 0, 0), (1, 1, 1), (0, 0, 1), (0, 0, 0)),
                          ('Ix*Iy*f4', ['f4', 'Ix', 'Iy'])),
                         (((0, 0, 0), (1, 1, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iy*Iz*f9', ['f9', 'Iy', 'Iz'])),
                         (((0, 0, 0), (2, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Iz*f14', ['Dy', 'f14', 'Iz'])),
                         (((0, 0, 0), (0, 0, 3), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Iz*f13', ['Dy', 'f13', 'Iz'])),
                         (((0, 0, 0), (0, 0, 3), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iz*f13', ['Dx', 'f13', 'Iz'])),
                         (((0, 0, 0), (0, 2, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iz*f10', ['Dx', 'Iz', 'f10'])),
                         (((0, 0, 0), (1, 2, 0), (1, 0, 0), (0, 0, 0)),
                          ('f10*f9', ['f9', 'f10'])),
                         (((0, 0, 0), (1, 0, 2), (1, 0, 0), (0, 0, 0)),
                          ('f11*f9', ['f9', 'f11'])),
                         (((0, 0, 0), (0, 1, 2), (0, 1, 0), (0, 0, 0)),
                          ('f11*f12', ['f12', 'f11'])),
                         (((0, 0, 0), (2, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('f12*f14', ['f14', 'f12'])),
                         (((0, 0, 0), (2, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('f14*f4', ['f4', 'f14'])),
                         (((0, 0, 0), (0, 2, 1), (0, 0, 1), (0, 0, 0)),
                          ('f10*f4', ['f4', 'f10'])),
                         (((0, 0, 0), (2, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Iy*f2', ['Iy', 'f2'])),
                         (((0, 0, 0), (2, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Iz*f2', ['Iz', 'f2'])),
                         (((0, 0, 0), (0, 2, 1), (0, 1, 0), (0, 0, 0)),
                          ('Iz*f7', ['f7', 'Iz'])),
                         (((0, 0, 0), (1, 2, 0), (0, 1, 0), (0, 0, 0)),
                          ('Ix*f7', ['f7', 'Ix'])),
                         (((0, 0, 0), (1, 0, 2), (0, 0, 1), (0, 0, 0)),
                          ('Ix*f1', ['f1', 'Ix'])),
                         (((0, 0, 0), (0, 1, 2), (0, 0, 1), (0, 0, 0)),
                          ('Iy*f1', ['f1', 'Iy'])))),
 ('s', 'f', 's', 'p'): ({'B00': '',
                         'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f11': '(B10 + pow(Iy,2))',
                         'f12': '(B00 + Iy*Ky)',
                         'f13': '(B10 + pow(Iz,2))',
                         'f14': '(3*B10 + pow(Iz,2))',
                         'f15': '(B10 + pow(Ix,2))',
                         'f16': '(3*B10 + pow(Ix,2))',
                         'f17': '(2*B00*Ix + Kx*(B10 + pow(Ix,2)))',
                         'f18': '(2*B00*Iy + Ky*(B10 + pow(Iy,2)))',
                         'f2': '3*B00*B10',
                         'f4': '(B00 + Ix*Kx)',
                         'f5': '(Iz*Kz + B00)',
                         'f7': '(3*B10 + pow(Iy,2))',
                         'f8': '(2*B00*Iz + Kz*(B10 + pow(Iz,2)))',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (3, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('(Ix*Kx*(3*B10 + pow(Ix,2)) + f2 + 3*B00*pow(Ix,2))',
                           ['B10', 'Ix', 'Kx', 'f2', 'B00'])),
                         (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 1, 0)),
                          ('(Iy*Ky*(3*B10 + pow(Iy,2)) + f2 + 3*B00*pow(Iy,2))',
                           ['B10', 'B00', 'Iy', 'f2', 'Ky'])),
                         (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 1)),
                          ('(3*B00*pow(Iz,2) + f2 + Iz*Kz*(3*B10 + pow(Iz,2)))',
                           ['Kz', 'B10', 'B00', 'Iz', 'f2'])),
                         (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 1, 0)),
                          ('Ix*Iz*f12', ['Ix', 'f12', 'Iz'])),
                         (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 1)),
                          ('Iy*Kz*f15', ['f15', 'Kz', 'Iy'])),
                         (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 1)),
                          ('Iy*Kz*f7', ['f7', 'Kz', 'Iy'])),
                         (((0, 0, 0), (0, 3, 0), (0, 0, 0), (1, 0, 0)),
                          ('Iy*Kx*f7', ['f7', 'Iy', 'Kx'])),
                         (((0, 0, 0), (0, 1, 2), (0, 0, 0), (1, 0, 0)),
                          ('Iy*Kx*f13', ['f13', 'Iy', 'Kx'])),
                         (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 1, 0)),
                          ('Ix*Ky*f13', ['f13', 'Ix', 'Ky'])),
                         (((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ix*Ky*f16', ['f16', 'Ix', 'Ky'])),
                         (((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Ix*Kz*f16', ['f16', 'Kz', 'Ix'])),
                         (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 1)),
                          ('Ix*Kz*f11', ['Kz', 'Ix', 'f11'])),
                         (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 1)),
                          ('Ix*Iy*f5', ['Ix', 'Iy', 'f5'])),
                         (((0, 0, 0), (1, 1, 1), (0, 0, 0), (1, 0, 0)),
                          ('Iy*Iz*f4', ['f4', 'Iy', 'Iz'])),
                         (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 1, 0)),
                          ('Iz*Ky*f15', ['f15', 'Iz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 1, 0)),
                          ('Iz*Ky*f14', ['f14', 'Iz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 3), (0, 0, 0), (1, 0, 0)),
                          ('Iz*Kx*f14', ['f14', 'Iz', 'Kx'])),
                         (((0, 0, 0), (0, 2, 1), (0, 0, 0), (1, 0, 0)),
                          ('Iz*Kx*f11', ['f11', 'Iz', 'Kx'])),
                         (((0, 0, 0), (1, 2, 0), (0, 0, 0), (1, 0, 0)),
                          ('f11*f4', ['f4', 'f11'])),
                         (((0, 0, 0), (1, 0, 2), (0, 0, 0), (1, 0, 0)),
                          ('f13*f4', ['f4', 'f13'])),
                         (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 1, 0)),
                          ('f12*f13', ['f13', 'f12'])),
                         (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 1, 0)),
                          ('f12*f15', ['f15', 'f12'])),
                         (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 1)),
                          ('f15*f5', ['f15', 'f5'])),
                         (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 1)),
                          ('f11*f5', ['f11', 'f5'])),
                         (((0, 0, 0), (2, 1, 0), (0, 0, 0), (1, 0, 0)),
                          ('Iy*f17', ['Iy', 'f17'])),
                         (((0, 0, 0), (2, 0, 1), (0, 0, 0), (1, 0, 0)),
                          ('Iz*f17', ['Iz', 'f17'])),
                         (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 1, 0)),
                          ('Iz*f18', ['Iz', 'f18'])),
                         (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ix*f18', ['Ix', 'f18'])),
                         (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 1)),
                          ('Ix*f8', ['Ix', 'f8'])),
                         (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 1)),
                          ('Iy*f8', ['f8', 'Iy'])))),
 ('s', 'f', 's', 's'): ({'B10': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'f0': '(B10 + pow(Ix,2))',
                         'f3': '(B10 + pow(Iy,2))',
                         'f5': '(B10 + pow(Iz,2))',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*(3*B10 + pow(Ix,2))', ['B10', 'Ix'])),
                         (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*(3*B10 + pow(Iy,2))', ['B10', 'Iy'])),
                         (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                          ('Iz*(3*B10 + pow(Iz,2))', ['B10', 'Iz'])),
                         (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                          ('Ix*Iy*Iz', ['Ix', 'Iy', 'Iz'])),
                         (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f0', ['f0', 'Iy'])),
                         (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f0', ['f0', 'Iz'])),
                         (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz*f3', ['Iz', 'f3'])),
                         (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f3', ['Ix', 'f3'])),
                         (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                          ('Ix*f5', ['Ix', 'f5'])),
                         (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                          ('Iy*f5', ['Iy', 'f5'])))),
 ('s', 'f', 's', 'sp'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f11': '(B10 + pow(Iy,2))',
                          'f12': '(B00 + Iy*Ky)',
                          'f13': '(B10 + pow(Iz,2))',
                          'f14': '(3*B10 + pow(Iz,2))',
                          'f15': '(B10 + pow(Ix,2))',
                          'f16': '(3*B10 + pow(Ix,2))',
                          'f17': '(2*B00*Ix + Kx*(B10 + pow(Ix,2)))',
                          'f18': '(2*B00*Iy + Ky*(B10 + pow(Iy,2)))',
                          'f2': '3*B00*B10',
                          'f4': '(B00 + Ix*Kx)',
                          'f5': '(Iz*Kz + B00)',
                          'f7': '(3*B10 + pow(Iy,2))',
                          'f8': '(2*B00*Iz + Kz*(B10 + pow(Iz,2)))',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (3, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(Ix*Kx*(3*B10 + pow(Ix,2)) + f2 + 3*B00*pow(Ix,2))',
                            ['B10', 'Ix', 'Kx', 'f2', 'B00'])),
                          (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 1, 0)),
                           ('(Iy*Ky*(3*B10 + pow(Iy,2)) + f2 + 3*B00*pow(Iy,2))',
                            ['B10', 'B00', 'Iy', 'f2', 'Ky'])),
                          (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 1)),
                           ('(3*B00*pow(Iz,2) + f2 + Iz*Kz*(3*B10 + pow(Iz,2)))',
                            ['Kz', 'B10', 'B00', 'Iz', 'f2'])),
                          (((0, 0, 0), (1, 1, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Iz*f4', ['f4', 'Iy', 'Iz'])),
                          (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 1, 0)),
                           ('Iz*Ky*f14', ['f14', 'Iz', 'Ky'])),
                          (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*Ky*f15', ['f15', 'Iz', 'Ky'])),
                          (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Iz*f12', ['Ix', 'f12', 'Iz'])),
                          (((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Kz*f16', ['f16', 'Kz', 'Ix'])),
                          (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Kz*f11', ['Kz', 'Ix', 'f11'])),
                          (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Iy*f5', ['Ix', 'Iy', 'f5'])),
                          (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy*Iz', ['Ix', 'Iy', 'Iz'])),
                          (((0, 0, 0), (0, 2, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*Kx*f11', ['f11', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 3), (0, 0, 0), (1, 0, 0)),
                           ('Iz*Kx*f14', ['f14', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f14', ['f14', 'Iz'])),
                          (((0, 0, 0), (2, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*f17', ['Iy', 'f17'])),
                          (((0, 0, 0), (2, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*f17', ['Iz', 'f17'])),
                          (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f15', ['f15', 'Iz'])),
                          (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('f12*f15', ['f15', 'f12'])),
                          (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*f18', ['Ix', 'f18'])),
                          (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*f18', ['Iz', 'f18'])),
                          (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f11', ['Iz', 'f11'])),
                          (((0, 0, 0), (1, 2, 0), (0, 0, 0), (1, 0, 0)),
                           ('f11*f4', ['f4', 'f11'])),
                          (((0, 0, 0), (1, 0, 2), (0, 0, 0), (1, 0, 0)),
                           ('f13*f4', ['f4', 'f13'])),
                          (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 1, 0)),
                           ('f12*f13', ['f13', 'f12'])),
                          (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f13', ['f13', 'Iy'])),
                          (((0, 0, 0), (0, 1, 2), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Kx*f13', ['f13', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 3, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Kx*f7', ['f7', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f7', ['f7', 'Iy'])),
                          (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*Kz*f7', ['f7', 'Kz', 'Iy'])),
                          (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*Kz*f15', ['f15', 'Kz', 'Iy'])),
                          (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f15', ['f15', 'Iy'])),
                          (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('f15*f5', ['f15', 'f5'])),
                          (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 1)),
                           ('f11*f5', ['f11', 'f5'])),
                          (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f13', ['f13', 'Ix'])),
                          (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Ky*f13', ['f13', 'Ix', 'Ky'])),
                          (((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Ky*f16', ['f16', 'Ix', 'Ky'])),
                          (((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f16', ['f16', 'Ix'])),
                          (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 1)),
                           ('Ix*f8', ['Ix', 'f8'])),
                          (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 1)),
                           ('Iy*f8', ['f8', 'Iy'])))),
 ('s', 'f', 'sp', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'f1': '(2*B00*Iz + Dz*(B10 + pow(Iz,2)))',
                          'f10': '(B10 + pow(Iy,2))',
                          'f11': '(B10 + pow(Iz,2))',
                          'f12': '(Dy*Iy + B00)',
                          'f13': '(3*B10 + pow(Iz,2))',
                          'f14': '(B10 + pow(Ix,2))',
                          'f15': '(3*B10 + pow(Ix,2))',
                          'f2': '(2*B00*Ix + Dx*(B10 + pow(Ix,2)))',
                          'f3': '3*B00*B10',
                          'f4': '(B00 + Dz*Iz)',
                          'f6': '(3*B10 + pow(Iy,2))',
                          'f7': '(2*B00*Iy + Dy*(B10 + pow(Iy,2)))',
                          'f9': '(Dx*Ix + B00)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 0), (3, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(3*B10*Dx*Ix + f3 + 3*B00*pow(Ix,2) + Dx*pow(Ix,3))',
                            ['B00', 'B10', 'Ix', 'Dx', 'f3'])),
                          (((0, 0, 0), (0, 3, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*pow(Iy,3) + f3 + 3*B00*pow(Iy,2) + 3*B10*Dy*Iy)',
                            ['Dy', 'B10', 'B00', 'Iy', 'f3'])),
                          (((0, 0, 0), (0, 0, 3), (0, 0, 1), (0, 0, 0)),
                           ('(Dz*pow(Iz,3) + 3*B00*pow(Iz,2) + 3*B10*Dz*Iz + f3)',
                            ['Dz', 'B10', 'B00', 'Iz', 'f3'])),
                          (((0, 0, 0), (1, 1, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Iz*f9', ['f9', 'Iy', 'Iz'])),
                          (((0, 0, 0), (0, 0, 3), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz*f13', ['Dy', 'f13', 'Iz'])),
                          (((0, 0, 0), (2, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz*f14', ['Dy', 'f14', 'Iz'])),
                          (((0, 0, 0), (1, 1, 1), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Iz*f12', ['Ix', 'f12', 'Iz'])),
                          (((0, 0, 0), (3, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix*f15', ['Dz', 'f15', 'Ix'])),
                          (((0, 0, 0), (1, 2, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix*f10', ['Dz', 'Ix', 'f10'])),
                          (((0, 0, 0), (1, 1, 1), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Iy*f4', ['f4', 'Ix', 'Iy'])),
                          (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy*Iz', ['Ix', 'Iy', 'Iz'])),
                          (((0, 0, 0), (0, 2, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz*f10', ['Dx', 'Iz', 'f10'])),
                          (((0, 0, 0), (0, 0, 3), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz*f13', ['Dx', 'f13', 'Iz'])),
                          (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f13', ['f13', 'Iz'])),
                          (((0, 0, 0), (2, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*f2', ['Iy', 'f2'])),
                          (((0, 0, 0), (2, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*f2', ['Iz', 'f2'])),
                          (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f14', ['f14', 'Iz'])),
                          (((0, 0, 0), (2, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('f12*f14', ['f14', 'f12'])),
                          (((0, 0, 0), (1, 2, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*f7', ['f7', 'Ix'])),
                          (((0, 0, 0), (0, 2, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*f7', ['f7', 'Iz'])),
                          (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f10', ['Iz', 'f10'])),
                          (((0, 0, 0), (1, 2, 0), (1, 0, 0), (0, 0, 0)),
                           ('f10*f9', ['f9', 'f10'])),
                          (((0, 0, 0), (1, 0, 2), (1, 0, 0), (0, 0, 0)),
                           ('f11*f9', ['f9', 'f11'])),
                          (((0, 0, 0), (0, 1, 2), (0, 1, 0), (0, 0, 0)),
                           ('f11*f12', ['f12', 'f11'])),
                          (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f11', ['Iy', 'f11'])),
                          (((0, 0, 0), (0, 1, 2), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy*f11', ['Dx', 'Iy', 'f11'])),
                          (((0, 0, 0), (0, 3, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy*f6', ['Dx', 'Iy', 'f6'])),
                          (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f6', ['f6', 'Iy'])),
                          (((0, 0, 0), (0, 3, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy*f6', ['Dz', 'f6', 'Iy'])),
                          (((0, 0, 0), (2, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy*f14', ['Dz', 'f14', 'Iy'])),
                          (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f14', ['f14', 'Iy'])),
                          (((0, 0, 0), (2, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('f14*f4', ['f4', 'f14'])),
                          (((0, 0, 0), (0, 2, 1), (0, 0, 1), (0, 0, 0)),
                           ('f10*f4', ['f4', 'f10'])),
                          (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f10', ['Ix', 'f10'])),
                          (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 0, 0), (1, 0, 2), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix*f11', ['Dy', 'Ix', 'f11'])),
                          (((0, 0, 0), (3, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix*f15', ['Dy', 'Ix', 'f15'])),
                          (((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f15', ['f15', 'Ix'])),
                          (((0, 0, 0), (1, 0, 2), (0, 0, 1), (0, 0, 0)),
                           ('Ix*f1', ['f1', 'Ix'])),
                          (((0, 0, 0), (0, 1, 2), (0, 0, 1), (0, 0, 0)),
                           ('Iy*f1', ['f1', 'Iy'])))),
 ('s', 'p', 'd', 's'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f3': '(B00 + Dz*Iz)',
                         'f6': '(Dy*Iy + B00)',
                         'f7': '(Dx*Ix + B00)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                          ('(2*B00*Dy + Iy*Ry)', ['Dy', 'B00', 'Iy', 'Ry'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                          ('(Iz*Rz + 2*B00*Dz)', ['Dz', 'Rz', 'B00', 'Iz'])),
                         (((0, 0, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('(2*B00*Dx + Ix*Rx)', ['Rx', 'Dx', 'B00', 'Ix'])),
                         (((0, 0, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Dy*Iz', ['Dy', 'Dx', 'Iz'])),
                         (((0, 0, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Dz*Ix', ['Dz', 'Dy', 'Ix'])),
                         (((0, 0, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Dz*Iy', ['Dz', 'Dx', 'Iy'])),
                         (((0, 0, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                          ('Iy*Rx', ['Rx', 'Iy'])),
                         (((0, 0, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                          ('Iz*Rx', ['Rx', 'Iz'])),
                         (((0, 0, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                          ('Iz*Ry', ['Iz', 'Ry'])),
                         (((0, 0, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Ix*Ry', ['Ix', 'Ry'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Ix*Rz', ['Rz', 'Ix'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                          ('Iy*Rz', ['Rz', 'Iy'])),
                         (((0, 0, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                          ('Dx*f3', ['Dx', 'f3'])),
                         (((0, 0, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*f6', ['Dx', 'f6'])),
                         (((0, 0, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dz*f6', ['Dz', 'f6'])),
                         (((0, 0, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dz*f7', ['Dz', 'f7'])),
                         (((0, 0, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dy*f7', ['Dy', 'f7'])),
                         (((0, 0, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                          ('Dy*f3', ['Dy', 'f3'])))),
 ('s', 'p', 'f', 's'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f0': '(Iz*Rz + 2*B00*Dz)',
                         'f10': '(2*B00*Dx + Ix*Rx)',
                         'f11': '(3*B01 + pow(Dy,2))',
                         'f12': '(Dy*Iy + B00)',
                         'f13': '(Dx*Ix + B00)',
                         'f15': '(2*B00*Dy + Iy*Ry)',
                         'f2': '(B00 + Dz*Iz)',
                         'f3': '(3*B01 + pow(Dx,2))',
                         'f5': '(pow(Dz,2) + 3*B01)',
                         'f7': '3*B00*B01',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (1, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('(Dx*(3*B00*Dx + Ix*f3) + f7)',
                           ['f7', 'Dx', 'B00', 'f3', 'Ix'])),
                         (((0, 0, 0), (0, 1, 0), (0, 3, 0), (0, 0, 0)),
                          ('(Dy*(Iy*f11 + 3*B00*Dy) + f7)',
                           ['Dy', 'B00', 'Iy', 'f11', 'f7'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 3), (0, 0, 0)),
                          ('(f7 + Dz*(Iz*f5 + 3*B00*Dz))',
                           ['Dz', 'f7', 'B00', 'Iz', 'f5'])),
                         (((0, 0, 0), (1, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Dz*Ix*Ry', ['Dz', 'Ix', 'Ry'])),
                         (((0, 0, 0), (0, 0, 1), (1, 2, 0), (0, 0, 0)),
                          ('Dx*Iz*Ry', ['Dx', 'Iz', 'Ry'])),
                         (((0, 0, 0), (0, 0, 1), (3, 0, 0), (0, 0, 0)),
                          ('Dx*Iz*f3', ['Dx', 'Iz', 'f3'])),
                         (((0, 0, 0), (0, 1, 0), (3, 0, 0), (0, 0, 0)),
                          ('Dx*Iy*f3', ['Dx', 'Iy', 'f3'])),
                         (((0, 0, 0), (0, 1, 0), (1, 0, 2), (0, 0, 0)),
                          ('Dx*Iy*Rz', ['Dx', 'Iy', 'Rz'])),
                         (((0, 0, 0), (0, 1, 0), (2, 0, 1), (0, 0, 0)),
                          ('Dz*Iy*Rx', ['Dz', 'Rx', 'Iy'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 3), (0, 0, 0)),
                          ('Dz*Iy*f5', ['Dz', 'Iy', 'f5'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('Dz*Ix*f5', ['Dz', 'Ix', 'f5'])),
                         (((0, 0, 0), (1, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dy*Dz*f13', ['Dz', 'Dy', 'f13'])),
                         (((0, 0, 0), (0, 1, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Dz*f12', ['Dz', 'Dx', 'f12'])),
                         (((0, 0, 0), (0, 0, 1), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Dy*f2', ['Dy', 'Dx', 'f2'])),
                         (((0, 0, 0), (1, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Dy*Ix*Rz', ['Dy', 'Rz', 'Ix'])),
                         (((0, 0, 0), (1, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('Dy*Ix*f11', ['Dy', 'Ix', 'f11'])),
                         (((0, 0, 0), (0, 0, 1), (0, 3, 0), (0, 0, 0)),
                          ('Dy*Iz*f11', ['Dy', 'Iz', 'f11'])),
                         (((0, 0, 0), (0, 0, 1), (2, 1, 0), (0, 0, 0)),
                          ('Dy*Iz*Rx', ['Rx', 'Dy', 'Iz'])),
                         (((0, 0, 0), (0, 1, 0), (2, 1, 0), (0, 0, 0)),
                          ('Rx*f12', ['Rx', 'f12'])),
                         (((0, 0, 0), (0, 0, 1), (2, 0, 1), (0, 0, 0)),
                          ('Rx*f2', ['Rx', 'f2'])),
                         (((0, 0, 0), (0, 0, 1), (0, 2, 1), (0, 0, 0)),
                          ('Ry*f2', ['f2', 'Ry'])),
                         (((0, 0, 0), (1, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Ry*f13', ['f13', 'Ry'])),
                         (((0, 0, 0), (1, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Rz*f13', ['Rz', 'f13'])),
                         (((0, 0, 0), (0, 1, 0), (0, 1, 2), (0, 0, 0)),
                          ('Rz*f12', ['Rz', 'f12'])),
                         (((0, 0, 0), (0, 0, 1), (1, 0, 2), (0, 0, 0)),
                          ('Dx*f0', ['Dx', 'f0'])),
                         (((0, 0, 0), (0, 1, 0), (1, 2, 0), (0, 0, 0)),
                          ('Dx*f15', ['f15', 'Dx'])),
                         (((0, 0, 0), (0, 1, 0), (0, 2, 1), (0, 0, 0)),
                          ('Dz*f15', ['Dz', 'f15'])),
                         (((0, 0, 0), (1, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Dz*f10', ['Dz', 'f10'])),
                         (((0, 0, 0), (1, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Dy*f10', ['Dy', 'f10'])),
                         (((0, 0, 0), (0, 0, 1), (0, 1, 2), (0, 0, 0)),
                          ('Dy*f0', ['Dy', 'f0'])))),
 ('s', 'p', 'p', 'p'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f10': '(Dz*Kz + B01)',
                         'f11': '(B01 + Dy*Ky)',
                         'f12': '(B00 + Iy*Ky)',
                         'f13': '(Dy*Iy + B00)',
                         'f14': '(Dx*Ix + B00)',
                         'f3': '(B00 + Ix*Kx)',
                         'f4': '(Iz*Kz + B00)',
                         'f5': '(B00 + Dz*Iz)',
                         'f7': '(B01 + Dx*Kx)',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                          ('(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                           ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Iy'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                          ('(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                           ['Kz', 'B01', 'Dz', 'B00', 'Iz', 'Zkl'])),
                         (((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('(Ix*(B01 + Dx*Kx) + B00*(Xkl + 2*Dx))',
                           ['Dx', 'Ix', 'B01', 'Xkl', 'B00', 'Kx'])),
                         (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                          ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                         (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                         (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                         (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                          ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                         (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                          ('Kx*f13', ['f13', 'Kx'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                          ('Kx*f5', ['Kx', 'f5'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                          ('Ky*f5', ['Ky', 'f5'])),
                         (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Ky*f14', ['f14', 'Ky'])),
                         (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Kz*f14', ['f14', 'Kz'])),
                         (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                          ('Kz*f13', ['f13', 'Kz'])),
                         (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                          ('Dx*f4', ['f4', 'Dx'])),
                         (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*f12', ['Dx', 'f12'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*f12', ['Dz', 'f12'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*f3', ['Dz', 'f3'])),
                         (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*f3', ['Dy', 'f3'])),
                         (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                          ('Dy*f4', ['f4', 'Dy'])),
                         (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                          ('Iy*f7', ['f7', 'Iy'])),
                         (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                          ('Iz*f7', ['f7', 'Iz'])),
                         (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                          ('Iz*f11', ['Iz', 'f11'])),
                         (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('Ix*f11', ['Ix', 'f11'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('Ix*f10', ['Ix', 'f10'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                          ('Iy*f10', ['Iy', 'f10'])))),
 ('s', 'p', 'p', 's'): ({'B00': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                          ('(Dy*Iy + B00)', ['Dy', 'B00', 'Iy'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                          ('(B00 + Dz*Iz)', ['Dz', 'B00', 'Iz'])),
                         (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('(Dx*Ix + B00)', ['Dx', 'Ix', 'B00'])),
                         (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iy', ['Dx', 'Iy'])),
                         (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                          ('Dx*Iz', ['Dx', 'Iz'])),
                         (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Iz', ['Dy', 'Iz'])),
                         (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy*Ix', ['Dy', 'Ix'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Ix', ['Dz', 'Ix'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz*Iy', ['Dz', 'Iy'])))),
 ('s', 'p', 'p', 'sp'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f10': '(Dz*Kz + B01)',
                          'f11': '(B01 + Dy*Ky)',
                          'f12': '(B00 + Iy*Ky)',
                          'f13': '(Dy*Iy + B00)',
                          'f14': '(Dx*Ix + B00)',
                          'f3': '(B00 + Ix*Kx)',
                          'f4': '(Iz*Kz + B00)',
                          'f5': '(B00 + Dz*Iz)',
                          'f7': '(B01 + Dx*Kx)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(Ix*(B01 + Dx*Kx) + B00*(Xkl + 2*Dx))',
                            ['Dx', 'Ix', 'B01', 'Xkl', 'B00', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                           ('(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                            ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Iy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                           ('(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                            ['Kz', 'B01', 'Dz', 'B00', 'Iz', 'Zkl'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f12', ['Dx', 'f12'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                           ('Iz*f11', ['Iz', 'f11'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f3', ['Dy', 'f3'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f3', ['Dz', 'f3'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix', ['Dz', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f12', ['Dz', 'f12'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy', ['Dz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                           ('Iy*f7', ['f7', 'Iy'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                           ('Iz*f7', ['f7', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz', ['Dy', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz', ['Dx', 'Iz'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy', ['Dx', 'Iy'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                           ('Dx*f4', ['f4', 'Dx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                           ('Dy*f4', ['f4', 'Dy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix', ['Dy', 'Ix'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Ix*f10', ['Ix', 'f10'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                           ('Iy*f10', ['Iy', 'f10'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*f14', ['f14', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*f13', ['f13', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*f13', ['f13', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                           ('Kx*f5', ['Kx', 'f5'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                           ('Ky*f5', ['Ky', 'f5'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*f14', ['f14', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('f14', ['f14'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('f13', ['f13'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('f5', ['f5'])))),
 ('s', 'p', 's', 'd'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f10': '(pow(Kx,2) + B01)',
                         'f11': '(pow(Ky,2) + B01)',
                         'f3': '(B00 + Ix*Kx)',
                         'f5': '(Iz*Kz + B00)',
                         'f6': '(pow(Kz,2) + B01)',
                         'f8': '(B00 + Iy*Ky)',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('(Ix*(pow(Kx,2) + B01) + 2*B00*Kx)',
                           ['Ix', 'B01', 'Kx', 'B00'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 2, 0)),
                          ('(2*B00*Ky + Iy*(pow(Ky,2) + B01))',
                           ['B01', 'B00', 'Iy', 'Ky'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 2)),
                          ('(Iz*(pow(Kz,2) + B01) + 2*B00*Kz)',
                           ['Kz', 'B01', 'Iz', 'B00'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 1, 0)),
                          ('Iz*Kx*Ky', ['Iz', 'Ky', 'Kx'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Ix*Ky*Kz', ['Kz', 'Ix', 'Ky'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 1)),
                          ('Iy*Kx*Kz', ['Kz', 'Iy', 'Kx'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (2, 0, 0)),
                          ('Iy*f10', ['Iy', 'f10'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (2, 0, 0)),
                          ('Iz*f10', ['Iz', 'f10'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 2, 0)),
                          ('Iz*f11', ['Iz', 'f11'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('Ix*f11', ['Ix', 'f11'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('Ix*f6', ['f6', 'Ix'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 2)),
                          ('Iy*f6', ['f6', 'Iy'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 1)),
                          ('Kx*f5', ['Kx', 'f5'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 1, 0)),
                          ('Kx*f8', ['f8', 'Kx'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 1)),
                          ('Kz*f8', ['Kz', 'f8'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kz*f3', ['Kz', 'f3'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Ky*f3', ['f3', 'Ky'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 1)),
                          ('Ky*f5', ['Ky', 'f5'])))),
 ('s', 'p', 's', 'f'): ({'B00': '',
                         'B01': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f1': '(Iz*(pow(Kz,2) + B01) + 2*B00*Kz)',
                         'f10': '(pow(Kz,2) + B01)',
                         'f11': '(2*B00*Ky + Iy*(pow(Ky,2) + B01))',
                         'f14': '(pow(Kx,2) + B01)',
                         'f15': '(pow(Kz,2) + 3*B01)',
                         'f16': '(B00 + Iy*Ky)',
                         'f17': '(3*B01 + pow(Kx,2))',
                         'f18': '(Ix*(pow(Kx,2) + B01) + 2*B00*Kx)',
                         'f4': '(B00 + Ix*Kx)',
                         'f5': '(pow(Ky,2) + B01)',
                         'f6': '(pow(Ky,2) + 3*B01)',
                         'f7': '3*B00*B01',
                         'f8': '(Iz*Kz + B00)',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (3, 0, 0)),
                          ('(f7 + Kx*(Ix*(3*B01 + pow(Kx,2)) + 3*B00*Kx))',
                           ['f7', 'Ix', 'B01', 'Kx', 'B00'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 3, 0)),
                          ('(f7 + Ky*(3*B00*Ky + Iy*(pow(Ky,2) + 3*B01)))',
                           ['f7', 'B00', 'Iy', 'Ky', 'B01'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 3)),
                          ('(f7 + Kz*(3*B00*Kz + Iz*(pow(Kz,2) + 3*B01)))',
                           ['f7', 'Kz', 'B01', 'Iz', 'B00'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 2, 1)),
                          ('Ix*Kz*f5', ['Kz', 'Ix', 'f5'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 2, 0)),
                          ('Iz*Kx*f5', ['f5', 'Iz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (3, 0, 0)),
                          ('Iz*Kx*f17', ['f17', 'Iz', 'Kx'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (3, 0, 0)),
                          ('Iy*Kx*f17', ['Iy', 'Kx', 'f17'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 2)),
                          ('Iy*Kx*f10', ['Iy', 'Kx', 'f10'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (2, 0, 1)),
                          ('Iy*Kz*f14', ['f14', 'Kz', 'Iy'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 3)),
                          ('Iy*Kz*f15', ['f15', 'Kz', 'Iy'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 3)),
                          ('Ix*Kz*f15', ['Kz', 'Ix', 'f15'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 1, 1)),
                          ('Ky*Kz*f4', ['f4', 'Kz', 'Ky'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 1, 1)),
                          ('Kx*Kz*f16', ['f16', 'Kz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 1, 1)),
                          ('Kx*Ky*f8', ['f8', 'Kx', 'Ky'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 2)),
                          ('Ix*Ky*f10', ['Ix', 'f10', 'Ky'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 3, 0)),
                          ('Ix*Ky*f6', ['f6', 'Ix', 'Ky'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 3, 0)),
                          ('Iz*Ky*f6', ['f6', 'Iz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (2, 1, 0)),
                          ('Iz*Ky*f14', ['f14', 'Iz', 'Ky'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (2, 1, 0)),
                          ('f14*f16', ['f16', 'f14'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (2, 0, 1)),
                          ('f14*f8', ['f14', 'f8'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 2, 1)),
                          ('f5*f8', ['f8', 'f5'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 2, 0)),
                          ('f4*f5', ['f4', 'f5'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 2)),
                          ('f10*f4', ['f4', 'f10'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 2)),
                          ('f10*f16', ['f16', 'f10'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 2)),
                          ('Kx*f1', ['f1', 'Kx'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 2, 0)),
                          ('Kx*f11', ['Kx', 'f11'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 2, 1)),
                          ('Kz*f11', ['Kz', 'f11'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (2, 0, 1)),
                          ('Kz*f18', ['Kz', 'f18'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (2, 1, 0)),
                          ('Ky*f18', ['f18', 'Ky'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 2)),
                          ('Ky*f1', ['f1', 'Ky'])))),
 ('s', 'p', 's', 'p'): ({'B00': '',
                         'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Xij': '',
                         'Xkl': '',
                         'Yij': '',
                         'Ykl': '',
                         'Zij': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('(B00 + Ix*Kx)', ['B00', 'Kx', 'Ix'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                          ('(B00 + Iy*Ky)', ['B00', 'Iy', 'Ky'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                          ('(Iz*Kz + B00)', ['Kz', 'Iz', 'B00'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                          ('Iy*Kx', ['Iy', 'Kx'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                          ('Iz*Kx', ['Iz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                          ('Iz*Ky', ['Iz', 'Ky'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ix*Ky', ['Ix', 'Ky'])),
                         (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Ix*Kz', ['Kz', 'Ix'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                          ('Iy*Kz', ['Kz', 'Iy'])))),
 ('s', 'p', 's', 's'): ({'Cx': '',
                         'Cy': '',
                         'Cz': '',
                         'Ix': '(Cx + Xij)',
                         'Iy': '(Cy + Yij)',
                         'Iz': '(Cz + Zij)',
                         'Xij': '',
                         'Yij': '',
                         'Zij': ''},
                        ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('Ix', ['Ix'])),
                         (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                          ('Iy', ['Iy'])),
                         (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                          ('Iz', ['Iz'])))),
 ('s', 'p', 's', 'sp'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(B00 + Ix*Kx)', ['B00', 'Kx', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('(B00 + Iy*Ky)', ['B00', 'Iy', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('(Iz*Kz + B00)', ['Kz', 'Iz', 'B00'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Kz', ['Kz', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*Kz', ['Kz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Kx', ['Iy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*Kx', ['Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*Ky', ['Iz', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Ky', ['Ix', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix', ['Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy', ['Iy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz', ['Iz'])))),
 ('s', 'p', 'sp', 'p'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f10': '(Dz*Kz + B01)',
                          'f11': '(B01 + Dy*Ky)',
                          'f12': '(B00 + Iy*Ky)',
                          'f13': '(Dy*Iy + B00)',
                          'f14': '(Dx*Ix + B00)',
                          'f3': '(B00 + Ix*Kx)',
                          'f4': '(Iz*Kz + B00)',
                          'f5': '(B00 + Dz*Iz)',
                          'f7': '(B01 + Dx*Kx)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(Ix*(B01 + Dx*Kx) + B00*(Xkl + 2*Dx))',
                            ['Dx', 'Ix', 'B01', 'Xkl', 'B00', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                           ('(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                            ['Kz', 'B01', 'Dz', 'B00', 'Iz', 'Zkl'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                           ('(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                            ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Iy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*f13', ['f13', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                           ('Kx*f5', ['Kx', 'f5'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*f14', ['f14', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                           ('Ky*f5', ['Ky', 'f5'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*Kz', ['Kz', 'Iy'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*f14', ['f14', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*f13', ['f13', 'Kz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Kz', ['Kz', 'Ix'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                           ('Iz*f11', ['Iz', 'f11'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                           ('Iz*f7', ['f7', 'Iz'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                           ('Iy*f7', ['f7', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Kx', ['Iy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*Kx', ['Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*Ky', ['Iz', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Ky', ['Ix', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Ix*f10', ['Ix', 'f10'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                           ('Iy*f10', ['Iy', 'f10'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                           ('Dy*f4', ['f4', 'Dy'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                           ('Dx*f4', ['f4', 'Dx'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f12', ['Dx', 'f12'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f12', ['Dz', 'f12'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f3', ['Dz', 'f3'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f3', ['Dy', 'f3'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('f3', ['f3'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('f12', ['f12'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('f4', ['f4'])))),
 ('s', 'p', 'sp', 's'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*Ix + B00)', ['Dx', 'Ix', 'B00'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*Iy + B00)', ['Dy', 'B00', 'Iy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(B00 + Dz*Iz)', ['Dz', 'B00', 'Iz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix', ['Dz', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy', ['Dz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy', ['Dx', 'Iy'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz', ['Dx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz', ['Dy', 'Iz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix', ['Dy', 'Ix'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix', ['Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy', ['Iy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz', ['Iz'])))),
 ('s', 's', 'd', 'd'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f13': '(Kx*pow(Dx,2) + B01*(3*Dx + Xkl))',
                         'f16': '(B01*(2*Zkl + 3*Dz) + Dz*pow(Kz,2))',
                         'f17': '(B01*(3*Dy + Ykl) + Ky*pow(Dy,2))',
                         'f18': '(B01*(3*Dz + Zkl) + Kz*pow(Dz,2))',
                         'f2': '3*pow(B01,2)',
                         'f4': '(B01*(2*Xkl + 3*Dx) + Dx*pow(Kx,2))',
                         'f9': '(Dy*pow(Ky,2) + B01*(3*Dy + 2*Ykl))',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 1, 1)),
                          ('(Ry + Dy*Ykl)*(Rz + Dz*Zkl)',
                           ['Dy', 'Rz', 'Dz', 'Ykl', 'Zkl', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (1, 1, 0)),
                          ('Dz*Kx*(Ry + Dy*Ykl)',
                           ['Dz', 'Dy', 'Ykl', 'Kx', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 2, 0)),
                          ('Dx*Dz*(Ykl*(Ykl + 2*Dy) + Ry)',
                           ['Dz', 'Ykl', 'Dx', 'Ry', 'Dy'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 1, 1)),
                          ('Dx*Kz*(Ry + Dy*Ykl)',
                           ['Dy', 'Dx', 'Kz', 'Ykl', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 2, 0)),
                          ('(pow(Dy,2)*pow(Ky,2) + f2 + B01*(6*Dy*Ykl + pow(Ykl,2) + 6*pow(Dy,2)))',
                           ['Dy', 'B01', 'f2', 'Ky', 'Ykl'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 2, 0)),
                          ('Rz*(Ykl*(Ykl + 2*Dy) + Ry)',
                           ['Ykl', 'Rz', 'Ry', 'Dy'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 2, 0)),
                          ('Rx*(Ykl*(Ykl + 2*Dy) + Ry)',
                           ['Rx', 'Ykl', 'Ry', 'Dy'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (1, 1, 0)),
                          ('(Rx + Dx*Xkl)*(Ry + Dy*Ykl)',
                           ['Dx', 'Dy', 'Ykl', 'Xkl', 'Rx', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (1, 0, 1)),
                          ('Dy*Kz*(Rx + Dx*Xkl)',
                           ['Rx', 'Dy', 'Dx', 'Kz', 'Xkl'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (1, 1, 0)),
                          ('Dz*Ky*(Rx + Dx*Xkl)',
                           ['Dz', 'Rx', 'Dx', 'Xkl', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (2, 0, 0)),
                          ('Dy*Dz*(Rx + Xkl*(Xkl + 2*Dx))',
                           ['Dz', 'Dy', 'Xkl', 'Rx', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (1, 0, 1)),
                          ('(Rx + Dx*Xkl)*(Rz + Dz*Zkl)',
                           ['Dx', 'Rz', 'Dz', 'Xkl', 'Rx', 'Zkl'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (2, 0, 0)),
                          ('Rz*(Rx + Xkl*(Xkl + 2*Dx))',
                           ['Rx', 'Rz', 'Xkl', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (2, 0, 0)),
                          ('Ry*(Rx + Xkl*(Xkl + 2*Dx))',
                           ['Rx', 'Xkl', 'Dx', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (2, 0, 0)),
                          ('(B01*(pow(Xkl,2) + 6*Dx*Xkl + 6*pow(Dx,2)) + pow(Dx,2)*pow(Kx,2) + f2)',
                           ['Xkl', 'B01', 'Dx', 'f2', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 2)),
                          ('(B01*(6*pow(Dz,2) + 6*Dz*Zkl + pow(Zkl,2)) + f2 + pow(Dz,2)*pow(Kz,2))',
                           ['Dz', 'Zkl', 'Kz', 'B01', 'f2'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 2)),
                          ('Ry*(Rz + Zkl*(2*Dz + Zkl))',
                           ['Dz', 'Rz', 'Zkl', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 2)),
                          ('Rx*(Rz + Zkl*(2*Dz + Zkl))',
                           ['Rx', 'Dz', 'Rz', 'Zkl'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 1, 1)),
                          ('Dx*Ky*(Rz + Dz*Zkl)',
                           ['Dz', 'Dx', 'Zkl', 'Rz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 2)),
                          ('Dx*Dy*(Rz + Zkl*(2*Dz + Zkl))',
                           ['Dz', 'Dy', 'Dx', 'Zkl', 'Rz'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (1, 0, 1)),
                          ('Dy*Kx*(Rz + Dz*Zkl)',
                           ['Dz', 'Dy', 'Rz', 'Zkl', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (1, 1, 0)),
                          ('Kx*Ky*Rz', ['Rz', 'Kx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (1, 0, 1)),
                          ('Kx*Kz*Ry', ['Kz', 'Kx', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 1, 1)),
                          ('Ky*Kz*Rx', ['Rx', 'Kz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (2, 0, 0)),
                          ('Dy*f4', ['f4', 'Dy'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (2, 0, 0)),
                          ('Dz*f4', ['Dz', 'f4'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 2, 0)),
                          ('Dz*f9', ['Dz', 'f9'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 2, 0)),
                          ('Dx*f9', ['Dx', 'f9'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 2)),
                          ('Dx*f16', ['f16', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 2)),
                          ('Dy*f16', ['f16', 'Dy'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (1, 0, 1)),
                          ('Kx*f18', ['Kx', 'f18'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (1, 1, 0)),
                          ('Kx*f17', ['Kx', 'f17'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 1, 1)),
                          ('Kz*f17', ['Kz', 'f17'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (1, 0, 1)),
                          ('Kz*f13', ['f13', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (1, 1, 0)),
                          ('Ky*f13', ['f13', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 1, 1)),
                          ('Ky*f18', ['f18', 'Ky'])))),
 ('s', 's', 'd', 'p'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f2': '(B01 + Dy*Ky)',
                         'f4': '(Dz*Kz + B01)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 1, 0)),
                          ('(B01*(3*Dy + Ykl) + Ky*pow(Dy,2))',
                           ['Dy', 'B01', 'Ky', 'Ykl'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 1, 0)),
                          ('Dx*Dz*Ky', ['Dz', 'Dx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 1)),
                          ('(B01*(3*Dz + Zkl) + Kz*pow(Dz,2))',
                           ['Dz', 'Zkl', 'Kz', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (1, 0, 0)),
                          ('(Kx*pow(Dx,2) + B01*(3*Dx + Xkl))',
                           ['Xkl', 'Dx', 'B01', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (1, 0, 0)),
                          ('Dz*(Rx + Dx*Xkl)', ['Dz', 'Rx', 'Dx', 'Xkl'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (1, 0, 0)),
                          ('Dy*(Rx + Dx*Xkl)', ['Rx', 'Dy', 'Dx', 'Xkl'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 1)),
                          ('Dx*Dy*Kz', ['Dy', 'Dx', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (1, 0, 0)),
                          ('Dy*Dz*Kx', ['Dz', 'Dy', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (1, 0, 0)),
                          ('Kx*Ry', ['Kx', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (1, 0, 0)),
                          ('Kx*Rz', ['Rz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 1, 0)),
                          ('Ky*Rz', ['Rz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 1, 0)),
                          ('Ky*Rx', ['Rx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 1)),
                          ('Kz*Rx', ['Rx', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 1)),
                          ('Kz*Ry', ['Kz', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 1, 0)),
                          ('Dz*f2', ['Dz', 'f2'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 1, 0)),
                          ('Dx*f2', ['Dx', 'f2'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 1)),
                          ('Dx*f4', ['f4', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 1)),
                          ('Dy*f4', ['f4', 'Dy'])))),
 ('s', 's', 'd', 's'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)'},
                        ((((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                          ('Ry', ['Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                          ('Rz', ['Rz'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                          ('Rx', ['Rx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                          ('Dx*Dy', ['Dy', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                          ('Dx*Dz', ['Dz', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                          ('Dy*Dz', ['Dz', 'Dy'])))),
 ('s', 's', 'd', 'sp'): ({'B01': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Rx': '(B01 + pow(Dx,2))',
                          'Ry': '(B01 + pow(Dy,2))',
                          'Rz': '(pow(Dz,2) + B01)',
                          'f5': '(Dz*Kz + B01)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 1, 0)),
                           ('Dx*(Ry + Dy*Ykl)', ['Dy', 'Dx', 'Ykl', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 1, 0)),
                           ('Dz*(Ry + Dy*Ykl)', ['Dz', 'Dy', 'Ykl', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 1), (1, 0, 0)),
                           ('Dy*Dz*Kx', ['Dz', 'Dy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 1, 0)),
                           ('(B01*(3*Dy + Ykl) + Ky*pow(Dy,2))',
                            ['Dy', 'B01', 'Ky', 'Ykl'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 1)),
                           ('(B01*(3*Dz + Zkl) + Kz*pow(Dz,2))',
                            ['Dz', 'Zkl', 'Kz', 'B01'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 0), (1, 0, 0)),
                           ('(Kx*pow(Dx,2) + B01*(3*Dx + Xkl))',
                            ['Xkl', 'Dx', 'B01', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 1), (1, 0, 0)),
                           ('Dz*(Rx + Dx*Xkl)', ['Dz', 'Rx', 'Dx', 'Xkl'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 0), (1, 0, 0)),
                           ('Dy*(Rx + Dx*Xkl)', ['Rx', 'Dy', 'Dx', 'Xkl'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 1)),
                           ('Dx*Dy*Kz', ['Dy', 'Dx', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 1, 0)),
                           ('Dx*Dz*Ky', ['Dz', 'Dx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Dz', ['Dz', 'Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Dz', ['Dz', 'Dy'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Dy', ['Dy', 'Dx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 1)),
                           ('Dx*f5', ['Dx', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 1)),
                           ('Dy*f5', ['Dy', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 1)),
                           ('Kz*Rx', ['Rx', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 1)),
                           ('Kz*Ry', ['Kz', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 0), (1, 0, 0)),
                           ('Kx*Ry', ['Kx', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 2), (1, 0, 0)),
                           ('Kx*Rz', ['Rz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 1, 0)),
                           ('Ky*Rz', ['Rz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 1, 0)),
                           ('Ky*Rx', ['Rx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Rx', ['Rx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Ry', ['Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Rz', ['Rz'])))),
 ('s', 's', 'f', 'p'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)',
                         'f1': '3*pow(B01,2)',
                         'f10': '(3*B01 + pow(Dx,2))',
                         'f12': '(Kx*pow(Dx,2) + B01*(3*Dx + Xkl))',
                         'f14': '(B01*(3*Dy + Ykl) + Ky*pow(Dy,2))',
                         'f15': '(B01*(3*Dz + Zkl) + Kz*pow(Dz,2))',
                         'f4': '(pow(Dz,2) + 3*B01)',
                         'f6': '(3*B01 + pow(Dy,2))',
                         'f7': '(Dz*Kz + B01)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 1, 0)),
                          ('Dx*Dz*(Ry + Dy*Ykl)',
                           ['Dz', 'Dy', 'Dx', 'Ykl', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 1), (1, 0, 0)),
                          ('Dy*Dz*(Rx + Dx*Xkl)',
                           ['Dz', 'Dy', 'Dx', 'Rx', 'Xkl'])),
                         (((0, 0, 0), (0, 0, 0), (3, 0, 0), (1, 0, 0)),
                          ('(Kx*pow(Dx,3) + 3*B01*Dx*(Xkl + 2*Dx) + f1)',
                           ['Xkl', 'Dx', 'f1', 'B01', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 1, 0)),
                          ('(Ky*pow(Dy,3) + f1 + 3*B01*Dy*(Ykl + 2*Dy))',
                           ['Dy', 'f1', 'B01', 'Ky', 'Ykl'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 1)),
                          ('(Kz*pow(Dz,3) + 3*B01*Dz*(2*Dz + Zkl) + f1)',
                           ['Dz', 'Zkl', 'Kz', 'B01', 'f1'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 1), (1, 0, 0)),
                          ('Dz*Kx*Ry', ['Dz', 'Kx', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 3), (1, 0, 0)),
                          ('Dz*Kx*f4', ['Dz', 'f4', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 1, 0)),
                          ('Dz*Ky*f4', ['Dz', 'f4', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 1, 0)),
                          ('Dz*Ky*Rx', ['Dz', 'Rx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 1, 0)),
                          ('Rx*(Ry + Dy*Ykl)', ['Rx', 'Dy', 'Ykl', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 1, 0)),
                          ('Rz*(Ry + Dy*Ykl)', ['Dy', 'Rz', 'Ykl', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 2), (1, 0, 0)),
                          ('Dy*Kx*Rz', ['Dy', 'Rz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 3, 0), (1, 0, 0)),
                          ('Dy*Kx*f6', ['Dy', 'f6', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 1)),
                          ('Dy*Kz*f6', ['Dy', 'f6', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 1)),
                          ('Dy*Kz*Rx', ['Rx', 'Dy', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (1, 2, 0), (1, 0, 0)),
                          ('Ry*(Rx + Dx*Xkl)', ['Rx', 'Dx', 'Xkl', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 2), (1, 0, 0)),
                          ('Rz*(Rx + Dx*Xkl)', ['Rx', 'Rz', 'Dx', 'Xkl'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 1, 0)),
                          ('Dx*Ky*Rz', ['Dx', 'Rz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 1, 0)),
                          ('Dx*Ky*f10', ['Dx', 'f10', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 1)),
                          ('Dx*Kz*f10', ['Dx', 'Kz', 'f10'])),
                         (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 1)),
                          ('Dx*Kz*Ry', ['Dx', 'Kz', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 1)),
                          ('Dx*Dy*f7', ['Dy', 'Dx', 'f7'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 1)),
                          ('Rx*f7', ['Rx', 'f7'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 1)),
                          ('Ry*f7', ['f7', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (2, 1, 0), (1, 0, 0)),
                          ('Dy*f12', ['Dy', 'f12'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 1), (1, 0, 0)),
                          ('Dz*f12', ['Dz', 'f12'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 1, 0)),
                          ('Dz*f14', ['Dz', 'f14'])),
                         (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 1, 0)),
                          ('Dx*f14', ['Dx', 'f14'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 1)),
                          ('Dx*f15', ['f15', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 1)),
                          ('Dy*f15', ['Dy', 'f15'])))),
 ('s', 's', 'f', 's'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Rx': '(B01 + pow(Dx,2))',
                         'Ry': '(B01 + pow(Dy,2))',
                         'Rz': '(pow(Dz,2) + B01)'},
                        ((((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                          ('Dx*Dy*Dz', ['Dz', 'Dy', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                          ('Dy*Rx', ['Rx', 'Dy'])),
                         (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                          ('Dz*Rx', ['Dz', 'Rx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                          ('Dx*Ry', ['Dx', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                          ('Dz*Ry', ['Dz', 'Ry'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                          ('(pow(Dz,3) + 3*B01*Dz)', ['Dz', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                          ('(pow(Dy,3) + 3*B01*Dy)', ['Dy', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                          ('(pow(Dx,3) + 3*B01*Dx)', ['Dx', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                          ('Dx*Rz', ['Dx', 'Rz'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                          ('Dy*Rz', ['Dy', 'Rz'])))),
 ('s', 's', 'f', 'sp'): ({'B01': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Rx': '(B01 + pow(Dx,2))',
                          'Ry': '(B01 + pow(Dy,2))',
                          'Rz': '(pow(Dz,2) + B01)',
                          'f1': '3*pow(B01,2)',
                          'f10': '(3*B01 + pow(Dx,2))',
                          'f12': '(Kx*pow(Dx,2) + B01*(3*Dx + Xkl))',
                          'f14': '(B01*(3*Dy + Ykl) + Ky*pow(Dy,2))',
                          'f15': '(B01*(3*Dz + Zkl) + Kz*pow(Dz,2))',
                          'f4': '(pow(Dz,2) + 3*B01)',
                          'f6': '(3*B01 + pow(Dy,2))',
                          'f7': '(Dz*Kz + B01)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 1, 0)),
                           ('(Ky*pow(Dy,3) + f1 + 3*B01*Dy*(Ykl + 2*Dy))',
                            ['Dy', 'f1', 'B01', 'Ky', 'Ykl'])),
                          (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 1, 0)),
                           ('Rx*(Ry + Dy*Ykl)', ['Rx', 'Dy', 'Ykl', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 1, 0)),
                           ('Rz*(Ry + Dy*Ykl)', ['Dy', 'Rz', 'Ykl', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 1, 0)),
                           ('Dx*Dz*(Ry + Dy*Ykl)',
                            ['Dz', 'Dy', 'Dx', 'Ykl', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 1), (1, 0, 0)),
                           ('Dy*Dz*(Rx + Dx*Xkl)',
                            ['Dz', 'Dy', 'Dx', 'Rx', 'Xkl'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 2), (1, 0, 0)),
                           ('Rz*(Rx + Dx*Xkl)', ['Rx', 'Rz', 'Dx', 'Xkl'])),
                          (((0, 0, 0), (0, 0, 0), (1, 2, 0), (1, 0, 0)),
                           ('Ry*(Rx + Dx*Xkl)', ['Rx', 'Dx', 'Xkl', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (3, 0, 0), (1, 0, 0)),
                           ('(Kx*pow(Dx,3) + 3*B01*Dx*(Xkl + 2*Dx) + f1)',
                            ['Xkl', 'Dx', 'f1', 'B01', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 1)),
                           ('(Kz*pow(Dz,3) + 3*B01*Dz*(2*Dz + Zkl) + f1)',
                            ['Dz', 'Zkl', 'Kz', 'B01', 'f1'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 1, 0)),
                           ('Dz*Ky*f4', ['Dz', 'f4', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 1, 0)),
                           ('Dz*Ky*Rx', ['Dz', 'Rx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 1)),
                           ('Dx*Kz*f10', ['Dx', 'Kz', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 1)),
                           ('Dx*Kz*Ry', ['Dx', 'Kz', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 1)),
                           ('Dx*Dy*f7', ['Dy', 'Dx', 'f7'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dx*Dy*Dz', ['Dz', 'Dy', 'Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 1), (1, 0, 0)),
                           ('Dz*Kx*Ry', ['Dz', 'Kx', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 3), (1, 0, 0)),
                           ('Dz*Kx*f4', ['Dz', 'f4', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                           ('Dz*f4', ['Dz', 'f4'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                           ('Dz*Rx', ['Dz', 'Rx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                           ('Dz*Ry', ['Dz', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 1, 0)),
                           ('Dx*f14', ['Dx', 'f14'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 1, 0)),
                           ('Dz*f14', ['Dz', 'f14'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 1), (1, 0, 0)),
                           ('Dz*f12', ['Dz', 'f12'])),
                          (((0, 0, 0), (0, 0, 0), (2, 1, 0), (1, 0, 0)),
                           ('Dy*f12', ['Dy', 'f12'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                           ('Dy*Rz', ['Dy', 'Rz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 2), (1, 0, 0)),
                           ('Dy*Kx*Rz', ['Dy', 'Rz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 3, 0), (1, 0, 0)),
                           ('Dy*Kx*f6', ['Dy', 'f6', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                           ('Dy*f6', ['Dy', 'f6'])),
                          (((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 1)),
                           ('Dy*Kz*f6', ['Dy', 'f6', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 1)),
                           ('Dy*Kz*Rx', ['Rx', 'Dy', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                           ('Dy*Rx', ['Rx', 'Dy'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 1)),
                           ('Rx*f7', ['Rx', 'f7'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 1)),
                           ('Ry*f7', ['f7', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                           ('Dx*Ry', ['Dx', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                           ('Dx*Rz', ['Dx', 'Rz'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 1, 0)),
                           ('Dx*Ky*Rz', ['Dx', 'Rz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 1, 0)),
                           ('Dx*Ky*f10', ['Dx', 'f10', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                           ('Dx*f10', ['Dx', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 1)),
                           ('Dx*f15', ['f15', 'Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 1)),
                           ('Dy*f15', ['Dy', 'f15'])))),
 ('s', 's', 'p', 'd'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f2': '(pow(Kz,2) + B01)',
                         'f3': '(B01 + Dx*Kx)',
                         'f5': '(pow(Kx,2) + B01)',
                         'f6': '(Dz*Kz + B01)',
                         'f7': '(pow(Ky,2) + B01)',
                         'f8': '(B01 + Dy*Ky)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 2)),
                          ('(B01*(2*Zkl + 3*Dz) + Dz*pow(Kz,2))',
                           ['Dz', 'Zkl', 'Kz', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 1, 0)),
                          ('Dz*Kx*Ky', ['Dz', 'Kx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 1)),
                          ('Dy*Kx*Kz', ['Dy', 'Kz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 1)),
                          ('Dx*Ky*Kz', ['Dx', 'Kz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (2, 0, 0)),
                          ('(B01*(2*Xkl + 3*Dx) + Dx*pow(Kx,2))',
                           ['Xkl', 'B01', 'Dx', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 2, 0)),
                          ('(Dy*pow(Ky,2) + B01*(3*Dy + 2*Ykl))',
                           ['Dy', 'B01', 'Ky', 'Ykl'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (2, 0, 0)),
                          ('Dy*f5', ['Dy', 'f5'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (2, 0, 0)),
                          ('Dz*f5', ['Dz', 'f5'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 2, 0)),
                          ('Dz*f7', ['Dz', 'f7'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 2, 0)),
                          ('Dx*f7', ['f7', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 2)),
                          ('Dx*f2', ['Dx', 'f2'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 2)),
                          ('Dy*f2', ['Dy', 'f2'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 1)),
                          ('Kx*f6', ['f6', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 1, 0)),
                          ('Kx*f8', ['f8', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 1)),
                          ('Kz*f8', ['Kz', 'f8'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 1)),
                          ('Kz*f3', ['Kz', 'f3'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 1, 0)),
                          ('Ky*f3', ['f3', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 1)),
                          ('Ky*f6', ['f6', 'Ky'])))),
 ('s', 's', 'p', 'f'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f1': '3*pow(B01,2)',
                         'f10': '(pow(Kz,2) + 3*B01)',
                         'f11': '(pow(Ky,2) + B01)',
                         'f12': '(Dz*Kz + B01)',
                         'f13': '(3*B01 + pow(Kx,2))',
                         'f14': '(B01*(2*Zkl + 3*Dz) + Dz*pow(Kz,2))',
                         'f15': '(B01 + Dy*Ky)',
                         'f2': '(B01*(2*Xkl + 3*Dx) + Dx*pow(Kx,2))',
                         'f4': '(pow(Kz,2) + B01)',
                         'f5': '(B01 + Dx*Kx)',
                         'f6': '(pow(Ky,2) + 3*B01)',
                         'f7': '(Dy*pow(Ky,2) + B01*(3*Dy + 2*Ykl))',
                         'f9': '(pow(Kx,2) + B01)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 3, 0)),
                          ('(Dy*pow(Ky,3) + f1 + 3*B01*Ky*(Ykl + 2*Dy))',
                           ['Dy', 'f1', 'B01', 'Ky', 'Ykl'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 3)),
                          ('(Dz*pow(Kz,3) + f1 + 3*B01*Kz*(2*Dz + Zkl))',
                           ['Dz', 'f1', 'Kz', 'B01', 'Zkl'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (3, 0, 0)),
                          ('(3*B01*Kx*(Xkl + 2*Dx) + f1 + Dx*pow(Kx,3))',
                           ['Xkl', 'f1', 'B01', 'Kx', 'Dx'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 2, 1)),
                          ('Dx*Kz*f11', ['Dx', 'Kz', 'f11'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 2, 0)),
                          ('Dz*Kx*f11', ['Dz', 'Kx', 'f11'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (3, 0, 0)),
                          ('Dz*Kx*f13', ['Dz', 'f13', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (3, 0, 0)),
                          ('Dy*Kx*f13', ['Dy', 'f13', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 2)),
                          ('Dy*Kx*f4', ['f4', 'Dy', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (2, 0, 1)),
                          ('Dy*Kz*f9', ['Dy', 'f9', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 3)),
                          ('Dy*Kz*f10', ['Dy', 'Kz', 'f10'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 3)),
                          ('Dx*Kz*f10', ['Dx', 'Kz', 'f10'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 1, 1)),
                          ('Ky*Kz*f5', ['Kz', 'Ky', 'f5'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 1, 1)),
                          ('Kx*Kz*f15', ['f15', 'Kz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 1, 1)),
                          ('Kx*Ky*f12', ['f12', 'Kx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 2)),
                          ('Dx*Ky*f4', ['f4', 'Dx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 3, 0)),
                          ('Dx*Ky*f6', ['Dx', 'f6', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 3, 0)),
                          ('Dz*Ky*f6', ['Dz', 'f6', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (2, 1, 0)),
                          ('Dz*Ky*f9', ['Dz', 'f9', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (2, 1, 0)),
                          ('f15*f9', ['f15', 'f9'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (2, 0, 1)),
                          ('f12*f9', ['f9', 'f12'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 2, 1)),
                          ('f11*f12', ['f12', 'f11'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 2, 0)),
                          ('f11*f5', ['f11', 'f5'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 2)),
                          ('f4*f5', ['f4', 'f5'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 2)),
                          ('f15*f4', ['f4', 'f15'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 2)),
                          ('Kx*f14', ['f14', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 2, 0)),
                          ('Kx*f7', ['f7', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 2, 1)),
                          ('Kz*f7', ['f7', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (2, 0, 1)),
                          ('Kz*f2', ['Kz', 'f2'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (2, 1, 0)),
                          ('Ky*f2', ['f2', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 2)),
                          ('Ky*f14', ['f14', 'Ky'])))),
 ('s', 's', 'p', 'p'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                          ('(B01 + Dx*Kx)', ['Dx', 'B01', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                          ('(Dz*Kz + B01)', ['Dz', 'Kz', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                          ('(B01 + Dy*Ky)', ['Dy', 'B01', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                          ('Dy*Kx', ['Dy', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                          ('Dz*Kx', ['Dz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                          ('Dz*Ky', ['Dz', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                          ('Dx*Ky', ['Dx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                          ('Dx*Kz', ['Dx', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                          ('Dy*Kz', ['Dy', 'Kz'])))),
 ('s', 's', 'p', 's'): ({'Dx': '', 'Dy': '', 'Dz': ''},
                        ((((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                          ('Dx', ['Dx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                          ('Dy', ['Dy'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                          ('Dz', ['Dz'])))),
 ('s', 's', 'p', 'sp'): ({'B01': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(B01 + Dy*Ky)', ['Dy', 'B01', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(Dz*Kz + B01)', ['Dz', 'Kz', 'B01'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01 + Dx*Kx)', ['Dx', 'B01', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Kz', ['Dx', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Kz', ['Dy', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Kx', ['Dy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Kx', ['Dz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ky', ['Dz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Ky', ['Dx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx', ['Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy', ['Dy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz', ['Dz'])))),
 ('s', 's', 's', 'd'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                          ('(pow(Kx,2) + B01)', ['B01', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                          ('(pow(Ky,2) + B01)', ['B01', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                          ('(pow(Kz,2) + B01)', ['Kz', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                          ('Kx*Ky', ['Kx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                          ('Kx*Kz', ['Kz', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                          ('Ky*Kz', ['Kz', 'Ky'])))),
 ('s', 's', 's', 'f'): ({'B01': '',
                         'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'f1': '(pow(Kx,2) + B01)',
                         'f2': '(pow(Kz,2) + B01)',
                         'f5': '(pow(Ky,2) + B01)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                          ('Kx*(3*B01 + pow(Kx,2))', ['B01', 'Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                          ('Ky*(pow(Ky,2) + 3*B01)', ['B01', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                          ('Kz*(pow(Kz,2) + 3*B01)', ['Kz', 'B01'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                          ('Kx*Ky*Kz', ['Kz', 'Kx', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                          ('Ky*f1', ['f1', 'Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                          ('Kz*f1', ['f1', 'Kz'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                          ('Kz*f5', ['Kz', 'f5'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                          ('Kx*f5', ['Kx', 'f5'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                          ('Kx*f2', ['Kx', 'f2'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                          ('Ky*f2', ['f2', 'Ky'])))),
 ('s', 's', 's', 'p'): ({'Dx': '',
                         'Dy': '',
                         'Dz': '',
                         'Kx': '(Xkl + Dx)',
                         'Ky': '(Ykl + Dy)',
                         'Kz': '(Dz + Zkl)',
                         'Xkl': '',
                         'Ykl': '',
                         'Zkl': ''},
                        ((((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                          ('Kx', ['Kx'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                          ('Ky', ['Ky'])),
                         (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                          ('Kz', ['Kz'])))),
 ('s', 's', 's', 's'): ({},
                        ((((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                          ('1', [])),)),
 ('s', 's', 's', 'sp'): ({'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx', ['Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky', ['Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz', ['Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('1', [])))),
 ('s', 's', 'sp', 'd'): ({'B01': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f2': '(pow(Kz,2) + B01)',
                          'f3': '(B01 + Dx*Kx)',
                          'f5': '(pow(Kx,2) + B01)',
                          'f6': '(Dz*Kz + B01)',
                          'f7': '(pow(Ky,2) + B01)',
                          'f8': '(B01 + Dy*Ky)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 0, 0), (1, 0, 0), (2, 0, 0)),
                           ('(B01*(2*Xkl + 3*Dx) + Dx*pow(Kx,2))',
                            ['Xkl', 'B01', 'Dx', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 2)),
                           ('(B01*(2*Zkl + 3*Dz) + Dz*pow(Kz,2))',
                            ['Dz', 'Zkl', 'Kz', 'B01'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 2, 0)),
                           ('(Dy*pow(Ky,2) + B01*(3*Dy + 2*Ykl))',
                            ['Dy', 'B01', 'Ky', 'Ykl'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 1)),
                           ('Dy*Kx*Kz', ['Dy', 'Kz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 1, 0)),
                           ('Kx*f8', ['f8', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 1)),
                           ('Kx*f6', ['f6', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                           ('Kx*Kz', ['Kz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 1)),
                           ('Dx*Ky*Kz', ['Dx', 'Kz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                           ('Ky*Kz', ['Kz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 1)),
                           ('Kz*f8', ['Kz', 'f8'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 1)),
                           ('Kz*f3', ['Kz', 'f3'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 1, 0)),
                           ('Ky*f3', ['f3', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 1, 0)),
                           ('Dz*Kx*Ky', ['Dz', 'Kx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                           ('Kx*Ky', ['Kx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 1)),
                           ('Ky*f6', ['f6', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 2)),
                           ('Dy*f2', ['Dy', 'f2'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 2)),
                           ('Dx*f2', ['Dx', 'f2'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 2, 0)),
                           ('Dx*f7', ['f7', 'Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 2, 0)),
                           ('Dz*f7', ['Dz', 'f7'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (2, 0, 0)),
                           ('Dz*f5', ['Dz', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (2, 0, 0)),
                           ('Dy*f5', ['Dy', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                           ('f5', ['f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                           ('f7', ['f7'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                           ('f2', ['f2'])))),
 ('s', 's', 'sp', 'f'): ({'B01': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f1': '3*pow(B01,2)',
                          'f10': '(pow(Kz,2) + 3*B01)',
                          'f11': '(pow(Ky,2) + B01)',
                          'f12': '(Dz*Kz + B01)',
                          'f13': '(3*B01 + pow(Kx,2))',
                          'f14': '(B01*(2*Zkl + 3*Dz) + Dz*pow(Kz,2))',
                          'f15': '(B01 + Dy*Ky)',
                          'f2': '(B01*(2*Xkl + 3*Dx) + Dx*pow(Kx,2))',
                          'f4': '(pow(Kz,2) + B01)',
                          'f5': '(B01 + Dx*Kx)',
                          'f6': '(pow(Ky,2) + 3*B01)',
                          'f7': '(Dy*pow(Ky,2) + B01*(3*Dy + 2*Ykl))',
                          'f9': '(pow(Kx,2) + B01)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 0, 0), (1, 0, 0), (3, 0, 0)),
                           ('(3*B01*Kx*(Xkl + 2*Dx) + f1 + Dx*pow(Kx,3))',
                            ['Xkl', 'f1', 'B01', 'Kx', 'Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 3)),
                           ('(Dz*pow(Kz,3) + f1 + 3*B01*Kz*(2*Dz + Zkl))',
                            ['Dz', 'f1', 'Kz', 'B01', 'Zkl'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 3, 0)),
                           ('(Dy*pow(Ky,3) + f1 + 3*B01*Ky*(Ykl + 2*Dy))',
                            ['Dy', 'f1', 'B01', 'Ky', 'Ykl'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 2)),
                           ('Dy*Kx*f4', ['f4', 'Dy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 1, 1)),
                           ('Ky*Kz*f5', ['Kz', 'Ky', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 1, 1)),
                           ('Kx*Kz*f15', ['f15', 'Kz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                           ('Kx*Ky*Kz', ['Kz', 'Kx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 1, 1)),
                           ('Kx*Ky*f12', ['f12', 'Kx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 2, 0)),
                           ('Kx*f7', ['f7', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 2, 1)),
                           ('Dx*Kz*f11', ['Dx', 'Kz', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                           ('Kz*f11', ['Kz', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 2, 1)),
                           ('Kz*f7', ['f7', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (2, 0, 1)),
                           ('f12*f9', ['f9', 'f12'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 2, 1)),
                           ('f11*f12', ['f12', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 2)),
                           ('f4*f5', ['f4', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 2, 0)),
                           ('f11*f5', ['f11', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                           ('Kx*f11', ['Kx', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 2, 0)),
                           ('Dz*Kx*f11', ['Dz', 'Kx', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (3, 0, 0)),
                           ('Dz*Kx*f13', ['Dz', 'f13', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (3, 0, 0)),
                           ('Dy*Kx*f13', ['Dy', 'f13', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                           ('Kx*f13', ['f13', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 2)),
                           ('Kx*f14', ['f14', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                           ('Kx*f4', ['f4', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 2)),
                           ('Dx*Ky*f4', ['f4', 'Dx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                           ('Ky*f4', ['f4', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 2)),
                           ('f15*f4', ['f4', 'f15'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (2, 1, 0)),
                           ('f15*f9', ['f15', 'f9'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                           ('Kz*f9', ['f9', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (2, 0, 1)),
                           ('Dy*Kz*f9', ['Dy', 'f9', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 3)),
                           ('Dy*Kz*f10', ['Dy', 'Kz', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 3)),
                           ('Dx*Kz*f10', ['Dx', 'Kz', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                           ('Kz*f10', ['Kz', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (2, 0, 1)),
                           ('Kz*f2', ['Kz', 'f2'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (2, 1, 0)),
                           ('Ky*f2', ['f2', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                           ('Ky*f9', ['f9', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (2, 1, 0)),
                           ('Dz*Ky*f9', ['Dz', 'f9', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 3, 0)),
                           ('Dz*Ky*f6', ['Dz', 'f6', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 3, 0)),
                           ('Dx*Ky*f6', ['Dx', 'f6', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                           ('Ky*f6', ['f6', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 2)),
                           ('Ky*f14', ['f14', 'Ky'])))),
 ('s', 's', 'sp', 'p'): ({'B01': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01 + Dx*Kx)', ['Dx', 'B01', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(B01 + Dy*Ky)', ['Dy', 'B01', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(Dz*Kz + B01)', ['Dz', 'Kz', 'B01'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Kx', ['Dz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ky', ['Dz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Ky', ['Dx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Kz', ['Dx', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Kz', ['Dy', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Kx', ['Dy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx', ['Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky', ['Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz', ['Kz'])))),
 ('s', 's', 'sp', 's'): ({'Dx': '', 'Dy': '', 'Dz': ''},
                         ((((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx', ['Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy', ['Dy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz', ['Dz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('1', [])))),
 ('s', 's', 'sp', 'sp'): ({'B01': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Kx': '(Xkl + Dx)',
                           'Ky': '(Ykl + Dy)',
                           'Kz': '(Dz + Zkl)',
                           'Xkl': '',
                           'Ykl': '',
                           'Zkl': ''},
                          ((((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('(B01 + Dy*Ky)', ['Dy', 'B01', 'Ky'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('(Dz*Kz + B01)', ['Dz', 'Kz', 'B01'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(B01 + Dx*Kx)', ['Dx', 'B01', 'Kx'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Kz', ['Dx', 'Kz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Kz', ['Dy', 'Kz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Kx', ['Dy', 'Kx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Kx', ['Dz', 'Kx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ky', ['Dz', 'Ky'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Ky', ['Dx', 'Ky'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx', ['Dx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy', ['Dy'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz', ['Dz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Kx', ['Kx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ky', ['Ky'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Kz', ['Kz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('1', [])))),
 ('s', 'sp', 'd', 's'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Rx': '(B01 + pow(Dx,2))',
                          'Ry': '(B01 + pow(Dy,2))',
                          'Rz': '(pow(Dz,2) + B01)',
                          'f3': '(B00 + Dz*Iz)',
                          'f6': '(Dy*Iy + B00)',
                          'f7': '(Dx*Ix + B00)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 0), (1, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('(2*B00*Dx + Ix*Rx)',
                            ['Rx', 'Dx', 'B00', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 2, 0), (0, 0, 0)),
                           ('(2*B00*Dy + Iy*Ry)',
                            ['Dy', 'B00', 'Iy', 'Ry'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 2), (0, 0, 0)),
                           ('(Iz*Rz + 2*B00*Dz)',
                            ['Dz', 'Rz', 'B00', 'Iz'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Dz*Iy', ['Dz', 'Dx', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*f6', ['Dx', 'f6'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 1), (0, 0, 0)),
                           ('Dx*f3', ['Dx', 'f3'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Dz', ['Dz', 'Dx'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Dz*Ix', ['Dz', 'Dy', 'Ix'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Dz', ['Dz', 'Dy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dz*f6', ['Dz', 'f6'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dz*f7', ['Dz', 'f7'])),
                          (((0, 0, 0), (1, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dy*f7', ['Dy', 'f7'])),
                          (((0, 0, 0), (0, 0, 1), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Dy*Iz', ['Dy', 'Dx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Dy', ['Dy', 'Dx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 1), (0, 0, 0)),
                           ('Dy*f3', ['Dy', 'f3'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 2), (0, 0, 0)),
                           ('Iy*Rz', ['Rz', 'Iy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Ix*Rz', ['Rz', 'Ix'])),
                          (((0, 0, 0), (1, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Ix*Ry', ['Ix', 'Ry'])),
                          (((0, 0, 0), (0, 0, 1), (0, 2, 0), (0, 0, 0)),
                           ('Iz*Ry', ['Iz', 'Ry'])),
                          (((0, 0, 0), (0, 0, 1), (2, 0, 0), (0, 0, 0)),
                           ('Iz*Rx', ['Rx', 'Iz'])),
                          (((0, 0, 0), (0, 1, 0), (2, 0, 0), (0, 0, 0)),
                           ('Iy*Rx', ['Rx', 'Iy'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Rx', ['Rx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Ry', ['Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Rz', ['Rz'])))),
 ('s', 'sp', 'f', 's'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Rx': '(B01 + pow(Dx,2))',
                          'Ry': '(B01 + pow(Dy,2))',
                          'Rz': '(pow(Dz,2) + B01)',
                          'f0': '(Iz*Rz + 2*B00*Dz)',
                          'f10': '(2*B00*Dx + Ix*Rx)',
                          'f11': '(3*B01 + pow(Dy,2))',
                          'f12': '(Dy*Iy + B00)',
                          'f13': '(Dx*Ix + B00)',
                          'f15': '(2*B00*Dy + Iy*Ry)',
                          'f2': '(B00 + Dz*Iz)',
                          'f3': '(3*B01 + pow(Dx,2))',
                          'f5': '(pow(Dz,2) + 3*B01)',
                          'f7': '3*B00*B01',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 0), (0, 1, 0), (0, 3, 0), (0, 0, 0)),
                           ('(Dy*(Iy*f11 + 3*B00*Dy) + f7)',
                            ['Dy', 'B00', 'Iy', 'f11', 'f7'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 3), (0, 0, 0)),
                           ('(f7 + Dz*(Iz*f5 + 3*B00*Dz))',
                            ['Dz', 'f7', 'B00', 'Iz', 'f5'])),
                          (((0, 0, 0), (1, 0, 0), (3, 0, 0), (0, 0, 0)),
                           ('(Dx*(3*B00*Dx + Ix*f3) + f7)',
                            ['f7', 'Dx', 'B00', 'f3', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 2), (0, 0, 0)),
                           ('Dx*Iy*Rz', ['Dx', 'Iy', 'Rz'])),
                          (((0, 0, 0), (1, 0, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dy*Dz*f13', ['Dz', 'Dy', 'f13'])),
                          (((0, 0, 0), (0, 1, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dx*Dz*f12', ['Dz', 'Dx', 'f12'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dx*Dy*Dz', ['Dz', 'Dy', 'Dx'])),
                          (((0, 0, 0), (0, 0, 1), (1, 1, 1), (0, 0, 0)),
                           ('Dx*Dy*f2', ['Dy', 'Dx', 'f2'])),
                          (((0, 0, 0), (0, 1, 0), (1, 2, 0), (0, 0, 0)),
                           ('Dx*f15', ['f15', 'Dx'])),
                          (((0, 0, 0), (1, 0, 0), (0, 2, 1), (0, 0, 0)),
                           ('Dz*Ix*Ry', ['Dz', 'Ix', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                           ('Dz*Ry', ['Dz', 'Ry'])),
                          (((0, 0, 0), (0, 1, 0), (0, 2, 1), (0, 0, 0)),
                           ('Dz*f15', ['Dz', 'f15'])),
                          (((0, 0, 0), (0, 0, 1), (2, 0, 1), (0, 0, 0)),
                           ('Rx*f2', ['Rx', 'f2'])),
                          (((0, 0, 0), (0, 0, 1), (0, 2, 1), (0, 0, 0)),
                           ('Ry*f2', ['f2', 'Ry'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 2), (0, 0, 0)),
                           ('Rz*f13', ['Rz', 'f13'])),
                          (((0, 0, 0), (1, 0, 0), (1, 2, 0), (0, 0, 0)),
                           ('Ry*f13', ['f13', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                           ('Dx*Ry', ['Dx', 'Ry'])),
                          (((0, 0, 0), (0, 0, 1), (1, 2, 0), (0, 0, 0)),
                           ('Dx*Iz*Ry', ['Dx', 'Iz', 'Ry'])),
                          (((0, 0, 0), (0, 0, 1), (3, 0, 0), (0, 0, 0)),
                           ('Dx*Iz*f3', ['Dx', 'Iz', 'f3'])),
                          (((0, 0, 0), (0, 1, 0), (3, 0, 0), (0, 0, 0)),
                           ('Dx*Iy*f3', ['Dx', 'Iy', 'f3'])),
                          (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                           ('Dx*f3', ['Dx', 'f3'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 2), (0, 0, 0)),
                           ('Dx*f0', ['Dx', 'f0'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                           ('Dx*Rz', ['Dx', 'Rz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 2), (0, 0, 0)),
                           ('Dy*Ix*Rz', ['Dy', 'Rz', 'Ix'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                           ('Dy*Rz', ['Dy', 'Rz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 2), (0, 0, 0)),
                           ('Rz*f12', ['Rz', 'f12'])),
                          (((0, 0, 0), (0, 1, 0), (2, 1, 0), (0, 0, 0)),
                           ('Rx*f12', ['Rx', 'f12'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                           ('Dz*Rx', ['Dz', 'Rx'])),
                          (((0, 0, 0), (0, 1, 0), (2, 0, 1), (0, 0, 0)),
                           ('Dz*Iy*Rx', ['Dz', 'Rx', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 3), (0, 0, 0)),
                           ('Dz*Iy*f5', ['Dz', 'Iy', 'f5'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 3), (0, 0, 0)),
                           ('Dz*Ix*f5', ['Dz', 'Ix', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                           ('Dz*f5', ['Dz', 'f5'])),
                          (((0, 0, 0), (1, 0, 0), (2, 0, 1), (0, 0, 0)),
                           ('Dz*f10', ['Dz', 'f10'])),
                          (((0, 0, 0), (1, 0, 0), (2, 1, 0), (0, 0, 0)),
                           ('Dy*f10', ['Dy', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                           ('Dy*Rx', ['Rx', 'Dy'])),
                          (((0, 0, 0), (0, 0, 1), (2, 1, 0), (0, 0, 0)),
                           ('Dy*Iz*Rx', ['Rx', 'Dy', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 3, 0), (0, 0, 0)),
                           ('Dy*Iz*f11', ['Dy', 'Iz', 'f11'])),
                          (((0, 0, 0), (1, 0, 0), (0, 3, 0), (0, 0, 0)),
                           ('Dy*Ix*f11', ['Dy', 'Ix', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                           ('Dy*f11', ['Dy', 'f11'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 2), (0, 0, 0)),
                           ('Dy*f0', ['Dy', 'f0'])))),
 ('s', 'sp', 'p', 'p'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f13': '(B00 + Iy*Ky)',
                          'f14': '(Dy*Iy + B00)',
                          'f15': '(Dx*Ix + B00)',
                          'f4': '(B00 + Ix*Kx)',
                          'f5': '(Iz*Kz + B00)',
                          'f6': '(B00 + Dz*Iz)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(Ix*(B01 + Dx*Kx) + B00*(Xkl + 2*Dx))',
                            ['Dx', 'Ix', 'B01', 'Xkl', 'B00', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                           ('(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                            ['Kz', 'B01', 'Dz', 'B00', 'Iz', 'Zkl'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                           ('(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                            ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Iy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Ix*(B01 + Dy*Ky)', ['Dy', 'Ix', 'B01', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                           ('Iz*(B01 + Dy*Ky)', ['Dy', 'B01', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(B01 + Dy*Ky)', ['Dy', 'B01', 'Ky'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                           ('Iy*(Dz*Kz + B01)', ['Dz', 'B01', 'Kz', 'Iy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Ix*(Dz*Kz + B01)', ['Dz', 'Kz', 'Ix', 'B01'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(Dz*Kz + B01)', ['Dz', 'Kz', 'B01'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                           ('Iz*(B01 + Dx*Kx)', ['Dx', 'B01', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                           ('Iy*(B01 + Dx*Kx)', ['B01', 'Dx', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01 + Dx*Kx)', ['Dx', 'B01', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f13', ['Dx', 'f13'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ky', ['Dz', 'Ky'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f13', ['Dz', 'f13'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                           ('Kx*f6', ['f6', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                           ('Ky*f6', ['f6', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*f15', ['f15', 'Kz'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*f15', ['f15', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Ky', ['Dx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                           ('Dx*f5', ['Dx', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Kz', ['Dx', 'Kz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Kz', ['Dy', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*f14', ['f14', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*f14', ['f14', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Kx', ['Dz', 'Kx'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f4', ['Dz', 'f4'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f4', ['f4', 'Dy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Kx', ['Dy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                           ('Dy*f5', ['Dy', 'f5'])))),
 ('s', 'sp', 'p', 's'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*Iy + B00)', ['Dy', 'B00', 'Iy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(B00 + Dz*Iz)', ['Dz', 'B00', 'Iz'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*Ix + B00)', ['Dx', 'Ix', 'B00'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz', ['Dx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz', ['Dy', 'Iz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix', ['Dy', 'Ix'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix', ['Dz', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy', ['Dz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy', ['Dx', 'Iy'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx', ['Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy', ['Dy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz', ['Dz'])))),
 ('s', 'sp', 's', 'd'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f10': '(pow(Kx,2) + B01)',
                          'f11': '(pow(Ky,2) + B01)',
                          'f3': '(B00 + Ix*Kx)',
                          'f4': '(Iz*Kz + B00)',
                          'f6': '(pow(Kz,2) + B01)',
                          'f8': '(B00 + Iy*Ky)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (2, 0, 0)),
                           ('(Ix*(pow(Kx,2) + B01) + 2*B00*Kx)',
                            ['Ix', 'B01', 'Kx', 'B00'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 2, 0)),
                           ('(2*B00*Ky + Iy*(pow(Ky,2) + B01))',
                            ['B01', 'B00', 'Iy', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 2)),
                           ('(Iz*(pow(Kz,2) + B01) + 2*B00*Kz)',
                            ['Kz', 'B01', 'Iz', 'B00'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 1)),
                           ('Iy*Kx*Kz', ['Kz', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 1, 0)),
                           ('Kx*f8', ['f8', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 1)),
                           ('Kx*f4', ['f4', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                           ('Kx*Kz', ['Kz', 'Kx'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 1)),
                           ('Ix*Ky*Kz', ['Kz', 'Ix', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                           ('Ky*Kz', ['Kz', 'Ky'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 1)),
                           ('Kz*f8', ['Kz', 'f8'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 1)),
                           ('Kz*f3', ['Kz', 'f3'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 1, 0)),
                           ('Ky*f3', ['f3', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 1, 0)),
                           ('Iz*Kx*Ky', ['Iz', 'Ky', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                           ('Kx*Ky', ['Kx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 1)),
                           ('Ky*f4', ['f4', 'Ky'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 2)),
                           ('Iy*f6', ['f6', 'Iy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 2)),
                           ('Ix*f6', ['f6', 'Ix'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 2, 0)),
                           ('Ix*f11', ['Ix', 'f11'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 2, 0)),
                           ('Iz*f11', ['Iz', 'f11'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (2, 0, 0)),
                           ('Iz*f10', ['Iz', 'f10'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (2, 0, 0)),
                           ('Iy*f10', ['Iy', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                           ('f10', ['f10'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                           ('f11', ['f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                           ('f6', ['f6'])))),
 ('s', 'sp', 's', 'f'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f1': '(Iz*(pow(Kz,2) + B01) + 2*B00*Kz)',
                          'f10': '(pow(Kz,2) + B01)',
                          'f11': '(2*B00*Ky + Iy*(pow(Ky,2) + B01))',
                          'f14': '(pow(Kx,2) + B01)',
                          'f15': '(pow(Kz,2) + 3*B01)',
                          'f16': '(B00 + Iy*Ky)',
                          'f17': '(3*B01 + pow(Kx,2))',
                          'f18': '(Ix*(pow(Kx,2) + B01) + 2*B00*Kx)',
                          'f4': '(B00 + Ix*Kx)',
                          'f5': '(pow(Ky,2) + B01)',
                          'f6': '(pow(Ky,2) + 3*B01)',
                          'f7': '3*B00*B01',
                          'f8': '(Iz*Kz + B00)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (3, 0, 0)),
                           ('(f7 + Kx*(Ix*(3*B01 + pow(Kx,2)) + 3*B00*Kx))',
                            ['f7', 'Ix', 'B01', 'Kx', 'B00'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 3, 0)),
                           ('(f7 + Ky*(3*B00*Ky + Iy*(pow(Ky,2) + 3*B01)))',
                            ['f7', 'B00', 'Iy', 'Ky', 'B01'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 3)),
                           ('(f7 + Kz*(3*B00*Kz + Iz*(pow(Kz,2) + 3*B01)))',
                            ['f7', 'Kz', 'B01', 'Iz', 'B00'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 2)),
                           ('Iy*Kx*f10', ['Iy', 'Kx', 'f10'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 1, 1)),
                           ('Ky*Kz*f4', ['f4', 'Kz', 'Ky'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 1, 1)),
                           ('Kx*Kz*f16', ['f16', 'Kz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                           ('Kx*Ky*Kz', ['Kz', 'Kx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 1, 1)),
                           ('Kx*Ky*f8', ['f8', 'Kx', 'Ky'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 2, 0)),
                           ('Kx*f11', ['Kx', 'f11'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 2, 1)),
                           ('Ix*Kz*f5', ['Kz', 'Ix', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                           ('Kz*f5', ['Kz', 'f5'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 2, 1)),
                           ('Kz*f11', ['Kz', 'f11'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (2, 0, 1)),
                           ('f14*f8', ['f14', 'f8'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 2, 1)),
                           ('f5*f8', ['f8', 'f5'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 2)),
                           ('f10*f4', ['f4', 'f10'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 2, 0)),
                           ('f4*f5', ['f4', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                           ('Kx*f5', ['Kx', 'f5'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 2, 0)),
                           ('Iz*Kx*f5', ['f5', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (3, 0, 0)),
                           ('Iz*Kx*f17', ['f17', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (3, 0, 0)),
                           ('Iy*Kx*f17', ['Iy', 'Kx', 'f17'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                           ('Kx*f17', ['Kx', 'f17'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 2)),
                           ('Kx*f1', ['f1', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                           ('Kx*f10', ['Kx', 'f10'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 2)),
                           ('Ix*Ky*f10', ['Ix', 'f10', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                           ('Ky*f10', ['f10', 'Ky'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 2)),
                           ('f10*f16', ['f16', 'f10'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (2, 1, 0)),
                           ('f14*f16', ['f16', 'f14'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                           ('Kz*f14', ['f14', 'Kz'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (2, 0, 1)),
                           ('Iy*Kz*f14', ['f14', 'Kz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 3)),
                           ('Iy*Kz*f15', ['f15', 'Kz', 'Iy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 3)),
                           ('Ix*Kz*f15', ['Kz', 'Ix', 'f15'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                           ('Kz*f15', ['f15', 'Kz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (2, 0, 1)),
                           ('Kz*f18', ['Kz', 'f18'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (2, 1, 0)),
                           ('Ky*f18', ['f18', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                           ('Ky*f14', ['f14', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (2, 1, 0)),
                           ('Iz*Ky*f14', ['f14', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 3, 0)),
                           ('Iz*Ky*f6', ['f6', 'Iz', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 3, 0)),
                           ('Ix*Ky*f6', ['f6', 'Ix', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                           ('Ky*f6', ['f6', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 2)),
                           ('Ky*f1', ['f1', 'Ky'])))),
 ('s', 'sp', 's', 'p'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(B00 + Ix*Kx)', ['B00', 'Kx', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('(B00 + Iy*Ky)', ['B00', 'Iy', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('(Iz*Kz + B00)', ['Kz', 'Iz', 'B00'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*Kx', ['Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*Ky', ['Iz', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Ky', ['Ix', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Kz', ['Kz', 'Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*Kz', ['Kz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Kx', ['Iy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx', ['Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky', ['Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz', ['Kz'])))),
 ('s', 'sp', 's', 's'): ({'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix', ['Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy', ['Iy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz', ['Iz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('1', [])))),
 ('s', 'sp', 's', 'sp'): ({'B00': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Kx': '(Xkl + Dx)',
                           'Ky': '(Ykl + Dy)',
                           'Kz': '(Dz + Zkl)',
                           'Xij': '',
                           'Xkl': '',
                           'Yij': '',
                           'Ykl': '',
                           'Zij': '',
                           'Zkl': ''},
                          ((((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('(B00 + Ix*Kx)', ['B00', 'Kx', 'Ix'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                            ('(B00 + Iy*Ky)', ['B00', 'Iy', 'Ky'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                            ('(Iz*Kz + B00)', ['Kz', 'Iz', 'B00'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Ix*Kz', ['Kz', 'Ix'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                            ('Iy*Kz', ['Kz', 'Iy'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                            ('Iy*Kx', ['Iy', 'Kx'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                            ('Iz*Kx', ['Iz', 'Kx'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                            ('Iz*Ky', ['Iz', 'Ky'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ix*Ky', ['Ix', 'Ky'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Ix', ['Ix'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Iy', ['Iy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Iz', ['Iz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Kx', ['Kx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ky', ['Ky'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Kz', ['Kz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('1', [])))),
 ('s', 'sp', 'sp', 's'): ({'B00': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Xij': '',
                           'Yij': '',
                           'Zij': ''},
                          ((((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(Dx*Ix + B00)', ['Dx', 'Ix', 'B00'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(Dy*Iy + B00)', ['Dy', 'B00', 'Iy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(B00 + Dz*Iz)', ['Dz', 'B00', 'Iz'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Ix', ['Dz', 'Ix'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Iy', ['Dz', 'Iy'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iy', ['Dx', 'Iy'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iz', ['Dx', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Iz', ['Dy', 'Iz'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Ix', ['Dy', 'Ix'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Ix', ['Ix'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Iy', ['Iy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Iz', ['Iz'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx', ['Dx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy', ['Dy'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz', ['Dz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('1', [])))),
 ('sp', 'd', 's', 's'): ({'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 0, 1), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*(B10 + Cz*Iz)', ['B10', 'Ix', 'Iz', 'Cz'])),
                          (((1, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*(Cx*Ix + B10)', ['B10', 'Ix', 'Iy', 'Cx'])),
                          (((1, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*(Cx*Ix + B10)', ['B10', 'Ix', 'Iz', 'Cx'])),
                          (((0, 1, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*(Cy*Iy + B10)', ['B10', 'Iy', 'Iz', 'Cy'])),
                          (((0, 0, 1), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*(B10 + pow(Iy,2))', ['B10', 'Cz', 'Iy'])),
                          (((0, 1, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(B10 + pow(Iz,2))', ['B10', 'Iz', 'Cy'])),
                          (((1, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Cx*(B10 + pow(Iz,2))', ['B10', 'Cx', 'Iz'])),
                          (((0, 0, 1), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iy*(B10 + Cz*Iz)', ['B10', 'Cz', 'Iy', 'Iz'])),
                          (((0, 0, 0), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Iz,2))', ['B10', 'Iz'])),
                          (((0, 0, 1), (0, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                            ['Zij', 'B10', 'Cz', 'Iz'])),
                          (((0, 0, 1), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*(B10 + pow(Ix,2))', ['B10', 'Cz', 'Ix'])),
                          (((1, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                            ['B10', 'Ix', 'Cx', 'Xij'])),
                          (((0, 0, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Ix,2))', ['B10', 'Ix'])),
                          (((0, 1, 0), (2, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*(B10 + pow(Ix,2))', ['B10', 'Ix', 'Cy'])),
                          (((1, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*(B10 + pow(Iy,2))', ['B10', 'Iy', 'Cx'])),
                          (((0, 1, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                            ['Yij', 'B10', 'Iy', 'Cy'])),
                          (((0, 0, 0), (0, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + pow(Iy,2))', ['B10', 'Iy'])),
                          (((0, 1, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*(Cy*Iy + B10)', ['B10', 'Ix', 'Iy', 'Cy'])),
                          (((0, 1, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*Iz', ['Ix', 'Iz', 'Cy'])),
                          (((1, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*Iz', ['Iy', 'Cx', 'Iz'])),
                          (((0, 0, 1), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*Iy', ['Cz', 'Iy', 'Ix'])),
                          (((0, 0, 0), (1, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy', ['Ix', 'Iy'])),
                          (((0, 0, 0), (1, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iz', ['Ix', 'Iz'])),
                          (((0, 0, 0), (0, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Iz', ['Iy', 'Iz'])))),
 ('sp', 'f', 's', 's'): ({'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'f1': '(B10*(3*Cx + 2*Xij) + Cx*pow(Ix,2))',
                          'f10': '(B10 + pow(Iz,2))',
                          'f11': '3*pow(B10,2)',
                          'f12': '(Cx*Ix + B10)',
                          'f13': '(3*B10 + pow(Iz,2))',
                          'f14': '(3*B10 + pow(Ix,2))',
                          'f15': '(B10 + Cz*Iz)',
                          'f3': '(3*B10 + pow(Iy,2))',
                          'f4': '(B10*(3*Cz + 2*Zij) + Cz*pow(Iz,2))',
                          'f5': '(Cy*Iy + B10)',
                          'f6': '(Cy*pow(Iy,2) + B10*(3*Cy + 2*Yij))',
                          'f8': '(B10 + pow(Iy,2))',
                          'f9': '(B10 + pow(Ix,2))',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(f11 + 3*B10*Ix*(Xij + 2*Cx) + Cx*pow(Ix,3))',
                            ['B10', 'Ix', 'f11', 'Xij', 'Cx'])),
                          (((0, 0, 1), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                           ('(f11 + Cz*pow(Iz,3) + 3*B10*Iz*(2*Cz + Zij))',
                            ['Zij', 'B10', 'Cz', 'f11', 'Iz'])),
                          (((0, 1, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                           ('(f11 + Cy*pow(Iy,3) + 3*B10*Iy*(Yij + 2*Cy))',
                            ['Yij', 'B10', 'Iy', 'f11', 'Cy'])),
                          (((0, 1, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*f10', ['Ix', 'f10', 'Cy'])),
                          (((1, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iy*Iz*f12', ['f12', 'Iy', 'Iz'])),
                          (((0, 1, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iz*f5', ['Ix', 'Iz', 'f5'])),
                          (((0, 0, 0), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy*Iz', ['Ix', 'Iy', 'Iz'])),
                          (((0, 0, 1), (1, 1, 1), (0, 0, 0), (0, 0, 0)),
                           ('Ix*Iy*f15', ['f15', 'Ix', 'Iy'])),
                          (((0, 1, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f6', ['f6', 'Ix'])),
                          (((1, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz*f8', ['f8', 'Cx', 'Iz'])),
                          (((0, 0, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f8', ['f8', 'Iz'])),
                          (((0, 1, 0), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f6', ['f6', 'Iz'])),
                          (((0, 0, 1), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('f15*f9', ['f15', 'f9'])),
                          (((0, 0, 1), (0, 2, 1), (0, 0, 0), (0, 0, 0)),
                           ('f15*f8', ['f15', 'f8'])),
                          (((1, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('f10*f12', ['f12', 'f10'])),
                          (((1, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('f12*f8', ['f8', 'f12'])),
                          (((0, 0, 0), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f8', ['Ix', 'f8'])),
                          (((0, 0, 1), (1, 2, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*f8', ['Cz', 'f8', 'Ix'])),
                          (((0, 0, 1), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix*f14', ['f14', 'Cz', 'Ix'])),
                          (((0, 1, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix*f14', ['f14', 'Ix', 'Cy'])),
                          (((0, 0, 0), (3, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f14', ['f14', 'Ix'])),
                          (((0, 0, 1), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f4', ['f4', 'Ix'])),
                          (((0, 0, 0), (1, 0, 2), (0, 0, 0), (0, 0, 0)),
                           ('Ix*f10', ['Ix', 'f10'])),
                          (((1, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*f10', ['Iy', 'Cx', 'f10'])),
                          (((0, 0, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f10', ['Iy', 'f10'])),
                          (((0, 1, 0), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                           ('f10*f5', ['f10', 'f5'])),
                          (((0, 1, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('f5*f9', ['f9', 'f5'])),
                          (((0, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f9', ['f9', 'Iz'])),
                          (((0, 1, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*f9', ['f9', 'Iz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz*f13', ['f13', 'Iz', 'Cy'])),
                          (((1, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz*f13', ['f13', 'Cx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 3), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f13', ['f13', 'Iz'])),
                          (((1, 0, 0), (2, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz*f1', ['f1', 'Iz'])),
                          (((1, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f1', ['f1', 'Iy'])),
                          (((0, 0, 0), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f9', ['f9', 'Iy'])),
                          (((0, 0, 1), (2, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*f9', ['f9', 'Cz', 'Iy'])),
                          (((0, 0, 1), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy*f3', ['Cz', 'Iy', 'f3'])),
                          (((1, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy*f3', ['Iy', 'Cx', 'f3'])),
                          (((0, 0, 0), (0, 3, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f3', ['Iy', 'f3'])),
                          (((0, 0, 1), (0, 1, 2), (0, 0, 0), (0, 0, 0)),
                           ('Iy*f4', ['f4', 'Iy'])))),
 ('sp', 'p', 'p', 'p'): ({'B00': '',
                          'B01': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f1': 'B01*B10',
                          'f11': '(B00 + Iy*Ky)',
                          'f12': '(B00 + Cy*Ky)',
                          'f13': '(Dy*Iy + B00)',
                          'f14': '(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                          'f15': '(Cx*Ix + B10)',
                          'f16': '(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                          'f18': '(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                          'f2': '(Dz*Kz + B01)',
                          'f20': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                          'f21': '(B01 + Dx*Kx)',
                          'f22': '(Cy*Iy + B10)',
                          'f23': '(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                          'f24': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                          'f26': '(B01 + Dy*Ky)',
                          'f28': '(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                          'f29': '(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                          'f3': '(B00 + Cx*Kx)',
                          'f30': '(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                          'f31': '2*pow(B00,2)',
                          'f36': '(B10 + Cz*Iz)',
                          'f4': '(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                          'f7': '(B00 + Dz*Iz)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B00*(Xij + 2*Cx)*(Xkl + 2*Dx) + f31 + B01*Cx*Ix + f1 + Dx*Kx*(Cx*Ix + B10))',
                            ['Dx',
                             'B00',
                             'Cx',
                             'Xij',
                             'B01',
                             'B10',
                             'f1',
                             'Xkl',
                             'f31',
                             'Ix',
                             'Kx'])),
                          (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                           ('(f31 + Dy*Ky*(Cy*Iy + B10) + B01*Cy*Iy + B00*(Yij + 2*Cy)*(Ykl + 2*Dy) + f1)',
                            ['B10',
                             'B00',
                             'Ykl',
                             'Dy',
                             'B01',
                             'f1',
                             'Yij',
                             'f31',
                             'Ky',
                             'Iy',
                             'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                           ('(Dz*Kz*(B10 + Cz*Iz) + f31 + B00*(2*Cz + Zij)*(2*Dz + Zkl) + f1 + B01*Cz*Iz)',
                            ['B10',
                             'B00',
                             'Cz',
                             'Zij',
                             'Kz',
                             'B01',
                             'Dz',
                             'f1',
                             'f31',
                             'Iz',
                             'Zkl'])),
                          (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Ix*(Cz*Zkl + Qz)',
                            ['Dy', 'Ix', 'Zkl', 'Qz', 'Cz'])),
                          (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                           ('Dy*(f14 + Zkl*(B10 + Cz*Iz))',
                            ['B10', 'Dy', 'Cz', 'Iz', 'f14', 'Zkl'])),
                          (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                           ('Dx*(f14 + Zkl*(B10 + Cz*Iz))',
                            ['Dx', 'B10', 'Cz', 'Iz', 'f14', 'Zkl'])),
                          (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Dx*(Iz*Zkl + f7)',
                            ['f7', 'Dx', 'Zkl', 'Iz', 'Cy'])),
                          (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                           ('Qx*(Iz*Zkl + f7)', ['f7', 'Qx', 'Zkl', 'Iz'])),
                          (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Dy*(Iz*Zkl + f7)',
                            ['Dy', 'f7', 'Zkl', 'Cx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                           ('Dy*(Iz*Zkl + f7)', ['Dy', 'Zkl', 'Iz', 'f7'])),
                          (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                           ('Qy*(Iz*Zkl + f7)', ['Zkl', 'Qy', 'Iz', 'f7'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                           ('Dx*(Iz*Zkl + f7)', ['f7', 'Dx', 'Zkl', 'Iz'])),
                          (((0, 0, 1), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*(f29 + Xij*(B01 + Dx*Kx))',
                            ['Dx', 'Xij', 'B01', 'Cz', 'f29', 'Kx'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(f29 + Xij*(B01 + Dx*Kx))',
                            ['Dx', 'B01', 'Xij', 'f29', 'Kx'])),
                          (((0, 1, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*(f29 + Xij*(B01 + Dx*Kx))',
                            ['Dx', 'Xij', 'B01', 'f29', 'Kx', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Dz*(Kx*Xij + f3)',
                            ['Dz', 'f3', 'Kx', 'Cy', 'Xij'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*(Kx*Xij + f3)', ['Dz', 'Kx', 'Xij', 'f3'])),
                          (((0, 1, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Qy*(Kx*Xij + f3)', ['Qy', 'Kx', 'Xij', 'f3'])),
                          (((0, 0, 1), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Dy*(Kx*Xij + f3)',
                            ['Dy', 'Cz', 'Kx', 'Xij', 'f3'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*(Kx*Xij + f3)', ['Dy', 'Kx', 'Xij', 'f3'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Qz*(Kx*Xij + f3)', ['f3', 'Qz', 'Xij', 'Kx'])),
                          (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('(Cz*Zkl + Qz)*(Dx*Xij + Qx)',
                            ['Dx', 'Xij', 'Qz', 'Cz', 'Qx', 'Zkl'])),
                          (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Iy*(Cz*Zkl + Qz)',
                            ['Zkl', 'Dx', 'Cz', 'Iy', 'Qz'])),
                          (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                           ('f13*(Cz*Zkl + Qz)',
                            ['f13', 'Zkl', 'Qz', 'Cz'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Dz*f11', ['Dz', 'Cx', 'f11'])),
                          (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Kz*f22', ['Dx', 'Kz', 'f22'])),
                          (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Ix*Kz*Qy', ['Kz', 'Ix', 'Qy'])),
                          (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Kz*f13', ['f13', 'Kz', 'Cx'])),
                          (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Kz*f15', ['Dy', 'Kz', 'f15'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*Ix*f2', ['Ix', 'f2', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ix*f12', ['Dz', 'Ix', 'f12'])),
                          (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Iz*f12', ['Dx', 'f12', 'Iz'])),
                          (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Ky*f36', ['Dx', 'f36', 'Ky'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ky*f15', ['Dz', 'f15', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Ix*Ky*Qz', ['Ix', 'Qz', 'Ky'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                           ('Iy*Kx*Qz', ['Iy', 'Kx', 'Qz'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Kx*f22', ['Dz', 'f22', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Kx*f36', ['Dy', 'f36', 'Kx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                           ('Iz*Kx*Qy', ['Qy', 'Iz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Iz*f3', ['Dy', 'Iz', 'f3'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Iy*f3', ['Dz', 'Iy', 'f3'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                          (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                           ('Iy*Kz*Qx', ['Qx', 'Kz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                          (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Kz*(Dx*Xij + Qx)',
                            ['Qx', 'Dx', 'Kz', 'Xij', 'Cy'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*(Dx*Xij + Qx)', ['Qx', 'Dx', 'Kz', 'Xij'])),
                          (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('f12*(Dx*Xij + Qx)',
                            ['Dx', 'Qx', 'f12', 'Xij'])),
                          (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Ky*(Dx*Xij + Qx)',
                            ['Qx', 'Dx', 'Cz', 'Xij', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'Ky'])),
                          (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                           ('Iz*Ky*Qx', ['Qx', 'Iz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                          (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f23', ['Dx', 'f23'])),
                          (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Ix*f28', ['Ix', 'f28'])),
                          (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                           ('Cx*Iz*f26', ['f26', 'Cx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                           ('Iz*f26', ['Iz', 'f26'])),
                          (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                           ('Iz*f28', ['Iz', 'f28'])),
                          (((0, 0, 1), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                           ('f21*f36', ['f36', 'f21'])),
                          (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                           ('f26*f36', ['f36', 'f26'])),
                          (((1, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f18', ['Dy', 'f18'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f18', ['Dz', 'f18'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f23', ['Dz', 'f23'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f11', ['Dz', 'f11'])),
                          (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                           ('Qx*f11', ['Qx', 'f11'])),
                          (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Dx*f11', ['Dx', 'Cz', 'f11'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f11', ['Dx', 'f11'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                           ('Qz*f11', ['Qz', 'f11'])),
                          (((0, 1, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*f24', ['f24', 'Kx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Kx*f7', ['f7', 'Kx', 'Cy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                           ('Kx*f7', ['f7', 'Kx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Ky*f7', ['f7', 'Cx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                           ('Ky*f7', ['f7', 'Ky'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                           ('f12*f7', ['f7', 'f12'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                           ('f3*f7', ['f7', 'f3'])),
                          (((1, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                           ('f13*f3', ['f13', 'f3'])),
                          (((0, 0, 1), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Kx*f13', ['f13', 'Cz', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*f13', ['f13', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                           ('Kx*f14', ['f14', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                           ('Ky*f14', ['f14', 'Ky'])),
                          (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*f20', ['f20', 'Ky'])),
                          (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*f20', ['Kz', 'f20'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*f13', ['f13', 'Kz'])),
                          (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*f24', ['f24', 'Kz'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('f15*f2', ['f15', 'f2'])),
                          (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('f15*f26', ['f15', 'f26'])),
                          (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*Ix*f26', ['Cz', 'Ix', 'f26'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Ix*f26', ['Ix', 'f26'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Ix*f30', ['Ix', 'f30'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Ix*f2', ['Ix', 'f2'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*Iy*f2', ['Iy', 'Cx', 'f2'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                           ('Iy*f2', ['Iy', 'f2'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                           ('f2*f22', ['f22', 'f2'])),
                          (((0, 1, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                           ('f21*f22', ['f22', 'f21'])),
                          (((0, 1, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                           ('Cy*Iz*f21', ['f21', 'Iz', 'Cy'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                           ('Iz*f21', ['Iz', 'f21'])),
                          (((1, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                           ('Iz*f29', ['Iz', 'f29'])),
                          (((1, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                           ('Iy*f29', ['Iy', 'f29'])),
                          (((0, 0, 1), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*Iy*f21', ['Cz', 'Iy', 'f21'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                           ('Iy*f21', ['Iy', 'f21'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                           ('Iy*f30', ['f30', 'Iy'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                           ('Cx*f16', ['f16', 'Cx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                           ('Cy*f16', ['f16', 'Cy'])),
                          (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*f4', ['f4', 'Cz'])),
                          (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*f4', ['f4', 'Cx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                           ('f4', ['f4'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                           ('f16', ['f16'])))),
 ('sp', 'p', 'p', 's'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f1': '(B00 + Dz*Iz)',
                          'f11': '(B10 + Cz*Iz)',
                          'f12': '(Cy*Iy + B10)',
                          'f6': '(Cx*Ix + B10)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                            ['B10', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                            ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz'])),
                          (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                            ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00'])),
                          (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'Cy'])),
                          (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*(Dx*Xij + Qx)', ['Qx', 'Dx', 'Cz', 'Xij'])),
                          (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij'])),
                          (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*(Dy*Yij + Qy)', ['Dy', 'Cz', 'Qy', 'Yij'])),
                          (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*(Dy*Yij + Qy)', ['Dy', 'Qy', 'Cx', 'Yij'])),
                          (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                           ('(Dy*Yij + Qy)', ['Dy', 'Qy', 'Yij'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Ix*Qy', ['Ix', 'Qy'])),
                          (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Iz', ['Dy', 'Iz'])),
                          (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Iz*Qy', ['Qy', 'Iz'])),
                          (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f11', ['Dx', 'f11'])),
                          (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f11', ['Dy', 'f11'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f6', ['Dz', 'f6'])),
                          (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*f6', ['Dy', 'f6'])),
                          (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                          (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy*Ix', ['Dy', 'Ix'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Ix*Qz', ['Ix', 'Qz'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Ix', ['Dz', 'Ix'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*Iy', ['Dz', 'Iy'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz*f12', ['Dz', 'f12'])),
                          (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*f12', ['Dx', 'f12'])),
                          (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                          (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iz', ['Dx', 'Iz'])),
                          (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                           ('Iz*Qx', ['Qx', 'Iz'])),
                          (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Iy*Qx', ['Qx', 'Iy'])),
                          (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                          (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx*Iy', ['Dx', 'Iy'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                           ('Iy*Qz', ['Iy', 'Qz'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cx*f1', ['f1', 'Cx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('Cy*f1', ['f1', 'Cy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                           ('f1', ['f1'])))),
 ('sp', 'p', 's', 'p'): ({'B00': '',
                          'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f10': '(B00 + Cy*Ky)',
                          'f11': '(Cx*Ix + B10)',
                          'f13': '(B10 + Cz*Iz)',
                          'f14': '(Cy*Iy + B10)',
                          'f3': '(B00 + Ix*Kx)',
                          'f4': '(Iz*Kz + B00)',
                          'f7': '(B00 + Iy*Ky)',
                          'f9': '(B00 + Cx*Kx)',
                          'Xij': '',
                          'Xkl': '',
                          'Yij': '',
                          'Ykl': '',
                          'Zij': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                            ['B10', 'Ix', 'Cx', 'Xij', 'B00', 'Kx'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                            ['B10', 'Yij', 'B00', 'Ky', 'Iy', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('(Kz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                            ['B10', 'B00', 'Zij', 'Kz', 'Cz', 'Iz'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*(B00 + Cz*Kz)', ['Kz', 'Ix', 'Cz', 'B00'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*(B00 + Cz*Kz)', ['Kz', 'B00', 'Iy', 'Cz'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Iy*Kz', ['Kz', 'Iy', 'Cx'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ix*Ky', ['Cz', 'Ky', 'Ix'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky*f11', ['f11', 'Ky'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*f10', ['Ix', 'f10'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx*f14', ['f14', 'Kx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Iz*Kx', ['Iz', 'Cy', 'Kx'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*Kx', ['Iz', 'Kx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Iz*Ky', ['Cx', 'Ky', 'Iz'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*Ky', ['Iz', 'Ky'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Iz*f10', ['Iz', 'f10'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Iz*f9', ['f9', 'Iz'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*f9', ['f9', 'Iy'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Iy*Kx', ['Cz', 'Iy', 'Kx'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                           ('Iy*Kx', ['Iy', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                           ('Kx*f13', ['f13', 'Kx'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                           ('Ky*f13', ['f13', 'Ky'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ix*Ky', ['Ix', 'Ky'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Ix*Kz', ['Kz', 'Ix', 'Cy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Ix*Kz', ['Kz', 'Ix'])),
                          (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*f11', ['Kz', 'f11'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Iy*Kz', ['Kz', 'Iy'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz*f14', ['f14', 'Kz'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*f3', ['Cz', 'f3'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*f7', ['f7', 'Cz'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*f7', ['f7', 'Cx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('Cx*f4', ['f4', 'Cx'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('Cy*f4', ['f4', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*f3', ['f3', 'Cy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('f3', ['f3'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                           ('f7', ['f7'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                           ('f4', ['f4'])))),
 ('sp', 'p', 's', 's'): ({'B10': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Ix': '(Cx + Xij)',
                          'Iy': '(Cy + Yij)',
                          'Iz': '(Cz + Zij)',
                          'Xij': '',
                          'Yij': '',
                          'Zij': ''},
                         ((((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                          (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                          (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                          (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Ix', ['Cz', 'Ix'])),
                          (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz*Iy', ['Cz', 'Iy'])),
                          (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iy', ['Iy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cx*Iz', ['Cx', 'Iz'])),
                          (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Iz', ['Iz', 'Cy'])),
                          (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy*Ix', ['Ix', 'Cy'])),
                          (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Ix', ['Ix'])),
                          (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                           ('Iy', ['Iy'])),
                          (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                           ('Iz', ['Iz'])))),
 ('sp', 'p', 'sp', 'p'): ({'B00': '',
                           'B01': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Kx': '(Xkl + Dx)',
                           'Ky': '(Ykl + Dy)',
                           'Kz': '(Dz + Zkl)',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)',
                           'f1': 'B01*B10',
                           'f14': '(Cx*Ix + B10)',
                           'f2': '(B00 + Cx*Kx)',
                           'f21': '(B01 + Dx*Kx)',
                           'f22': '(Cy*Iy + B10)',
                           'f26': '(B01 + Dy*Ky)',
                           'f3': '(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                           'f30': '(Dz*Kz + B01)',
                           'f32': '2*pow(B00,2)',
                           'f37': '(B10 + Cz*Iz)',
                           'Xij': '',
                           'Xkl': '',
                           'Yij': '',
                           'Ykl': '',
                           'Zij': '',
                           'Zkl': ''},
                          ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('(f32 + Dy*Ky*(Cy*Iy + B10) + B01*Cy*Iy + B00*(Yij + 2*Cy)*(Ykl + 2*Dy) + f1)',
                             ['B10',
                              'f1',
                              'Ykl',
                              'Dy',
                              'B01',
                              'Yij',
                              'B00',
                              'Cy',
                              'Ky',
                              'Iy',
                              'f32'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('(B00 + Cz*Kz)*(Dx*Ix + B00)',
                             ['Kz', 'Dx', 'B00', 'Ix', 'Cz'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('(B00 + Cy*Ky)*(Dx*Ix + B00)',
                             ['Ix', 'Dx', 'B00', 'Ky', 'Cy'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Dx*(B00 + Iy*Ky)',
                             ['Dx', 'Cz', 'Iy', 'Ky', 'B00'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('(B00 + Cz*Kz)*(Dy*Iy + B00)',
                             ['Kz', 'B00', 'Iy', 'Cz', 'Dy'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('(Dz*Kz*(B10 + Cz*Iz) + f32 + B00*(2*Cz + Zij)*(2*Dz + Zkl) + f1 + B01*Cz*Iz)',
                             ['B10',
                              'B00',
                              'Zij',
                              'Kz',
                              'B01',
                              'Dz',
                              'f1',
                              'Cz',
                              'Iz',
                              'Zkl',
                              'f32'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('Cx*(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                             ['Cx', 'Kz', 'B01', 'Dz', 'B00', 'Iz', 'Zkl'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('Cy*(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                             ['Kz', 'B01', 'Dz', 'B00', 'Iz', 'Zkl', 'Cy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('(B00*(2*Dz + Zkl) + Iz*(Dz*Kz + B01))',
                             ['Kz', 'B01', 'Dz', 'B00', 'Iz', 'Zkl'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Iy*(B00 + Cz*Kz)',
                             ['Kz', 'Dx', 'B00', 'Iy', 'Cz'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Iy*Kx*Qz', ['Iy', 'Kx', 'Qz'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('Iy*(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                             ['B00', 'Zkl', 'Kz', 'B01', 'Dz', 'Cz', 'Iy'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Ix*(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                             ['Ix', 'Kz', 'B01', 'Dz', 'Cz', 'Zkl', 'B00'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Ix*(B00 + Cz*Kz)',
                             ['Kz', 'Dy', 'Ix', 'Cz', 'B00'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Ix*(B00 + Cz*Kz)', ['Kz', 'Ix', 'Cz', 'B00'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                            ('Iy*(B00 + Cz*Kz)', ['Kz', 'B00', 'Iy', 'Cz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('f2*(B00 + Dz*Iz)', ['Dz', 'B00', 'Iz', 'f2'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Qz*(Kx*Xij + f2)', ['f2', 'Qz', 'Xij', 'Kx'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['B10', 'Ix', 'Cx', 'Xij', 'Dz', 'B00', 'Kx'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['B10', 'Ix', 'Cx', 'Xij', 'Dy', 'B00', 'Kx'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(B00*(Xij + 2*Cx)*(Xkl + 2*Dx) + f32 + B01*Cx*Ix + f1 + Dx*Kx*(Cx*Ix + B10))',
                             ['Dx',
                              'Ix',
                              'Cx',
                              'Xij',
                              'B01',
                              'B10',
                              'f1',
                              'Xkl',
                              'B00',
                              'Kx',
                              'f32'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('Iz*(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                             ['Dx', 'Cx', 'B01', 'Xkl', 'B00', 'Iz', 'Kx'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Iz*Ky*Qx', ['Qx', 'Iz', 'Ky'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Ky*(Dx*Ix + B00)',
                             ['Dx', 'Cz', 'Ix', 'Ky', 'B00'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00', 'Ky'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*(Dx*Ix + B00)', ['Dx', 'Ix', 'Ky', 'B00'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Iy*Kz*Qx', ['Qx', 'Kz', 'Iy'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('Iy*(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                             ['Dx', 'Cx', 'B01', 'Xkl', 'B00', 'Iy', 'Kx'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*(Ix*(B01 + Dx*Kx) + B00*(Xkl + 2*Dx))',
                             ['Dx', 'Ix', 'B01', 'Xkl', 'Cz', 'Kx', 'B00'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(Ix*(B01 + Dx*Kx) + B00*(Xkl + 2*Dx))',
                             ['Dx', 'Ix', 'B01', 'Xkl', 'B00', 'Kx'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*(Ix*(B01 + Dx*Kx) + B00*(Xkl + 2*Dx))',
                             ['Dx', 'Ix', 'B01', 'Xkl', 'B00', 'Kx', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Qy*(Kx*Xij + f2)', ['f2', 'Qy', 'Kx', 'Xij'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*(Kx*Xij + f2)', ['Dy', 'f2', 'Kx', 'Xij'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Dy*(Kx*Xij + f2)',
                             ['Dy', 'f2', 'Cz', 'Kx', 'Xij'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cz*(Kx*Xij + f2)', ['f2', 'Cz', 'Kx', 'Xij'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*(Kx*Xij + f2)', ['Dz', 'f2', 'Kx', 'Xij'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Dz*(Kx*Xij + f2)',
                             ['Dz', 'f2', 'Kx', 'Cy', 'Xij'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*(Kx*Xij + f2)', ['f2', 'Kx', 'Cy', 'Xij'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('(Kx*Xij + f2)', ['f2', 'Kx', 'Xij'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['B10', 'Ix', 'Cx', 'Xij', 'B00', 'Kx'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['Dx', 'Ix', 'Cx', 'Xij', 'Kz', 'B10', 'B00'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*(Dx*Ix + B00)', ['Dx', 'Kz', 'Ix', 'B00'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Kz*(Dx*Ix + B00)',
                             ['Dx', 'Kz', 'Ix', 'Cy', 'B00'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Ix*Kz*Qy', ['Kz', 'Ix', 'Qy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                             ['B10', 'Dy', 'Kz', 'Yij', 'B00', 'Iy', 'Cy'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Kz*(Dy*Iy + B00)',
                             ['Dy', 'Kz', 'Iy', 'Cx', 'B00'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*(Dy*Iy + B00)', ['Dy', 'Kz', 'Iy', 'B00'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('f2*(Dy*Iy + B00)', ['Dy', 'B00', 'Iy', 'f2'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Kx*(Dy*Iy + B00)',
                             ['Dy', 'Cz', 'Iy', 'Kx', 'B00'])),
                           (((0, 1, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                             ['B10', 'Dy', 'Yij', 'B00', 'Iy', 'Kx', 'Cy'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*(Dy*Iy + B00)', ['Dy', 'B00', 'Iy', 'Kx'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Iz*Kx*Qy', ['Qy', 'Iz', 'Kx'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Iz*(B00 + Cy*Ky)',
                             ['Dx', 'B00', 'Ky', 'Iz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                            ('Iz*(B00 + Cy*Ky)', ['Ky', 'B00', 'Iz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('Iz*(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                             ['Dy', 'B01', 'Ykl', 'B00', 'Iz', 'Ky', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Ix*(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                             ['Ix', 'Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ix*(B00 + Cy*Ky)', ['Ix', 'Ky', 'Cy', 'B00'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ix*(B00 + Cy*Ky)',
                             ['Dz', 'Ix', 'Ky', 'Cy', 'B00'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Dz*(B00 + Iy*Ky)',
                             ['Dz', 'B00', 'Iy', 'Cx', 'Ky'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*(B00 + Iy*Ky)', ['Dz', 'B00', 'Iy', 'Ky'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                             ['B10', 'Dz', 'Yij', 'B00', 'Ky', 'Iy', 'Cy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                            ('(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                             ['B10', 'Yij', 'B00', 'Ky', 'Iy', 'Cy'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                             ['Dx', 'B10', 'Yij', 'B00', 'Ky', 'Iy', 'Cy'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*(B00 + Iy*Ky)', ['Dx', 'B00', 'Iy', 'Ky'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Qx*(B00 + Iy*Ky)', ['Qx', 'Iy', 'Ky', 'B00'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*(B00 + Iy*Ky)', ['B00', 'Iy', 'Cx', 'Ky'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                            ('(B00 + Iy*Ky)', ['B00', 'Iy', 'Ky'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cz*(B00 + Iy*Ky)', ['Cz', 'Iy', 'Ky', 'B00'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Qz*(B00 + Iy*Ky)', ['B00', 'Iy', 'Qz', 'Ky'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('(B00 + Cy*Ky)*(B00 + Dz*Iz)',
                             ['Dz', 'B00', 'Ky', 'Cy', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Qy*(Iz*Kz + B00)', ['Kz', 'Qy', 'Iz', 'B00'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Dy*(Iz*Kz + B00)',
                             ['B00', 'Dy', 'Kz', 'Cx', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Dy*(Iz*Kz + B00)', ['Dy', 'Kz', 'Iz', 'B00'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Dy*(Kz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['B10', 'B00', 'Zij', 'Dy', 'Kz', 'Cz', 'Iz'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                            ('(Kz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['B10', 'B00', 'Zij', 'Kz', 'Cz', 'Iz'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Dx*(Kz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['Dx', 'Cz', 'Zij', 'Kz', 'B10', 'B00', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Dx*(Iz*Kz + B00)',
                             ['Dx', 'Kz', 'Iz', 'Cy', 'B00'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Dx*(Iz*Kz + B00)', ['Dx', 'Kz', 'Iz', 'B00'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Qx*(Iz*Kz + B00)', ['Kz', 'Qx', 'Iz', 'B00'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                            ('Cx*(Iz*Kz + B00)', ['B00', 'Kz', 'Cx', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                            ('(Iz*Kz + B00)', ['Kz', 'Iz', 'B00'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                            ('Cy*(Iz*Kz + B00)', ['Kz', 'Iz', 'Cy', 'B00'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Kx*(B00 + Dz*Iz)',
                             ['Dz', 'B00', 'Kx', 'Cy', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('Kx*(B00 + Dz*Iz)', ['Dz', 'B00', 'Kx', 'Iz'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('Kx*(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz', 'Kx'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('Ky*(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz', 'Ky'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Ky*(B00 + Dz*Iz)',
                             ['Dz', 'B00', 'Cx', 'Ky', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('Ky*(B00 + Dz*Iz)', ['Dz', 'B00', 'Iz', 'Ky'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Ix*Ky*Qz', ['Ix', 'Qz', 'Ky'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ky*f14', ['Dz', 'f14', 'Ky'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Kz*f22', ['Dx', 'Kz', 'f22'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*Iy*Kz', ['Kz', 'Iy', 'Cx'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*Iy*f30', ['f30', 'Iy', 'Cx'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('Cx*Iz*f26', ['f26', 'Cx', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('Cy*Iz*f21', ['f21', 'Iz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                            ('Cy*Iz*Kx', ['Iz', 'Cy', 'Kx'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Kx*f22', ['Dz', 'f22', 'Kx'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                            ('Kx*f22', ['f22', 'Kx'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Iy*f2', ['Dz', 'Iy', 'f2'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                            ('Iy*f2', ['Iy', 'f2'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Iz*f2', ['Dy', 'Iz', 'f2'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                            ('Iz*f2', ['Iz', 'f2'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                            ('Iz*Kx', ['Iz', 'Kx'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Kx*f37', ['Dy', 'Kx', 'f37'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                            ('Kx*f37', ['f37', 'Kx'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                            ('Iy*Kx', ['Iy', 'Kx'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cz*Iy*Kx', ['Cz', 'Iy', 'Kx'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*Iy*f21', ['Cz', 'Iy', 'f21'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('Iy*f21', ['Iy', 'f21'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('f21*f22', ['f22', 'f21'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('Iz*f21', ['Iz', 'f21'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('f21*f37', ['f37', 'f21'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Ky*f37', ['f37', 'Dx', 'Ky'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                            ('Cx*Iz*Ky', ['Cx', 'Ky', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                            ('Iz*Ky', ['Iz', 'Ky'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                            ('Ky*f37', ['f37', 'Ky'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ky*f14', ['f14', 'Ky'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('f14*f26', ['f14', 'f26'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('Iz*f26', ['Iz', 'f26'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('f26*f37', ['f37', 'f26'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Ix*f26', ['Ix', 'f26'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*Ix*f26', ['Cz', 'Ix', 'f26'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cz*Ix*Ky', ['Cz', 'Ky', 'Ix'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ix*Ky', ['Ix', 'Ky'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Kz*f14', ['Dy', 'f14', 'Kz'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Kz*f14', ['f14', 'Kz'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                            ('Iy*Kz', ['Kz', 'Iy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                            ('Kz*f22', ['Kz', 'f22'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Ix*Kz', ['Kz', 'Ix'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cy*Ix*Kz', ['Kz', 'Ix', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cy*Ix*f30', ['Ix', 'f30', 'Cy'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Ix*f30', ['Ix', 'f30'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('f14*f30', ['f14', 'f30'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('Iy*f30', ['f30', 'Iy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('f22*f30', ['f22', 'f30'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*f3', ['Cz', 'f3'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*f3', ['Cx', 'f3'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('f3', ['f3'])))),
 ('sp', 'p', 'sp', 's'): ({'B00': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)',
                           'Xij': '',
                           'Yij': '',
                           'Zij': ''},
                          ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                             ['B10', 'Dy', 'Yij', 'B00', 'Iy', 'Cy'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                             ['B10', 'B00', 'Zij', 'Dz', 'Cz', 'Iz'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                             ['Dx', 'Ix', 'Cx', 'Xij', 'B10', 'B00'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*(Cx*Ix + B10)', ['Dy', 'B10', 'Ix', 'Cx'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*(Cx*Ix + B10)', ['Dz', 'B10', 'Ix', 'Cx'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*(Dx*Xij + Qx)', ['Qx', 'Dx', 'Cz', 'Xij'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'Cy'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*(B10 + Cz*Iz)', ['Dx', 'Cz', 'B10', 'Iz'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*(B10 + Cz*Iz)', ['Dy', 'B10', 'Cz', 'Iz'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*(Dy*Yij + Qy)', ['Dy', 'Cz', 'Qy', 'Yij'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*(Dy*Yij + Qy)', ['Dy', 'Qy', 'Cx', 'Yij'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(Dy*Yij + Qy)', ['Dy', 'Qy', 'Yij'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*(Cy*Iy + B10)', ['Dx', 'Iy', 'B10', 'Cy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*(Cy*Iy + B10)', ['Dz', 'B10', 'Iy', 'Cy'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cy*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz', 'Cy'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*(Dz*Zij + Qz)', ['Dz', 'Zij', 'Cx', 'Qz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(Dz*Zij + Qz)', ['Dz', 'Zij', 'Qz'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Ix*Qz', ['Ix', 'Qz'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Iz*Qx', ['Qx', 'Iz'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Iy*Qx', ['Qx', 'Iy'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Iy', ['Cz', 'Iy'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iy', ['Iy', 'Cx'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Iy', ['Dz', 'Iy'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Iy*Qz', ['Iy', 'Qz'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iy', ['Dx', 'Iy'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iz', ['Dx', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Iz', ['Iz', 'Cy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Iz', ['Dy', 'Iz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iz', ['Cx', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Iz*Qy', ['Qy', 'Iz'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Ix*Qy', ['Ix', 'Qy'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Ix', ['Dy', 'Ix'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Ix', ['Cz', 'Ix'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Ix', ['Dz', 'Ix'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Ix', ['Ix', 'Cy'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Ix', ['Ix'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Iy', ['Iy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Iz', ['Iz'])))),
 ('sp', 's', 'd', 's'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'Rx': '(B01 + pow(Dx,2))',
                          'Ry': '(B01 + pow(Dy,2))',
                          'Rz': '(pow(Dz,2) + B01)'},
                         ((((1, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('(2*B00*Dx + Cx*Rx)',
                            ['Rx', 'Dx', 'B00', 'Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('(2*B00*Dy + Cy*Ry)',
                            ['Dy', 'B00', 'Cy', 'Ry'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('(2*B00*Dz + Cz*Rz)',
                            ['Dz', 'Rz', 'B00', 'Cz'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Cy*Dx*Dz', ['Dz', 'Dx', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Qy', ['Dx', 'Qy'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Dz', ['Dz', 'Dx'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dx*Qz', ['Dx', 'Qz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cy*Rz', ['Rz', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Cx*Rz', ['Rz', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Cx*Dy*Dz', ['Dz', 'Dy', 'Cx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Dz', ['Dz', 'Dy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dz*Qy', ['Dz', 'Qy'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 1), (0, 0, 0)),
                           ('Dz*Qx', ['Dz', 'Qx'])),
                          (((1, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dy*Qx', ['Dy', 'Qx'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Dx*Dy', ['Dy', 'Dx'])),
                          (((0, 0, 1), (0, 0, 0), (1, 1, 0), (0, 0, 0)),
                           ('Cz*Dx*Dy', ['Dy', 'Dx', 'Cz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cz*Ry', ['Cz', 'Ry'])),
                          (((1, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Cx*Ry', ['Cx', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 0), (0, 0, 0)),
                           ('Ry', ['Ry'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 1), (0, 0, 0)),
                           ('Dy*Qz', ['Dy', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cz*Rx', ['Rx', 'Cz'])),
                          (((0, 1, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Cy*Rx', ['Rx', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 0), (0, 0, 0)),
                           ('Rx', ['Rx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 2), (0, 0, 0)),
                           ('Rz', ['Rz'])))),
 ('sp', 's', 'f', 's'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'Rx': '(B01 + pow(Dx,2))',
                          'Ry': '(B01 + pow(Dy,2))',
                          'Rz': '(pow(Dz,2) + B01)',
                          'f0': '(3*B01 + pow(Dx,2))',
                          'f10': '3*B00*B01',
                          'f12': '(2*B00*Dy + Cy*Ry)',
                          'f2': '(2*B00*Dz + Cz*Rz)',
                          'f3': '(pow(Dz,2) + 3*B01)',
                          'f5': '(3*B01 + pow(Dy,2))',
                          'f7': '(2*B00*Dx + Cx*Rx)'},
                         ((((0, 1, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                           ('(3*B01*Cy*Dy + f10 + Cy*pow(Dy,3) + 3*B00*pow(Dy,2))',
                            ['Dy', 'B00', 'B01', 'f10', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                           ('(f10 + 3*B00*pow(Dz,2) + 3*B01*Cz*Dz + Cz*pow(Dz,3))',
                            ['Dz', 'B00', 'B01', 'f10', 'Cz'])),
                          (((1, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                           ('(f10 + Cx*pow(Dx,3) + 3*B00*pow(Dx,2) + 3*B01*Cx*Dx)',
                            ['Dx', 'B00', 'B01', 'Cx', 'f10'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                           ('Cy*Dx*Rz', ['Dx', 'Rz', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dy*Dz*Qx', ['Dz', 'Dy', 'Qx'])),
                          (((0, 1, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dx*Dz*Qy', ['Dz', 'Dx', 'Qy'])),
                          (((0, 0, 0), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dx*Dy*Dz', ['Dz', 'Dy', 'Dx'])),
                          (((0, 0, 1), (0, 0, 0), (1, 1, 1), (0, 0, 0)),
                           ('Dx*Dy*Qz', ['Dy', 'Dx', 'Qz'])),
                          (((0, 1, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                           ('Dx*f12', ['Dx', 'f12'])),
                          (((1, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                           ('Cx*Dz*Ry', ['Dz', 'Cx', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                           ('Dz*Ry', ['Dz', 'Ry'])),
                          (((0, 1, 0), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                           ('Dz*f12', ['Dz', 'f12'])),
                          (((0, 0, 1), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                           ('Qz*Rx', ['Rx', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 2, 1), (0, 0, 0)),
                           ('Qz*Ry', ['Qz', 'Ry'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                           ('Qx*Rz', ['Rz', 'Qx'])),
                          (((1, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                           ('Qx*Ry', ['Qx', 'Ry'])),
                          (((0, 0, 0), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                           ('Dx*Ry', ['Dx', 'Ry'])),
                          (((0, 0, 1), (0, 0, 0), (1, 2, 0), (0, 0, 0)),
                           ('Cz*Dx*Ry', ['Dx', 'Cz', 'Ry'])),
                          (((0, 0, 1), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                           ('Cz*Dx*f0', ['Dx', 'Cz', 'f0'])),
                          (((0, 1, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                           ('Cy*Dx*f0', ['Dx', 'f0', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (3, 0, 0), (0, 0, 0)),
                           ('Dx*f0', ['Dx', 'f0'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                           ('Dx*f2', ['Dx', 'f2'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 2), (0, 0, 0)),
                           ('Dx*Rz', ['Dx', 'Rz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                           ('Cx*Dy*Rz', ['Dy', 'Rz', 'Cx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                           ('Dy*Rz', ['Dy', 'Rz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                           ('Qy*Rz', ['Rz', 'Qy'])),
                          (((0, 1, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                           ('Qy*Rx', ['Rx', 'Qy'])),
                          (((0, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                           ('Dz*Rx', ['Dz', 'Rx'])),
                          (((0, 1, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                           ('Cy*Dz*Rx', ['Dz', 'Rx', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                           ('Cy*Dz*f3', ['Dz', 'f3', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                           ('Cx*Dz*f3', ['Dz', 'Cx', 'f3'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 3), (0, 0, 0)),
                           ('Dz*f3', ['Dz', 'f3'])),
                          (((1, 0, 0), (0, 0, 0), (2, 0, 1), (0, 0, 0)),
                           ('Dz*f7', ['Dz', 'f7'])),
                          (((1, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                           ('Dy*f7', ['Dy', 'f7'])),
                          (((0, 0, 0), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                           ('Dy*Rx', ['Rx', 'Dy'])),
                          (((0, 0, 1), (0, 0, 0), (2, 1, 0), (0, 0, 0)),
                           ('Cz*Dy*Rx', ['Rx', 'Dy', 'Cz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                           ('Cz*Dy*f5', ['Dy', 'Cz', 'f5'])),
                          (((1, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                           ('Cx*Dy*f5', ['Dy', 'Cx', 'f5'])),
                          (((0, 0, 0), (0, 0, 0), (0, 3, 0), (0, 0, 0)),
                           ('Dy*f5', ['Dy', 'f5'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 2), (0, 0, 0)),
                           ('Dy*f2', ['Dy', 'f2'])))),
 ('sp', 's', 'p', 'p'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)',
                          'f7': '(B00 + Cy*Ky)',
                          'f9': '(B00 + Cx*Kx)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(Cy*Dy*Ky + B01*Cy + B00*(Ykl + 2*Dy))',
                            ['Dy', 'B01', 'Ykl', 'B00', 'Ky', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01*Cx + Cx*Dx*Kx + B00*(Xkl + 2*Dx))',
                            ['Dx', 'Cx', 'B01', 'Xkl', 'B00', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*(Cz*Zkl + Qz)', ['Dx', 'Cz', 'Zkl', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*(Cz*Zkl + Qz)', ['Dy', 'Cz', 'Zkl', 'Qz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Cx*Dy*Kz', ['Dy', 'Kz', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cx*(B01 + Dy*Ky)', ['Dy', 'B01', 'Cx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('(B01 + Dy*Ky)', ['Dy', 'B01', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                           ('Cz*(B01 + Dy*Ky)', ['Dy', 'Cz', 'B01', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(B01*Cz + B00*(2*Dz + Zkl) + Cz*Dz*Kz)',
                            ['B00', 'Kz', 'B01', 'Dz', 'Cz', 'Zkl'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cy*(Dz*Kz + B01)', ['Dz', 'Kz', 'B01', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('Cx*(Dz*Kz + B01)', ['Dz', 'Kz', 'B01', 'Cx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                           ('(Dz*Kz + B01)', ['Dz', 'Kz', 'B01'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cy*(B01 + Dx*Kx)', ['Dx', 'B01', 'Kx', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('(B01 + Dx*Kx)', ['Dx', 'B01', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                           ('Cz*(B01 + Dx*Kx)', ['Dx', 'Cz', 'B01', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Cz*Dx*Ky', ['Dx', 'Cz', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Ky*Qx', ['Qx', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*f7', ['f7', 'Dx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Kx*Qy', ['Qy', 'Kx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Cy*Dz*Kx', ['Dz', 'Kx', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*Kx', ['Dz', 'Kx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Cx*Dz*Ky', ['Dz', 'Cx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*Ky', ['Dz', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Dz*f7', ['Dz', 'f7'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Dz*f9', ['Dz', 'f9'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*f9', ['Dy', 'f9'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Cz*Dy*Kx', ['Dy', 'Cz', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                           ('Dy*Kx', ['Dy', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                           ('Kx*Qz', ['Kx', 'Qz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                           ('Ky*Qz', ['Qz', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                           ('Dx*Ky', ['Dx', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Cy*Dx*Kz', ['Dx', 'Kz', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Dx*Kz', ['Dx', 'Kz'])),
                          (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                           ('Kz*Qx', ['Qx', 'Kz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Dy*Kz', ['Dy', 'Kz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                           ('Kz*Qy', ['Kz', 'Qy'])))),
 ('sp', 's', 'p', 's'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Qx': '(Cx*Dx + B00)',
                          'Qy': '(Cy*Dy + B00)',
                          'Qz': '(Cz*Dz + B00)'},
                         ((((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Qx', ['Qx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Qy', ['Qy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Qz', ['Qz'])),
                          (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cz*Dx', ['Dx', 'Cz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cz*Dy', ['Dy', 'Cz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Cx*Dy', ['Dy', 'Cx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cx*Dz', ['Dz', 'Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Cy*Dz', ['Dz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Cy*Dx', ['Dx', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                           ('Dx', ['Dx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                           ('Dy', ['Dy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                           ('Dz', ['Dz'])))),
 ('sp', 's', 's', 'd'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f2': '(pow(Kz,2) + B01)',
                          'f4': '(pow(Kx,2) + B01)',
                          'f5': '(B00 + Cy*Ky)',
                          'f6': '(B00 + Cx*Kx)',
                          'f7': '(pow(Ky,2) + B01)',
                          'f9': '(B00 + Cz*Kz)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                           ('(2*B00*Kx + Cx*(pow(Kx,2) + B01))',
                            ['B00', 'B01', 'Kx', 'Cx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                           ('(2*B00*Kz + Cz*(pow(Kz,2) + B01))',
                            ['Kz', 'B00', 'B01', 'Cz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                           ('(2*B00*Ky + Cy*(pow(Ky,2) + B01))',
                            ['B00', 'B01', 'Cy', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                           ('Cy*Kx*Kz', ['Kz', 'Kx', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                           ('Kx*f5', ['Kx', 'f5'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                           ('Kx*f9', ['f9', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                           ('Kx*Kz', ['Kz', 'Kx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                           ('Cx*Ky*Kz', ['Kz', 'Cx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                           ('Ky*Kz', ['Kz', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                           ('Kz*f5', ['Kz', 'f5'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 1)),
                           ('Kz*f6', ['f6', 'Kz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                           ('Ky*f6', ['f6', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                           ('Cz*Kx*Ky', ['Cz', 'Kx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 0)),
                           ('Kx*Ky', ['Kx', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 1)),
                           ('Ky*f9', ['f9', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                           ('Cy*f2', ['f2', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                           ('Cx*f2', ['Cx', 'f2'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                           ('Cx*f7', ['f7', 'Cx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                           ('Cz*f7', ['f7', 'Cz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                           ('Cz*f4', ['f4', 'Cz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                           ('Cy*f4', ['f4', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 0)),
                           ('f4', ['f4'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 0)),
                           ('f7', ['f7'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 2)),
                           ('f2', ['f2'])))),
 ('sp', 's', 's', 'f'): ({'B00': '',
                          'B01': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'f0': '(2*B00*Ky + Cy*(pow(Ky,2) + B01))',
                          'f10': '(pow(Kz,2) + 3*B01)',
                          'f11': '(B00 + Cy*Ky)',
                          'f12': '(B00 + Cx*Kx)',
                          'f13': '(3*B01 + pow(Kx,2))',
                          'f14': '(2*B00*Kx + Cx*(pow(Kx,2) + B01))',
                          'f15': '(B00 + Cz*Kz)',
                          'f3': '(pow(Ky,2) + B01)',
                          'f4': '(pow(Ky,2) + 3*B01)',
                          'f5': '3*B00*B01',
                          'f6': '(pow(Kz,2) + B01)',
                          'f7': '(2*B00*Kz + Cz*(pow(Kz,2) + B01))',
                          'f9': '(pow(Kx,2) + B01)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                           ('(3*B00*pow(Kx,2) + 3*B01*Cx*Kx + f5 + Cx*pow(Kx,3))',
                            ['f5', 'B00', 'B01', 'Kx', 'Cx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                           ('(f5 + 3*B00*pow(Kz,2) + 3*B01*Cz*Kz + Cz*pow(Kz,3))',
                            ['Kz', 'B00', 'B01', 'Cz', 'f5'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                           ('(3*B01*Cy*Ky + Cy*pow(Ky,3) + 3*B00*pow(Ky,2) + f5)',
                            ['B00', 'B01', 'Ky', 'Cy', 'f5'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                           ('Cy*Kx*f6', ['f6', 'Kx', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                           ('Ky*Kz*f12', ['Kz', 'f12', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                           ('Kx*Kz*f11', ['Kz', 'Kx', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                           ('Kx*Ky*Kz', ['Kz', 'Kx', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 1, 1)),
                           ('Kx*Ky*f15', ['f15', 'Kx', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                           ('Kx*f0', ['f0', 'Kx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                           ('Cx*Kz*f3', ['Kz', 'Cx', 'f3'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                           ('Kz*f3', ['Kz', 'f3'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                           ('Kz*f0', ['Kz', 'f0'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                           ('f15*f9', ['f15', 'f9'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 2, 1)),
                           ('f15*f3', ['f15', 'f3'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                           ('f12*f6', ['f6', 'f12'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                           ('f12*f3', ['f12', 'f3'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                           ('Kx*f3', ['Kx', 'f3'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 2, 0)),
                           ('Cz*Kx*f3', ['Cz', 'Kx', 'f3'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                           ('Cz*Kx*f13', ['f13', 'Cz', 'Kx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                           ('Cy*Kx*f13', ['f13', 'Kx', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (3, 0, 0)),
                           ('Kx*f13', ['f13', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                           ('Kx*f7', ['f7', 'Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 2)),
                           ('Kx*f6', ['f6', 'Kx'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                           ('Cx*Ky*f6', ['f6', 'Cx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                           ('Ky*f6', ['f6', 'Ky'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                           ('f11*f6', ['f6', 'f11'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                           ('f11*f9', ['f9', 'f11'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                           ('Kz*f9', ['f9', 'Kz'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                           ('Cy*Kz*f9', ['f9', 'Kz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                           ('Cy*Kz*f10', ['Kz', 'f10', 'Cy'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                           ('Cx*Kz*f10', ['Kz', 'Cx', 'f10'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 3)),
                           ('Kz*f10', ['Kz', 'f10'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (2, 0, 1)),
                           ('Kz*f14', ['f14', 'Kz'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                           ('Ky*f14', ['f14', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                           ('Ky*f9', ['f9', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (2, 1, 0)),
                           ('Cz*Ky*f9', ['f9', 'Cz', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                           ('Cz*Ky*f4', ['f4', 'Cz', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                           ('Cx*Ky*f4', ['f4', 'Cx', 'Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 3, 0)),
                           ('Ky*f4', ['f4', 'Ky'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 2)),
                           ('Ky*f7', ['f7', 'Ky'])))),
 ('sp', 's', 's', 'p'): ({'B00': '',
                          'Cx': '',
                          'Cy': '',
                          'Cz': '',
                          'Dx': '',
                          'Dy': '',
                          'Dz': '',
                          'Kx': '(Xkl + Dx)',
                          'Ky': '(Ykl + Dy)',
                          'Kz': '(Dz + Zkl)',
                          'Xkl': '',
                          'Ykl': '',
                          'Zkl': ''},
                         ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('(B00 + Cx*Kx)', ['B00', 'Cx', 'Kx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('(B00 + Cy*Ky)', ['B00', 'Ky', 'Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('(B00 + Cz*Kz)', ['Kz', 'B00', 'Cz'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cz*Kx', ['Cz', 'Kx'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cz*Ky', ['Cz', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Cx*Ky', ['Cx', 'Ky'])),
                          (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cx*Kz', ['Kz', 'Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Cy*Kz', ['Kz', 'Cy'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Cy*Kx', ['Kx', 'Cy'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                           ('Kx', ['Kx'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                           ('Ky', ['Ky'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                           ('Kz', ['Kz'])))),
 ('sp', 's', 's', 's'): ({'Cx': '', 'Cy': '', 'Cz': ''},
                         ((((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cx', ['Cx'])),
                          (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cy', ['Cy'])),
                          (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('Cz', ['Cz'])),
                          (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                           ('1', [])))),
 ('sp', 's', 's', 'sp'): ({'B00': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Kx': '(Xkl + Dx)',
                           'Ky': '(Ykl + Dy)',
                           'Kz': '(Dz + Zkl)',
                           'Xkl': '',
                           'Ykl': '',
                           'Zkl': ''},
                          ((((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('(B00 + Cy*Ky)', ['B00', 'Ky', 'Cy'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('(B00 + Cz*Kz)', ['Kz', 'B00', 'Cz'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('(B00 + Cx*Kx)', ['B00', 'Cx', 'Kx'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cx*Kz', ['Kz', 'Cx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Cy*Kz', ['Kz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cy*Kx', ['Kx', 'Cy'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Cz*Kx', ['Cz', 'Kx'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cz*Ky', ['Cz', 'Ky'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Cx*Ky', ['Cx', 'Ky'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx', ['Cx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy', ['Cy'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz', ['Cz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                            ('Kx', ['Kx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                            ('Ky', ['Ky'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                            ('Kz', ['Kz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('1', [])))),
 ('sp', 's', 'sp', 's'): ({'B00': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)'},
                          ((((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Qx', ['Qx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Qy', ['Qy'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Qz', ['Qz'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz', ['Dz', 'Cx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz', ['Dz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx', ['Dx', 'Cy'])),
                           (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx', ['Dx', 'Cz'])),
                           (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy', ['Dy', 'Cz'])),
                           (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy', ['Dy', 'Cx'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx', ['Cx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy', ['Cy'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz', ['Cz'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx', ['Dx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy', ['Dy'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz', ['Dz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('1', [])))),
 ('sp', 'sp', 'p', 'p'): ({'B00': '',
                           'B01': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Kx': '(Xkl + Dx)',
                           'Ky': '(Ykl + Dy)',
                           'Kz': '(Dz + Zkl)',
                           'Qx': '(Cx*Dx + B00)',
                           'Qy': '(Cy*Dy + B00)',
                           'Qz': '(Cz*Dz + B00)',
                           'f1': 'B00*Zkl',
                           'f10': 'B00*Xkl',
                           'f13': 'Cz*pow(Dz,2)',
                           'f14': '(B00 + Dz*Iz)',
                           'f18': '(B00 + Iy*Ky)',
                           'f19': '(B00 + Cy*Ky)',
                           'f2': 'B01*B10',
                           'f20': '(Dy*Iy + B00)',
                           'f21': 'Cz*Dz*Zkl',
                           'f22': '(Dz*(B10 + Cz*Iz) + B00*(2*Cz + Zij))',
                           'f23': 'B01*Cy',
                           'f24': '(Cx*Ix + B10)',
                           'f27': '(Kx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                           'f28': '2*B00*Dy',
                           'f3': '(Dz*Kz + B01)',
                           'f30': '(Dx*(Cx*Ix + B10) + B00*(Xij + 2*Cx))',
                           'f31': '(B01 + Dx*Kx)',
                           'f32': '(Cy*Iy + B10)',
                           'f33': '(B00*(Yij + 2*Cy) + Ky*(Cy*Iy + B10))',
                           'f34': '(B00*(Yij + 2*Cy) + Dy*(Cy*Iy + B10))',
                           'f36': '2*B00*Dz',
                           'f37': '(B01 + Dy*Ky)',
                           'f39': 'B01*Cx',
                           'f4': '(B00 + Cx*Kx)',
                           'f42': 'Cx*pow(Dx,2)',
                           'f45': 'Cy*pow(Dy,2)',
                           'f46': '2*pow(B00,2)',
                           'f5': '(B00*(Ykl + 2*Dy) + Iy*(B01 + Dy*Ky))',
                           'f51': 'B01*Cz',
                           'f52': '(B10 + Cz*Iz)',
                           'f6': 'B00*Ykl',
                           'f7': 'Cy*Dy*Ykl',
                           'f8': 'Cx*Dx*Xkl',
                           'f9': '2*B00*Dx',
                           'Xij': '',
                           'Xkl': '',
                           'Yij': '',
                           'Ykl': '',
                           'Zij': '',
                           'Zkl': ''},
                          ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('(f46 + f23*Yij + 2*Cy*(f28 + f6) + B01*pow(Cy,2) + Dy*Ky*pow(Cy,2) + f2 + B10*pow(Dy,2) + B10*Dy*Ykl + Yij*(f45 + f28 + f7 + f6))',
                             ['f45',
                              'B10',
                              'Ykl',
                              'B01',
                              'f23',
                              'f2',
                              'Yij',
                              'f6',
                              'f7',
                              'Ky',
                              'Dy',
                              'f46',
                              'f28',
                              'Cy'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(f46 + 2*Cx*(f10 + f9) + B10*Dx*Xkl + f39*(Cx + Xij) + B10*pow(Dx,2) + f2 + Xij*(f10 + f42 + f9 + f8) + Dx*Kx*pow(Cx,2))',
                             ['B10',
                              'Cx',
                              'Xij',
                              'f39',
                              'Dx',
                              'f2',
                              'Xkl',
                              'f8',
                              'f42',
                              'f10',
                              'f46',
                              'f9',
                              'Kx'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*(f10 + f42 + f9 + f8 + B01*Ix + Dx*Kx*Xij)',
                             ['Dx',
                              'Ix',
                              'Xij',
                              'B01',
                              'f8',
                              'f42',
                              'f10',
                              'f9',
                              'Kx',
                              'Cy'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*(f10 + f42 + f9 + f8 + B01*Ix + Dx*Kx*Xij)',
                             ['Dx',
                              'Ix',
                              'Xij',
                              'B01',
                              'Cz',
                              'f8',
                              'f42',
                              'f10',
                              'f9',
                              'Kx'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(f10 + f42 + f9 + f8 + B01*Ix + Dx*Kx*Xij)',
                             ['Dx',
                              'Ix',
                              'Xij',
                              'B01',
                              'f8',
                              'f42',
                              'f10',
                              'f9',
                              'Kx'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('Iy*(f10 + f42 + f39 + f9 + f8)',
                             ['f39', 'f8', 'f42', 'f10', 'f9', 'Iy'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('Iz*(f10 + f42 + f39 + f9 + f8)',
                             ['f39', 'f8', 'Iz', 'f10', 'f9', 'f42'])),
                           (((1, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('(f10 + f42 + f39 + f9 + f8)',
                             ['f9', 'f39', 'f8', 'f42', 'f10'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('(Dz*Kz*pow(Cz,2) + f46 + Zij*(f13 + f21 + f36 + f1) + B10*Dz*Zkl + B10*pow(Dz,2) + 2*Cz*(f36 + f1) + f2 + f51*(Cz + Zij))',
                             ['f36',
                              'Kz',
                              'Zij',
                              'f13',
                              'B10',
                              'f2',
                              'Dz',
                              'f1',
                              'Cz',
                              'f51',
                              'f46',
                              'Zkl',
                              'f21'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('Cy*(f13 + f21 + f36 + Dz*Kz*Zij + f1 + B01*Iz)',
                             ['f36',
                              'f13',
                              'Zij',
                              'Kz',
                              'B01',
                              'Dz',
                              'f1',
                              'Cy',
                              'f21',
                              'Iz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('Cx*(f13 + f21 + f36 + Dz*Kz*Zij + f1 + B01*Iz)',
                             ['f36',
                              'f13',
                              'Cx',
                              'Zij',
                              'Kz',
                              'B01',
                              'Dz',
                              'f1',
                              'Iz',
                              'f21'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                            ('(f13 + f21 + f36 + Dz*Kz*Zij + f1 + B01*Iz)',
                             ['f36',
                              'f13',
                              'Zij',
                              'Kz',
                              'B01',
                              'Dz',
                              'f1',
                              'Iz',
                              'f21'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('Iy*(f13 + f51 + f21 + f36 + f1)',
                             ['f36', 'f1', 'f13', 'f51', 'Iy', 'f21'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Ix*(f13 + f51 + f21 + f36 + f1)',
                             ['f36', 'Ix', 'f13', 'f1', 'f51', 'f21'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('(f13 + f51 + f21 + f36 + f1)',
                             ['f51', 'f36', 'f13', 'f21', 'f1'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('Iz*(f45 + f28 + f23 + f7 + f6)',
                             ['f45', 'f23', 'f6', 'Iz', 'f7', 'f28'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Ix*(f45 + f28 + f23 + f7 + f6)',
                             ['f45', 'Ix', 'f23', 'f6', 'f7', 'f28'])),
                           (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('(f45 + f28 + f23 + f7 + f6)',
                             ['f45', 'f7', 'f6', 'f23', 'f28'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Dx*(f22 + Zkl*(B10 + Cz*Iz))',
                             ['Dx', 'Cz', 'B10', 'f22', 'Iz', 'Zkl'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Dy*(f22 + Zkl*(B10 + Cz*Iz))',
                             ['B10', 'Cz', 'Dy', 'f22', 'Iz', 'Zkl'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Ix*(Cz*Zkl + Qz)',
                             ['Dy', 'Ix', 'Zkl', 'Qz', 'Cz'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Qx*(f14 + Iz*Zkl)',
                             ['f14', 'Qx', 'Zkl', 'Iz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Dy*(f14 + Iz*Zkl)',
                             ['Dy', 'f14', 'Zkl', 'Cx', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Dy*(f14 + Iz*Zkl)',
                             ['Dy', 'f14', 'Zkl', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                            ('Qy*(f14 + Iz*Zkl)',
                             ['Zkl', 'f14', 'Qy', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Dx*(f14 + Iz*Zkl)',
                             ['Dx', 'Zkl', 'f14', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Dx*(f14 + Iz*Zkl)',
                             ['Dx', 'Zkl', 'f14', 'Cy', 'Iz'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Dz*(Kx*Xij + f4)',
                             ['Dz', 'f4', 'Kx', 'Cy', 'Xij'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*(Kx*Xij + f4)', ['Dz', 'f4', 'Kx', 'Xij'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Qy*(Kx*Xij + f4)', ['f4', 'Qy', 'Kx', 'Xij'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Dy*(Kx*Xij + f4)',
                             ['f4', 'Dy', 'Cz', 'Kx', 'Xij'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*(Kx*Xij + f4)', ['f4', 'Dy', 'Kx', 'Xij'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Qz*(Kx*Xij + f4)', ['f4', 'Qz', 'Xij', 'Kx'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('(Cz*Zkl + Qz)*(Dx*Xij + Qx)',
                             ['Dx', 'Xij', 'Qz', 'Cz', 'Qx', 'Zkl'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Iy*(Cz*Zkl + Qz)',
                             ['Zkl', 'Dx', 'Cz', 'Iy', 'Qz'])),
                           (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*(Cz*Zkl + Qz)', ['Dx', 'Cz', 'Zkl', 'Qz'])),
                           (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*(Cz*Zkl + Qz)', ['Dy', 'Cz', 'Zkl', 'Qz'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('f20*(Cz*Zkl + Qz)',
                             ['Cz', 'Zkl', 'f20', 'Qz'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Kz*f20', ['Kz', 'Cx', 'f20'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cy*Ix*f3', ['Ix', 'f3', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Ix*Kz*Qy', ['Kz', 'Ix', 'Qy'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Kz*f24', ['Dy', 'Kz', 'f24'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                           (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Cx*Dy*Kz', ['Dy', 'Kz', 'Cx'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Kx*f52', ['f52', 'Dy', 'Kx'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Kx*f32', ['Dz', 'Kx', 'f32'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Kz*f32', ['Dx', 'Kz', 'f32'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Kz*(Dx*Xij + Qx)',
                             ['Qx', 'Dx', 'Kz', 'Xij', 'Cy'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*(Dx*Xij + Qx)', ['Qx', 'Dx', 'Kz', 'Xij'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('f19*(Dx*Xij + Qx)',
                             ['Dx', 'Qx', 'f19', 'Xij'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Ky*(Dx*Xij + Qx)',
                             ['Qx', 'Dx', 'Cz', 'Xij', 'Ky'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*(Dx*Xij + Qx)', ['Dx', 'Qx', 'Xij', 'Ky'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Ky*f52', ['f52', 'Dx', 'Ky'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*f33', ['Dx', 'f33'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*f5', ['Cx', 'f5'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*f5', ['Cz', 'f5'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Iz*Ky*Qx', ['Qx', 'Iz', 'Ky'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Iz*f19', ['Dx', 'Iz', 'f19'])),
                           (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*f19', ['Dx', 'f19'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ix*f19', ['Dz', 'Ix', 'f19'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*f19', ['Dz', 'f19'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*f30', ['f30', 'Ky'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Ix*Ky*Qz', ['Ix', 'Qz', 'Ky'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Ky*Qz', ['Qz', 'Ky'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Qx*f18', ['Qx', 'f18'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Dz*f18', ['Dz', 'Cx', 'f18'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*f18', ['Dz', 'f18'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*f33', ['Dz', 'f33'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Kx*f14', ['f14', 'Kx', 'Cy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('Kx*f14', ['f14', 'Kx'])),
                           (((0, 1, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*f34', ['f34', 'Kx'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Iy*Kx*Qz', ['Iy', 'Kx', 'Qz'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Kx*Qz', ['Kx', 'Qz'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                            ('Qz*f18', ['Qz', 'f18'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*f18', ['Dx', 'f18'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Dx*f18', ['Dx', 'Cz', 'f18'])),
                           (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Cz*Dx*Ky', ['Dx', 'Cz', 'Ky'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Dx*Ky', ['Dx', 'Ky'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ky*f24', ['Dz', 'f24', 'Ky'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Dz*Ky', ['Dz', 'Ky'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Dz*Ky', ['Dz', 'Cx', 'Ky'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('Cx*Ky*f14', ['f14', 'Cx', 'Ky'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('Ky*f14', ['f14', 'Ky'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('f14*f19', ['f14', 'f19'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('f14*f4', ['f4', 'f14'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('f20*f4', ['f4', 'f20'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*f4', ['Dz', 'f4'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Iy*f4', ['Dz', 'f4', 'Iy'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Cy*Dz*Kx', ['Dz', 'Kx', 'Cy'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*Kx', ['Dz', 'Kx'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                            ('Dz*f27', ['Dz', 'f27'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*f27', ['f27', 'Dy'])),
                           (((1, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*f4', ['f4', 'Dy'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Iz*f4', ['f4', 'Dy', 'Iz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                            ('Iz*Kx*Qy', ['Qy', 'Iz', 'Kx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*Qy', ['Qy', 'Kx'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('Kx*f20', ['Kx', 'f20'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Kx*f20', ['Cz', 'Kx', 'f20'])),
                           (((0, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Cz*Dy*Kx', ['Dy', 'Cz', 'Kx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                            ('Dy*Kx', ['Dy', 'Kx'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                            ('Kx*f22', ['f22', 'Kx'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                            ('Ky*f22', ['f22', 'Ky'])),
                           (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                            ('Ky*Qx', ['Qx', 'Ky'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Iy*Kz*Qx', ['Qx', 'Kz', 'Iy'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                           (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Cy*Dx*Kz', ['Dx', 'Kz', 'Cy'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Dx*Kz', ['Dx', 'Kz'])),
                           (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*Qx', ['Qx', 'Kz'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                            ('Kz*f30', ['Kz', 'f30'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Dy*Kz', ['Dy', 'Kz'])),
                           (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*Qy', ['Kz', 'Qy'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*f20', ['Kz', 'f20'])),
                           (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                            ('Kz*f34', ['f34', 'Kz'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('f31*f52', ['f52', 'f31'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('f37*f52', ['f52', 'f37'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('f24*f37', ['f24', 'f37'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Ix*f37', ['f37', 'Ix'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*Ix*f37', ['f37', 'Cz', 'Ix'])),
                           (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cz*f37', ['f37', 'Cz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('Iz*f37', ['f37', 'Iz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                            ('Cx*Iz*f37', ['f37', 'Cx', 'Iz'])),
                           (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('Cx*f37', ['f37', 'Cx'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*Iy*f3', ['Iy', 'Cx', 'f3'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cx*f3', ['Cx', 'f3'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Cy*f3', ['f3', 'Cy'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('Ix*f3', ['Ix', 'f3'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('f24*f3', ['f24', 'f3'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('Iy*f3', ['Iy', 'f3'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                            ('f3*f32', ['f3', 'f32'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('f31*f32', ['f31', 'f32'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('Iy*f31', ['f31', 'Iy'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*Iy*f31', ['f31', 'Cz', 'Iy'])),
                           (((0, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cz*f31', ['f31', 'Cz'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('Iz*f31', ['f31', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                            ('Cy*Iz*f31', ['f31', 'Iz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('Cy*f31', ['f31', 'Cy'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                            ('f31', ['f31'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                            ('f37', ['f37'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                            ('f5', ['f5'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                            ('f3', ['f3'])))),
 ('sp', 'sp', 'p', 's'): ({'B00': '',
                           'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Dx': '',
                           'Dy': '',
                           'Dz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Px': '(B10 + pow(Cx,2))',
                           'Py': '(B10 + pow(Cy,2))',
                           'Pz': '(B10 + pow(Cz,2))',
                           'Qy': '(Cy*Dy + B00)',
                           'f1': 'Cz*Dz',
                           'f14': '(B10 + Cz*Iz)',
                           'f15': '(Cy*Iy + B10)',
                           'f4': 'Cx*Dx',
                           'f8': 'Cy*Dy',
                           'f9': '(Cx*Ix + B10)',
                           'Xij': '',
                           'Yij': '',
                           'Zij': ''},
                          ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(B00*(Yij + 2*Cy) + f8*Yij + Dy*Py)',
                             ['Dy', 'Py', 'Yij', 'B00', 'f8', 'Cy'])),
                           (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(f4*Xij + Dx*Px + B00*(Xij + 2*Cx))',
                             ['f4', 'Dx', 'Xij', 'Px', 'B00', 'Cx'])),
                           (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*(B00 + f4 + Dx*Xij)',
                             ['f4', 'Dx', 'B00', 'Xij', 'Cy'])),
                           (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*(B00 + f4 + Dx*Xij)',
                             ['f4', 'Dx', 'Cz', 'Xij', 'B00'])),
                           (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(B00 + f4 + Dx*Xij)',
                             ['f4', 'Dx', 'B00', 'Xij'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(Dz*Pz + B00*(2*Cz + Zij) + f1*Zij)',
                             ['f1', 'Cz', 'Zij', 'Dz', 'B00', 'Pz'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cy*(B00 + Dz*Zij + f1)',
                             ['Dz', 'Zij', 'B00', 'Cy', 'f1'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('Cx*(B00 + Dz*Zij + f1)',
                             ['Dz', 'Zij', 'B00', 'Cx', 'f1'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                            ('(B00 + Dz*Zij + f1)',
                             ['Dz', 'Zij', 'B00', 'f1'])),
                           (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*(Dy*Yij + Qy)', ['Dy', 'Cz', 'Qy', 'Yij'])),
                           (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*(Dy*Yij + Qy)', ['Dy', 'Qy', 'Cx', 'Yij'])),
                           (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                            ('(Dy*Yij + Qy)', ['Dy', 'Qy', 'Yij'])),
                           (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Ix*Qy', ['Ix', 'Qy'])),
                           (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Iz*Qy', ['Qy', 'Iz'])),
                           (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Iz*(B00 + f4)', ['f4', 'B00', 'Iz'])),
                           (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('(B00 + f4)', ['f4', 'B00'])),
                           (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Iy*(B00 + f4)', ['f4', 'B00', 'Iy'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Iy*(B00 + f1)', ['f1', 'B00', 'Iy'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Ix*(B00 + f1)', ['f1', 'Ix', 'B00'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('(B00 + f1)', ['f1', 'B00'])),
                           (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*f14', ['Dx', 'f14'])),
                           (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*f14', ['Dy', 'f14'])),
                           (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*f9', ['Dy', 'f9'])),
                           (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Ix', ['Dy', 'Ix'])),
                           (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                           (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cz*Dy', ['Dy', 'Cz'])),
                           (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Dy*Iz', ['Dy', 'Iz'])),
                           (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                           (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Cx*Dy', ['Dy', 'Cx'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cx*Dz', ['Dz', 'Cx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz', ['Dz', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Ix', ['Dz', 'Ix'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*f9', ['Dz', 'f9'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*Iy', ['Dz', 'Iy'])),
                           (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz*f15', ['Dz', 'f15'])),
                           (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*f15', ['f15', 'Dx'])),
                           (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iy', ['Dx', 'Iy'])),
                           (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                           (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cz*Dx', ['Dx', 'Cz'])),
                           (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Dx*Iz', ['Dx', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                           (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Cy*Dx', ['Dx', 'Cy'])),
                           (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                            ('Dx', ['Dx'])),
                           (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Dy', ['Dy'])),
                           (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                            ('Qy', ['Qy'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                            ('Dz', ['Dz'])))),
 ('sp', 'sp', 's', 's'): ({'B10': '',
                           'Cx': '',
                           'Cy': '',
                           'Cz': '',
                           'Ix': '(Cx + Xij)',
                           'Iy': '(Cy + Yij)',
                           'Iz': '(Cz + Zij)',
                           'Xij': '',
                           'Yij': '',
                           'Zij': ''},
                          ((((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                           (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                           (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                           (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iz', ['Cx', 'Iz'])),
                           (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Iz', ['Iz', 'Cy'])),
                           (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy*Ix', ['Ix', 'Cy'])),
                           (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Ix', ['Cz', 'Ix'])),
                           (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz*Iy', ['Cz', 'Iy'])),
                           (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx*Iy', ['Iy', 'Cx'])),
                           (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cx', ['Cx'])),
                           (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cy', ['Cy'])),
                           (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Cz', ['Cz'])),
                           (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('Ix', ['Ix'])),
                           (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                            ('Iy', ['Iy'])),
                           (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                            ('Iz', ['Iz'])),
                           (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                            ('1', [])))),
 ('sp', 'sp', 'sp', 'p'): ({'B00': '',
                            'B01': '',
                            'B10': '',
                            'Cx': '',
                            'Cy': '',
                            'Cz': '',
                            'Dx': '',
                            'Dy': '',
                            'Dz': '',
                            'Ix': '(Cx + Xij)',
                            'Iy': '(Cy + Yij)',
                            'Iz': '(Cz + Zij)',
                            'Kx': '(Xkl + Dx)',
                            'Ky': '(Ykl + Dy)',
                            'Kz': '(Dz + Zkl)',
                            'Px': '(B10 + pow(Cx,2))',
                            'Py': '(B10 + pow(Cy,2))',
                            'Pz': '(B10 + pow(Cz,2))',
                            'Qy': '(Cy*Dy + B00)',
                            'f1': 'B00*Zkl',
                            'f11': '2*B00*Dx',
                            'f14': 'Cz*pow(Dz,2)',
                            'f19': 'Cz*Zkl',
                            'f2': 'Cx*Dx',
                            'f25': 'B01*Cy',
                            'f27': 'Cx*Xkl',
                            'f3': 'B01*B10',
                            'f31': '(Cx*Ix + B10)',
                            'f32': '2*B00*Dy',
                            'f35': '(B01 + Dx*Kx)',
                            'f36': '(Cy*Iy + B10)',
                            'f38': 'Cy*Ykl',
                            'f41': '2*B00*Dz',
                            'f42': '(B01 + Dy*Ky)',
                            'f44': 'B01*Cx',
                            'f47': 'Cx*pow(Dx,2)',
                            'f49': 'Cz*Dz',
                            'f52': 'Cy*pow(Dy,2)',
                            'f53': '2*pow(B00,2)',
                            'f58': 'B01*Cz',
                            'f59': '(B10 + Cz*Iz)',
                            'f6': 'B00*Ykl',
                            'f7': 'Cy*Dy',
                            'Xij': '',
                            'Xkl': '',
                            'Yij': '',
                            'Ykl': '',
                            'Zij': '',
                            'Zkl': ''},
                           ((((1, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('(f53 + Px*pow(Dx,2) + f44*(Cx + Xij) + f3 + Dx*Px*Xkl + B00*(2*f27 + 4*f2 + Xij*(Xkl + 2*Dx)) + Xij*(f47 + f2*Xkl))',
                              ['Dx',
                               'Cx',
                               'Xij',
                               'f44',
                               'f53',
                               'f47',
                               'f2',
                               'f27',
                               'Xkl',
                               'B00',
                               'f3',
                               'Px'])),
                            (((0, 1, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('Cy*(Xkl*(B00 + f2) + f11 + f47 + B01*Ix + Dx*Kx*Xij)',
                              ['Dx',
                               'Ix',
                               'Xij',
                               'B01',
                               'f47',
                               'f2',
                               'Kx',
                               'Xkl',
                               'B00',
                               'f11',
                               'Cy'])),
                            (((0, 0, 1), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('Cz*(Xkl*(B00 + f2) + f11 + f47 + B01*Ix + Dx*Kx*Xij)',
                              ['Dx',
                               'B00',
                               'Xij',
                               'Ix',
                               'B01',
                               'f47',
                               'f2',
                               'Kx',
                               'Xkl',
                               'Cz',
                               'f11'])),
                            (((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('(Xkl*(B00 + f2) + f11 + f47 + B01*Ix + Dx*Kx*Xij)',
                              ['Dx',
                               'Ix',
                               'Xij',
                               'B01',
                               'f47',
                               'f2',
                               'Kx',
                               'Xkl',
                               'B00',
                               'f11'])),
                            (((1, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                             ('Iy*(Xkl*(B00 + f2) + f11 + f44 + f47)',
                              ['f44',
                               'f47',
                               'f2',
                               'Xkl',
                               'B00',
                               'Iy',
                               'f11'])),
                            (((1, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                             ('Iz*(Xkl*(B00 + f2) + f11 + f44 + f47)',
                              ['f44',
                               'f47',
                               'f2',
                               'Xkl',
                               'B00',
                               'Iz',
                               'f11'])),
                            (((1, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('(Xkl*(B00 + f2) + f11 + f44 + f47)',
                              ['f44', 'f47', 'f2', 'Xkl', 'B00', 'f11'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('Dz*(Xij*(f27 + f2) + Kx*Px + B00*(Xij + 2*Cx))',
                              ['f27',
                               'Xij',
                               'Px',
                               'f2',
                               'Dz',
                               'B00',
                               'Kx',
                               'Cx'])),
                            (((1, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Dy*(Xij*(f27 + f2) + Kx*Px + B00*(Xij + 2*Cx))',
                              ['Xij',
                               'Px',
                               'Dy',
                               'f2',
                               'f27',
                               'B00',
                               'Kx',
                               'Cx'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('(Xij*(f27 + f2) + Kx*Px + B00*(Xij + 2*Cx))',
                              ['Xij',
                               'Px',
                               'f2',
                               'f27',
                               'B00',
                               'Kx',
                               'Cx'])),
                            (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('Ky*(Dx*Px + B00*(Xij + 2*Cx) + f2*Xij)',
                              ['Dx', 'Cx', 'Px', 'f2', 'Xij', 'B00', 'Ky'])),
                            (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('Kz*(Dx*Px + B00*(Xij + 2*Cx) + f2*Xij)',
                              ['Dx', 'Cx', 'Xij', 'Kz', 'f2', 'B00', 'Px'])),
                            (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                             ('(Yij*(f52 + f25 + f7*Ykl + f6) + f53 + Dy*Py*Ykl + B01*pow(Cy,2) + f3 + Py*pow(Dy,2) + 2*Cy*f6 + 2*B00*(Dy*Yij + 2*f7))',
                              ['f52',
                               'f25',
                               'Ykl',
                               'Dy',
                               'f53',
                               'B01',
                               'Py',
                               'Yij',
                               'f6',
                               'B00',
                               'f3',
                               'f7',
                               'Cy'])),
                            (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                             ('Cz*(f52 + f25 + f32 + f7*Ykl + Yij*(B01 + Dy*Ky) + f6)',
                              ['f52',
                               'f25',
                               'Yij',
                               'Dy',
                               'B01',
                               'Ykl',
                               'f6',
                               'Cz',
                               'Ky',
                               'f7',
                               'f32'])),
                            (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                             ('Cx*(f52 + f25 + f32 + f7*Ykl + Yij*(B01 + Dy*Ky) + f6)',
                              ['f52',
                               'f25',
                               'Cx',
                               'Yij',
                               'Dy',
                               'B01',
                               'Ykl',
                               'f6',
                               'Ky',
                               'f7',
                               'f32'])),
                            (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                             ('(f52 + f25 + f32 + f7*Ykl + Yij*(B01 + Dy*Ky) + f6)',
                              ['f52',
                               'f25',
                               'Ykl',
                               'Dy',
                               'B01',
                               'Yij',
                               'f6',
                               'Ky',
                               'f7',
                               'f32'])),
                            (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                             ('Iz*(f52 + f25 + f32 + f7*Ykl + f6)',
                              ['f52',
                               'f25',
                               'Ykl',
                               'f6',
                               'Iz',
                               'f7',
                               'f32'])),
                            (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('Ix*(f52 + f25 + f32 + f7*Ykl + f6)',
                              ['f52',
                               'f25',
                               'Ix',
                               'Ykl',
                               'f6',
                               'f7',
                               'f32'])),
                            (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('(f52 + f25 + f32 + f7*Ykl + f6)',
                              ['f52', 'f25', 'Ykl', 'f6', 'f7', 'f32'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                             ('Dz*(B00*(Yij + 2*Cy) + Yij*(f38 + f7) + Ky*Py)',
                              ['f38',
                               'Py',
                               'Dz',
                               'Yij',
                               'B00',
                               'Ky',
                               'f7',
                               'Cy'])),
                            (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                             ('Dx*(B00*(Yij + 2*Cy) + Yij*(f38 + f7) + Ky*Py)',
                              ['Dx',
                               'f38',
                               'Py',
                               'Yij',
                               'B00',
                               'Ky',
                               'f7',
                               'Cy'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                             ('(B00*(Yij + 2*Cy) + Yij*(f38 + f7) + Ky*Py)',
                              ['f38',
                               'Py',
                               'Yij',
                               'B00',
                               'Ky',
                               'f7',
                               'Cy'])),
                            (((0, 1, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                             ('Kx*(f7*Yij + B00*(Yij + 2*Cy) + Dy*Py)',
                              ['Dy', 'Py', 'Yij', 'B00', 'f7', 'Kx', 'Cy'])),
                            (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                             ('Kz*(f7*Yij + B00*(Yij + 2*Cy) + Dy*Py)',
                              ['Dy', 'Kz', 'Py', 'Yij', 'B00', 'f7', 'Cy'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                             ('(f53 + Pz*pow(Dz,2) + Dz*Pz*Zkl + f58*(Cz + Zij) + Zij*(f14 + f1 + Dz*f19) + f3 + 2*Cz*f1 + 2*B00*(2*f49 + Dz*Zij))',
                              ['f1',
                               'f19',
                               'f53',
                               'Zij',
                               'f58',
                               'Dz',
                               'Cz',
                               'Pz',
                               'f3',
                               'f49',
                               'f14',
                               'Zkl',
                               'B00'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                             ('Cy*(f14 + Dz*(f19 + 2*B00 + Kz*Zij) + f1 + B01*Iz)',
                              ['f1',
                               'f19',
                               'Zij',
                               'Kz',
                               'B01',
                               'Dz',
                               'B00',
                               'Iz',
                               'f14',
                               'Cy'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                             ('Cx*(f14 + Dz*(f19 + 2*B00 + Kz*Zij) + f1 + B01*Iz)',
                              ['f1',
                               'Cx',
                               'Zij',
                               'Kz',
                               'B01',
                               'Dz',
                               'B00',
                               'Iz',
                               'f14',
                               'f19'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                             ('(f14 + Dz*(f19 + 2*B00 + Kz*Zij) + f1 + B01*Iz)',
                              ['f1',
                               'f19',
                               'Zij',
                               'Kz',
                               'B01',
                               'Dz',
                               'B00',
                               'Iz',
                               'f14'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                             ('Iy*(f14 + f41 + f58 + f1 + Dz*f19)',
                              ['f1',
                               'f19',
                               'Iy',
                               'f58',
                               'Dz',
                               'f14',
                               'f41'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('Ix*(f14 + f41 + f58 + f1 + Dz*f19)',
                              ['f1',
                               'f19',
                               'f58',
                               'Dz',
                               'Ix',
                               'f14',
                               'f41'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('(f14 + f41 + f58 + f1 + Dz*f19)',
                              ['f1', 'f19', 'f58', 'Dz', 'f14', 'f41'])),
                            (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                             ('Dy*(Kz*Pz + Zij*(f19 + f49) + B00*(2*Cz + Zij))',
                              ['f19',
                               'Cz',
                               'Zij',
                               'Dy',
                               'Kz',
                               'B00',
                               'Pz',
                               'f49'])),
                            (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                             ('Dx*(Kz*Pz + Zij*(f19 + f49) + B00*(2*Cz + Zij))',
                              ['Dx',
                               'f19',
                               'Cz',
                               'Zij',
                               'Kz',
                               'B00',
                               'f49',
                               'Pz'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                             ('(Kz*Pz + Zij*(f19 + f49) + B00*(2*Cz + Zij))',
                              ['f19',
                               'Cz',
                               'Zij',
                               'Kz',
                               'B00',
                               'f49',
                               'Pz'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                             ('Ky*(f49*Zij + Dz*Pz + B00*(2*Cz + Zij))',
                              ['Cz',
                               'Zij',
                               'Dz',
                               'B00',
                               'f49',
                               'Ky',
                               'Pz'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                             ('Kx*(f49*Zij + Dz*Pz + B00*(2*Cz + Zij))',
                              ['Cz',
                               'Zij',
                               'Dz',
                               'B00',
                               'Pz',
                               'f49',
                               'Kx'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                             ('(f38 + Qy)*(f49 + B00 + Dz*Zij)',
                              ['f38', 'Zij', 'Dz', 'B00', 'Qy', 'f49'])),
                            (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                             ('Qy*(f19 + f49 + B00 + Kz*Zij)',
                              ['f19', 'Zij', 'Kz', 'B00', 'f49', 'Qy'])),
                            (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                             ('(B00 + f2)*(f19 + f49 + B00 + Kz*Zij)',
                              ['f19', 'Zij', 'Kz', 'f2', 'B00', 'f49'])),
                            (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                             ('Dx*(f19 + f49 + B00 + Kz*Zij)',
                              ['Dx', 'f19', 'Zij', 'Kz', 'B00', 'f49'])),
                            (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                             ('Cy*Dx*(f19 + f49 + B00 + Kz*Zij)',
                              ['Dx',
                               'f19',
                               'Zij',
                               'Kz',
                               'B00',
                               'f49',
                               'Cy'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                             ('Cy*(f19 + f49 + B00 + Kz*Zij)',
                              ['f19', 'Zij', 'Kz', 'B00', 'f49', 'Cy'])),
                            (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                             ('Dy*(f19 + f49 + B00 + Kz*Zij)',
                              ['f19', 'Zij', 'Dy', 'Kz', 'B00', 'f49'])),
                            (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                             ('Cx*Dy*(f19 + f49 + B00 + Kz*Zij)',
                              ['Cx',
                               'Zij',
                               'Dy',
                               'Kz',
                               'B00',
                               'f49',
                               'f19'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                             ('Cx*(f19 + f49 + B00 + Kz*Zij)',
                              ['Cx', 'Zij', 'Kz', 'B00', 'f49', 'f19'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                             ('(f19 + f49 + B00 + Kz*Zij)',
                              ['Zij', 'Kz', 'B00', 'f49', 'f19'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                             ('(f27 + B00 + f2)*(f49 + B00 + Dz*Zij)',
                              ['Dz', 'Zij', 'f2', 'f27', 'B00', 'f49'])),
                            (((1, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                             ('(Dy*Yij + Qy)*(f27 + B00 + f2)',
                              ['Dy', 'f2', 'f27', 'Yij', 'B00', 'Qy'])),
                            (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                             ('(Dy*Yij + Qy)*(f19 + f49 + B00)',
                              ['f19', 'Dy', 'Yij', 'B00', 'f49', 'Qy'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                             ('(f49 + B00)*(f38 + Ky*Yij + Qy)',
                              ['f38', 'Yij', 'B00', 'f49', 'Ky', 'Qy'])),
                            (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                             ('(B00 + f2)*(f38 + Ky*Yij + Qy)',
                              ['f38', 'f2', 'Yij', 'B00', 'Qy', 'Ky'])),
                            (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                             ('Dx*(f38 + Ky*Yij + Qy)',
                              ['Yij', 'Dx', 'f38', 'Qy', 'Ky'])),
                            (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                             ('Cz*Dx*(f38 + Ky*Yij + Qy)',
                              ['Dx', 'f38', 'Yij', 'Cz', 'Qy', 'Ky'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                             ('Cz*(f38 + Ky*Yij + Qy)',
                              ['Yij', 'Cz', 'f38', 'Qy', 'Ky'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                             ('Dz*(f38 + Ky*Yij + Qy)',
                              ['Dz', 'Yij', 'f38', 'Qy', 'Ky'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                             ('Cx*Dz*(f38 + Ky*Yij + Qy)',
                              ['f38', 'Cx', 'Dz', 'Yij', 'Qy', 'Ky'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                             ('Cx*(f38 + Ky*Yij + Qy)',
                              ['Yij', 'Qy', 'f38', 'Cx', 'Ky'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                             ('(f38 + Ky*Yij + Qy)',
                              ['Yij', 'f38', 'Qy', 'Ky'])),
                            (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                             ('Cx*Kz*(Dy*Yij + Qy)',
                              ['Dy', 'Kz', 'Qy', 'Cx', 'Yij'])),
                            (((0, 0, 1), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                             ('Cz*Kx*(Dy*Yij + Qy)',
                              ['Dy', 'Cz', 'Qy', 'Kx', 'Yij'])),
                            (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                             ('Kx*(Dy*Yij + Qy)',
                              ['Dy', 'Qy', 'Kx', 'Yij'])),
                            (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                             ('Kz*(Dy*Yij + Qy)',
                              ['Dy', 'Kz', 'Qy', 'Yij'])),
                            (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('(f38 + Qy)*(B00 + f2 + Dx*Xij)',
                              ['Dx', 'f38', 'Xij', 'f2', 'B00', 'Qy'])),
                            (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('(B00 + f2 + Dx*Xij)*(f19 + f49 + B00)',
                              ['Dx', 'f19', 'Xij', 'f2', 'B00', 'f49'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('(f49 + B00)*(f27 + Kx*Xij + B00 + f2)',
                              ['Xij', 'f2', 'f27', 'B00', 'f49', 'Kx'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('Cy*Dz*(f27 + Kx*Xij + B00 + f2)',
                              ['f27',
                               'Xij',
                               'f2',
                               'Dz',
                               'B00',
                               'Kx',
                               'Cy'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('Dz*(f27 + Kx*Xij + B00 + f2)',
                              ['f27', 'Xij', 'f2', 'Dz', 'B00', 'Kx'])),
                            (((0, 1, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Qy*(f27 + Kx*Xij + B00 + f2)',
                              ['Xij', 'f2', 'f27', 'B00', 'Qy', 'Kx'])),
                            (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Dy*(f27 + Kx*Xij + B00 + f2)',
                              ['Xij', 'Dy', 'f2', 'f27', 'B00', 'Kx'])),
                            (((0, 0, 1), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Cz*Dy*(f27 + Kx*Xij + B00 + f2)',
                              ['B00',
                               'Xij',
                               'Dy',
                               'f2',
                               'f27',
                               'Cz',
                               'Kx'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('Cz*(f27 + Kx*Xij + B00 + f2)',
                              ['B00', 'Xij', 'f2', 'f27', 'Cz', 'Kx'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('(f27 + Kx*Xij + B00 + f2)',
                              ['f27', 'f2', 'B00', 'Kx', 'Xij'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('Cy*(f27 + Kx*Xij + B00 + f2)',
                              ['Xij', 'f2', 'f27', 'B00', 'Kx', 'Cy'])),
                            (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('Cy*Kz*(B00 + f2 + Dx*Xij)',
                              ['Dx', 'Xij', 'Kz', 'f2', 'B00', 'Cy'])),
                            (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('Kz*(B00 + f2 + Dx*Xij)',
                              ['Dx', 'Kz', 'Xij', 'f2', 'B00'])),
                            (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('Cz*Ky*(B00 + f2 + Dx*Xij)',
                              ['Dx', 'B00', 'Xij', 'f2', 'Cz', 'Ky'])),
                            (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('Ky*(B00 + f2 + Dx*Xij)',
                              ['Dx', 'B00', 'f2', 'Ky', 'Xij'])),
                            (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                             ('Dx*Ky*f59', ['f59', 'Dx', 'Ky'])),
                            (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('Cz*Ix*f42', ['Cz', 'f42', 'Ix'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Ix*Ky*(f49 + B00)',
                              ['Ix', 'f49', 'Ky', 'B00'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                             ('Cx*Ky*(f49 + B00 + Dz*Zij)',
                              ['Cx', 'Zij', 'Dz', 'B00', 'f49', 'Ky'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                             ('Ky*(f49 + B00 + Dz*Zij)',
                              ['Dz', 'Zij', 'B00', 'f49', 'Ky'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                             ('Cy*Kx*(f49 + B00 + Dz*Zij)',
                              ['Zij', 'Dz', 'B00', 'f49', 'Kx', 'Cy'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                             ('Kx*(f49 + B00 + Dz*Zij)',
                              ['Dz', 'Zij', 'B00', 'f49', 'Kx'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                             ('Iy*Kx*(f49 + B00)',
                              ['f49', 'B00', 'Iy', 'Kx'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('Kx*(f49 + B00)', ['B00', 'f49', 'Kx'])),
                            (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('Dx*(f19 + f49 + B00)',
                              ['Dx', 'B00', 'f49', 'f19'])),
                            (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                             ('Dx*Iy*(f19 + f49 + B00)',
                              ['f49', 'Dx', 'B00', 'Iy', 'f19'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                             ('Iy*(f19 + f49 + B00)',
                              ['f49', 'B00', 'Iy', 'f19'])),
                            (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Dy*(f19 + f49 + B00)',
                              ['Dy', 'B00', 'f49', 'f19'])),
                            (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Dy*Ix*(f19 + f49 + B00)',
                              ['Dy', 'Ix', 'f49', 'f19', 'B00'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('Ix*(f19 + f49 + B00)',
                              ['Ix', 'f49', 'f19', 'B00'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('(f19 + f49 + B00)', ['B00', 'f49', 'f19'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Ky*(f49 + B00)', ['B00', 'f49', 'Ky'])),
                            (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                             ('Iz*Ky*(B00 + f2)',
                              ['f2', 'B00', 'Iz', 'Ky'])),
                            (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('Ky*(B00 + f2)', ['B00', 'f2', 'Ky'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                             ('Dz*Iy*(f27 + B00 + f2)',
                              ['Dz', 'f27', 'B00', 'Iy', 'f2'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('Dz*(f27 + B00 + f2)',
                              ['Dz', 'f27', 'B00', 'f2'])),
                            (((1, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Dy*(f27 + B00 + f2)',
                              ['f27', 'Dy', 'B00', 'f2'])),
                            (((1, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                             ('Dy*Iz*(f27 + B00 + f2)',
                              ['f27', 'Dy', 'B00', 'Iz', 'f2'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                             ('Iz*(f27 + B00 + f2)',
                              ['f27', 'B00', 'Iz', 'f2'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('(f27 + B00 + f2)', ['f27', 'B00', 'f2'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                             ('Iy*(f27 + B00 + f2)',
                              ['f27', 'B00', 'Iy', 'f2'])),
                            (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                             ('Iy*Kz*(B00 + f2)',
                              ['Kz', 'Iy', 'f2', 'B00'])),
                            (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('Kz*(B00 + f2)', ['Kz', 'f2', 'B00'])),
                            (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Ix*Kz*Qy', ['Kz', 'Ix', 'Qy'])),
                            (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                             ('Dx*Kz*f36', ['Dx', 'Kz', 'f36'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                             ('f36*(Dz*Kz + B01)',
                              ['Dz', 'f36', 'Kz', 'B01'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('f31*(Dz*Kz + B01)',
                              ['Dz', 'Kz', 'f31', 'B01'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('Ix*(Dz*Kz + B01)',
                              ['Dz', 'Kz', 'Ix', 'B01'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('Cy*Ix*(Dz*Kz + B01)',
                              ['Dz', 'Kz', 'Ix', 'B01', 'Cy'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('Cy*(Dz*Kz + B01)',
                              ['Dz', 'Kz', 'B01', 'Cy'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                             ('Iy*(Dz*Kz + B01)',
                              ['Dz', 'B01', 'Kz', 'Iy'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                             ('Cx*Iy*(Dz*Kz + B01)',
                              ['Dz', 'B01', 'Kz', 'Iy', 'Cx'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('Cx*(Dz*Kz + B01)',
                              ['Dz', 'Kz', 'B01', 'Cx'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                             ('(Dz*Kz + B01)', ['Dz', 'Kz', 'B01'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Dz*(f38 + Qy)', ['Dz', 'Qy', 'f38'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Dz*Ix*(f38 + Qy)',
                              ['Dz', 'Qy', 'Ix', 'f38'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('Ix*(f38 + Qy)', ['Qy', 'Ix', 'f38'])),
                            (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('Dx*(f38 + Qy)', ['Qy', 'Dx', 'f38'])),
                            (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                             ('Dx*Iz*(f38 + Qy)',
                              ['Qy', 'Dx', 'f38', 'Iz'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                             ('Iz*(f38 + Qy)', ['Qy', 'f38', 'Iz'])),
                            (((0, 1, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                             ('Iz*Kx*Qy', ['Qy', 'Iz', 'Kx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Kx*Qy', ['Qy', 'Kx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('(f38 + Qy)', ['Qy', 'f38'])),
                            (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                             ('Cx*Iz*f42', ['f42', 'Cx', 'Iz'])),
                            (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('Cx*f42', ['Cx', 'f42'])),
                            (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('Cz*f42', ['Cz', 'f42'])),
                            (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('Ix*f42', ['Ix', 'f42'])),
                            (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('f31*f42', ['f31', 'f42'])),
                            (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                             ('Iz*f42', ['Iz', 'f42'])),
                            (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                             ('f42*f59', ['f59', 'f42'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                             ('Ky*f59', ['f59', 'Ky'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Dz*Ky*f31', ['Dz', 'f31', 'Ky'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('Ix*Ky', ['Ix', 'Ky'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('Cz*Ix*Ky', ['Cz', 'Ky', 'Ix'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('Cz*Ky', ['Cz', 'Ky'])),
                            (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('Cz*Dx*Ky', ['Dx', 'Cz', 'Ky'])),
                            (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                             ('Dx*Ky', ['Dx', 'Ky'])),
                            (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                             ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                             ('Iz*Ky', ['Iz', 'Ky'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                             ('Cx*Iz*Ky', ['Cx', 'Ky', 'Iz'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('Cx*Ky', ['Cx', 'Ky'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Cx*Dz*Ky', ['Dz', 'Cx', 'Ky'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                             ('Dz*Ky', ['Dz', 'Ky'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('Ky*f31', ['f31', 'Ky'])),
                            (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Dy*Kz*f31', ['Dy', 'f31', 'Kz'])),
                            (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Cx*Dy*Kz', ['Dy', 'Kz', 'Cx'])),
                            (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('Cy*Ix*Kz', ['Kz', 'Ix', 'Cy'])),
                            (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('Cy*Dx*Kz', ['Dx', 'Kz', 'Cy'])),
                            (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                             ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                             ('Cx*Iy*Kz', ['Kz', 'Iy', 'Cx'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('Cx*Kz', ['Kz', 'Cx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('Cy*Kz', ['Kz', 'Cy'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('Ix*Kz', ['Kz', 'Ix'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('Kz*f31', ['f31', 'Kz'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                             ('Iy*Kz', ['Kz', 'Iy'])),
                            (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                             ('Dx*Kz', ['Dx', 'Kz'])),
                            (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Dy*Kz', ['Dy', 'Kz'])),
                            (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                             ('Kz*Qy', ['Kz', 'Qy'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                             ('Kz*f36', ['f36', 'Kz'])),
                            (((0, 1, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                             ('f35*f36', ['f36', 'f35'])),
                            (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                             ('Iy*f35', ['Iy', 'f35'])),
                            (((0, 0, 1), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                             ('Cz*Iy*f35', ['Cz', 'Iy', 'f35'])),
                            (((0, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('Cz*f35', ['Cz', 'f35'])),
                            (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                             ('Iz*f35', ['Iz', 'f35'])),
                            (((0, 1, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                             ('Cy*Iz*f35', ['Iz', 'Cy', 'f35'])),
                            (((0, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('Cy*f35', ['Cy', 'f35'])),
                            (((0, 0, 1), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                             ('f35*f59', ['f59', 'f35'])),
                            (((0, 0, 1), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                             ('Dy*Kx*f59', ['Dy', 'Kx', 'f59'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                             ('Kx*f59', ['f59', 'Kx'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                             ('Kx*f36', ['f36', 'Kx'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                             ('Dz*Kx*f36', ['Dz', 'f36', 'Kx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('Cy*Dz*Kx', ['Dz', 'Kx', 'Cy'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                             ('Dz*Kx', ['Dz', 'Kx'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                             ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                             ('Iy*Kx', ['Iy', 'Kx'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                             ('Cz*Iy*Kx', ['Cz', 'Iy', 'Kx'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('Cz*Kx', ['Cz', 'Kx'])),
                            (((0, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Cz*Dy*Kx', ['Dy', 'Cz', 'Kx'])),
                            (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                             ('Dy*Kx', ['Dy', 'Kx'])),
                            (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                             ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                             ('Iz*Kx', ['Iz', 'Kx'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                             ('Cy*Iz*Kx', ['Iz', 'Cy', 'Kx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('Cy*Kx', ['Kx', 'Cy'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                             ('Kx', ['Kx'])),
                            (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                             ('f35', ['f35'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                             ('Ky', ['Ky'])),
                            (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                             ('f42', ['f42'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                             ('Kz', ['Kz'])))),
 ('sp', 'sp', 'sp', 's'): ({'B00': '',
                            'B10': '',
                            'Cx': '',
                            'Cy': '',
                            'Cz': '',
                            'Dx': '',
                            'Dy': '',
                            'Dz': '',
                            'Ix': '(Cx + Xij)',
                            'Iy': '(Cy + Yij)',
                            'Iz': '(Cz + Zij)',
                            'Px': '(B10 + pow(Cx,2))',
                            'Py': '(B10 + pow(Cy,2))',
                            'Pz': '(B10 + pow(Cz,2))',
                            'Qy': '(Cy*Dy + B00)',
                            'f2': 'Cz*Dz',
                            'f4': 'Cx*Dx',
                            'f8': 'Cy*Dy',
                            'Xij': '',
                            'Yij': '',
                            'Zij': ''},
                           ((((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('(B00*(Yij + 2*Cy) + f8*Yij + Dy*Py)',
                              ['Dy', 'Py', 'Yij', 'B00', 'f8', 'Cy'])),
                            (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('(f4*Xij + Dx*Px + B00*(Xij + 2*Cx))',
                              ['f4', 'Dx', 'Xij', 'Px', 'B00', 'Cx'])),
                            (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cy*(B00 + f4 + Dx*Xij)',
                              ['f4', 'Dx', 'B00', 'Xij', 'Cy'])),
                            (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cz*(B00 + f4 + Dx*Xij)',
                              ['f4', 'Dx', 'Cz', 'Xij', 'B00'])),
                            (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('(B00 + f4 + Dx*Xij)',
                              ['f4', 'Dx', 'B00', 'Xij'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('(Dz*Pz + B00*(2*Cz + Zij) + f2*Zij)',
                              ['Cz', 'Zij', 'f2', 'Dz', 'B00', 'Pz'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('Cy*(B00 + Dz*Zij + f2)',
                              ['Dz', 'Zij', 'B00', 'f2', 'Cy'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('Cx*(B00 + Dz*Zij + f2)',
                              ['Dz', 'Zij', 'B00', 'Cx', 'f2'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                             ('(B00 + Dz*Zij + f2)',
                              ['Dz', 'Zij', 'B00', 'f2'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*(Cy*Iy + B10)',
                              ['Dz', 'B10', 'Iy', 'Cy'])),
                            (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('Dx*(Cy*Iy + B10)',
                              ['Dx', 'Iy', 'B10', 'Cy'])),
                            (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                            (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Dy*(B10 + Cz*Iz)',
                              ['Dy', 'B10', 'Cz', 'Iz'])),
                            (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('Dx*(B10 + Cz*Iz)',
                              ['Dx', 'Cz', 'B10', 'Iz'])),
                            (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                            (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cz*(Dy*Yij + Qy)',
                              ['Dy', 'Cz', 'Qy', 'Yij'])),
                            (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cx*(Dy*Yij + Qy)',
                              ['Dy', 'Qy', 'Cx', 'Yij'])),
                            (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                             ('(Dy*Yij + Qy)', ['Dy', 'Qy', 'Yij'])),
                            (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Dy*(Cx*Ix + B10)',
                              ['Dy', 'B10', 'Ix', 'Cx'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                            (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*(Cx*Ix + B10)',
                              ['Dz', 'B10', 'Ix', 'Cx'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cx*Dz', ['Dz', 'Cx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cy*Dz', ['Dz', 'Cy'])),
                            (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Dy*Iz', ['Dy', 'Iz'])),
                            (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('Iz*(B00 + f4)', ['f4', 'B00', 'Iz'])),
                            (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('(B00 + f4)', ['f4', 'B00'])),
                            (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('Iy*(B00 + f4)', ['f4', 'B00', 'Iy'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('Iy*(B00 + f2)', ['B00', 'Iy', 'f2'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Ix*(B00 + f2)', ['Ix', 'f2', 'B00'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('(B00 + f2)', ['B00', 'f2'])),
                            (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('Dx*Iy', ['Dx', 'Iy'])),
                            (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('Dx*Iz', ['Dx', 'Iz'])),
                            (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Iz*Qy', ['Qy', 'Iz'])),
                            (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Ix*Qy', ['Ix', 'Qy'])),
                            (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Dy*Ix', ['Dy', 'Ix'])),
                            (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cx*Dy', ['Dy', 'Cx'])),
                            (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                             ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                            (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('Cx*Iz', ['Cx', 'Iz'])),
                            (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('Cy*Iz', ['Iz', 'Cy'])),
                            (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                             ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                            (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cy*Dx', ['Dx', 'Cy'])),
                            (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cz*Dx', ['Dx', 'Cz'])),
                            (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                             ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                            (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cz*Iy', ['Cz', 'Iy'])),
                            (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cz*Dy', ['Dy', 'Cz'])),
                            (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                            (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cz*Ix', ['Cz', 'Ix'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cy*Ix', ['Ix', 'Cy'])),
                            (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*Ix', ['Dz', 'Ix'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz*Iy', ['Dz', 'Iy'])),
                            (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cx*Iy', ['Iy', 'Cx'])),
                            (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cx', ['Cx'])),
                            (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cy', ['Cy'])),
                            (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Cz', ['Cz'])),
                            (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('Ix', ['Ix'])),
                            (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                             ('Iy', ['Iy'])),
                            (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                             ('Iz', ['Iz'])),
                            (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                             ('Dx', ['Dx'])),
                            (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Dy', ['Dy'])),
                            (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                             ('Qy', ['Qy'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                             ('Dz', ['Dz'])),
                            (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                             ('1', [])))),
 ('sp', 'sp', 'sp', 'sp'): ({'B00': '',
                             'B01': '',
                             'B10': '',
                             'Cx': '',
                             'Cy': '',
                             'Cz': '',
                             'Dx': '',
                             'Dy': '',
                             'Dz': '',
                             'Ix': '(Cx + Xij)',
                             'Iy': '(Cy + Yij)',
                             'Iz': '(Cz + Zij)',
                             'Kx': '(Xkl + Dx)',
                             'Ky': '(Ykl + Dy)',
                             'Kz': '(Dz + Zkl)',
                             'Px': '(B10 + pow(Cx,2))',
                             'Qy': '(Cy*Dy + B00)',
                             'Ry': '(B01 + pow(Dy,2))',
                             'f1': 'Cx*Dx*Xij',
                             'f10': 'Cz*Dz*Zij',
                             'f11': 'B00*Ykl',
                             'f12': 'Cy*Dy',
                             'f13': '(Dz*Kz + B01)',
                             'f17': '2*B00*Dx',
                             'f2': 'B00*Xij',
                             'f20': 'Cz*Dz',
                             'f21': 'Cz*pow(Dz,2)',
                             'f26': 'Cz*Zkl',
                             'f3': 'B00*Zkl',
                             'f33': 'Dy*Yij',
                             'f34': 'B10*Dx',
                             'f35': 'B01*Cy',
                             'f38': 'Cx*Xkl',
                             'f4': 'Cx*Dx',
                             'f41': '2*B00*Cy',
                             'f44': '2*B00*Dy',
                             'f45': 'B10*Dy',
                             'f46': 'Dz*pow(Cz,2)',
                             'f48': '(B01 + Dx*Kx)',
                             'f49': 'Dz*Zij',
                             'f5': 'B01*B10',
                             'f51': 'Cy*Ykl',
                             'f54': '2*B00*Dz',
                             'f55': 'B10*Dz',
                             'f56': '(B01 + Dy*Ky)',
                             'f58': 'B01*Cx',
                             'f59': 'Dy*pow(Cy,2)',
                             'f6': '2*B00*Cz',
                             'f63': 'Cx*pow(Dx,2)',
                             'f64': 'B00*Zij',
                             'f67': '2*B00*Cx',
                             'f68': 'Cy*pow(Dy,2)',
                             'f7': 'Dx*pow(Cx,2)',
                             'f76': 'Dx*Xij',
                             'f77': 'B01*Cz',
                             'Xij': '',
                             'Xkl': '',
                             'Yij': '',
                             'Ykl': '',
                             'Zij': '',
                             'Zkl': ''},
                            ((((1, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('(f58*(Cx + Xij) + f1*Xkl + f5 + f63*Xij + Dx*(2*f2 + Dx*Px) + Xkl*(f34 + f2 + f7) + 2*B00*(f38 + B00 + 2*f4))',
                               ['f4',
                                'Dx',
                                'f1',
                                'f38',
                                'Cx',
                                'Xij',
                                'f5',
                                'f63',
                                'f58',
                                'f2',
                                'f34',
                                'Xkl',
                                'B00',
                                'f7',
                                'Px'])),
                             (((0, 1, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('Cy*(Xij*pow(Dx,2) + f17 + f63 + B01*Ix + Xkl*(f76 + B00 + f4))',
                               ['f4',
                                'Dx',
                                'Ix',
                                'Xij',
                                'f63',
                                'B01',
                                'f17',
                                'Xkl',
                                'B00',
                                'f76',
                                'Cy'])),
                             (((0, 0, 1), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('Cz*(Xij*pow(Dx,2) + f17 + f63 + B01*Ix + Xkl*(f76 + B00 + f4))',
                               ['f4',
                                'Dx',
                                'Ix',
                                'Xij',
                                'f63',
                                'B01',
                                'f17',
                                'Xkl',
                                'Cz',
                                'f76',
                                'B00'])),
                             (((0, 0, 0), (1, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('(Xij*pow(Dx,2) + f17 + f63 + B01*Ix + Xkl*(f76 + B00 + f4))',
                               ['f4',
                                'Dx',
                                'Ix',
                                'Xij',
                                'f63',
                                'B01',
                                'f17',
                                'Xkl',
                                'B00',
                                'f76'])),
                             (((1, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                              ('Iy*(f17 + f63 + f58 + Xkl*(B00 + f4))',
                               ['f4',
                                'f63',
                                'f58',
                                'f17',
                                'Xkl',
                                'B00',
                                'Iy'])),
                             (((1, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                              ('Iz*(f17 + f63 + f58 + Xkl*(B00 + f4))',
                               ['f4',
                                'f63',
                                'f58',
                                'f17',
                                'Xkl',
                                'B00',
                                'Iz'])),
                             (((1, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('(f17 + f63 + f58 + Xkl*(B00 + f4))',
                               ['f4', 'f63', 'f58', 'f17', 'Xkl', 'B00'])),
                             (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                              ('(Cy*(f68 + 2*f11) + 2*B00*(f33 + B00 + 2*f12) + Yij*(f11 + f68 + f35) + B01*pow(Cy,2) + f12*Yij*Ykl + f59*Ykl + f5 + f45*(Ykl + Dy))',
                               ['f45',
                                'f12',
                                'f33',
                                'f59',
                                'Ykl',
                                'f68',
                                'f5',
                                'B01',
                                'Yij',
                                'B00',
                                'f35',
                                'Dy',
                                'f11',
                                'Cy'])),
                             (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                              ('Cz*(f11 + f68 + f44 + f35 + Ry*Yij + Ykl*(f12 + f33))',
                               ['Ykl',
                                'f33',
                                'f44',
                                'f68',
                                'Yij',
                                'Cz',
                                'f35',
                                'f12',
                                'f11',
                                'Ry'])),
                             (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                              ('Cx*(f11 + f68 + f44 + f35 + Ry*Yij + Ykl*(f12 + f33))',
                               ['Ykl',
                                'Cx',
                                'f33',
                                'f44',
                                'f68',
                                'Yij',
                                'f35',
                                'f12',
                                'f11',
                                'Ry'])),
                             (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 1, 0)),
                              ('(f11 + f68 + f44 + f35 + Ry*Yij + Ykl*(f12 + f33))',
                               ['Ykl',
                                'f33',
                                'f44',
                                'f68',
                                'Yij',
                                'f35',
                                'f12',
                                'f11',
                                'Ry'])),
                             (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                              ('Iz*(f11 + f68 + f44 + f35 + f12*Ykl)',
                               ['f12',
                                'f44',
                                'f68',
                                'Ykl',
                                'Iz',
                                'f35',
                                'f11'])),
                             (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('Ix*(f11 + f68 + f44 + f35 + f12*Ykl)',
                               ['Ix',
                                'f12',
                                'f44',
                                'f68',
                                'Ykl',
                                'f35',
                                'f11'])),
                             (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('(f11 + f68 + f44 + f35 + f12*Ykl)',
                               ['f12', 'f44', 'f68', 'Ykl', 'f35', 'f11'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                              ('Dz*(f59 + B00*(Yij + 2*Cy) + B10*Ky + Yij*(f12 + f51) + Ykl*pow(Cy,2))',
                               ['B10',
                                'f12',
                                'Yij',
                                'Dz',
                                'f59',
                                'B00',
                                'Ky',
                                'Ykl',
                                'f51',
                                'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                              ('Dx*(f59 + B00*(Yij + 2*Cy) + B10*Ky + Yij*(f12 + f51) + Ykl*pow(Cy,2))',
                               ['Dx',
                                'f12',
                                'Yij',
                                'B10',
                                'f59',
                                'B00',
                                'Ky',
                                'Ykl',
                                'f51',
                                'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                              ('(f59 + B00*(Yij + 2*Cy) + B10*Ky + Yij*(f12 + f51) + Ykl*pow(Cy,2))',
                               ['B10',
                                'f12',
                                'Yij',
                                'f59',
                                'B00',
                                'Ky',
                                'Ykl',
                                'f51',
                                'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                              ('Kz*(f41 + f45 + f59 + Yij*(f12 + B00))',
                               ['f45',
                                'f12',
                                'Yij',
                                'Kz',
                                'f59',
                                'B00',
                                'f41'])),
                             (((0, 1, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                              ('Kx*(f41 + f45 + f59 + Yij*(f12 + B00))',
                               ['f45',
                                'f12',
                                'Yij',
                                'f59',
                                'B00',
                                'f41',
                                'Kx'])),
                             (((0, 1, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                              ('(f41 + f45 + f59 + Yij*(f12 + B00))',
                               ['f45', 'f12', 'Yij', 'f59', 'B00', 'f41'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                              ('(2*B00*(f49 + B00) + Zkl*(f10 + f46) + f3*Zij + f21*Zij + f5 + 2*Cz*f3 + pow(Cz,2)*pow(Dz,2) + 2*Dz*f6 + f77*(Cz + Zij) + f55*(Dz + Zkl))',
                               ['Cz',
                                'f5',
                                'Zij',
                                'Dz',
                                'f6',
                                'B00',
                                'f49',
                                'f3',
                                'f10',
                                'f46',
                                'Zkl',
                                'f77',
                                'f21',
                                'f55'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                              ('Cy*(f54 + f21 + Zij*pow(Dz,2) + f3 + Zkl*(f49 + f20) + B01*Iz)',
                               ['f20',
                                'Zij',
                                'B01',
                                'f54',
                                'Dz',
                                'Iz',
                                'f49',
                                'Cy',
                                'Zkl',
                                'f21',
                                'f3'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                              ('Cx*(f54 + f21 + Zij*pow(Dz,2) + f3 + Zkl*(f49 + f20) + B01*Iz)',
                               ['Cx',
                                'Zij',
                                'B01',
                                'f54',
                                'Dz',
                                'Iz',
                                'f49',
                                'f3',
                                'Zkl',
                                'f21',
                                'f20'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 1)),
                              ('(f54 + f21 + Zij*pow(Dz,2) + f3 + Zkl*(f49 + f20) + B01*Iz)',
                               ['f20',
                                'Zij',
                                'B01',
                                'f54',
                                'Dz',
                                'f49',
                                'f3',
                                'Zkl',
                                'f21',
                                'Iz'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                              ('Iy*(f77 + f54 + f21 + f3 + f20*Zkl)',
                               ['f20',
                                'Zkl',
                                'f54',
                                'f3',
                                'Iy',
                                'f77',
                                'f21'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('Ix*(f77 + f54 + f21 + f3 + f20*Zkl)',
                               ['Ix',
                                'f20',
                                'f54',
                                'f3',
                                'Zkl',
                                'f77',
                                'f21'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('(f77 + f54 + f21 + f3 + f20*Zkl)',
                               ['f20', 'f54', 'f3', 'Zkl', 'f77', 'f21'])),
                             (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                              ('Dy*(Zkl*pow(Cz,2) + f10 + f46 + Zij*(f26 + B00) + B10*Kz + f6)',
                               ['B10',
                                'B00',
                                'Zij',
                                'Dy',
                                'Kz',
                                'f6',
                                'Cz',
                                'f10',
                                'f26',
                                'f46',
                                'Zkl'])),
                             (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                              ('Dx*(Zkl*pow(Cz,2) + f10 + f46 + Zij*(f26 + B00) + B10*Kz + f6)',
                               ['Dx',
                                'B00',
                                'Zij',
                                'Kz',
                                'B10',
                                'f6',
                                'Cz',
                                'f10',
                                'f26',
                                'f46',
                                'Zkl'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                              ('(Zkl*pow(Cz,2) + f10 + f46 + Zij*(f26 + B00) + B10*Kz + f6)',
                               ['B10',
                                'B00',
                                'Zij',
                                'Kz',
                                'f6',
                                'Cz',
                                'f10',
                                'f26',
                                'f46',
                                'Zkl'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                              ('Ky*(f10 + f64 + f46 + f55 + f6)',
                               ['Ky', 'f6', 'f55', 'f10', 'f46', 'f64'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                              ('Kx*(f10 + f64 + f46 + f55 + f6)',
                               ['f64', 'f6', 'f55', 'f10', 'f46', 'Kx'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                              ('(f10 + f64 + f46 + f55 + f6)',
                               ['f46', 'f6', 'f64', 'f10', 'f55'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('Dz*(f67 + f34 + Px*Xkl + f1 + f2 + f7 + f38*Xij)',
                               ['f38',
                                'f34',
                                'f1',
                                'f67',
                                'Xij',
                                'Px',
                                'f2',
                                'Dz',
                                'Xkl',
                                'f7'])),
                             (((1, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Dy*(f67 + f34 + Px*Xkl + f1 + f2 + f7 + f38*Xij)',
                               ['f38',
                                'f1',
                                'f67',
                                'Xij',
                                'Px',
                                'Dy',
                                'f2',
                                'f34',
                                'Xkl',
                                'f7'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('(f67 + f34 + Px*Xkl + f1 + f2 + f7 + f38*Xij)',
                               ['f38',
                                'f1',
                                'f67',
                                'Xij',
                                'Px',
                                'f2',
                                'f34',
                                'Xkl',
                                'f7'])),
                             (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('Ky*(f67 + f34 + f1 + f2 + f7)',
                               ['f1', 'f67', 'f2', 'f34', 'Ky', 'f7'])),
                             (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('Kz*(f67 + f34 + f1 + f2 + f7)',
                               ['f1', 'f67', 'Kz', 'f2', 'f34', 'f7'])),
                             (((1, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('(f67 + f34 + f1 + f2 + f7)',
                               ['f34', 'f7', 'f1', 'f67', 'f2'])),
                             (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                              ('Qy*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['f20',
                                'Zij',
                                'B00',
                                'f49',
                                'f26',
                                'Qy',
                                'Zkl'])),
                             (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                              ('(B00 + f4)*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['f4',
                                'f20',
                                'Zij',
                                'B00',
                                'f49',
                                'f26',
                                'Zkl'])),
                             (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                              ('Dx*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['Dx',
                                'f20',
                                'Zij',
                                'B00',
                                'f49',
                                'f26',
                                'Zkl'])),
                             (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 1)),
                              ('Cy*Dx*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['Dx',
                                'f20',
                                'Zij',
                                'B00',
                                'f49',
                                'f26',
                                'Zkl',
                                'Cy'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                              ('Cy*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['f20',
                                'Zij',
                                'B00',
                                'f49',
                                'f26',
                                'Zkl',
                                'Cy'])),
                             (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                              ('Dy*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['f20',
                                'Zij',
                                'Dy',
                                'B00',
                                'f49',
                                'f26',
                                'Zkl'])),
                             (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 1)),
                              ('Cx*Dy*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['Cx',
                                'Zij',
                                'Dy',
                                'B00',
                                'f49',
                                'f26',
                                'Zkl',
                                'f20'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                              ('Cx*(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['Cx',
                                'Zij',
                                'B00',
                                'f49',
                                'f26',
                                'Zkl',
                                'f20'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 1)),
                              ('(f49 + f20 + f26 + Zij*Zkl + B00)',
                               ['f20', 'Zij', 'B00', 'f49', 'f26', 'Zkl'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('(f20 + B00)*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'f38',
                                'f20',
                                'Xij',
                                'Xkl',
                                'B00',
                                'f76'])),
                             (((0, 1, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Qy*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'f38',
                                'Xij',
                                'Xkl',
                                'B00',
                                'Qy',
                                'f76'])),
                             (((0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Dy*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'f38',
                                'Xij',
                                'Dy',
                                'Xkl',
                                'B00',
                                'f76'])),
                             (((0, 0, 1), (1, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Cz*Dy*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'B00',
                                'f38',
                                'Xij',
                                'Dy',
                                'Xkl',
                                'Cz',
                                'f76'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('Cz*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'B00',
                                'f38',
                                'Xij',
                                'Xkl',
                                'Cz',
                                'f76'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('Cy*Dz*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'f38',
                                'Xij',
                                'Dz',
                                'Xkl',
                                'B00',
                                'f76',
                                'Cy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('Cy*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'f38',
                                'Xij',
                                'Xkl',
                                'B00',
                                'f76',
                                'Cy'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4', 'f38', 'Xij', 'Xkl', 'B00', 'f76'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('Dz*(f76 + f38 + Xij*Xkl + B00 + f4)',
                               ['f4',
                                'f38',
                                'Xij',
                                'Dz',
                                'Xkl',
                                'B00',
                                'f76'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                              ('Dz*Iy*(f38 + B00 + f4)',
                               ['Dz', 'f38', 'B00', 'Iy', 'f4'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                              ('(f20 + B00)*(f51 + f33 + Yij*Ykl + Qy)',
                               ['f20',
                                'Ykl',
                                'Yij',
                                'B00',
                                'Qy',
                                'f51',
                                'f33'])),
                             (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                              ('(B00 + f4)*(f51 + f33 + Yij*Ykl + Qy)',
                               ['f4',
                                'f33',
                                'Yij',
                                'Ykl',
                                'B00',
                                'Qy',
                                'f51'])),
                             (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                              ('Dx*(f51 + f33 + Yij*Ykl + Qy)',
                               ['Dx', 'f33', 'Yij', 'Ykl', 'Qy', 'f51'])),
                             (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 1, 0)),
                              ('Cz*Dx*(f51 + f33 + Yij*Ykl + Qy)',
                               ['Dx',
                                'f33',
                                'Yij',
                                'Ykl',
                                'Cz',
                                'Qy',
                                'f51'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                              ('Cz*(f51 + f33 + Yij*Ykl + Qy)',
                               ['f33', 'Yij', 'Ykl', 'Cz', 'Qy', 'f51'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                              ('Dz*(f51 + f33 + Yij*Ykl + Qy)',
                               ['f33', 'Yij', 'Dz', 'Ykl', 'Qy', 'f51'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 1, 0)),
                              ('Cx*Dz*(f51 + f33 + Yij*Ykl + Qy)',
                               ['Cx',
                                'Yij',
                                'Dz',
                                'Ykl',
                                'Qy',
                                'f51',
                                'f33'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                              ('Cx*(f51 + f33 + Yij*Ykl + Qy)',
                               ['Cx', 'Ykl', 'Yij', 'Qy', 'f51', 'f33'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 1, 0)),
                              ('(f51 + f33 + Yij*Ykl + Qy)',
                               ['f51', 'Ykl', 'f33', 'Qy', 'Yij'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                              ('(f51 + Qy)*(f49 + f20 + B00)',
                               ['f51', 'f49', 'Qy', 'f20', 'B00'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                              ('(f38 + B00 + f4)*(f49 + f20 + B00)',
                               ['f4', 'f49', 'B00', 'f38', 'f20'])),
                             (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('(f20 + f26 + B00)*(f76 + B00 + f4)',
                               ['f4', 'B00', 'f20', 'f76', 'f26'])),
                             (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                              ('(f33 + Qy)*(f20 + f26 + B00)',
                               ['B00', 'f26', 'Qy', 'f33', 'f20'])),
                             (((1, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                              ('(f33 + Qy)*(f38 + B00 + f4)',
                               ['f4', 'f38', 'B00', 'Qy', 'f33'])),
                             (((1, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                              ('Dy*Iz*(f38 + B00 + f4)',
                               ['f4', 'Dy', 'B00', 'f38', 'Iz'])),
                             (((1, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Dy*(f38 + B00 + f4)',
                               ['f4', 'Dy', 'B00', 'f38'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('Dz*(f38 + B00 + f4)',
                               ['Dz', 'f4', 'B00', 'f38'])),
                             (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('Cz*Ix*f56', ['Cz', 'f56', 'Ix'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('Cy*Dz*Kx', ['Dz', 'Kx', 'Cy'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                              ('Dz*Iy*Kx', ['Dz', 'Iy', 'Kx'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                              ('Iy*Kx*(f20 + B00)',
                               ['B00', 'Iy', 'Kx', 'f20'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('Kx*(f20 + B00)', ['B00', 'Kx', 'f20'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                              ('Kx*(f49 + f20 + B00)',
                               ['B00', 'f49', 'Kx', 'f20'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 1), (1, 0, 0)),
                              ('Cy*Kx*(f49 + f20 + B00)',
                               ['B00', 'f49', 'Kx', 'Cy', 'f20'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                              ('Cy*(f49 + f20 + B00)',
                               ['B00', 'f49', 'f20', 'Cy'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                              ('Ky*(f49 + f20 + B00)',
                               ['B00', 'f49', 'f20', 'Ky'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 1, 0)),
                              ('Cx*Ky*(f49 + f20 + B00)',
                               ['B00', 'f49', 'Cx', 'Ky', 'f20'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                              ('Cx*(f49 + f20 + B00)',
                               ['B00', 'f49', 'Cx', 'f20'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 1), (0, 0, 0)),
                              ('(f49 + f20 + B00)', ['B00', 'f49', 'f20'])),
                             (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('Dx*(f20 + f26 + B00)',
                               ['Dx', 'B00', 'f20', 'f26'])),
                             (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                              ('Dx*Iy*(f20 + f26 + B00)',
                               ['Dx', 'B00', 'Iy', 'f20', 'f26'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                              ('Iy*(f20 + f26 + B00)',
                               ['B00', 'Iy', 'f20', 'f26'])),
                             (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Dy*(f20 + f26 + B00)',
                               ['Dy', 'B00', 'f20', 'f26'])),
                             (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Dy*Ix*(f20 + f26 + B00)',
                               ['B00', 'Dy', 'Ix', 'f20', 'f26'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('Ix*(f20 + f26 + B00)',
                               ['B00', 'Ix', 'f20', 'f26'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('Ix*(f20 + B00)', ['Ix', 'f20', 'B00'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Ix*Ky*(f20 + B00)',
                               ['Ix', 'f20', 'Ky', 'B00'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Ky*(f20 + B00)', ['B00', 'f20', 'Ky'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('(f20 + f26 + B00)', ['B00', 'f20', 'f26'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                              ('Iy*(f20 + B00)', ['B00', 'Iy', 'f20'])),
                             (((0, 0, 1), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                              ('Cz*Iy*f48', ['Cz', 'Iy', 'f48'])),
                             (((0, 0, 1), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                              ('f48*(B10 + Cz*Iz)',
                               ['B10', 'f48', 'Iz', 'Cz'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                              ('Kx*(B10 + Cz*Iz)',
                               ['B10', 'Cz', 'Kx', 'Iz'])),
                             (((0, 0, 1), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                              ('Dy*Kx*(B10 + Cz*Iz)',
                               ['Dy', 'B10', 'Cz', 'Kx', 'Iz'])),
                             (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                              ('Dy*(B10 + Cz*Iz)',
                               ['Dy', 'B10', 'Cz', 'Iz'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                              ('Ky*(B10 + Cz*Iz)',
                               ['B10', 'Cz', 'Iz', 'Ky'])),
                             (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                              ('Dx*Ky*(B10 + Cz*Iz)',
                               ['Dx', 'Cz', 'B10', 'Ky', 'Iz'])),
                             (((0, 0, 1), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                              ('Dx*(B10 + Cz*Iz)',
                               ['Dx', 'Cz', 'B10', 'Iz'])),
                             (((0, 0, 1), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                              ('(B10 + Cz*Iz)', ['B10', 'Cz', 'Iz'])),
                             (((0, 0, 1), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                              ('f56*(B10 + Cz*Iz)',
                               ['B10', 'Cz', 'f56', 'Iz'])),
                             (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('f56*(Cx*Ix + B10)',
                               ['B10', 'Ix', 'f56', 'Cx'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('Ky*(Cx*Ix + B10)',
                               ['B10', 'Ix', 'Cx', 'Ky'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Dz*Ky*(Cx*Ix + B10)',
                               ['Dz', 'B10', 'Ix', 'Cx', 'Ky'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('Dz*(Cx*Ix + B10)',
                               ['Dz', 'B10', 'Ix', 'Cx'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('Kz*(Cx*Ix + B10)',
                               ['B10', 'Kz', 'Cx', 'Ix'])),
                             (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Dy*Kz*(Cx*Ix + B10)',
                               ['Dy', 'B10', 'Kz', 'Cx', 'Ix'])),
                             (((1, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Dy*(Cx*Ix + B10)',
                               ['Dy', 'B10', 'Ix', 'Cx'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('(Cx*Ix + B10)', ['B10', 'Ix', 'Cx'])),
                             (((1, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('f13*(Cx*Ix + B10)',
                               ['B10', 'f13', 'Cx', 'Ix'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                              ('f13*(Cy*Iy + B10)',
                               ['B10', 'f13', 'Iy', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                              ('Kz*(Cy*Iy + B10)',
                               ['B10', 'Kz', 'Iy', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                              ('f48*(Cy*Iy + B10)',
                               ['B10', 'f48', 'Iy', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                              ('Kx*(Cy*Iy + B10)',
                               ['B10', 'Iy', 'Kx', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 1), (1, 0, 0)),
                              ('Dz*Kx*(Cy*Iy + B10)',
                               ['Dz', 'B10', 'Iy', 'Kx', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                              ('Dz*(Cy*Iy + B10)',
                               ['Dz', 'B10', 'Iy', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                              ('(Cy*Iy + B10)', ['B10', 'Iy', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                              ('Dx*(Cy*Iy + B10)',
                               ['Dx', 'Iy', 'B10', 'Cy'])),
                             (((0, 1, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                              ('Dx*Kz*(Cy*Iy + B10)',
                               ['Dx', 'Kz', 'Iy', 'B10', 'Cy'])),
                             (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('Cy*Dx*Kz', ['Dx', 'Kz', 'Cy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('Cy*Ix*f13', ['f13', 'Ix', 'Cy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Dz*Ix*(f51 + Qy)',
                               ['Dz', 'f51', 'Ix', 'Qy'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Dz*(f51 + Qy)', ['Dz', 'f51', 'Qy'])),
                             (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                              ('Dx*Iz*(f51 + Qy)',
                               ['f51', 'Dx', 'Qy', 'Iz'])),
                             (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('Dx*(f51 + Qy)', ['f51', 'Dx', 'Qy'])),
                             (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('(f51 + Qy)*(f76 + B00 + f4)',
                               ['f4', 'f51', 'B00', 'Qy', 'f76'])),
                             (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('Cz*(f76 + B00 + f4)',
                               ['f4', 'Cz', 'f76', 'B00'])),
                             (((0, 0, 1), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('Cz*Ky*(f76 + B00 + f4)',
                               ['f4', 'Cz', 'f76', 'Ky', 'B00'])),
                             (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('Ky*(f76 + B00 + f4)',
                               ['f4', 'B00', 'f76', 'Ky'])),
                             (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('Ky*(B00 + f4)', ['f4', 'B00', 'Ky'])),
                             (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                              ('Iz*Ky*(B00 + f4)',
                               ['f4', 'B00', 'Iz', 'Ky'])),
                             (((1, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                              ('Iz*(B00 + f4)', ['f4', 'B00', 'Iz'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                              ('Iz*(f38 + B00 + f4)',
                               ['f4', 'B00', 'f38', 'Iz'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('(f38 + B00 + f4)', ['f4', 'B00', 'f38'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                              ('Iy*(f38 + B00 + f4)',
                               ['f4', 'f38', 'B00', 'Iy'])),
                             (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                              ('Iy*(B00 + f4)', ['f4', 'B00', 'Iy'])),
                             (((1, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                              ('Iy*Kz*(B00 + f4)',
                               ['f4', 'Kz', 'Iy', 'B00'])),
                             (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('Kz*(B00 + f4)', ['f4', 'Kz', 'B00'])),
                             (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('Kz*(f76 + B00 + f4)',
                               ['f4', 'Kz', 'f76', 'B00'])),
                             (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('Cy*Kz*(f76 + B00 + f4)',
                               ['f4', 'Kz', 'f76', 'Cy', 'B00'])),
                             (((0, 1, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('Cy*(f76 + B00 + f4)',
                               ['f4', 'B00', 'f76', 'Cy'])),
                             (((0, 0, 0), (1, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('(f76 + B00 + f4)', ['f4', 'B00', 'f76'])),
                             (((1, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('(B00 + f4)', ['f4', 'B00'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('(f20 + B00)', ['B00', 'f20'])),
                             (((0, 0, 1), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                              ('Cz*Kx*(f33 + Qy)',
                               ['Cz', 'Qy', 'Kx', 'f33'])),
                             (((0, 0, 1), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                              ('Cz*(f33 + Qy)', ['Cz', 'Qy', 'f33'])),
                             (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                              ('Kz*(f33 + Qy)', ['Kz', 'Qy', 'f33'])),
                             (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 1)),
                              ('Cx*Kz*(f33 + Qy)',
                               ['Kz', 'Qy', 'Cx', 'f33'])),
                             (((1, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                              ('Cx*(f33 + Qy)', ['Qy', 'Cx', 'f33'])),
                             (((0, 0, 0), (0, 1, 0), (0, 1, 0), (0, 0, 0)),
                              ('(f33 + Qy)', ['Qy', 'f33'])),
                             (((0, 0, 0), (0, 1, 0), (0, 1, 0), (1, 0, 0)),
                              ('Kx*(f33 + Qy)', ['Qy', 'Kx', 'f33'])),
                             (((0, 1, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                              ('Iz*Kx*Qy', ['Qy', 'Iz', 'Kx'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                              ('Cy*Iz*Kx', ['Iz', 'Cy', 'Kx'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('Cy*Kx', ['Kx', 'Cy'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                              ('Iy*Kx', ['Iy', 'Kx'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 0), (1, 0, 0)),
                              ('Iz*Kx', ['Iz', 'Kx'])),
                             (((0, 1, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                              ('Cy*Iz*f48', ['f48', 'Iz', 'Cy'])),
                             (((0, 1, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('Cy*f48', ['f48', 'Cy'])),
                             (((0, 0, 1), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('Cz*f48', ['Cz', 'f48'])),
                             (((0, 0, 0), (0, 1, 0), (1, 0, 0), (1, 0, 0)),
                              ('Iy*f48', ['f48', 'Iy'])),
                             (((0, 0, 0), (0, 0, 1), (1, 0, 0), (1, 0, 0)),
                              ('Iz*f48', ['f48', 'Iz'])),
                             (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                              ('Dy*Iz', ['Dy', 'Iz'])),
                             (((0, 0, 0), (0, 0, 1), (0, 1, 0), (1, 0, 0)),
                              ('Dy*Iz*Kx', ['Dy', 'Iz', 'Kx'])),
                             (((0, 0, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Dy*Kx', ['Dy', 'Kx'])),
                             (((0, 1, 0), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Kx*Qy', ['Qy', 'Kx'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 1), (1, 0, 0)),
                              ('Dz*Kx', ['Dz', 'Kx'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                              ('Dz*Iy', ['Dz', 'Iy'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                              ('Cx*Iy*Kz', ['Kz', 'Iy', 'Cx'])),
                             (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 1)),
                              ('Dx*Iy*Kz', ['Dx', 'Kz', 'Iy'])),
                             (((0, 0, 0), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                              ('Dx*Iy', ['Dx', 'Iy'])),
                             (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                              ('Dx*Iz', ['Dx', 'Iz'])),
                             (((0, 0, 0), (0, 0, 1), (1, 0, 0), (0, 1, 0)),
                              ('Dx*Iz*Ky', ['Dx', 'Iz', 'Ky'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                              ('Iz*Ky', ['Iz', 'Ky'])),
                             (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('Dx*Ky', ['Dx', 'Ky'])),
                             (((0, 1, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('Cy*Dx', ['Dx', 'Cy'])),
                             (((0, 1, 0), (0, 0, 1), (1, 0, 0), (0, 0, 0)),
                              ('Cy*Dx*Iz', ['Dx', 'Iz', 'Cy'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                              ('Cy*Iz', ['Iz', 'Cy'])),
                             (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                              ('Cx*Iz*f56', ['f56', 'Cx', 'Iz'])),
                             (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('Cx*f56', ['f56', 'Cx'])),
                             (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('Cz*f56', ['Cz', 'f56'])),
                             (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('Ix*f56', ['Ix', 'f56'])),
                             (((0, 0, 0), (0, 0, 1), (0, 1, 0), (0, 1, 0)),
                              ('Iz*f56', ['f56', 'Iz'])),
                             (((0, 1, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                              ('Iz*Qy', ['Qy', 'Iz'])),
                             (((0, 1, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                              ('Iz*(f51 + Qy)', ['f51', 'Qy', 'Iz'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('(f51 + Qy)', ['f51', 'Qy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('Ix*(f51 + Qy)', ['f51', 'Ix', 'Qy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Ix*Qy', ['Ix', 'Qy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Ix*Kz*Qy', ['Kz', 'Ix', 'Qy'])),
                             (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Dy*Ix*Kz', ['Dy', 'Ix', 'Kz'])),
                             (((0, 0, 0), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Dy*Ix', ['Dy', 'Ix'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('Ix*Ky', ['Ix', 'Ky'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('Cz*Ix*Ky', ['Cz', 'Ky', 'Ix'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('Cz*Ky', ['Cz', 'Ky'])),
                             (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 1, 0)),
                              ('Cz*Dx*Ky', ['Dx', 'Cz', 'Ky'])),
                             (((0, 0, 1), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('Cz*Dx', ['Dx', 'Cz'])),
                             (((0, 0, 1), (0, 1, 0), (1, 0, 0), (0, 0, 0)),
                              ('Cz*Dx*Iy', ['Dx', 'Cz', 'Iy'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                              ('Cz*Iy', ['Cz', 'Iy'])),
                             (((0, 0, 1), (0, 1, 0), (0, 0, 0), (1, 0, 0)),
                              ('Cz*Iy*Kx', ['Cz', 'Iy', 'Kx'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('Cz*Kx', ['Cz', 'Kx'])),
                             (((0, 0, 1), (0, 0, 0), (0, 1, 0), (1, 0, 0)),
                              ('Cz*Dy*Kx', ['Dy', 'Cz', 'Kx'])),
                             (((0, 0, 1), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Cz*Dy', ['Dy', 'Cz'])),
                             (((0, 0, 1), (1, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Cz*Dy*Ix', ['Dy', 'Cz', 'Ix'])),
                             (((0, 0, 1), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('Cz*Ix', ['Cz', 'Ix'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('Dz*Ix', ['Dz', 'Ix'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Dz*Ix*Ky', ['Dz', 'Ix', 'Ky'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Dz*Ky', ['Dz', 'Ky'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('Cy*Dz', ['Dz', 'Cy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('Cy*Dz*Ix', ['Dz', 'Ix', 'Cy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('Cy*Ix', ['Ix', 'Cy'])),
                             (((0, 1, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('Cy*Ix*Kz', ['Kz', 'Ix', 'Cy'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('Cy*Kz', ['Kz', 'Cy'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('Ix*Kz', ['Kz', 'Ix'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 1)),
                              ('Iy*Kz', ['Kz', 'Iy'])),
                             (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 1)),
                              ('Dx*Kz', ['Dx', 'Kz'])),
                             (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Dy*Kz', ['Dy', 'Kz'])),
                             (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Kz*Qy', ['Kz', 'Qy'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('Cx*Kz', ['Kz', 'Cx'])),
                             (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 1)),
                              ('Cx*Dy*Kz', ['Dy', 'Kz', 'Cx'])),
                             (((1, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Cx*Dy', ['Dy', 'Cx'])),
                             (((1, 0, 0), (0, 0, 1), (0, 1, 0), (0, 0, 0)),
                              ('Cx*Dy*Iz', ['Dy', 'Cx', 'Iz'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                              ('Cx*Iz', ['Cx', 'Iz'])),
                             (((1, 0, 0), (0, 0, 1), (0, 0, 0), (0, 1, 0)),
                              ('Cx*Iz*Ky', ['Cx', 'Ky', 'Iz'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('Cx*Ky', ['Cx', 'Ky'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 1, 0)),
                              ('Cx*Dz*Ky', ['Dz', 'Cx', 'Ky'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('Cx*Dz', ['Dz', 'Cx'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)),
                              ('Cx*Dz*Iy', ['Dz', 'Iy', 'Cx'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                              ('Cx*Iy*f13', ['f13', 'Iy', 'Cx'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('Cx*f13', ['f13', 'Cx'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('Cy*f13', ['f13', 'Cy'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('Ix*f13', ['f13', 'Ix'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 1)),
                              ('Iy*f13', ['f13', 'Iy'])),
                             (((1, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                              ('Cx*Iy', ['Iy', 'Cx'])),
                             (((1, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('Cx', ['Cx'])),
                             (((0, 1, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('Cy', ['Cy'])),
                             (((0, 0, 1), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('Cz', ['Cz'])),
                             (((0, 0, 0), (1, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('Ix', ['Ix'])),
                             (((0, 0, 0), (0, 1, 0), (0, 0, 0), (0, 0, 0)),
                              ('Iy', ['Iy'])),
                             (((0, 0, 0), (0, 0, 1), (0, 0, 0), (0, 0, 0)),
                              ('Iz', ['Iz'])),
                             (((0, 0, 0), (0, 0, 0), (1, 0, 0), (0, 0, 0)),
                              ('Dx', ['Dx'])),
                             (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Dy', ['Dy'])),
                             (((0, 1, 0), (0, 0, 0), (0, 1, 0), (0, 0, 0)),
                              ('Qy', ['Qy'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 0)),
                              ('Dz', ['Dz'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 0), (1, 0, 0)),
                              ('Kx', ['Kx'])),
                             (((0, 0, 0), (0, 0, 0), (1, 0, 0), (1, 0, 0)),
                              ('f48', ['f48'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 1, 0)),
                              ('Ky', ['Ky'])),
                             (((0, 0, 0), (0, 0, 0), (0, 1, 0), (0, 1, 0)),
                              ('f56', ['f56'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 1)),
                              ('Kz', ['Kz'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 1), (0, 0, 1)),
                              ('f13', ['f13'])),
                             (((0, 0, 0), (0, 0, 0), (0, 0, 0), (0, 0, 0)),
                              ('1', []))))}
